unit BPLabel;

{$A-}

{ Class TBPLabel }
{ Rewritten 14-09-98 }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,BPDef;


type

  TVAlignment =(taTopJustify,taVCenter,taBottomJustify);

{ TBPCustomLabel definition }
  TBPCustomLabel = class(TGraphicControl)
  private
    { Private declarations }
    FUpdating:Boolean;
     { Drawing Options }
     {New options }
    FDefWidth:Integer;       {    }
    FDefHeight:Integer;      {    }
    FAutoSize:Boolean;
    FHAlign:TAlignment;      {    }
    FVAlign:TVAlignment;     {    -    FAutoHeight=False}
    FWordWrap:Boolean;
    {Internal variables}
    FMaxWidth:Integer;
    FMaxHeight:Integer;
    FAcceptPosition:Boolean;
    FLeftDragPos:Integer;
    FTopDragPos:Integer;
    FPath:String;
    FFullCaption:String;
    { mouse routines }
    {procedures & functions for Draw }
    function  GetRectSize:TRect; { fucking calculation function }
    function  GetFont:TFont;
    procedure SetFont(Font:TFont);
    procedure SetDefWidth(Value: Integer);
    procedure SetDefHeight(Value: Integer);
    procedure SetAutoSize(Value: Boolean);
    procedure SetHAlign(Value: TAlignment);
    procedure SetVAlign(Value: TVAlignment);
    procedure SetTransparent(Value: Boolean);
    function  GetTransparent:Boolean;
    procedure SetWordWrap(Value: Boolean);
    function  HasPath:Boolean;
  protected
    { Protected declarations }
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure Paint; override;
    function  GetLabelText:String;
    property Font:TFont read getFont write SetFont;
    property DefWidth:Integer read FDefWidth write SetDefWidth default 100;
    property DefHeight:Integer read FDefHeight write SetDefHeight default 100;
    property AutoSize:Boolean read FAutoSize write SetAutoSize default True;
    property HAlign:TAlignment read FHAlign write SetHAlign default taCenter;
    property VAlign:TVAlignment read FVAlign write SetVAlign default taVCenter;
    property MaxWidth:Integer read FMaxWidth default 0;
    property MaxHeight:Integer read FMaxHeight default 0;
    property Transparent:Boolean read GetTransparent write SetTransparent default True;
    property WordWrap:Boolean read FWordWrap write SetWordWrap default True;
    property AcceptPosition:Boolean read FAcceptPosition write FAcceptPosition default False;
    property LeftDragPos:Integer read FLeftDragPos write FLeftDragPos;
    property TopDragPos:Integer read FTopDragPos write FTopDragPos;
    property Path:String read FPath write FPath;
    property IsPath:Boolean read HasPath;
    property FullCaption:String read FFullCaption write FFullCaption;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);  override; { Create empty node }
    procedure   SetFontDPI(Value:Integer);
    property    Canvas;
    property    DragMode;
    property    DragCursor;
    property    OnDragDrop;
    property    OnDragOver;
    property    OnEndDrag;
    property    OnStartDrag;
    property    Tag;
    property    Cursor;
  end;


 TBPLabel = class (TBPCustomLabel)
   published
    property Caption;
    property Font;
    property Canvas;
    property DefWidth;
    property DefHeight;
    property AutoSize;
    property HAlign;
    property VAlign;
    property Color default clWhite;
    property Height default 30;
    property Width  default 50;
    property Visible;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property MaxWidth;
    property MaxHeight;
    property Transparent;
    property WordWrap;
    property AcceptPosition;
    property LeftDragPos;
    property TopDragPos;
    property Path;
    property IsPath;
    property FullCaption;
 end;



Const reSpace=2;

implementation

{ TBPCustomLabel }

function TBPCustomLabel.GetTransparent: Boolean;
begin
  Result := not (csOpaque in ControlStyle);
end;


function  TBPCustomLabel.HasPath:Boolean;
 begin
  Result:=(Length(FPath)>0);
 end;

function  TBPCustomLabel.GetLabelText:String;
begin
  Result:=Caption;
end;

constructor TBPCustomLabel.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FUpdating:=False;
   Color:=clWhite;
   FDefWidth:=100;
   FDefHeight:=100;
   FAutoSize:=True;
   FHAlign:=taCenter;
   FVAlign:=taVCenter;
   FMaxWidth:=0;
   FMaxHeight:=0;
   ControlStyle := ControlStyle + [csOpaque, csReplicatable];
   FWordWrap:=False;
   Parent:=AOwner as TWinControl; {???}
   FAcceptPosition:=False;
   DragCursor:=crMyCursor;
{   Cursor:=crHandPoint;}
   DragMode:=dmManual;
   FPath:='';
   Paint;
end;

procedure   TBPCustomLabel.Paint;
Var r:TRect;
    oldColor:TColor;
    oldColor1:TColor;
    uf:UINT;
    th:Integer;
    FText:String;
begin
 if FUpdating then Exit;
 oldColor1:=Canvas.Pen.Color;
 Canvas.Pen.Color:=clBlack;
 FText:=GetLabelText;
 r:=GetRectSize; { Get Caption rect }
 th:=0;
 if not(FAutoSize) then
  begin
  th:=r.Bottom-r.Top;
  if th > (FDefHeight) then th:=FDefHeight;
  r.Bottom:=r.Top+FDefHeight;
  case FVAlign of
   taTopJustify: th:=0;
   taVCenter:    th:=(FDefHeight-th) div 2;
   taBottomJustify: th:=FDefHeight-th;
  end;
 end;
 oldColor:=Canvas.Brush.Color;
 if not Transparent then
    begin
      r.Left:=0;
      r.Top:=0;
      r.Bottom:=r.Bottom;
      r.Right:=r.Right;
      Canvas.Brush.Color := Self.Color;
      Canvas.Brush.Style := bsSolid;
      Canvas.FillRect(r);
    end;
 Canvas.Brush.Style := bsClear; // Change it for transparent 
 width:=r.Right+1;
 Height:=r.Bottom+1;
 r.Left:=0;
 r.Top:=th;
 { Draw Caption }
 if FWordWrap then uf:=DT_WORDBREAK else uf:=0;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
{ DT_SINGLELINE or DT_WORDBREAK ); }
 Canvas.Brush.Color:=oldColor;
 Canvas.Pen.Color:=oldColor1;
end;

function   TBPCustomLabel.GetRectSize:TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
    FText:String;
begin
 {  Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
 FText:=GetLabelText;
 r.Left:=0;
 r.Top:=0;
 r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
{     }
 if FWordWrap then uf:=DT_WORDBREAK else uf:=0;
 uf:=uf or DT_CALCRECT;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 ht:=DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 r.Bottom:=ht+r.Top;
 FMaxWidth:=r.Right-r.Left;
 FMaxHeight:=r.Bottom-r.Top;
 if not(FAutoSize) then
   begin
     r.Right:=r.Left+FDefWidth;
   end;
 r.Right:=r.Right;
 result:=r;
end;

function  TBPCustomLabel.GetFont:TFont;
begin
 result:=Canvas.Font;
end;

procedure TBPCustomLabel.SetFont(Font:TFont);
begin
 Canvas.Font:=Font; {Changed 15.03.98 }
 if not(FUpdating) then Paint;
end;


procedure TBPCustomLabel.SetDefWidth(Value: Integer);
begin
 FDefWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPCustomLabel.SetDefHeight(Value: Integer);
begin
 FDefHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPCustomLabel.SetAutoSize(Value: Boolean);
begin
 FAutoSize:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPCustomLabel.SetHAlign(Value: TAlignment);
begin
 FHAlign:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPCustomLabel.SetVAlign(Value: TVAlignment);
begin
 FVAlign:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPCustomLabel.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = Parent) then
    Parent := nil;
end;

procedure TBPCustomLabel.Loaded;
begin
  inherited Loaded;
  if not(FUpdating) then Paint;
end;

procedure  TBPCustomLabel.SetFontDPI(Value:Integer);
begin
 Canvas.Font.PixelsPerInch:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPCustomLabel.SetTransparent(Value: Boolean);
begin
 if Transparent <> Value then
  begin
    if Value then
      ControlStyle := ControlStyle - [csOpaque] else
      ControlStyle := ControlStyle + [csOpaque];
    Invalidate;
  end;
end;

procedure TBPCustomLabel.SetWordWrap(Value: Boolean);
begin
 FWordWrap:=Value;
 if not(FUpdating) then Paint;
end;

{$A-}

end.
