unit BPNode;

{$A-}

{ Classes TBPGraphNode
         ,TBPDGraphNode
         ,TBPLSAGraphNode - rewritten }
{ Rewritten 14-09-98 }
{ Modified  06-08-02 }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,BPDef;

Const EM_FORMATRANGE                      = WM_USER + 57;


type

  TVAlignment =(taTopJustify,taVCenter,taBottomJustify);

  TDSShadowType = (shNone,shLeftBoxed,shLeftFramed,shTopPerspective,
   shInversePerspective,shRightBoxed,shRightFramed,shBottomPerspective);

  TDSRectStyle = (reNone,re1x,re2x,re3x,re4x,re2x3,re3x2,re2x4,re4x2,
                  re2x5,re5x2);

  TDSSelectType = (stNone,stLeft,stTop,stRight,stBottom);
    { None        0
      1x          1
      2x          2
      3x          3
      4x          4
      2x3         2 reSpace 3
        }


{ TBPGraphCustomNode definition }
  TBPGraphCustomNode = class(TGraphicControl)
  private
    { Private declarations }
    FSNodeNumber:ShortString;
    FNodeNumber:DWORD;
    FUpdating:Boolean;
     { Drawing Options }
    FPaintColor:TColor;   {    }
    FDrawColor:TColor;    {   }
    FShadowType:TDSShadowType; {   }
    FShadowColor:TColor;   {   }
    FShadowDepth:Integer;  {   }
    FRectStyle:TDSRectStyle; {  }
    FLineStyle:TPenStyle;    {     ;) }
    FLineWidth:Integer;      {    }
    FLineColor:TColor;
     {New options }
    FDefWidth:Integer;       {    }
    FDefHeight:Integer;      {    }
    FAutoHeight:Boolean;     {     }
    FAutoWidth:Boolean;      {     }
    FHSpacing:Integer;       {       }
    FVSpacing:Integer;       {       }
    FHAlign:TAlignment;      {    }
    FVAlign:TVAlignment;     {    -    FAutoHeight=False}
    {Internal variables}
    FIntervalLeft:Integer;
    FIntervalRight:Integer;
    FIntervalTop:Integer;
    FIntervalBottom:Integer;
    FShadowLeft:Integer;
    FShadowRight:Integer;
    FShadowTop:Integer;
    FShadowBottom:Integer;
    FMaxWidth:Integer;
    FMaxHeight:Integer;
    { Node Links accumulators }
    FTopToLeftCount:Integer;
    FTopToRightCount:Integer;
    FBottomToLeftCount:Integer;
    FBottomToRightCount:Integer;
    FLeftToTopCount:Integer;
    FLeftToBottomCount:Integer;
    FRightToTopCount:Integer;
    FRightToBottomCount:Integer;
    { Old accumulators }
    FTopLinksCount:Integer;
    FBottomLinksCount:Integer;
    FLeftLinksCount:Integer;
    FRightLinksCount:Integer;
    FFromUpLinksCount:Integer;
    FFromDownLinksCount:Integer;
    FToUpLinksCount:Integer;
    FToDownLinksCount:Integer;
    { Selection variables }
    FABCValue:Double;
    FDrawABCValue:Boolean;
    FAcceptPosition:Boolean;
    FLeftDragPos:Integer;
    FTopDragPos:Integer;
    FHasDecompose:Boolean;
    FFullCaption:String;
    {procedures & functions for Draw }
    procedure SetUpRect(r: TRect); { Draw Frame with RectStyle}
    procedure DrawRect(r:TRect;val1,val2:Integer); {Internal Subroutine}
    procedure DrawNodeNumber(r:TRect);
    procedure DrawABCValue(r:TRect);
    procedure DrawDecompose(left,top,size:Integer);
    function  GetRectSize:TRect; { fucking calculation function }
    function  GetFont:TFont;
    procedure SetFont(Font:TFont);
    procedure SetRectStyle(Value: TDSRectStyle);
    procedure SetRectInterval(Value: Integer); {Internal function}
    procedure SetDrawColor(Value: TColor);
    procedure SetLineStyle(Value: TPenStyle);
    procedure SetLineWidth(Value: Integer);
    procedure SetPaintColor(Value: TColor);
    procedure SetShadowColor(Value: TColor);
    procedure SetShadowType(Value: TDSShadowType);
    procedure SetShadowInterval(Left,Right,Top,Bottom:Integer); { Internal function}
    procedure SetShadowDepth(Value: Integer);
    procedure SetHasDecompose(Value: Boolean);
    procedure DrawShadow;
    procedure DrawShadowLeft(Diagonal:Boolean); {Internal function }
    procedure DrawShadowRight(Diagonal:Boolean);{Internal function }
    procedure DrawShadowTop; {Internal function }
    procedure DrawShadowBottom(Diagonal:Boolean;Orient:Integer); {Internal function }
    procedure SetDefWidth(Value: Integer);
    procedure SetDefHeight(Value: Integer);
    procedure SetAutoHeight(Value: Boolean);
    procedure SetAutoWidth(Value: Boolean);
    procedure SetHAlign(Value: TAlignment);
    procedure SetVAlign(Value: TVAlignment);
    procedure SetVSpacing(Value: Integer);
    procedure SetHSpacing(Value: Integer);
    procedure SetABCValue(Value:Double);
    { Procedures for tree }
    procedure SetLineColor(Value: TColor);
    procedure SetNodeNumber(Value: ShortString);
  protected
    { Protected declarations }
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure Paint; override;
    function  GetNodeText:String;
    function  GetMaxWord(const s:String):String;
    property LineWidth:Integer read FLineWidth write SetLineWidth default 1;
    property LineColor:TColor read FLineColor write SetLineColor default clBlack;
    property RectLineStyle:TPenStyle read FLineStyle write SetLineStyle;
    property RectColor:TColor read FDrawColor write SetDrawColor default clWindowText;
    property PaintColor:TColor read FPaintColor write SetPaintColor default clWindow;
    property ShadowColor:TColor read FShadowColor write SetShadowColor default clWindowText;
    property ShadowType:TDSShadowType read FShadowType write SetShadowType default shRightFramed;
    property ShadowDepth:Integer read FShadowDepth write SetShadowDepth default 4;
    property RectStyle:TDSRectStyle read FRectStyle write SetRectStyle;
    property Font:TFont read getFont write SetFont;
    property DefWidth:Integer read FDefWidth write SetDefWidth default 100;
    property DefHeight:Integer read FDefHeight write SetDefHeight default 100;
    property AutoHeight:Boolean read FAutoHeight write SetAutoHeight default True;
    property AutoWidth:Boolean read FAutoWidth write SetAutoWidth default True;
    property HSpacing:Integer read FHSpacing write SetHSpacing default 8;
    property VSpacing:Integer read FVSpacing write SetVSpacing default 8;
    property HAlign:TAlignment read FHAlign write SetHAlign default taCenter;
    property VAlign:TVAlignment read FVAlign write SetVAlign default taVCenter;
    property SNodeNumber:ShortString read FSNodeNumber write SetNodeNumber;
    property NodeNumber:DWORD read FNodeNumber write FNodeNumber default 0;
    property MaxWidth:Integer read FMaxWidth default 0;
    property MaxHeight:Integer read FMaxHeight default 0;

    property TopToLeftCount:Integer read FTopToLeftCount write FTopToLeftCount default 0;
    property BottomToLeftCount:Integer read FBottomToLeftCount write FBottomToLeftCount default 0;
    property LeftToTopCount:Integer read FLeftToTopCount write FLeftToTopCount default 0;
    property RightToTopCount:Integer read FRightToTopCount write FRightToTopCount default 0;
    property TopToRightCount:Integer read FTopToRightCount write FTopToRightCount default 0;
    property BottomToRightCount:Integer read FBottomToRightCount write FBottomToRightCount default 0;
    property LeftToBottomCount:Integer read FLeftToBottomCount write FLeftToBottomCount default 0;
    property RightToBottomCount:Integer read FRightToBottomCount write FRightToBottomCount default 0;

    property TopLinksCount:Integer read FTopLinksCount write FTopLinksCount default 0;
    property BottomLinksCount:Integer read FBottomLinksCount write FBottomLinksCount default 0;
    property LeftLinksCount:Integer read FLeftLinksCount write FLeftLinksCount default 0;
    property RightLinksCount:Integer read FRightLinksCount write FRightLinksCount default 0;
    property FromUpLinksCount:Integer read FFromUpLinksCount write FFromUpLinksCount default 0;
    property FromDownLinksCount:Integer read FFromDownLinksCount write FFromDownLinksCount default 0;
    property ToUpLinksCount:Integer read FToUpLinksCount write FToUpLinksCount default 0;
    property ToDownLinksCount:Integer read FToDownLinksCount write FToDownLinksCount default 0;

    property ABCValue:Double read FABCValue write SetABCValue;
    property AcceptPosition:Boolean read FAcceptPosition write FAcceptPosition default False;
    property LeftDragPos:Integer read FLeftDragPos write FLeftDragPos;
    property TopDragPos:Integer read FTopDragPos write FTopDragPos;
    property HasDecompose:Boolean read FHasDecompose write SetHasDecompose;
    property Updating:Boolean read FUpdating write FUpdating;
    property FullCaption:String read FFullCaption write FFullCaption;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);  override; { Create empty node }
    procedure   SetFontDPI(Value:Integer);
    procedure   PaintImmediate;
    property    Canvas;
    property    DragMode;
    property    DragCursor;
    property    OnDragDrop;
    property    OnDragOver;
    property    OnEndDrag;
    property    OnStartDrag;
    property    Tag;
    property    Cursor;
  end;


 TBPGraphNode = class (TBPGraphCustomNode)
   published
    property Caption;
    property NodeNumber;
    property SNodeNumber;
    property LineWidth;
    property LineColor;
    property RectLineStyle;
    property RectColor;
    property PaintColor;
    property ShadowColor;
    property ShadowType;
    property ShadowDepth;
    property RectStyle;
    property Font;
    property Canvas;
    property DefWidth;
    property DefHeight;
    property AutoHeight;
    property AutoWidth;
    property HSpacing;
    property VSpacing;
    property HAlign;
    property VAlign;
    property Color default clWhite;
    property Height default 30;
    property Width  default 50;
    property Visible;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property MaxWidth;
    property MaxHeight;
    property TopToLeftCount;
    property BottomToLeftCount;
    property LeftToTopCount;
    property RightToTopCount;
    property TopToRightCount;
    property BottomToRightCount;
    property LeftToBottomCount;
    property RightToBottomCount;
    property TopLinksCount;
    property BottomLinksCount;
    property LeftLinksCount;
    property RightLinksCount;
    property FromUpLinksCount;
    property FromDownLinksCount;
    property ToUpLinksCount;
    property ToDownLinksCount;
    property ABCValue;
    property AcceptPosition;
    property LeftDragPos;
    property TopDragPos;
    property HasDecompose;
    property Updating;
    property FullCaption;
 end;


 { TBPIPGraphCustomNode definition }
  TBPIPGraphCustomNode = class(TGraphicControl)
  private
    { Private declarations }
    FNodeNumber:DWORD;
    FUpdating:Boolean;
     { Drawing Options }
    FPaintColor:TColor;   {    }
    FDrawColor:TColor;    {   }
    FShadowType:TDSShadowType; {   }
    FShadowColor:TColor;   {   }
    FShadowDepth:Integer;  {   }
    FRectStyle:TDSRectStyle; {  }
    FLineStyle:TPenStyle;    {     ;) }
    FLineWidth:Integer;      {    }
    FLineColor:TColor;
     {New options }
    FDefWidth:Integer;       {    }
    FDefHeight:Integer;      {    }
    FAutoHeight:Boolean;     {     }
    FAutoWidth:Boolean;      {     }
    FHSpacing:Integer;       {       }
    FVSpacing:Integer;       {       }
    FHAlign:TAlignment;      {    }
    FVAlign:TVAlignment;     {    -    FAutoHeight=False}
    {Internal variables}
    FIntervalLeft:Integer;
    FIntervalRight:Integer;
    FIntervalTop:Integer;
    FIntervalBottom:Integer;
    FShadowLeft:Integer;
    FShadowRight:Integer;
    FShadowTop:Integer;
    FShadowBottom:Integer;
    FMaxWidth:Integer;
    FMaxHeight:Integer;
    { Node Links accumulators }
    FTopToLeftCount:Integer;
    FTopToRightCount:Integer;
    FBottomToLeftCount:Integer;
    FBottomToRightCount:Integer;
    FLeftToTopCount:Integer;
    FLeftToBottomCount:Integer;
    FRightToTopCount:Integer;
    FRightToBottomCount:Integer;
    { Old accumulators }
    FTopLinksCount:Integer;
    FBottomLinksCount:Integer;
    FLeftLinksCount:Integer;
    FRightLinksCount:Integer;
    FFromUpLinksCount:Integer;
    FFromDownLinksCount:Integer;
    FToUpLinksCount:Integer;
    FToDownLinksCount:Integer;
    { Selection variables }
    FAcceptPosition:Boolean;
    FLeftDragPos:Integer;
    FTopDragPos:Integer;
    FPath:ShortString;
    FFullCaption:String;
    {procedures & functions for Draw }
    procedure SetUpRect(r: TRect); { Draw Frame with RectStyle}
    procedure DrawRect(r:TRect;val1,val2:Integer); {Internal Subroutine}
    function  GetRectSize:TRect; { fucking calculation function }
    function  GetFont:TFont;
    procedure SetFont(Font:TFont);
    procedure SetRectStyle(Value: TDSRectStyle);
    procedure SetRectInterval(Value: Integer); {Internal function}
    procedure SetDrawColor(Value: TColor);
    procedure SetLineStyle(Value: TPenStyle);
    procedure SetLineWidth(Value: Integer);
    procedure SetPaintColor(Value: TColor);
    procedure SetShadowColor(Value: TColor);
    procedure SetShadowType(Value: TDSShadowType);
    procedure SetShadowInterval(Left,Right,Top,Bottom:Integer); { Internal function}
    procedure SetShadowDepth(Value: Integer);
    procedure DrawShadow;
    procedure DrawShadowLeft(Diagonal:Boolean); {Internal function }
    procedure DrawShadowRight(Diagonal:Boolean);{Internal function }
    procedure DrawShadowTop; {Internal function }
    procedure DrawShadowBottom(Diagonal:Boolean;Orient:Integer); {Internal function }
    procedure SetDefWidth(Value: Integer);
    procedure SetDefHeight(Value: Integer);
    procedure SetAutoHeight(Value: Boolean);
    procedure SetAutoWidth(Value: Boolean);
    procedure SetHAlign(Value: TAlignment);
    procedure SetVAlign(Value: TVAlignment);
    procedure SetVSpacing(Value: Integer);
    procedure SetHSpacing(Value: Integer);
    procedure SetLineColor(Value: TColor);
    function  HasPath:Boolean; 
  protected
    { Protected declarations }
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure Paint; override;
    function  GetNodeText:String;
    function  GetMaxWord(const s:String):String;
    property LineWidth:Integer read FLineWidth write SetLineWidth default 1;
    property LineColor:TColor read FLineColor write SetLineColor default clBlack;
    property RectLineStyle:TPenStyle read FLineStyle write SetLineStyle;
    property RectColor:TColor read FDrawColor write SetDrawColor default clWindowText;
    property PaintColor:TColor read FPaintColor write SetPaintColor default clWindow;
    property ShadowColor:TColor read FShadowColor write SetShadowColor default clWindowText;
    property ShadowType:TDSShadowType read FShadowType write SetShadowType default shRightFramed;
    property ShadowDepth:Integer read FShadowDepth write SetShadowDepth default 4;
    property RectStyle:TDSRectStyle read FRectStyle write SetRectStyle;
    property Font:TFont read getFont write SetFont;
    property DefWidth:Integer read FDefWidth write SetDefWidth default 100;
    property DefHeight:Integer read FDefHeight write SetDefHeight default 100;
    property AutoHeight:Boolean read FAutoHeight write SetAutoHeight default True;
    property AutoWidth:Boolean read FAutoWidth write SetAutoWidth default True;
    property HSpacing:Integer read FHSpacing write SetHSpacing default 8;
    property VSpacing:Integer read FVSpacing write SetVSpacing default 8;
    property HAlign:TAlignment read FHAlign write SetHAlign default taCenter;
    property VAlign:TVAlignment read FVAlign write SetVAlign default taVCenter;
    property NodeNumber:DWORD read FNodeNumber write FNodeNumber default 0;
    property MaxWidth:Integer read FMaxWidth default 0;
    property MaxHeight:Integer read FMaxHeight default 0;

    property TopLinksCount:Integer read FTopLinksCount write FTopLinksCount default 0;
    property BottomLinksCount:Integer read FBottomLinksCount write FBottomLinksCount default 0;
    property LeftLinksCount:Integer read FLeftLinksCount write FLeftLinksCount default 0;
    property RightLinksCount:Integer read FRightLinksCount write FRightLinksCount default 0;

    property AcceptPosition:Boolean read FAcceptPosition write FAcceptPosition default False;
    property LeftDragPos:Integer read FLeftDragPos write FLeftDragPos;
    property TopDragPos:Integer read FTopDragPos write FTopDragPos;
    property Path:ShortString read FPath write FPath;
    property IsPath:Boolean read HasPath;
    property Updating:Boolean read FUpdating write FUpdating;
    property FullCaption:String read FFUllCaption write FFullCaption;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);  override; { Create empty node }
    procedure   SetFontDPI(Value:Integer);
    procedure   PaintImmediate;
    property    Canvas;
    property    DragMode;
    property    DragCursor;
    property    OnDragDrop;
    property    OnDragOver;
    property    OnEndDrag;
    property    OnStartDrag;
    property    Tag;
    property    Cursor;
  end;


 TBPIPGraphNode = class (TBPIPGraphCustomNode)
   published
    property Caption;
    property NodeNumber;
    property LineWidth;
    property LineColor;
    property RectLineStyle;
    property RectColor;
    property PaintColor;
    property ShadowColor;
    property ShadowType;
    property ShadowDepth;
    property RectStyle;
    property Font;
    property Canvas;
    property DefWidth;
    property DefHeight;
    property AutoHeight;
    property AutoWidth;
    property HSpacing;
    property VSpacing;
    property HAlign;
    property VAlign;
    property Color default clWhite;
    property Height default 30;
    property Width  default 50;
    property Visible;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property MaxWidth;
    property MaxHeight;
    property AcceptPosition;
    property LeftDragPos;
    property TopDragPos;
    property TopLinksCount;
    property BottomLinksCount;
    property LeftLinksCount;
    property RightLinksCount;
    property Path;
    property IsPath;
    property Updating;
    property FullCaption;
 end;



  TBPDGraphNode = class(TGraphicControl)
  private
    { Private declarations }
    FSNodeNumber:ShortString;
    FUpdating:Boolean;
    FNodeNumber:DWORD;
    FText:String;                  {   ॢ  }
    FProjection:String;            { Projection text        }
    FWriteOrRead:Boolean;          { True on Write }
      { Drawing Options }
    FPaintColor:TColor;   {    }
    FDrawColor:TColor;    {   }
    FShadowType:TDSShadowType; {   }
    FShadowColor:TColor;   {   }
    FShadowDepth:Integer;  {   }
    FRectStyle:TDSRectStyle; {  }
    FLineStyle:TPenStyle;    {     ;) }
    FLineWidth:Integer;      {    }
    FLineColor:TColor;
     {New options }
    FDefWidth:Integer;       {    }
    FDefHeight:Integer;      {    }
    FMaxWidth:Integer;
    FMaxHeight:Integer;
    FPrjMaxHeight:Integer;
    FDefPrjHeight:Integer;
    FAutoHeight:Boolean;     {     }
    FAutoWidth:Boolean;      {     }
    FHSpacing:Integer;       {       }
    FVSpacing:Integer;       {       }
    FHAlign:TAlignment;      {    }
    FVAlign:TVAlignment;     {    -    FAutoHeight=False}
    {Internal variables}
    FIntervalLeft:Integer;
    FIntervalRight:Integer;
    FIntervalTop:Integer;
    FIntervalBottom:Integer;
    FShadowLeft:Integer;
    FShadowRight:Integer;
    FShadowTop:Integer;
    FShadowBottom:Integer;
    {}
    FHInterval:Integer;
    FVInterval:Integer;
    {}
    FFontDPI:Integer;
    {}
    FPrjFont:TFont;
    { New !!! }
    FTopLinksCount:Integer;
    FBottomLinksCount:Integer;
    FAcceptPosition:Boolean;
    FLeftDragPos:Integer;
    FTopDragPos:Integer;
    FLinkCount:Integer;
    FFullCaption:String;
    FFullProjection:String;
    {procedures & functions for Draw }
    procedure SetUpRect(r: TRect; SubLine:Boolean; SubY:Integer); { Draw Frame with RectStyle}
    procedure DrawRect(r:TRect;val1,val2:Integer; SubLine:Boolean; SubY:Integer); {Internal Subroutine}
    function  GetRectSize:TRect; { fucking calculation function }
    function  GetProjRectSize(left,top:Integer):TRect;
    function  GetFont:TFont;
    procedure SetFont(Font:TFont);
    function  GetPrjFont:TFont;
    procedure SetPrjFont(Font:TFont);
    procedure SetText(Value: String);
    function  GetText:String;
    procedure SetProjection(Value: String);
    function  GetProjection:String;
    procedure SetRectStyle(Value: TDSRectStyle);
    procedure SetRectInterval(Value: Integer); {Internal function}
    procedure SetDrawColor(Value: TColor);
    procedure SetLineStyle(Value: TPenStyle);
    procedure SetLineWidth(Value: Integer);
    procedure SetPaintColor(Value: TColor);
    procedure SetShadowColor(Value: TColor);
    procedure SetShadowType(Value: TDSShadowType);
    procedure SetShadowInterval(Left,Right,Top,Bottom:Integer); { Internal function}
    procedure SetShadowDepth(Value: Integer);
    procedure DrawShadow;
    procedure DrawShadowLeft(Diagonal:Boolean); {Internal function }
    procedure DrawShadowRight(Diagonal:Boolean);{Internal function }
    procedure DrawShadowTop; {Internal function }
    procedure DrawShadowBottom(Diagonal:Boolean;Orient:Integer); {Internal function }
    procedure SetDefWidth(Value: Integer);
    procedure SetDefHeight(Value: Integer);
    procedure SetDefPrjHeight(Value: Integer);
    procedure SetAutoHeight(Value: Boolean);
    procedure SetAutoWidth(Value: Boolean);
    procedure SetHAlign(Value: TAlignment);
    procedure SetVAlign(Value: TVAlignment);
    procedure SetVSpacing(Value: Integer);
    procedure SetHSpacing(Value: Integer);
    { Procedures for tree }
    function  GetSpaces(Count: Integer):String;
    procedure SetNode(lleft,ltop:Integer);
    {}
    procedure SetLineColor(Value: TColor);
    procedure SetNodeNumber(Value: ShortString);
  protected
    { Protected declarations }
    procedure Paint; override;
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
  public
    { Public declarations }
    procedure   SetFontCharset(ch:TFontCharset);
    constructor Create(AOwner: TComponent);  override; { Create empty node }
    destructor  Destroy; override;             { Call only for root entry }
    procedure  SetTreeColor(Value:TColor);
    procedure  SetFontDPI1(Handle:HDC);
    procedure  SetFontDPI(NewDPI:Integer);
    procedure  RestoreFontDPI;
    procedure  PaintImmediate;
  published
    { Published declarations }
    property Text:String read GetText write SetText;
    property Projection:String read GetProjection write SetProjection;
    property FullCaption:String read FFullCaption write FFullCaption;
    property FullProjection:String read FFullProjection write FFullProjection;
    property LineWidth:Integer read FLineWidth write SetLineWidth default 1;
    property LineColor:TColor read FLineColor write SetLineColor default clBlack;
    property RectLineStyle:TPenStyle read FLineStyle write SetLineStyle;
    property RectColor:TColor read FDrawColor write SetDrawColor default clWindowText;
    property PaintColor:TColor read FPaintColor write SetPaintColor default clWindow;
    property ShadowColor:TColor read FShadowColor write SetShadowColor default clWindowText;
    property ShadowType:TDSShadowType read FShadowType write SetShadowType default shRightFramed;
    property ShadowDepth:Integer read FShadowDepth write SetShadowDepth default 4;
    property Color default clWhite;
    property RectStyle:TDSRectStyle read FRectStyle write SetRectStyle;
    property Font:TFont read getFont write SetFont;
    property PrjFont:TFont read getPrjFont write SetPrjFont;
    property NodeNumber:DWORD read FNodeNumber write FNodeNumber;
    property SNodeNumber:ShortString read FSNodeNumber write SetNodeNumber;
    property AcceptPosition:Boolean read FAcceptPosition write FAcceptPosition default False;
    property LeftDragPos:Integer read FLeftDragPos write FLeftDragPos default 0;
    property TopDragPos:Integer read FTopDragPos write FTopDragPos default 0;
    property Height default 30;
    property Width  default 50;
    property Visible;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property Hint;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property HInterval:Integer read FHInterval write FHInterval default 10;
    property VInterval:Integer read FVInterval write FVInterval default 10;
    { New propeties }
    property DefWidth:Integer read FDefWidth write SetDefWidth default 100;
    property DefPrjHeight:Integer read FDefPrjHeight write SetDefPrjHeight default 100;
    property DefHeight:Integer read FDefHeight write SetDefHeight default 100;
    property AutoHeight:Boolean read FAutoHeight write SetAutoHeight default True;
    property AutoWidth:Boolean read FAutoWidth write SetAutoWidth default True;
    property HSpacing:Integer read FHSpacing write SetHSpacing default 8;
    property VSpacing:Integer read FVSpacing write SetVSpacing default 8;
    property HAlign:TAlignment read FHAlign write SetHAlign default taCenter;
    property VAlign:TVAlignment read FVAlign write SetVAlign default taVCenter;
    property MaxWidth:Integer read FMaxWidth default 0;
    property MaxHeight:Integer read FMaxHeight default 0;
    property PrjMaxHeight:Integer read FPrjMaxHeight default 0;
    property TopLinksCount:Integer read FTopLinksCount write FTopLinksCount default 0;
    property BottomLinksCount:Integer read FBottomLinksCount write FBottomLinksCount default 0;
    property WriteOrRead:Boolean read FWriteOrRead write FWriteOrRead default True;
    property Parent;
    property Left;
    property Top;
    property LinkCount:Integer read FLinkCount write FLinkCount default 0;
    property Updating:Boolean read FUpdating write FUpdating;
  end;

  TLSAShapeType=(lsa_Node,lsa_Junction);

{ TBPLSAGraphCustomNode definition }
  TBPLSAGraphCustomNode = class(TGraphicControl)
  private
    { Private declarations }
    FSNodeNumber:ShortString;
    FNodeNumber:DWORD;
    FShapeType:TLSAShapeType;
    FOutputCount:Integer;
    FUpdating:Boolean;
     { Drawing Options }
    FPaintColor:TColor;   {    }
    FDrawColor:TColor;    {   }
    FShadowType:TDSShadowType; {   }
    FShadowColor:TColor;   {   }
    FShadowDepth:Integer;  {   }
    FRectStyle:TDSRectStyle; {  }
    FLineStyle:TPenStyle;    {     ;) }
    FLineWidth:Integer;      {    }
    FLineColor:TColor;
     {New options }
    FDefWidth:Integer;       {    }
    FDefHeight:Integer;      {    }
    FAutoHeight:Boolean;     {     }
    FAutoWidth:Boolean;      {     }
    FHSpacing:Integer;       {       }
    FVSpacing:Integer;       {       }
    FHAlign:TAlignment;      {    }
    FVAlign:TVAlignment;     {    -    FAutoHeight=False}
    {Internal variables}
    FIntervalLeft:Integer;
    FIntervalRight:Integer;
    FIntervalTop:Integer;
    FIntervalBottom:Integer;
    FShadowLeft:Integer;
    FShadowRight:Integer;
    FShadowTop:Integer;
    FShadowBottom:Integer;
    FMaxWidth:Integer;
    FMaxHeight:Integer;
    FMinHeight:Integer;
    { Old accumulators }
    FLeftLinksCount:Integer;
    FRightLinksCount:Integer;
    FTopLinksCount:Integer;
    FBottomLinksCount:Integer;
    FInputLinksCount:Integer;
    FOutputLinksCount:Integer;
    { Selection variables }
    FAcceptPosition:Boolean;
    FLeftDragPos:Integer;
    FTopDragPos:Integer;
    FRightRegion:Integer;
    FLeftRegion:Integer;
    FTopRegion:Integer;
    FBottomRegion:Integer;
    FHW:Boolean;
    {procedures & functions for Draw }
    procedure SetUpRect(r: TRect); { Draw Frame with RectStyle}
    procedure DrawRect(r:TRect;val1,val2:Integer); {Internal Subroutine}
    function  GetRectSize:TRect; { fucking calculation function }
    function  GetFont:TFont;
    procedure SetFont(Font:TFont);
    procedure SetRectStyle(Value: TDSRectStyle);
    procedure SetRectInterval(Value: Integer); {Internal function}
    procedure SetDrawColor(Value: TColor);
    procedure SetLineStyle(Value: TPenStyle);
    procedure SetLineWidth(Value: Integer);
    procedure SetPaintColor(Value: TColor);
    procedure SetShadowColor(Value: TColor);
    procedure SetShadowType(Value: TDSShadowType);
    procedure SetShadowInterval(Left,Right,Top,Bottom:Integer); { Internal function}
    procedure SetShadowDepth(Value: Integer);
    procedure DrawShadow;
    procedure DrawShadowLeft(Diagonal:Boolean); {Internal function }
    procedure DrawShadowRight(Diagonal:Boolean);{Internal function }
    procedure DrawShadowTop; {Internal function }
    procedure DrawShadowBottom(Diagonal:Boolean;Orient:Integer); {Internal function }
    procedure SetDefWidth(Value: Integer);
    procedure SetDefHeight(Value: Integer);
    procedure SetAutoHeight(Value: Boolean);
    procedure SetAutoWidth(Value: Boolean);
    procedure SetHAlign(Value: TAlignment);
    procedure SetVAlign(Value: TVAlignment);
    procedure SetVSpacing(Value: Integer);
    procedure SetHSpacing(Value: Integer);
    { Procedures for tree }
    procedure SetLineColor(Value: TColor);
    procedure SetNodeNumber(Value: ShortString);
    procedure SetShapeType(Value:TLSAShapeType);
    procedure SetOutputCount(Value:Integer);
  protected
    { Protected declarations }
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure Paint; override;
    function  GetNodeText:String;
    function  GetMaxWord(const s:String):String;
    property LineWidth:Integer read FLineWidth write SetLineWidth default 1;
    property LineColor:TColor read FLineColor write SetLineColor default clBlack;
    property RectLineStyle:TPenStyle read FLineStyle write SetLineStyle;
    property RectColor:TColor read FDrawColor write SetDrawColor default clWindowText;
    property PaintColor:TColor read FPaintColor write SetPaintColor default clWindow;
    property ShadowColor:TColor read FShadowColor write SetShadowColor default clWindowText;
    property ShadowType:TDSShadowType read FShadowType write SetShadowType default shRightFramed;
    property ShadowDepth:Integer read FShadowDepth write SetShadowDepth default 4;
    property RectStyle:TDSRectStyle read FRectStyle write SetRectStyle;
    property Font:TFont read getFont write SetFont;
    property DefWidth:Integer read FDefWidth write SetDefWidth default 100;
    property DefHeight:Integer read FDefHeight write SetDefHeight default 100;
    property AutoHeight:Boolean read FAutoHeight write SetAutoHeight default True;
    property AutoWidth:Boolean read FAutoWidth write SetAutoWidth default True;
    property HSpacing:Integer read FHSpacing write SetHSpacing default 8;
    property VSpacing:Integer read FVSpacing write SetVSpacing default 8;
    property HAlign:TAlignment read FHAlign write SetHAlign default taCenter;
    property VAlign:TVAlignment read FVAlign write SetVAlign default taVCenter;
    property SNodeNumber:ShortString read FSNodeNumber write SetNodeNumber;
    property NodeNumber:DWORD read FNodeNumber write FNodeNumber default 0;
    property MaxWidth:Integer read FMaxWidth default 0;
    property MaxHeight:Integer read FMaxHeight default 0;

    property LeftLinksCount:Integer read FLeftLinksCount write FLeftLinksCount default 0;
    property RightLinksCount:Integer read FRightLinksCount write FRightLinksCount default 0;
    property TopLinksCount:Integer read FTopLinksCount write FTopLinksCount default 0;
    property BottomLinksCount:Integer read FBottomLinksCount write FBottomLinksCount default 0;
    property OutputLinksCount:Integer read FOutputLinksCOunt write FOutputLinksCount default 0;
    property InputLinksCount:Integer read FInputLinksCount write FInputLinksCount default 0;

    property OutputCount:Integer read FOutputCount write SetOutputCount default 0;

    property AcceptPosition:Boolean read FAcceptPosition write FAcceptPosition default False;
    property LeftDragPos:Integer read FLeftDragPos write FLeftDragPos;
    property TopDragPos:Integer read FTopDragPos write FTopDragPos;
    property ShapeType:TLSAShapeType read FShapeType write SetShapeType;
    property MinHeight:Integer read FMinHeight;
    property RightRegion:Integer read FRightRegion write FRightRegion default 0;
    property LeftRegion:Integer read FLeftRegion write FLeftRegion default 0;
    property TopRegion:Integer read FTopRegion write FTopRegion default 0;
    property BottomRegion:Integer read FBottomRegion write FBottomRegion default 0;
    property HW:Boolean read FHW;
    property Updating:Boolean read FUpdating write FUpdating;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);  override; { Create empty node }
    procedure   SetFontDPI(Value:Integer);
    procedure   PaintImmediate;
    property    Canvas;
    property    DragMode;
    property    DragCursor;
    property    OnDragDrop;
    property    OnDragOver;
    property    OnEndDrag;
    property    OnStartDrag;
    property    Tag;
    property    Cursor;
  end;


 TBPLSAGraphNode = class (TBPLSAGraphCustomNode)
   published
    property Caption;
    property NodeNumber;
    property SNodeNumber;
    property ShapeType;
    property MinHeight;
    property OutputCount;
    property LineWidth;
    property LineColor;
    property RectLineStyle;
    property RectColor;
    property PaintColor;
    property ShadowColor;
    property ShadowType;
    property ShadowDepth;
    property RectStyle;
    property Font;
    property Canvas;
    property DefWidth;
    property DefHeight;
    property AutoHeight;
    property AutoWidth;
    property HSpacing;
    property VSpacing;
    property HAlign;
    property VAlign;
    property Color default clWhite;
    property Height default 30;
    property Width  default 50;
    property Visible;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property MaxWidth;
    property MaxHeight;
    property LeftLinksCount;
    property RightLinksCount;
    property TopLinksCount;
    property BottomLinksCount;
    property InputLinksCount;
    property OutputLinksCount;
    property AcceptPosition;
    property LeftDragPos;
    property TopDragPos;
    property RightRegion;
    property LeftRegion;
    property TopRegion;
    property BottomRegion;
    property HW;
    property Updating;
 end;


Const reSpace=2;

implementation

{ TBPGraphCustomNode }


procedure TBPGraphCustomNode.SetHasDecompose(Value: Boolean);
 begin
   FHasDecompose:=Value;
   if not(FUpdating) then Paint;
 end;

function  TBPGraphCustomNode.GetNodeText:String;
begin
  Result:=Trim(Caption);
end;


procedure TBPGraphCustomNode.DrawDecompose(left,top,size:Integer);
Var oldColor:TColor;
    oldStyle:TPenStyle;
     i:Integer;
 begin
   with Canvas do
   begin
    oldColor:=Pen.Color;
    oldStyle:=Pen.Style;
    Pen.Color:=FDrawColor;
    Pen.Style:=psSolid;
    for i:=1 to size do
     begin
      MoveTo(left,i+top);
      LineTo(left+i,top);
     end;
    Pen.Style:=oldStyle;
    Pen.Color:=oldColor;
   end;
 end;

function  TBPGraphCustomNode.GetMaxWord(const s:String):String;
Var s1,word:String;
    i,j,maxLen:Integer;
 begin
   s1:=s;
   maxLen:=0;
   Result:='';
   if length(s1)=0 then Exit;
   i:=1;
   j:=1;
   while (i<=length(s1)) do
    begin
      while (i<=length(s1)) and (s1[i]<>' ') do
        begin
         inc(i);
        end;
       if (MaxLen<(i-j)) then
         begin
            MaxLen:=i-j;
            Result:=copy(s1,j,i-j);
         end;
     j:=i+1;
     inc(i);
    end;
 end;

constructor TBPGraphCustomNode.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FUpdating:=False;
   Color:=clWhite;
   FPaintColor:=clWindow;
   FDrawColor:=clWindowText;
   FShadowType:=shRightFramed;
   FShadowDepth:=4;
   FLineStyle:=psSolid;
   FLineWidth:=1;
   FIntervalLeft:=2*FLineWidth;
   FIntervalTop:=2*FLineWidth;
   FIntervalBottom:=2*FLineWidth;
   FIntervalRight:=2*FLineWidth;
   FShadowLeft:=0;
   FShadowRight:=0;
   FShadowTop:=0;
   FShadowBottom:=0;
   FRectStyle:=re2x;
   FShadowColor:=clWindowText;
   FDefWidth:=100;
   FDefHeight:=100;
   FAutoHeight:=True;
   FAutoWidth:=True;
   FHSpacing:=8;
   FVSpacing:=8;
   FHAlign:=taCenter;
   FVAlign:=taVCenter;
   FLineColor:=clBlack;
   FSNodeNumber:='';
   FNodeNumber:=0;
   FMaxWidth:=0;
   FMaxHeight:=0;
   FHasDecompose:=False;
   FTopToLeftCount:=0;
   FBottomToLeftCount:=0;
   FLeftToTopCount:=0;
   FRightToTopCount:=0;
   FTopToRightCount:=0;
   FBottomToRightCount:=0;
   FLeftToBottomCount:=0;
   FRightToBottomCount:=0;

   FTopLinksCount:=0;
   FBottomLinksCount:=0;
   FLeftLinksCount:=0;
   FRightLinksCount:=0;
   FFromUpLinksCount:=0;
   FFromDownLinksCount:=0;
   FToUpLinksCount:=0;
   FToDownLinksCount:=0;

   FABCValue:=0;
   FDrawABCValue:=False;
   Parent:=AOwner as TWinControl; {???}
   FAcceptPosition:=False;
   DragCursor:=crMyCursor;
   Cursor:=crHandPoint;
   DragMode:=dmManual;
   FLeftDragPos:=0;
   FTopDragPos:=0;
   Paint;
end;

procedure TBPGraphCustomNode.SetLineColor(Value: TColor);
begin
 FLineColor:=Value;
 if not(FUpdating) then Paint;
end;


function   TBPGraphCustomNode.GetRectSize:TRect;
Var
    r:TRect;
    ht:Integer;
    uf:UINT;
    FText:String;
    FMaxWord:String;
    mw:Integer;
    tmp:Integer;
begin
  FText:=GetNodeText;
  if Length(FText)<Length(FSNodeNumber) then FText:=FSNodeNumber;
  FMaxWord:=GetMaxWord(FText);
 {_ _ Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
 if length(FMaxWord)>0 then
 begin
 r.Left:=FIntervalLeft+FShadowLeft;
 r.Top:=FIntervalTop+FShadowTop;
 r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
 uf:=DT_CALCRECT or DT_SINGLELINE;
 ht:=DrawText(Canvas.Handle,Pchar(FMaxWord),length(FMaxWord),r,uf);
 mw:=r.Right-r.Left;
 end else mw:=0;
 r.Left:=FIntervalLeft+FShadowLeft;
 r.Top:=FIntervalTop+FShadowTop;
 if mw>0 then
  r.Right:=r.Left+Round(mw*1.1)
 else
  r.Right:=r.Left+FDefWidth;
 if not(FAutoWidth) then r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
{ +_  _ _ }
 uf:=DT_WORDBREAK or DT_CALCRECT;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 ht:=DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 r.Bottom:=ht+r.Top;
 FMaxWidth:=r.Right-r.Left;
 FMaxHeight:=r.Bottom-r.Top;
 if not(FAutoWidth) then
   begin
     r.Right:=r.Left+FDefWidth;
   end;
 r.Right:=r.Right+2*FHSpacing;
 result:=r;
end;


procedure  TBPGraphCustomNode.PaintImmediate;
 begin
   FUpdating:=False;
   Paint;
 end;

procedure   TBPGraphCustomNode.Paint;
Var r:TRect;
    oldColor:TColor;
    uf:UINT;
    th:Integer;
    FText:String;
    FNN:String;
    r1:TRect;
    i:Integer;
    oc:TColor;
    w,h:Integer;
    xxx,yyy,iii:Integer;
    cc:TColor;
    delta:Integer;
    tmp:Integer;
begin
 if FUpdating then Exit;
 FText:=GetNodeText;
 r:=GetRectSize; { Get Caption rect }
 if FAutoHeight then
  begin
   th:=FVSpacing;
   r.Bottom:=r.Bottom+3*FVSpacing;
  end
 else
  begin
  th:=r.Bottom-r.Top;
  if th > (FDefHeight) then th:=FDefHeight;
  r.Bottom:=r.Top+FDefHeight+3*FVSpacing;
  case FVAlign of
   taTopJustify: th:=FVSpacing;
   taVCenter:    th:=FVSpacing+(FDefHeight-th) div 2;
   taBottomJustify: th:= FVSpacing+FDefHeight-th;
  end;
 end;
 r.Left:=FShadowLeft;
 r.Top:=FShadowTop;
 r.Bottom:=r.Bottom+FIntervalBottom;
 r.Right:=r.Right+FIntervalRight;
 oldColor:=Canvas.Brush.Color;
 Canvas.Brush.Color:=FPaintColor;
 { New code }
 if FAutoWidth then
 begin
 r1.Top:=r.Bottom +FVSpacing + Round(1.2*Canvas.Font.Height) - (FVSpacing div 4);
 r1.Left:=((r.Right+r.Left) div 2) + ((r.Right-r.Left) div 16);
 r1.Bottom:=r.Bottom+ FVSpacing;
 r1.Right:=r.Right+FHSpacing;
 delta:=r1.Right;
 FNN:=SNodeNumber;
 uf:=DT_CALCRECT or DT_SINGLELINE;
 DrawText(Canvas.Handle,Pchar(FNN),length(FNN),r1,uf);
 delta:=r1.Right-delta;
 if delta>0 then
 begin
   r.Right:=r.Right+delta*2;
   FDefWidth:=FDefWidth+delta*2;
   Width:=Width+delta*2;
  end;
 end;
 { End New code }
 Canvas.FillRect(r);    { Fill with PaintColor }
 if FHasDecompose then DrawDecompose(r.Left,r.Top,(r.Right-r.Left) div 12);
 SetUpRect(r);          { Draw Frame with DrawColor }
 width:=r.Right+FShadowRight+1;
 Height:=r.Bottom+FShadowBottom+1;
 r.Left:=FIntervalLeft+FShadowLeft+FHSpacing;
 r.Top:=FIntervalTop+FShadowTop+th;
 r.Bottom:=r.Bottom-FIntervalBottom-FVSpacing;
 r.Right:=r.Right-FIntervalRight-FHSpacing;
 { Draw Caption }
 uf:=DT_WORDBREAK;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 r1.Top:=r.Bottom +FVSpacing + Round(1.2*Canvas.Font.Height) - (FVSpacing div 4);
 r1.Left:=((r.Right+r.Left) div 2) + ((r.Right-r.Left) div 16);
 r1.Bottom:=r.Bottom+ FVSpacing;
 r1.Right:=r.Right+FHSpacing;
 yyy:=r1.Top -(FVSpacing div 4)-FLineWidth;
 xxx:=(r.Left+r.Right) div 2;
 cc:=Canvas.Pen.Color;
 Canvas.Pen.Color:=FDrawColor;
 For iii:=0 to (FLineWidth-1) do
  begin
   if FDrawABCValue then
    begin
     Canvas.MoveTo(r.Left-FHSpacing,yyy+iii);
     Canvas.LineTo(r.Right+FHSpacing+1,yyy+iii);
     Canvas.MoveTo(xxx+iii,yyy);
     Canvas.LineTo(xxx+iii,r.Bottom+FVSpacing+1);
    end;
  end;
 Canvas.Pen.Color:=cc;
 DrawNodeNumber(r1);
 r1.Top:=r.Bottom +FVSpacing + Round(1.2*Canvas.Font.Height) - (FVSpacing div 4);
 r1.Bottom:=r.Bottom+ FVSpacing;
 r1.Right:=xxx- ((r.Right-r.Left) div 16);
 r1.Left:=r.Left-FHSpacing;
 if FDrawABCValue then DrawABCValue(r1);
{ DT_SINGLELINE or DT_WORDBREAK ); }
 DrawShadow;
 Canvas.Brush.Color:=oldColor;
end;



procedure TBPGraphCustomNode.DrawABCValue(r:TRect);
Var s:String;
 begin
   s:=Format('%f',[FABCValue]);
   DrawText(Canvas.Handle,Pchar(s),length(s),r,DT_RIGHT);
 end;

procedure TBPGraphCustomNode.DrawNodeNumber(r:TRect);
Var s:String;
 begin
   s:=FSNodeNumber;
   DrawText(Canvas.Handle,Pchar(s),length(s),r,DT_CENTER);
 end;

procedure   TBPGraphCustomNode.DrawRect(r:TRect;val1,val2:Integer);
Var i,j:Integer;
begin
 with Canvas do
  begin
   for j:=0 to Val1 do
    begin
      if (j<Val2) or (j>(Val2+reSpace-1)) then
        Pen.Color:=FDrawColor else Pen.Color:=FPaintColor;
     for i:=0 to (FLineWidth-1) do
      begin
       MoveTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
      end;
     end;
   end;
end;

procedure   TBPGraphCustomNode.SetUpRect(r: TRect);
Var oldColor:TColor;
    oc:TColor;
begin
{     }
 with Canvas do
  begin
   oldColor:=Pen.Color;
   oc:=FDrawColor;
   Pen.Color:=FDrawColor;
   Pen.Style:=FLineStyle;
   case FRectStyle of
    reNone: begin end;
    re1x: DrawRect(r,0,1);
    re2x: DrawRect(r,1,2);
    re3x: DrawRect(r,2,3);
    re4x: DrawRect(r,3,4);
    re2x3: DrawRect(r,4+reSpace,2);
    re3x2: DrawRect(r,4+reSpace,3);
    re2x4: DrawRect(r,5+reSpace,2);
    re4x2: DrawRect(r,5+reSpace,4);
    re2x5: DrawRect(r,6+reSpace,2);
    re5x2: DrawRect(r,6+reSpace,5);
   end;
   FDrawColor:=oc;
   Pen.Color:=oldColor;
  end;
end;

function  TBPGraphCustomNode.GetFont:TFont;
begin
 result:=Canvas.Font;
end;

procedure TBPGraphCustomNode.SetFont(Font:TFont);
begin
 Canvas.Font:=Font; {Changed 15.03.98 }
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetRectInterval(Value: Integer);
begin
 FIntervalLeft:=FLineWidth*Value;
 FIntervalRight:=FLineWidth*Value;
 FIntervalTop:=FLineWidth*Value;
 FIntervalBottom:=FLineWidth*Value;
end;

procedure TBPGraphCustomNode.SetRectStyle(Value: TDSRectStyle);
begin
 case Value of
  reNone:     SetRectInterval(0);
  re1x:       SetRectInterval(1);
  re2x:       SetRectInterval(2);
  re3x:       SetRectInterval(3);
  re4x:       SetRectInterval(4);
  re2x3,re3x2: SetRectInterval(5+reSpace);
  re2x4,re4x2: SetRectInterval(6+reSpace);
  re2x5,re5x2: SetRectInterval(7+reSpace);
 end;
 FRectStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetDrawColor(Value: TColor);
begin
 FDrawColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetLineStyle(Value: TPenStyle);
begin
 FLineStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetLineWidth(Value: Integer);
begin
 FLineWidth:=Value;
 SetRectStyle(FRectStyle);
end;

procedure TBPGraphCustomNode.SetPaintColor(Value: TColor);
begin
 FPaintColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetShadowColor(Value: TColor);
begin
 FShadowColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetShadowInterval(Left,Right,Top,Bottom:Integer);
begin
 FShadowLeft:=FLineWidth*Left;
 FShadowRight:=FLineWidth*Right;
 FShadowTop:=FLineWidth*Top;
 FShadowBottom:=FLineWidth*Bottom;
end;

procedure TBPGraphCustomNode.SetShadowType(Value: TDSShadowType);
begin
 FShadowType:=Value;
 case Value of
  shNone:                 SetShadowInterval(0,0,0,0);
  shLeftBoxed:            SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shLeftFramed:           SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shTopPerspective:       SetShadowInterval(0,0,0,FShadowDepth);
  shInversePerspective:   SetShadowInterval(FShadowDepth,FShadowDepth,0,FShadowDepth);
  shRightBoxed:           SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shRightFramed:          SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shBottomPerspective:    SetShadowInterval(0,0,FShadowDepth,0);
 end;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetShadowDepth(Value: Integer);
begin
 FShadowDepth:=Value;
 SetShadowType(FShadowType);
end;


procedure TBPGraphCustomNode.DrawShadowBottom(Diagonal:Boolean;Orient:Integer);
Var r:TRect;
    h,w:Integer;
    i:Integer;
begin
{ Orient 0  - Left
         1  - Center
         2  - Right }
 with Canvas do
  Begin
   h:=self.Height;
   w:=self.Width;
   r.Left:=FShadowLeft;
   r.Top:=h-FShadowBottom;
   r.Right:=w-FShadowRight;
   r.Bottom:=h;
   Brush.Color:=self.Color;
   FillRect(r);
   Pen.Color:=FShadowColor;
    if Diagonal then
       begin
        {Diagonal}
         case Orient of
          0: {Left}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowLeft,h-i);
                   LineTo(w-FShadowLeft+i,h-i);
                 end;
              end;
          1: {Center}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowBottom-i,h-i);
                   LineTo(w-FShadowBottom+i,h-i);
                 end;
              end;
          2: {Right}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowRight-i,h-i);
                   LineTo(w-FShadowRight,h-i);
                 end;
              end;
         end;
       end
     else
       begin
         case Orient of
          0: {Left}
              begin
               r.Right:=w-FShadowLeft;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          1: {Center}
              begin
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          2: {Right}
              begin
               r.Left:=FShadowRight;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
         end;
       end;
  end;
end;

procedure TBPGraphCustomNode.DrawShadowTop;
Var r:TRect;
    i:Integer;
    w:Integer;
begin
{}
 with Canvas do
  begin
   w:=self.Width;
   r.Left:=0;
   r.Top:=0;
   r.Right:=w;
   r.Bottom:=FShadowTop;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
    for i:=0 to (FShadowTop) do
       begin
         MoveTo(FShadowTop-i,i);
         LineTo(w-FShadowTop+i,i);
       end;
  end;
end;

procedure TBPGraphCustomNode.DrawShadowLeft(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h:Integer;
begin
 with Canvas do
 begin
   h:=self.Height;
   r.Left:=0;
   r.Top:=0;
   r.Right:=FShadowLeft;
   r.Bottom:=self.Height;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
 if Diagonal then
  begin
   {Left Diagonal Shadow}
    for i:=0 to (FShadowLeft-1) do
     begin
      MoveTo(i,FShadowLeft-i);
      LineTo(i,h);
     end;
  end
 else
  begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
  end;
 end;
end;

procedure TBPGraphCustomNode.DrawShadowRight(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h,w:Integer;
begin
 with Canvas do
 begin
    w:=self.width;
    h:=self.Height;
    r.Left:=w-FShadowRight;
    r.Top:=0;
    r.Right:=w;
    r.Bottom:=self.Height;
    Brush.Color:=self.Color;
    Pen.Color:=FShadowColor;
    FillRect(r);
 if Diagonal then
  begin
   {Right Diagonal Shadow}
    for i:=0 to (FShadowRight-1) do
     begin
      MoveTo(w-FShadowRight+i,i);
      LineTo(w-FShadowRight+i,h);
     end;
  end
 else
   begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
   end;
 end;
end;

procedure TBPGraphCustomNode.DrawShadow;
Var oldColor,oldColor1:TColor;
    penStyle:TPenStyle;
begin
{}
 with Canvas do
 begin
 oldColor:=Brush.Color;
 oldColor1:=Pen.Color;
 penStyle:=Pen.Style;
 Pen.Style:=psSolid;
 case FShadowType of
  shNone:                 begin end;
  shLeftBoxed:            begin
                            DrawShadowLeft(True);
                            DrawShadowBottom(True,0);
                          end;
  shLeftFramed:           begin
                            DrawShadowLeft(False);
                            DrawShadowBottom(False,0);
                          end;
  shTopPerspective:       DrawShadowBottom(True,1);
  shInversePerspective:   begin
                           DrawShadowLeft(True);
                           DrawShadowRight(True);
                           DrawShadowBottom(False,1);
                          end;
  shRightBoxed:           begin
                           DrawShadowRight(True);
                           DrawShadowBottom(True,2);
                          end;
  shRightFramed:          begin
                           DrawShadowRight(False);
                           DrawShadowBottom(False,2);
                          end;
  shBottomPerspective:    DrawShadowTop;

 end;
  Pen.Style:=penStyle;
  Pen.Color:=oldColor1;
  Brush.Color:=oldColor;
 end;
end;

procedure TBPGraphCustomNode.SetDefWidth(Value: Integer);
begin
 FDefWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetDefHeight(Value: Integer);
begin
 FDefHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetAutoHeight(Value: Boolean);
begin
 FAutoHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetAutoWidth(Value: Boolean);
begin
 FAutoWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetHAlign(Value: TAlignment);
begin
 FHAlign:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPGraphCustomNode.SetVAlign(Value: TVAlignment);
begin
 FVAlign:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetNodeNumber(Value: ShortString);
begin
 FSNodeNumber:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPGraphCustomNode.SetVSpacing(Value: Integer);
begin
 FVSpacing:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPGraphCustomNode.SetHSpacing(Value: Integer);
begin
 FHSpacing:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = Parent) then
    Parent := nil;
end;

procedure TBPGraphCustomNode.Loaded;
begin
  inherited Loaded;
  if not(FUpdating) then Paint;
end;


procedure  TBPGraphCustomNode.SetFontDPI(Value:Integer);
begin
 Canvas.Font.PixelsPerInch:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPGraphCustomNode.SetABCValue(Value:Double);
 begin
   FABCValue:=Value;
   if Value=0 then FDrawABCValue:=False else FDrawABCValue:=True;
   if not(FUpdating) then Paint;
 end;


 { TBPIPGraphCustomNode }

function  TBPIPGraphCustomNode.HasPath:Boolean;
 begin
  Result:=(Length(FPath)>0);
 end;

function  TBPIPGraphCustomNode.GetNodeText:String;
begin
  Result:=Trim(Caption);
end;

function  TBPIPGraphCustomNode.GetMaxWord(const s:String):String;
Var s1,word:String;
    i,j,maxLen:Integer;
 begin
   s1:=s;
   maxLen:=0;
   Result:='';
   if length(s1)=0 then Exit;
   i:=1;
   j:=1;
   while (i<=length(s1)) do
    begin
      while (i<=length(s1)) and (s1[i]<>' ') do
        begin
         inc(i);
        end;
       if (MaxLen<(i-j)) then
         begin
            MaxLen:=i-j;
            Result:=copy(s1,j,i-j);
         end;
     j:=i+1;
     inc(i);
    end;
 end;

constructor TBPIPGraphCustomNode.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FUpdating:=False;
   FPath:='';
   Color:=clWhite;
   FPaintColor:=clWindow;
   FDrawColor:=clWindowText;
   FShadowType:=shRightFramed;
   FShadowDepth:=4;
   FLineStyle:=psSolid;
   FLineWidth:=1;
   FIntervalLeft:=2*FLineWidth;
   FIntervalTop:=2*FLineWidth;
   FIntervalBottom:=2*FLineWidth;
   FIntervalRight:=2*FLineWidth;
   FShadowLeft:=0;
   FShadowRight:=0;
   FShadowTop:=0;
   FShadowBottom:=0;
   FRectStyle:=re2x;
   FShadowColor:=clWindowText;
   FDefWidth:=100;
   FDefHeight:=100;
   FAutoHeight:=True;
   FAutoWidth:=True;
   FHSpacing:=8;
   FVSpacing:=8;
   FHAlign:=taCenter;
   FVAlign:=taVCenter;
   FLineColor:=clBlack;
   FNodeNumber:=0;
   FMaxWidth:=0;
   FMaxHeight:=0;
   FTopLinksCount:=0;
   FBottomLinksCount:=0;
   FLeftLinksCount:=0;
   FRightLinksCount:=0;
   Parent:=AOwner as TWinControl; {???}
   FAcceptPosition:=False;
   DragCursor:=crMyCursor;
   Cursor:=crHandPoint;
   DragMode:=dmManual;
   Paint;
end;

procedure TBPIPGraphCustomNode.SetLineColor(Value: TColor);
begin
 FLineColor:=Value;
 if not(FUpdating) then Paint;
end;




procedure   TBPIPGraphCustomNode.Paint;
Var r:TRect;
    oldColor:TColor;
    uf:UINT;
    th:Integer;
    FText:String;
    FNN:String;
    r1:TRect;
    i:Integer;
    oc:TColor;
    w,h:Integer;
    cc:TColor;
    delta:Integer;
    tmp:Integer;
begin
 if FUpdating then Exit;
 FText:=GetNodeText;
 r:=GetRectSize; { Get Caption rect }
 if FAutoHeight then
  begin
   th:=FVSpacing;
   r.Bottom:=r.Bottom+3*FVSpacing;
  end
 else
  begin
  th:=r.Bottom-r.Top;
  if th > (FDefHeight) then th:=FDefHeight;
  r.Bottom:=r.Top+FDefHeight+2*FVSpacing;
  case FVAlign of
   taTopJustify: th:=FVSpacing;
   taVCenter:    th:=FVSpacing+(FDefHeight-th) div 2;
   taBottomJustify: th:= FVSpacing+FDefHeight-th;
  end;
 end;
 r.Left:=FShadowLeft;
 r.Top:=FShadowTop;
 r.Bottom:=r.Bottom+FIntervalBottom;
 r.Right:=r.Right+FIntervalRight;
 oldColor:=Canvas.Brush.Color;
 Canvas.Brush.Color:=FPaintColor;
 Canvas.FillRect(r);    { Fill with PaintColor }
 SetUpRect(r);          { Draw Frame with DrawColor }
 width:=r.Right+FShadowRight+1;
 Height:=r.Bottom+FShadowBottom+1;
 r.Left:=FIntervalLeft+FShadowLeft+FHSpacing;
 r.Top:=FIntervalTop+FShadowTop+th;
 r.Bottom:=r.Bottom-FIntervalBottom-FVSpacing;
 r.Right:=r.Right-FIntervalRight-FHSpacing;
 { Draw Caption }
 uf:=DT_SINGLELINE;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 DrawShadow;
 Canvas.Brush.Color:=oldColor;
end;



procedure   TBPIPGraphCustomNode.DrawRect(r:TRect;val1,val2:Integer);
Var i,j:Integer;
begin
 with Canvas do
  begin
   for j:=0 to Val1 do
    begin
      if (j<Val2) or (j>(Val2+reSpace-1)) then
        Pen.Color:=FDrawColor else Pen.Color:=FPaintColor;
     for i:=0 to (FLineWidth-1) do
      begin
       MoveTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
      end;
     end;
   end;
end;

procedure   TBPIPGraphCustomNode.SetUpRect(r: TRect);
Var oldColor:TColor;
    oc:TColor;
begin
{     }
 with Canvas do
  begin
   oldColor:=Pen.Color;
   oc:=FDrawColor;
   Pen.Color:=FDrawColor;
   Pen.Style:=FLineStyle;
   case FRectStyle of
    reNone: begin end;
    re1x: DrawRect(r,0,1);
    re2x: DrawRect(r,1,2);
    re3x: DrawRect(r,2,3);
    re4x: DrawRect(r,3,4);
    re2x3: DrawRect(r,4+reSpace,2);
    re3x2: DrawRect(r,4+reSpace,3);
    re2x4: DrawRect(r,5+reSpace,2);
    re4x2: DrawRect(r,5+reSpace,4);
    re2x5: DrawRect(r,6+reSpace,2);
    re5x2: DrawRect(r,6+reSpace,5);
   end;
   FDrawColor:=oc;
   Pen.Color:=oldColor;
  end;
end;


function   TBPIPGraphCustomNode.GetRectSize:TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
    FText:String;
    FMaxWord:String;
    mw:Integer;
    tmp:Integer;
begin
  FText:=GetNodeText;
  r.Left:=FIntervalLeft+FShadowLeft;
  r.Top:=FIntervalTop+FShadowTop;
  r.Right:=r.Left+FDefWidth;
  r.Bottom:=Parent.ClientRect.Bottom;
{ +_  _ _ }
 uf:=DT_SINGLELINE or DT_CALCRECT;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 ht:=DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 r.Bottom:=ht+r.Top;
 FMaxWidth:=r.Right-r.Left;
 FMaxHeight:=r.Bottom-r.Top;
 if not(FAutoWidth) then
   begin
     r.Right:=r.Left+FDefWidth;
   end;
 r.Right:=r.Right+2*FHSpacing;
 result:=r;
end;



function  TBPIPGraphCustomNode.GetFont:TFont;
begin
 result:=Canvas.Font;
end;

procedure TBPIPGraphCustomNode.SetFont(Font:TFont);
begin
 Canvas.Font:=Font; {Changed 15.03.98 }
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetRectInterval(Value: Integer);
begin
 FIntervalLeft:=FLineWidth*Value;
 FIntervalRight:=FLineWidth*Value;
 FIntervalTop:=FLineWidth*Value;
 FIntervalBottom:=FLineWidth*Value;
end;

procedure TBPIPGraphCustomNode.SetRectStyle(Value: TDSRectStyle);
begin
 case Value of
  reNone:     SetRectInterval(0);
  re1x:       SetRectInterval(1);
  re2x:       SetRectInterval(2);
  re3x:       SetRectInterval(3);
  re4x:       SetRectInterval(4);
  re2x3,re3x2: SetRectInterval(5+reSpace);
  re2x4,re4x2: SetRectInterval(6+reSpace);
  re2x5,re5x2: SetRectInterval(7+reSpace);
 end;
 FRectStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetDrawColor(Value: TColor);
begin
 FDrawColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetLineStyle(Value: TPenStyle);
begin
 FLineStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetLineWidth(Value: Integer);
begin
 FLineWidth:=Value;
 SetRectStyle(FRectStyle);
end;

procedure TBPIPGraphCustomNode.SetPaintColor(Value: TColor);
begin
 FPaintColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetShadowColor(Value: TColor);
begin
 FShadowColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetShadowInterval(Left,Right,Top,Bottom:Integer);
begin
 FShadowLeft:=FLineWidth*Left;
 FShadowRight:=FLineWidth*Right;
 FShadowTop:=FLineWidth*Top;
 FShadowBottom:=FLineWidth*Bottom;
end;

procedure TBPIPGraphCustomNode.SetShadowType(Value: TDSShadowType);
begin
 FShadowType:=Value;
 case Value of
  shNone:                 SetShadowInterval(0,0,0,0);
  shLeftBoxed:            SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shLeftFramed:           SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shTopPerspective:       SetShadowInterval(0,0,0,FShadowDepth);
  shInversePerspective:   SetShadowInterval(FShadowDepth,FShadowDepth,0,FShadowDepth);
  shRightBoxed:           SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shRightFramed:          SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shBottomPerspective:    SetShadowInterval(0,0,FShadowDepth,0);
 end;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetShadowDepth(Value: Integer);
begin
 FShadowDepth:=Value;
 SetShadowType(FShadowType);
end;


procedure TBPIPGraphCustomNode.DrawShadowBottom(Diagonal:Boolean;Orient:Integer);
Var r:TRect;
    h,w:Integer;
    i:Integer;
begin
{ Orient 0  - Left
         1  - Center
         2  - Right }
 with Canvas do
  Begin
   h:=self.Height;
   w:=self.Width;
   r.Left:=FShadowLeft;
   r.Top:=h-FShadowBottom;
   r.Right:=w-FShadowRight;
   r.Bottom:=h;
   Brush.Color:=self.Color;
   FillRect(r);
   Pen.Color:=FShadowColor;
    if Diagonal then
       begin
        {Diagonal}
         case Orient of
          0: {Left}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowLeft,h-i);
                   LineTo(w-FShadowLeft+i,h-i);
                 end;
              end;
          1: {Center}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowBottom-i,h-i);
                   LineTo(w-FShadowBottom+i,h-i);
                 end;
              end;
          2: {Right}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowRight-i,h-i);
                   LineTo(w-FShadowRight,h-i);
                 end;
              end;
         end;
       end
     else
       begin
         case Orient of
          0: {Left}
              begin
               r.Right:=w-FShadowLeft;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          1: {Center}
              begin
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          2: {Right}
              begin
               r.Left:=FShadowRight;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
         end;
       end;
  end;
end;

procedure TBPIPGraphCustomNode.DrawShadowTop;
Var r:TRect;
    i:Integer;
    w:Integer;
begin
{}
 with Canvas do
  begin
   w:=self.Width;
   r.Left:=0;
   r.Top:=0;
   r.Right:=w;
   r.Bottom:=FShadowTop;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
    for i:=0 to (FShadowTop) do
       begin
         MoveTo(FShadowTop-i,i);
         LineTo(w-FShadowTop+i,i);
       end;
  end;
end;

procedure TBPIPGraphCustomNode.DrawShadowLeft(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h:Integer;
begin
 with Canvas do
 begin
   h:=self.Height;
   r.Left:=0;
   r.Top:=0;
   r.Right:=FShadowLeft;
   r.Bottom:=self.Height;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
 if Diagonal then
  begin
   {Left Diagonal Shadow}
    for i:=0 to (FShadowLeft-1) do
     begin
      MoveTo(i,FShadowLeft-i);
      LineTo(i,h);
     end;
  end
 else
  begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
  end;
 end;
end;

procedure TBPIPGraphCustomNode.DrawShadowRight(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h,w:Integer;
begin
 with Canvas do
 begin
    w:=self.width;
    h:=self.Height;
    r.Left:=w-FShadowRight;
    r.Top:=0;
    r.Right:=w;
    r.Bottom:=self.Height;
    Brush.Color:=self.Color;
    Pen.Color:=FShadowColor;
    FillRect(r);
 if Diagonal then
  begin
   {Right Diagonal Shadow}
    for i:=0 to (FShadowRight-1) do
     begin
      MoveTo(w-FShadowRight+i,i);
      LineTo(w-FShadowRight+i,h);
     end;
  end
 else
   begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
   end;
 end;
end;

procedure TBPIPGraphCustomNode.DrawShadow;
Var oldColor,oldColor1:TColor;
    penStyle:TPenStyle;
begin
{}
 with Canvas do
 begin
 oldColor:=Brush.Color;
 oldColor1:=Pen.Color;
 penStyle:=Pen.Style;
 Pen.Style:=psSolid;
 case FShadowType of
  shNone:                 begin end;
  shLeftBoxed:            begin
                            DrawShadowLeft(True);
                            DrawShadowBottom(True,0);
                          end;
  shLeftFramed:           begin
                            DrawShadowLeft(False);
                            DrawShadowBottom(False,0);
                          end;
  shTopPerspective:       DrawShadowBottom(True,1);
  shInversePerspective:   begin
                           DrawShadowLeft(True);
                           DrawShadowRight(True);
                           DrawShadowBottom(False,1);
                          end;
  shRightBoxed:           begin
                           DrawShadowRight(True);
                           DrawShadowBottom(True,2);
                          end;
  shRightFramed:          begin
                           DrawShadowRight(False);
                           DrawShadowBottom(False,2);
                          end;
  shBottomPerspective:    DrawShadowTop;

 end;
  Pen.Style:=penStyle;
  Pen.Color:=oldColor1;
  Brush.Color:=oldColor;
 end;
end;

procedure TBPIPGraphCustomNode.SetDefWidth(Value: Integer);
begin
 FDefWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetDefHeight(Value: Integer);
begin
 FDefHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetAutoHeight(Value: Boolean);
begin
 FAutoHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetAutoWidth(Value: Boolean);
begin
 FAutoWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.SetHAlign(Value: TAlignment);
begin
 FHAlign:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPIPGraphCustomNode.SetVAlign(Value: TVAlignment);
begin
 FVAlign:=Value;
 if not(FUpdating) then Paint;
end;


procedure TBPIPGraphCustomNode.SetVSpacing(Value: Integer);
begin
 FVSpacing:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPIPGraphCustomNode.SetHSpacing(Value: Integer);
begin
 FHSpacing:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = Parent) then
    Parent := nil;
end;

procedure TBPIPGraphCustomNode.Loaded;
begin
  inherited Loaded;
  if not(FUpdating) then Paint;
end;

procedure TBPIPGraphCustomNode.PaintImmediate;
 begin
   FUpdating:=False;
   Paint;
 end;


procedure  TBPIPGraphCustomNode.SetFontDPI(Value:Integer);
begin
 Canvas.Font.PixelsPerInch:=Value;
 if not(FUpdating) then Paint;
end;



{ TBPDGraphNode }

procedure TBPDGraphNode.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = Parent) then
    Parent := nil;
end;

procedure TBPDGraphNode.Loaded;
begin
  inherited Loaded;
  if not(FUpdating) then Paint;
end;


procedure   TBPDGraphNode.SetFontCharset(ch:TFontCharset);
begin
 Font.Charset:=ch;
end;


procedure  TBPDGraphNode.SetTreeColor(Value:TColor);
begin
 color:=Value;
end;

procedure TBPDGraphNode.SetProjection(Value: String);
Var s:String;
 begin
   s:=Value;
   s:=TrimLeft(s);
   FProjection:=s;
   if not(FUpdating) then Paint;
 end;

function  TBPDGraphNode.GetProjection:String;
 begin
   Result:=FProjection;
 end;

procedure TBPDGraphNode.SetNodeNumber(Value: ShortString);
begin
 FSNodeNumber:=Value;
 if not(FUpdating) then  Paint;
end;


constructor TBPDGraphNode.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FUpdating:=False;
   Color:=clWhite;
   FPaintColor:=clWindow;
   FDrawColor:=clWindowText;
   FShadowType:=shRightFramed;
   FShadowDepth:=4;
   FLineStyle:=psSolid;
   FLineWidth:=1;
   FIntervalLeft:=2*FLineWidth;
   FIntervalTop:=2*FLineWidth;
   FIntervalBottom:=2*FLineWidth;
   FIntervalRight:=2*FLineWidth;
   FShadowLeft:=0;
   FShadowRight:=0;
   FShadowTop:=0;
   FShadowBottom:=0;
   FRectStyle:=re2x;
   FText:='';
   FProjection:='';
   FWriteOrRead:=True;
   FShadowColor:=clWindowText;
   FHInterval:=10;
   FVInterval:=10;
   FDefWidth:=100;
   FDefHeight:=100;
   FAutoHeight:=True;
   FAutoWidth:=True;
   FHSpacing:=8;
   FVSpacing:=8;
   FHAlign:=taCenter;
   FVAlign:=taVCenter;
   FMaxWidth:=0;
   FMaxHeight:=0;
   FPrjMaxHeight:=0;
   FDefPrjHeight:=200;
   FFontDPI:=96;
   FLineColor:=clBlack;
   FPrjFont:=TFont.Create;
   FPrjFont.Assign(Font);
   FTopLinksCount:=0;
   FBottomLinksCount:=0;
   FSNodeNumber:='';
   FAcceptPosition:=False;
   FLeftDragPos:=0;
   FTopDragPos:=0;
   Parent:=AOwner as TWinControl; {???}
end;

destructor  TBPDGraphNode.Destroy;
begin
 if (FPrjFont<>nil) then
   begin
     FPrjFont.Free;
     FPrjFont:=nil;
   end;
 if length(FProjection)>0 then
  begin
    FProjection:='';
  end;
 Parent:=nil;
 inherited Destroy;
end;

procedure TBPDGraphNode.SetLineColor(Value: TColor);
begin
 FLineColor:=Value;
 if not(FUpdating) then Paint;
end;


function   TBPDGraphNode.GetSpaces(Count: Integer):String;
Var i:Integer;
begin
  Result:='';
  i:=0;
  while (i<=Count) do
   begin
    Inc(i);
    Result:=Result+' ';
   end;
end;

procedure TBPDGraphNode.PaintImmediate;
 begin
   FUpdating:=False;
   Paint;
 end;



procedure TBPDGraphNode.SetFontDPI(NewDPI:Integer);
begin
 FFontDPI:=Canvas.Font.PixelsPerInch;
 FPrjFont.PixelsPerInch:=NewDPI;
 Canvas.Font.PixelsPerInch:=NewDPI;
end;

procedure   TBPDGraphNode.SetFontDPI1(Handle:HDC);
begin
 FFontDPI:=Canvas.Font.PixelsPerInch;
 Canvas.Font.PixelsPerInch:=GetDeviceCaps(Handle,LOGPIXELSX);
 FPrjFont.PixelsPerInch:=GetDeviceCaps(Handle,LOGPIXELSX);
end;

procedure   TBPDGraphNode.RestoreFontDPI;
begin
 Canvas.Font.PixelsPerInch:=FFontDPI;
 FPrjFont.PixelsPerInch:=FFontDPI;
end;

function  TBPDGraphNode.GetProjRectSize(left,top:Integer):TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
    mw:Integer;
    CFont:TFont;
 begin
 {  Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
 r.Left:=left+FIntervalLeft;
 r.Top:=top;
 r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
{     }
 uf:=DT_WORDBREAK or DT_CALCRECT or DT_LEFT;
 CFont:=TFont.Create;
 CFont.Assign(Canvas.Font);
 Canvas.Font.Assign(FPrjFont);
 ht:=DrawText(Canvas.Handle,Pchar(FProjection),length(FProjection),r,uf);
 Canvas.Font.Assign(CFont);
 CFont.Free;
 if (not(FAutoHeight)) then ht:=FDefPrjHeight
  else ht:=ht{+FIntervalTop+FVSpacing};
 r.Bottom:=ht+r.Top;   { New FIntervalTop+FVSpacing}
 r.Right:=r.Right+2*FHSpacing;
 mw:=r.Right-r.Left;
 if (mw>FMaxWidth) then FMaxWidth:=mw;
 FPrjMaxHeight:=ht{+FIntervalTop+FVSpacing};
 result:=r;
 end;

 function   TBPDGraphNode.GetRectSize:TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
begin
 {  Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
 r.Left:=FIntervalLeft+FShadowLeft;
 r.Top:=FIntervalTop+FShadowTop;
 r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
{     }
 uf:=DT_WORDBREAK or DT_CALCRECT;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 ht:=DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 r.Bottom:=ht+r.Top;
 FMaxWidth:=r.Right-r.Left;
 FMaxHeight:=r.Bottom-r.Top;
 if not(FAutoWidth) then
   begin
     r.Right:=r.Left+FDefWidth;
   end;
 if not(FAutoHeight) then
   begin
     r.Bottom:=r.Top+FDefHeight;
   end;
 r.Right:=r.Right+2*FHSpacing;
 result:=r;
end;

procedure   TBPDGraphNode.Paint;
Var r,r1:TRect;
    oldColor:TColor;
    uf:UINT;
    th:Integer;
    lenP:Integer;
    SubY:Integer;
    CFont:TFont;
    tmp:Integer;
begin
 if FUpdating then Exit;
 FMaxHeight:=0;
 FMaxWidth:=0;
 FPrjMaxHeight:=0;
 r:=GetRectSize; { Get Caption rect }
 lenP:=length(FProjection);
 if (lenP<>0) then
  begin
   r1:=GetProjRectSize(r.Left,r.Bottom);
   r.Bottom:=r1.Bottom;
  end else
   begin
    r1.Top:=0;
    r1.Bottom:=0;
    r1.Left:=0;
    r1.Right:=0;
   end;
 if FAutoHeight then
  begin
   th:=FVSpacing;
   r.Bottom:=r.Bottom+2*FVSpacing;
  end
 else
  begin
  th:=r.Bottom-r.Top;
  if th > (FDefHeight) then th:=FDefHeight;
  r.Bottom:=r.Top+FDefHeight+r1.Bottom-r1.Top+2*FVSpacing;
  case FVAlign of
   taTopJustify: th:=FVSpacing;
   taVCenter:    th:=FVSpacing+(FDefHeight-th) div 2;
   taBottomJustify: th:= FVSpacing+FDefHeight-th;
  end;
 end;
 r.Left:=FShadowLeft;
 r.Top:=FShadowTop;
 r.Bottom:=r.Bottom+FIntervalBottom;
 r.Right:=r.Right+FIntervalRight;
 oldColor:=Canvas.Brush.Color;
 Canvas.Brush.Color:=FPaintColor;
 Canvas.FillRect(r);    { Fill with PaintColor }
 if FAutoHeight then SubY:=r1.Top else SubY:=r.Top+FDefHeight+FHSpacing+FShadowTop+FIntervalTop+FIntervalBottom;
 SetUpRect(r,(lenP>0),SubY);          { Draw Frame with DrawColor }
 width:=r.Right+FShadowRight+1;
 Height:=r.Bottom+FShadowBottom+1;
 r.Left:=FIntervalLeft+FShadowLeft+FHSpacing;
 r.Top:=FIntervalTop+FShadowTop+th;
 tmp:=r1.Top;
 r1.Top:=SubY+FIntervalTop{-(FPrjFont.Height div 2)};
 r1.Bottom:=r1.Bottom-tmp+SubY+FIntervalTop-(FPrjFont.Height div 2);
 r.Bottom:=r.Bottom-FIntervalBottom-FVSpacing;
 r.Right:=r.Right-FIntervalRight-FHSpacing;
 { Draw Caption }
 uf:=DT_WORDBREAK;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 if length(FProjection)<>0 then
  begin
   uf:=DT_WORDBREAK or DT_LEFT;
   {r1.Top:=SubY+FIntervalTop+FHSpacing;
   r1.Bottom:=r.Bottom;
   r1.Left:=r1.Left+FIntervalLeft;}
   CFont:=TFont.Create;
   CFont.Assign(Canvas.Font);
   Canvas.Font.Assign(FPrjFont);
   DrawText(Canvas.Handle,Pchar(FProjection),length(FProjection),r1,uf);
   Canvas.Font.Assign(CFont);
   CFont.Free;
  end;
{ DT_SINGLELINE or DT_WORDBREAK ); }
 DrawShadow;
 Canvas.Brush.Color:=oldColor;
end;




procedure   TBPDGraphNode.DrawRect(r:TRect;val1,val2:Integer; SubLine:Boolean; SubY:Integer);
Var i,j:Integer;
begin
 with Canvas do
  begin
   for j:=0 to Val1 do
    begin
      if (j<Val2) or (j>(Val2+reSpace-1)) then
        Pen.Color:=FDrawColor else Pen.Color:=FPaintColor;
     for i:=0 to (FLineWidth-1) do
      begin
       MoveTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
       if SubLine then
         begin
           MoveTo(r.Left+i+j*FLineWidth,SubY+i+j*FLineWidth);
           LineTo(r.Right-i-j*FLineWidth,SubY+i+j*FLineWidth);
         end;
      end;
     end;
   end;
end;

procedure   TBPDGraphNode.SetUpRect(r: TRect; SubLine:Boolean; SubY:Integer);
Var oldColor:TColor;
begin
{     }
 with Canvas do
  begin
   oldColor:=Pen.Color;
   Pen.Color:=FDrawColor;
   Pen.Style:=FLineStyle;
   case FRectStyle of
    reNone: begin end;
    re1x: DrawRect(r,0,1,SubLine,SubY);
    re2x: DrawRect(r,1,2,SubLine,SubY);
    re3x: DrawRect(r,2,3,SubLine,SubY);
    re4x: DrawRect(r,3,4,SubLine,SubY);
    re2x3: DrawRect(r,4+reSpace,2,SubLine,SubY);
    re3x2: DrawRect(r,4+reSpace,3,SubLine,SubY);
    re2x4: DrawRect(r,5+reSpace,2,SubLine,SubY);
    re4x2: DrawRect(r,5+reSpace,4,SubLine,SubY);
    re2x5: DrawRect(r,6+reSpace,2,SubLine,SubY);
    re5x2: DrawRect(r,6+reSpace,5,SubLine,SubY);
   end;
   Pen.Color:=oldColor;
  end;
end;


function  TBPDGraphNode.GetPrjFont:TFont;
 begin
   result:=FPrjFont;
 end;

procedure TBPDGraphNode.SetPrjFont(Font:TFont);
 begin
   FPrjFont:=Font;
   if not(FUpdating) then Paint;
 end;

function  TBPDGraphNode.GetFont:TFont;
begin
 result:=Canvas.Font;
end;

procedure TBPDGraphNode.SetFont(Font:TFont);
begin
 Canvas.Font:=Font; {Changed 15.03.98 }
 if not(FUpdating) then Paint;
end;

function  TBPDGraphNode.GetText:String;
begin
 Result:=FText;
end;

procedure TBPDGraphNode.SetText(Value: String);
Var s:String;
begin
 s:=Value;
 s:=TrimLeft(s);
 FText:=s;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetRectInterval(Value: Integer);
begin
 FIntervalLeft:=FLineWidth*Value;
 FIntervalRight:=FLineWidth*Value;
 FIntervalTop:=FLineWidth*Value;
 FIntervalBottom:=FLineWidth*Value;
end;

procedure TBPDGraphNode.SetRectStyle(Value: TDSRectStyle);
begin
 case Value of
  reNone:     SetRectInterval(0);
  re1x:       SetRectInterval(1);
  re2x:       SetRectInterval(2);
  re3x:       SetRectInterval(3);
  re4x:       SetRectInterval(4);
  re2x3,re3x2: SetRectInterval(5+reSpace);
  re2x4,re4x2: SetRectInterval(6+reSpace);
  re2x5,re5x2: SetRectInterval(7+reSpace);
 end;
 FRectStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetDrawColor(Value: TColor);
begin
 FDrawColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetLineStyle(Value: TPenStyle);
begin
 FLineStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetLineWidth(Value: Integer);
begin
 FLineWidth:=Value;
 SetRectStyle(FRectStyle);
end;

procedure TBPDGraphNode.SetPaintColor(Value: TColor);
begin
 FPaintColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetShadowColor(Value: TColor);
begin
 FShadowColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetShadowInterval(Left,Right,Top,Bottom:Integer);
begin
 FShadowLeft:=FLineWidth*Left;
 FShadowRight:=FLineWidth*Right;
 FShadowTop:=FLineWidth*Top;
 FShadowBottom:=FLineWidth*Bottom;
end;

procedure TBPDGraphNode.SetShadowType(Value: TDSShadowType);
begin
 FShadowType:=Value;
 case Value of
  shNone:                 SetShadowInterval(0,0,0,0);
  shLeftBoxed:            SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shLeftFramed:           SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shTopPerspective:       SetShadowInterval(0,0,0,FShadowDepth);
  shInversePerspective:   SetShadowInterval(FShadowDepth,FShadowDepth,0,FShadowDepth);
  shRightBoxed:           SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shRightFramed:          SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shBottomPerspective:    SetShadowInterval(0,0,FShadowDepth,0);
 end;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetShadowDepth(Value: Integer);
begin
 FShadowDepth:=Value;
 SetShadowType(FShadowType);
end;

procedure TBPDGraphNode.DrawShadowBottom(Diagonal:Boolean;Orient:Integer);
Var r:TRect;
    h,w:Integer;
    i:Integer;
begin
{ Orient 0  - Left
         1  - Center
         2  - Right }
 with Canvas do
  Begin
   h:=self.Height;
   w:=self.Width;
   r.Left:=FShadowLeft;
   r.Top:=h-FShadowBottom;
   r.Right:=w-FShadowRight;
   r.Bottom:=h;
   Brush.Color:=self.Color;
   FillRect(r);
   Pen.Color:=FShadowColor;
    if Diagonal then
       begin
        {Diagonal}
         case Orient of
          0: {Left}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowLeft,h-i);
                   LineTo(w-FShadowLeft+i,h-i);
                 end;
              end;
          1: {Center}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowBottom-i,h-i);
                   LineTo(w-FShadowBottom+i,h-i);
                 end;
              end;
          2: {Right}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowRight-i,h-i);
                   LineTo(w-FShadowRight,h-i);
                 end;
              end;
         end;
       end
     else
       begin
         case Orient of
          0: {Left}
              begin
               r.Right:=w-FShadowLeft;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          1: {Center}
              begin
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          2: {Right}
              begin
               r.Left:=FShadowRight;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
         end;
       end;
  end;
end;

procedure TBPDGraphNode.DrawShadowTop;
Var r:TRect;
    i:Integer;
    w:Integer;
begin
{}
 with Canvas do
  begin
   w:=self.Width;
   r.Left:=0;
   r.Top:=0;
   r.Right:=w;
   r.Bottom:=FShadowTop;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
    for i:=0 to (FShadowTop) do
       begin
         MoveTo(FShadowTop-i,i);
         LineTo(w-FShadowTop+i,i);
       end;
  end;
end;

procedure TBPDGraphNode.DrawShadowLeft(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h:Integer;
begin
 with Canvas do
 begin
   h:=self.Height;
   r.Left:=0;
   r.Top:=0;
   r.Right:=FShadowLeft;
   r.Bottom:=self.Height;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
 if Diagonal then
  begin
   {Left Diagonal Shadow}
    for i:=0 to (FShadowLeft-1) do
     begin
      MoveTo(i,FShadowLeft-i);
      LineTo(i,h);
     end;
  end
 else
  begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
  end;
 end;
end;

procedure TBPDGraphNode.DrawShadowRight(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h,w:Integer;
begin
 with Canvas do
 begin
    w:=self.width;
    h:=self.Height;
    r.Left:=w-FShadowRight;
    r.Top:=0;
    r.Right:=w;
    r.Bottom:=self.Height;
    Brush.Color:=self.Color;
    Pen.Color:=FShadowColor;
    FillRect(r);
 if Diagonal then
  begin
   {Right Diagonal Shadow}
    for i:=0 to (FShadowRight-1) do
     begin
      MoveTo(w-FShadowRight+i,i);
      LineTo(w-FShadowRight+i,h);
     end;
  end
 else
   begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
   end;
 end;
end;

procedure TBPDGraphNode.DrawShadow;
Var oldColor,oldColor1:TColor;
    penStyle:TPenStyle;
begin
{}
 with Canvas do
 begin
 oldColor:=Brush.Color;
 oldColor1:=Pen.Color;
 penStyle:=Pen.Style;
 Pen.Style:=psSolid;
 case FShadowType of
  shNone:                 begin end;
  shLeftBoxed:            begin
                            DrawShadowLeft(True);
                            DrawShadowBottom(True,0);
                          end;
  shLeftFramed:           begin
                            DrawShadowLeft(False);
                            DrawShadowBottom(False,0);
                          end;
  shTopPerspective:       DrawShadowBottom(True,1);
  shInversePerspective:   begin
                           DrawShadowLeft(True);
                           DrawShadowRight(True);
                           DrawShadowBottom(False,1);
                          end;
  shRightBoxed:           begin
                           DrawShadowRight(True);
                           DrawShadowBottom(True,2);
                          end;
  shRightFramed:          begin
                           DrawShadowRight(False);
                           DrawShadowBottom(False,2);
                          end;
  shBottomPerspective:    DrawShadowTop;

 end;
  Pen.Style:=penStyle;
  Pen.Color:=oldColor1;
  Brush.Color:=oldColor;
 end;
end;

procedure TBPDGraphNode.SetDefWidth(Value: Integer);
begin
 FDefWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetDefPrjHeight(Value: Integer);
begin
 FDefPrjHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetDefHeight(Value: Integer);
begin
 FDefHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetAutoHeight(Value: Boolean);
begin
 FAutoHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetAutoWidth(Value: Boolean);
begin
 FAutoWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetHAlign(Value: TAlignment);
begin
 FHAlign:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPDGraphNode.SetVAlign(Value: TVAlignment);
begin
 FVAlign:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetVSpacing(Value: Integer);
begin
 FVSpacing:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPDGraphNode.SetHSpacing(Value: Integer);
begin
 FHSpacing:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPDGraphNode.SetNode(lleft,ltop:Integer);
begin
 FUpdating:=True;
 Left:=lleft;
 Top:= ltop;
 FUpdating:=False;
 if not(FUpdating) then Paint;
end;

{ TBPLSACustomGraphNode }

function  TBPLSAGraphCustomNode.GetNodeText:String;
begin
  Result:=Caption;
end;


function  TBPLSAGraphCustomNode.GetMaxWord(const s:String):String;
Var s1,word:String;
    i,j,maxLen:Integer;
 begin
   s1:=s;
   maxLen:=0;
   Result:='';
   if length(s1)=0 then Exit;
   i:=1;
   j:=1;
   while (i<=length(s1)) do
    begin
      while (i<=length(s1)) and (s1[i]<>' ') do
        begin
         inc(i);
        end;
       if (MaxLen<(i-j)) then
         begin
            MaxLen:=i-j;
            Result:=copy(s1,j,i-j);
         end;
     j:=i+1;
     inc(i);
    end;
 end;

constructor TBPLSAGraphCustomNode.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FUpdating:=False;
   Color:=clWhite;
   FShapeType:=lsa_Node;
   FOutputCount:=0;
   FPaintColor:=clWindow;
   FDrawColor:=clWindowText;
   FShadowType:=shRightFramed;
   FShadowDepth:=4;
   FLineStyle:=psSolid;
   FLineWidth:=1;
   FIntervalLeft:=2*FLineWidth;
   FIntervalTop:=2*FLineWidth;
   FIntervalBottom:=2*FLineWidth;
   FIntervalRight:=2*FLineWidth;
   FShadowLeft:=0;
   FShadowRight:=0;
   FShadowTop:=0;
   FShadowBottom:=0;
   FRectStyle:=re2x;
   FShadowColor:=clWindowText;
   FDefWidth:=100;
   FDefHeight:=100;
   FMinHeight:=0;
   FAutoHeight:=True;
   FAutoWidth:=True;
   FHSpacing:=8;
   FVSpacing:=8;
   FHAlign:=taCenter;
   FVAlign:=taVCenter;
   FLineColor:=clBlack;
   FSNodeNumber:='';
   FNodeNumber:=0;
   FMaxWidth:=0;
   FMaxHeight:=0;
   FLeftLinksCount:=0;
   FRightLinksCount:=0;
   FTopLinksCount:=0;
   FBottomLinksCount:=0;
   FInputLinksCount:=0;
   FOutputLinksCount:=0;
   Parent:=AOwner as TWinControl; {???}
   FAcceptPosition:=False;
   DragCursor:=crMyCursor;
   Cursor:=crHandPoint;
   DragMode:=dmManual;
   FHW:=False;
   Paint;
end;

procedure TBPLSAGraphCustomNode.SetLineColor(Value: TColor);
begin
 FLineColor:=Value;
 if not(FUpdating) then Paint;
end;


function   TBPLSAGraphCustomNode.GetRectSize:TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
    FText:String;
begin
  FText:=GetNodeText;
 {_ _ Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
  r.Left:=FIntervalLeft+FShadowLeft+FHSpacing;
  r.Top:=FIntervalTop+FShadowTop+FVSpacing;
  r.Right:=FDefWidth-FIntervalRight-FShadowRight-FHSpacing;
  r.Bottom:=Parent.ClientRect.Bottom;
{ +_  _ _ }
 uf:=DT_WORDBREAK or DT_CALCRECT;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 ht:=DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 r.Bottom:=ht+r.Top;
 FMaxWidth:=r.Right-r.Left+FIntervalLeft+FShadowLeft+FIntervalRight+FShadowRight+2*FHSpacing;
 FMaxHeight:=r.Bottom-r.Top+FIntervalTop+FShadowTop+FIntervalBottom+FShadowBottom+2*FVSpacing;
 result:=r;
end;



procedure   TBPLSAGraphCustomNode.Paint;
Var r:TRect;
    oldColor:TColor;
    uf:UINT;
    th:Integer;
    FText:String;
    FNN:String;
    r1:TRect;
    i:Integer;
    oc:TColor;
    w,h:Integer;
    delta:Integer;
begin
 if FUpdating then Exit;
 FText:=GetNodeText;
 r:=GetRectSize; { Get Caption rect }
 if not(FAutoWidth) then
   begin
     r.Right:=FDefWidth-FShadowRight-FIntervalRight-FHSpacing;
   end;
 r.Right:=r.Right+FHSpacing;
 if FAutoHeight then
  begin
   th:=0;
   r.Bottom:=r.Bottom+FVSpacing;
  end
 else
  begin
  th:=r.Bottom-r.Top;
  if th > (FDefHeight-2*FVSpacing-FShadowTop-FShadowBottom-FIntervalTop-FIntervalBottom) then
      th:=FDefHeight-2*FVSpacing-FShadowTop-FShadowBottom-FIntervalTop-FIntervalBottom;
  r.Bottom:=r.Top+FDefHeight-FVSpacing-FShadowTop-FShadowBottom-FIntervalTop-FIntervalBottom;
  case FVAlign of
   taTopJustify: th:=0;
   taVCenter:    th:=(FDefHeight-2*FVSpacing-FShadowTop-FShadowBottom-FIntervalTop-FIntervalBottom-th) div 2;
   taBottomJustify: th:= FDefHeight-2*FVSpacing-FShadowTop-FShadowBottom-FIntervalTop-FIntervalBottom-th;
  end;
 end;
 r.Left:=FShadowLeft;
 r.Top:=FShadowTop;
 r.Bottom:=r.Bottom+FIntervalBottom;
 r.Right:=r.Right+FIntervalRight;
 oldColor:=Canvas.Brush.Color;
 case FShapeType of
  lsa_Node: begin
             Canvas.Brush.Color:=FPaintColor;
             Canvas.FillRect(r);    { Fill with PaintColor }
            end;
  lsa_Junction: begin
                  Canvas.Brush.Color:=clWhite;
                  Canvas.FillRect(r);    { Fill with PaintColor }
                end;
 end;
 SetUpRect(r);          { Draw Frame with DrawColor }
 if FShapeType=lsa_Junction then
   begin
    Canvas.Brush.Color:=FPaintColor;
    Canvas.FloodFill((r.Left+R.Right) div 2,(r.Top+r.Bottom) div 2,FDrawColor,fsBorder);
   end;
 width:=r.Right+FShadowRight+1;
 Height:=r.Bottom+FShadowBottom+1;
 r.Left:=FIntervalLeft+FShadowLeft+FHSpacing;
 r.Top:=FIntervalTop+FShadowTop+FVSpacing+th;
 r.Bottom:=r.Bottom-FIntervalBottom-FVSpacing;
 r.Right:=r.Right-FIntervalRight-FHSpacing;
 { Draw Caption }
 uf:=DT_WORDBREAK;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 DrawShadow;
 Canvas.Brush.Color:=oldColor;
 FMinHeight:=Height-FShadowTop-FShadowBottom;
end;


procedure   TBPLSAGraphCustomNode.DrawRect(r:TRect;val1,val2:Integer);
Var i,j:Integer;
    hh:Integer;
    hw:Integer;
begin
 with Canvas do
  begin { with Canvas }
   for j:=0 to Val1 do
    begin
      if (j<Val2) or (j>(Val2+reSpace-1)) then
        Pen.Color:=FDrawColor else Pen.Color:=FPaintColor;
       case (FShapeType) of
       lsa_Node: begin
                  for i:=0 to (FLineWidth-1) do
                   begin
                     MoveTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
                     LineTo(r.Right-i-j*FLineWidth,r.Top+i+j*FLineWidth);
                     LineTo(r.Right-i-j*FLineWidth,r.Bottom-i-j*FLineWidth);
                     LineTo(r.Left+i+j*FLineWidth,r.Bottom-i-j*FLineWidth);
                     LineTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
                    end;
                   end;
        lsa_Junction: begin
                        hh:=(r.Bottom-r.Top) div 2;
                        hw:=(r.Right-r.Left) div 2;
                        if hw>hh then hw:=hh;
                        for i:=0 to (FLineWidth-1) do
                         begin
                          MoveTo(r.Left+hw{+i+j*FLineWidth},r.Top+i+j*FLineWidth);
                          LineTo(r.Right-hw{-i-j*FLineWidth},r.Top+i+j*FLineWidth);
                          LineTo(r.Right-i-j*FLineWidth,r.Top+hh{+i+j*FLineWidth});
                          LineTo(r.Right-hw{-i-j*FLineWidth},r.Bottom-i-j*FLineWidth);
                          LineTo(r.Left+hw{+i+j*FLineWidth},r.Bottom-i-j*FLineWidth);
                          LineTo(r.Left+i+j*FLineWidth,r.Bottom-hh{-i-j*FLineWidth});
                          LineTo(r.Left+hw{+i+j*FLineWidth},r.Top+i+j*FLineWidth);
                         end;
                      end;
       end; { case }
     end;
   end; { with Canvas }
end;

procedure   TBPLSAGraphCustomNode.SetUpRect(r: TRect);
Var oldColor:TColor;
    oc:TColor;
begin
{     }
 with Canvas do
  begin
   oldColor:=Pen.Color;
   oc:=FDrawColor;
   Pen.Color:=FDrawColor;
   Pen.Style:=FLineStyle;
   case FRectStyle of
    reNone: begin end;
    re1x: DrawRect(r,0,1);
    re2x: DrawRect(r,1,2);
    re3x: DrawRect(r,2,3);
    re4x: DrawRect(r,3,4);
    re2x3: DrawRect(r,4+reSpace,2);
    re3x2: DrawRect(r,4+reSpace,3);
    re2x4: DrawRect(r,5+reSpace,2);
    re4x2: DrawRect(r,5+reSpace,4);
    re2x5: DrawRect(r,6+reSpace,2);
    re5x2: DrawRect(r,6+reSpace,5);
   end;
   FDrawColor:=oc;
   Pen.Color:=oldColor;
  end;
end;


function  TBPLSAGraphCustomNode.GetFont:TFont;
begin
 result:=Canvas.Font;
end;

procedure TBPLSAGraphCustomNode.SetFont(Font:TFont);
begin
 Canvas.Font:=Font; {Changed 15.03.98 }
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetRectInterval(Value: Integer);
begin
 FIntervalLeft:=FLineWidth*Value;
 FIntervalRight:=FLineWidth*Value;
 FIntervalTop:=FLineWidth*Value;
 FIntervalBottom:=FLineWidth*Value;
end;

procedure TBPLSAGraphCustomNode.SetRectStyle(Value: TDSRectStyle);
begin
 case Value of
  reNone:     SetRectInterval(0);
  re1x:       SetRectInterval(1);
  re2x:       SetRectInterval(2);
  re3x:       SetRectInterval(3);
  re4x:       SetRectInterval(4);
  re2x3,re3x2: SetRectInterval(5+reSpace);
  re2x4,re4x2: SetRectInterval(6+reSpace);
  re2x5,re5x2: SetRectInterval(7+reSpace);
 end;
 FRectStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetDrawColor(Value: TColor);
begin
 FDrawColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetLineStyle(Value: TPenStyle);
begin
 FLineStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetLineWidth(Value: Integer);
begin
 FLineWidth:=Value;
 SetRectStyle(FRectStyle);
end;

procedure TBPLSAGraphCustomNode.SetPaintColor(Value: TColor);
begin
 FPaintColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetShadowColor(Value: TColor);
begin
 FShadowColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetShadowInterval(Left,Right,Top,Bottom:Integer);
begin
 FShadowLeft:=FLineWidth*Left;
 FShadowRight:=FLineWidth*Right;
 FShadowTop:=FLineWidth*Top;
 FShadowBottom:=FLineWidth*Bottom;
end;

procedure TBPLSAGraphCustomNode.SetShadowType(Value: TDSShadowType);
begin
 FShadowType:=Value;
 case Value of
  shNone:                 SetShadowInterval(0,0,0,0);
  shLeftBoxed:            SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shLeftFramed:           SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shTopPerspective:       SetShadowInterval(0,0,0,FShadowDepth);
  shInversePerspective:   SetShadowInterval(FShadowDepth,FShadowDepth,0,FShadowDepth);
  shRightBoxed:           SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shRightFramed:          SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shBottomPerspective:    SetShadowInterval(0,0,FShadowDepth,0);
 end;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetShadowDepth(Value: Integer);
begin
 FShadowDepth:=Value;
 SetShadowType(FShadowType);
end;


procedure TBPLSAGraphCustomNode.DrawShadowBottom(Diagonal:Boolean;Orient:Integer);
Var r:TRect;
    h,w:Integer;
    mhw:Integer;
    h1,w1:Integer;
    i:Integer;
begin
{ Orient 0  - Left
         1  - Center
         2  - Right }
 with Canvas do
  Begin
   h:=self.Height;
   w:=self.Width;
   if (FShapeType=lsa_Junction) and FHW then mhw:=w else mhw:=h;
   h1:=self.FMinHeight;
   r.Left:=FShadowLeft;
   r.Top:=h-FShadowBottom;
   r.Right:=w-FShadowRight;
   r.Bottom:=h;
   Brush.Color:=self.Color;
   FillRect(r);
   Pen.Color:=FShadowColor;
   case (FShapeType) of
   lsa_Node: begin
    if Diagonal then
       begin
        {Diagonal}
         case Orient of
          0: {Left}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowLeft,h-i);
                   LineTo(w-FShadowLeft+i,h-i);
                 end;
              end;
          1: {Center}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowBottom-i,h-i);
                   LineTo(w-FShadowBottom+i,h-i);
                 end;
              end;
          2: {Right}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowRight-i,h-i);
                   LineTo(w-FShadowRight,h-i);
                 end;
              end;
         end;
       end
     else
       begin
         case Orient of
          0: {Left}
              begin
               r.Right:=w-FShadowLeft;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          1: {Center}
              begin
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          2: {Right}
              begin
               r.Left:=FShadowRight;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
         end;
       end;
     end; { lsa_Node}
   lsa_Junction: begin
                  case Orient of
                   0: { Left }
                     begin
                        if (h<w) then
                        begin
                        Brush.Color:=FShadowColor;
                        r.Left:=FShadowLeft+(h1 div 2);
                        r.Right:=w-FShadowRight-(h div 2);
                        FillRect(r);
                        end;
                      end;
                   1: { Center }
                     begin
                        if (h<w) then
                        begin
                        Brush.Color:=FShadowColor;
                        r.Left:=FShadowLeft+(h div 2);
                        r.Right:=w-FShadowRight-(h div 2);
                        FillRect(r);
                        end;
                      end;
                    2: { Right}
                      begin
                        if (h<w) then
                        begin
                        Brush.Color:=FShadowColor;
                        r.Left:=FShadowLeft+(h1 div 2);
                        r.Right:=w-(h div 2);
                        FillRect(r);
                        end;
                      end;
                   end;
                 end;
   end; { Case }

  end;
end;

procedure TBPLSAGraphCustomNode.DrawShadowTop;
Var r:TRect;
    i:Integer;
    w:Integer;
begin
{}
 with Canvas do
  begin
   w:=self.Width;
   r.Left:=0;
   r.Top:=0;
   r.Right:=w;
   r.Bottom:=FShadowTop;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
    for i:=0 to (FShadowTop) do
       begin
         MoveTo(FShadowTop-i,i);
         LineTo(w-FShadowTop+i,i);
       end;
  end;
end;

procedure TBPLSAGraphCustomNode.DrawShadowLeft(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h:Integer;
begin
 with Canvas do
 begin
   h:=self.Height;
   r.Left:=0;
   r.Top:=0;
   r.Right:=FShadowLeft;
   r.Bottom:=self.Height;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
 if Diagonal then
  begin
   {Left Diagonal Shadow}
    for i:=0 to (FShadowLeft-1) do
     begin
      MoveTo(i,FShadowLeft-i);
      LineTo(i,h);
     end;
  end
 else
  begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
  end;
 end;
end;

procedure TBPLSAGraphCustomNode.DrawShadowRight(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h,h1,w:Integer;
    mhw:Integer;

begin
 with Canvas do
 begin
    w:=self.width;
    h:=self.Height;
    h1:=self.FMinHeight;
    if (w<h) then mhw:=(w-2*FShadowRight) else mhw:=h1;
    r.Left:=w-FShadowRight;
    r.Top:=0;
    r.Right:=w;
    r.Bottom:=self.Height;
    Brush.Color:=self.Color;
    Pen.Color:=FShadowColor;
    FillRect(r);
 case FShapeType of
 lsa_Node: begin
            if Diagonal then
              begin
               {Right Diagonal Shadow}
                for i:=0 to (FShadowRight-1) do
                 begin
                  MoveTo(w-FShadowRight+i,i);
                  LineTo(w-FShadowRight+i,h);
                 end;
              end
              else
              begin
               {Left Framed Shadow }
               r.Top:=FShadowBottom;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
            end;
  lsa_Junction: begin
                  for i:=0 to (FShadowRight) do
                   begin
                     MoveTo(w-(mhw div 2)-2*FShadowRight,h+FShadowRight-i);
                     LineTo(w-i-FShadowRight,h-(h1 div 2));
                   end;
                end;
   end; { case }
 end;
end;

procedure TBPLSAGraphCustomNode.DrawShadow;
Var oldColor,oldColor1:TColor;
    penStyle:TPenStyle;
begin
{}
 with Canvas do
 begin
 oldColor:=Brush.Color;
 oldColor1:=Pen.Color;
 penStyle:=Pen.Style;
 Pen.Style:=psSolid;
 case FShadowType of
  shNone:                 begin end;
  shLeftBoxed:            begin
                            DrawShadowLeft(True);
                            DrawShadowBottom(True,0);
                          end;
  shLeftFramed:           begin
                            DrawShadowLeft(False);
                            DrawShadowBottom(False,0);
                          end;
  shTopPerspective:       DrawShadowBottom(True,1);
  shInversePerspective:   begin
                           DrawShadowLeft(True);
                           DrawShadowRight(True);
                           DrawShadowBottom(False,1);
                          end;
  shRightBoxed:           begin
                           DrawShadowRight(True);
                           DrawShadowBottom(True,2);
                          end;
  shRightFramed:          begin
                           DrawShadowRight(False);
                           DrawShadowBottom(False,2);
                          end;
  shBottomPerspective:    DrawShadowTop;

 end;
  Pen.Style:=penStyle;
  Pen.Color:=oldColor1;
  Brush.Color:=oldColor;
 end;
end;

procedure TBPLSAGraphCustomNode.SetDefWidth(Value: Integer);
begin
 FDefWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetDefHeight(Value: Integer);
begin
 FDefHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetAutoHeight(Value: Boolean);
begin
 FAutoHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetAutoWidth(Value: Boolean);
begin
 FAutoWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetHAlign(Value: TAlignment);
begin
 FHAlign:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPLSAGraphCustomNode.SetVAlign(Value: TVAlignment);
begin
 FVAlign:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.SetNodeNumber(Value: ShortString);
begin
 FSNodeNumber:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPLSAGraphCustomNode.SetVSpacing(Value: Integer);
begin
 FVSpacing:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TBPLSAGraphCustomNode.SetHSpacing(Value: Integer);
begin
 FHSpacing:=Value;
 if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (AComponent = Parent) then
    Parent := nil;
end;

procedure TBPLSAGraphCustomNode.Loaded;
begin
  inherited Loaded;
  if not(FUpdating) then Paint;
end;

procedure TBPLSAGraphCustomNode.PaintImmediate;
 begin
   FUpdating:=False;
   Paint;
 end;


procedure  TBPLSAGraphCustomNode.SetFontDPI(Value:Integer);
begin
 Canvas.Font.PixelsPerInch:=Value;
 if not(FUpdating) then Paint;
end;


procedure TBPLSAGraphCustomNode.SetShapeType(Value:TLSAShapeType);
 begin
   FShapeType:=Value;
   if not(FUpdating) then Paint;
 end;

procedure TBPLSAGraphCustomNode.SetOutputCount(Value:Integer);
 begin
   FOutputCount:=Value;
   if (FOutputCount>1) then FShapeType:=lsa_Junction else FShapeType:=lsa_Node;
   if not(FUpdating) then Paint;
 end;

end.
