unit MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OrgChart, StdCtrls, ComCtrls, TB97, Spin, Buttons, RXCtrls, ExtCtrls,
  Placemnt, Spellers,printers, Db, DBTables, TB97Ctls, TB97Tlbr, RichEdit2,
  Menus, Jpeg, StrHlder,GIFImage;

type

  TOCTokenType = (octt_Unknown,octt_OrgChartName,octt_PrilNumber,octt_OrgChartPicture);

  TMainForm = class(TForm)
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    CustomOrgChart1: TCustomOrgChart;
    OpenDialog: TOpenDialog;
    Label1: TLabel;
    Label2: TLabel;
    PrintDialog: TPrintDialog;
    FormStorage: TFormStorage;
    PrinterSetupDialog: TPrinterSetupDialog;
    SaveDialog: TSaveDialog;
    Image1: TImage;
    Image2: TImage;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Dock971: TDock97;
    MainToolbar: TToolbar97;
    ExitButton: TToolbarButton97;
    ToolbarSep971: TToolbarSep97;
    LoadButton: TToolbarButton97;
    ToolbarSep972: TToolbarSep97;
    LSetupButton: TToolbarButton97;
    PrintButton: TToolbarButton97;
    ToolbarSep976: TToolbarSep97;
    PageSetupButton: TToolbarButton97;
    PrinterSetupButton: TToolbarButton97;
    SaveButton: TToolbarButton97;
    PreviewButton: TToolbarButton97;
    ToolbarSep9713: TToolbarSep97;
    HelpButton: TToolbarButton97;
    PreviewToolbar: TToolbar97;
    LastButton: TToolbarButton97;
    NextButton: TToolbarButton97;
    PrevButton: TToolbarButton97;
    FirstButton: TToolbarButton97;
    ToolbarSep977: TToolbarSep97;
    ToolbarSep978: TToolbarSep97;
    ToolbarSep979: TToolbarSep97;
    EndPreviewButton: TToolbarButton97;
    ToolbarSep9710: TToolbarSep97;
    ToolbarSep9711: TToolbarSep97;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    PreviewZoom: TComboBox;
    PageEdit: TEdit;
    MaxPage: TEdit;
    ReportToolbar: TToolbar97;
    TruncateButton: TToolbarButton97;
    ToolbarSep9712: TToolbarSep97;
    Label9: TLabel;
    ToolbarSep974: TToolbarSep97;
    Label4: TLabel;
    ConvertButton: TToolbarButton97;
    ToolbarSep975: TToolbarSep97;
    Label3: TLabel;
    ToolbarSep973: TToolbarSep97;
    Label5: TLabel;
    TruncateLevelEdit: TSpinEdit;
    LevelsEdit: TSpinEdit;
    Zagolovok: TEdit97;
    Header: TEdit97;
    TZAnimate: TAnimate;
    TZImage: TImage;
    OrfoButton: TToolbarButton97;
    ToolbarSep9714: TToolbarSep97;
    ExportButton: TToolbarButton97;
    SaveDialog1: TSaveDialog;
    Editor: TRichEdit98;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    OpenItem: TMenuItem;
    CreateNewItem: TMenuItem;
    N4: TMenuItem;
    SaveItem: TMenuItem;
    N6: TMenuItem;
    PageParamItem: TMenuItem;
    PreviewItem: TMenuItem;
    PrinterSetupItem: TMenuItem;
    PrintItem: TMenuItem;
    N11: TMenuItem;
    ExitItem: TMenuItem;
    ExportItem: TMenuItem;
    N14: TMenuItem;
    TranslateItem: TMenuItem;
    N16: TMenuItem;
    TruncateItem: TMenuItem;
    OnlyNumbers: TMenuItem;
    N19: TMenuItem;
    OrfoItem: TMenuItem;
    N21: TMenuItem;
    HelpItem: TMenuItem;
    N23: TMenuItem;
    AboutItem: TMenuItem;
    N25: TMenuItem;
    LevelsSetupItem: TMenuItem;
    SpellChecker: TSpellChecker;
    MasterTable: TTable;
    SaveAsWEBItem: TMenuItem;
    SaveAsWEBButton: TToolbarButton97;
    HTMLTemplate: TStrHolder;
    procedure ExitButtonClick(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure LSetupButtonClick(Sender: TObject);
    procedure ConvertButtonClick(Sender: TObject);
    procedure PrintButtonClick(Sender: TObject);
    procedure HeaderChange(Sender: TObject);
    procedure PageSetupButtonClick(Sender: TObject);
    procedure FormStorageRestorePlacement(Sender: TObject);
    procedure FormStorageSavePlacement(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PrinterSetupButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure EditorChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PreviewButtonClick(Sender: TObject);
    procedure PreviewZoomChange(Sender: TObject);
    procedure EndPreviewButtonClick(Sender: TObject);
    procedure FirstButtonClick(Sender: TObject);
    procedure LastButtonClick(Sender: TObject);
    procedure PrevButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure TruncateButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure SetAnimation(Value:Boolean);
    procedure PageControlChange(Sender: TObject);
    procedure OrfoButtonClick(Sender: TObject);
    procedure MarkUnFormated;
    procedure SetZagolovok(Sender: TObject);
    procedure ExportButtonClick(Sender: TObject);
    function  FormatText:Boolean;
    procedure CreateNewItemClick(Sender: TObject);
    procedure OnlyNumbersClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure SaveAsWEBButtonClick(Sender: TObject);
  private
    { Private declarations }
    FModified:Boolean;
    NormalExit:Boolean;
    FIndexList:TStringList;
    function  QuitQuery:Boolean;
    procedure TransformLine(Var s:String;Var success:Boolean;Var doNotAdd:Integer;level:Integer);
    function  GetLineIndex(var S:String):String;
    function  GetNewLevel(s:String):String;
    function  FoundStartLevel:Integer;
    function  CalcLevel(s:String):Integer;
    function  TrimPageBreak(s:String):String;
    procedure CheckForOne(Var s:String);
    function  ScanKnownToken(Const s:String; Var startTok,endTok:Integer):TOCTokenType;
    function  QuerySaveImageDlg(Var translateType,iWidth,iHeight,ImageType:Integer):Boolean; 
  public
    { Public declarations }
     {      ! }
    FPageTop:Integer;
    FPageBottom:Integer;
    FPageLeft:Integer;
    FPageRight:Integer;
    FFileName:String;
    {}
    repModified:Boolean;
  end;

var
  MainForm: TMainForm;

Const myRegistryKey='SOFTWARE\BIG\ORGCHART\TOOLBARS';
      orgchartVersion='2.60';

implementation

uses SetupLevelsFormUnit, CheckDateUnit, PageSetupFormUnit, FileNameUnit,
  PreviewFormUnit, DebugUnit, AboutBoxUnit, SelWEBImageDlgUnit;

{$R *.DFM}
{$R STR_MOV.RES }

function  TMainForm.ScanKnownToken(Const s:String; Var startTok,endTok:Integer):TOCTokenType;
var len,i:Integer;
    tmps:String;
 begin
   Result:=octt_Unknown;
   len:=length(s);
   if (len<13) then Exit;
   startTok:=pos('<#PRILNUMBER>',s);
   if (startTok>0) then
          begin
            endTok:=startTok+12;
            Result:=octt_PrilNumber;
            Exit;
          end;
   if (len<15) then Exit;
   startTok:=pos('<#ORGCHARTNAME>',s);
   if (startTok>0) then
          begin
            endTok:=startTok+14;
            Result:=octt_OrgChartName;
            Exit;
          end;
   if (len<18) then Exit;
   startTok:=pos('<#ORGCHARTPICTURE>',s);
   if (startTok>0) then
          begin
            endTok:=startTok+17;
            Result:=octt_OrgChartPicture;
            Exit;
          end;
 end;

function  TMainForm.TrimPageBreak(s:String):String;
Var i:Integer;
    len:Integer;
    ch:Char;
 begin
   Result:='';
   if length(s)=0 then Exit;
   i:=1;
   len:=length(s);
   ch:=Chr($0c);
   while ((i<=len) and (s[i]<>ch)) do
    begin
     Result:=Result+s[i];
     inc(i);
    end;
 end;

function  TMainForm.CalcLevel(s:String):Integer;
Var t:String;
    i:Integer;
 begin
   Result:=0;
   if length(s)=0 then Exit;
   t:=s;
   i:=1;
   while (i<length(t)) do
    begin
      if t[i]='.' then inc(Result);
      inc(i);
    end;
   inc(Result);
 end;

function TMainForm.FoundStartLevel:Integer;
Var i,count,j:Integer;
    s:String;
 begin
  { Return Minimal non-zero level if exist
   or zero if none }
   Result:=0;
   count:=Editor.Lines.Count;
   i:=0;
   j:=0;
   while (i<count) and (j=0) do
       begin
         s:=Editor.Lines.Strings[i];
         s:=GetLineIndex(s);
         if length(s)<>0 then j:=CalcLevel(s);
         inc(i);
       end;
  Result:=j;
 end;

function TMainForm.FormatText:Boolean;
Var MinLevel:Integer;
    hm:Integer;
 begin
    Result:=False;
    MinLevel:=FoundStartLevel-1;
    if MinLevel>0 then
     begin
       hm:=Application.MessageBox('        ?','   ',MB_YESNO);
       if (hm=mrYes) then
        begin
         TruncateLevelEdit.Value:=MinLevel+1;
         TruncateButtonClick(self);
         Result:=True;
        end;
     end;
 end;

function TMainForm.QuitQuery:Boolean;
Var i:Integer;
begin
 try
  Result:=True;
  if Editor.Modified then
  i:=Application.MessageBox('  ?','  ',MB_YESNOCANCEL);
  case i of
   ID_YES:    SaveButtonClick(self);
   ID_CANCEL: Result:=False;
  end;
  except
   on E:Exception do
    begin
    WriteLog('QuitQuery',E);
    Result:=True;
    end;
  end;
end;

procedure TMainForm.ExitButtonClick(Sender: TObject);
begin
  try
  if QuitQuery then
   begin
    NormalExit:=True;
    if (PreviewForm<>nil) then
      begin
       PreviewForm.Close;
       PreviewForm:=nil;
      end;
    close;
   end;
  except
   on E:Exception do WriteLog('ExitButtonClick',E);
  end;
end;

procedure TMainForm.SetZagolovok(Sender: TObject);
var i:LongInt;
begin
 try
 i:=0;
 while (length(trim(editor.Lines[i]))=0) and (i<editor.Lines.Count) do
  begin
   inc(i);
  end;
  Zagolovok.Text:=editor.Lines[i];
  except
   on E:Exception do WriteLog('SetZagolovok',E);
  end;
end;

procedure TMainForm.LoadButtonClick(Sender: TObject);
begin
 try
 if QuitQuery then
 begin
 OpenDialog.InitialDir:=ExtractFilePath(Application.ExeName)+'Reports';
 if OpenDialog.Execute then
   begin
    FFileName:=OpenDialog.FileName;
    Editor.Clear;
   try
    Editor.Lines.LoadFromFile(FFileName);
   except
    Editor.InputFormat:=ifTEXT;
    Editor.Lines.LoadFromFile(FFileName);
    Editor.InputFormat:=ifRTF;
   end;
    Editor.SelectAll;
    Editor.SelAttributes.Hidden:=False;
    Editor.SelLength:=0;
    Editor.Modified:=False;
    repModified:=FormatText;
    CustomOrgChart1.Nodes.Clear;
    CustomOrgChart1.Nodes.LoadLevels(GetLoadFileName(FFileName,'lsa'));
    SetZagolovok(self);
    FModified:=repModified;
    Editor.Modified:=repModified;
    SaveButton.Enabled:=repModified;
    ExportButton.Enabled:=False;
    PrintButton.Enabled:=False;
    PreviewButton.Enabled:=False;
    OrfoButton.Enabled:=True;
    SaveItem.Enabled:=repModified;
    ExportItem.Enabled:=False;
    PrintItem.Enabled:=False;
    PreviewItem.Enabled:=False;
    OrfoItem.Enabled:=True;
    PageControl.ActivePage:=TabSheet1;
   end;
  end;
  except
   on E:Exception do WriteLog('LoadButtonClick',E);
  end;
end;

procedure TMainForm.LSetupButtonClick(Sender: TObject);
begin
 try
 Application.CreateForm(TLevelSetupForm, LevelSetupForm);
 except
   on E:Exception do WriteLog('LSetupButtonClick',E);
 end;
end;

procedure TMainForm.ConvertButtonClick(Sender: TObject);
Var bl:Boolean;
begin
 try
 SetAnimation(True);
 CustomOrgChart1.Visible:=False;
 Editor.WordWrap:=False;
 CustomOrgChart1.Nodes.Caption:=Zagolovok.Text;
 bl:=CustomOrgChart1.Nodes.LoadFromTStrings(Editor.Lines,LevelsEdit.Value,OnlyNumbers.Checked);
 if not(bl) then
   begin
    PageControl.ActivePage:=TabSheet2;
    PrintButton.Enabled:=True;
    PreviewButton.Enabled:=True;
    OrfoButton.Enabled:=False;
    ExportButton.Enabled:=True;
    ExportItem.Enabled:=True;
    PrintItem.Enabled:=True;
    PreviewItem.Enabled:=True;
    OrfoItem.Enabled:=False;
    SaveAsWEBButton.Enabled:=True;
    SaveAsWEBItem.Enabled:=True;
   end
 else LSetupButtonClick(self);
 SetAnimation(False);
 CustomOrgChart1.Visible:=True;
  except
   on E:Exception do
    begin
     CustomOrgChart1.Visible:=True;
     SetAnimation(False);
     WriteLog('ConvertButtonClick',E);
    end;
  end;
end;


procedure TMainForm.PrintButtonClick(Sender: TObject);
Var s:String;
begin
 try
 try
 SetAnimation(True);
 if PrintDialog.Execute then
   begin
    CustomOrgChart1.SetPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight);
    CustomOrgChart1.Print(GetOChartFName(FFileName,'lsa'));
   end;
  finally
   SetAnimation(False);
  end;
  except
   on E:Exception do
    begin
     WriteLog('PrintButtonClick',E);
     SetAnimation(False);
    end;
  end;
end;

procedure TMainForm.HeaderChange(Sender: TObject);
begin
 try
 CustomOrgChart1.HeaderText:='  '+Header.Text;
 except
  on E:Exception do WriteLog('HeaderChange',E);
 end;
end;

procedure TMainForm.PageSetupButtonClick(Sender: TObject);
begin
 { Page Setup }
  try
  Application.CreateForm(TPageSetupForm, PageSetupForm);
  except
   on E:Exception do WriteLog('PageSetupButtonClick',E);
  end;
end;

procedure TMainForm.FormStorageRestorePlacement(Sender: TObject);
begin
 try
 FPageTop:=FormStorage.RegIniFile.ReadInteger('PageParam','Top',20);
 FPageBottom:=FormStorage.RegIniFile.ReadInteger('PageParam','Bottom',20);
 FPageLeft:=FormStorage.RegIniFile.ReadInteger('PageParam','Left',25);
 FPageRight:=FormStorage.RegIniFile.ReadInteger('PageParam','Right',20);
  except
   on E:Exception do WriteLog('FormStorageRestorePlacement',E);
  end;
end;

procedure TMainForm.FormStorageSavePlacement(Sender: TObject);
begin
 try
 FormStorage.RegIniFile.WriteInteger('PageParam','Top',FPageTop);
 FormStorage.RegIniFile.WriteInteger('PageParam','Bottom',FPageBottom);
 FormStorage.RegIniFile.WriteInteger('PageParam','Left',FPageLeft);
 FormStorage.RegIniFile.WriteInteger('PageParam','Right',FPageRight);
  except
   on E:Exception do WriteLog('FormStorageSavePlacement',E);
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
Var i:Integer;
    fname:String;
    s:String;
    verInfo:TOSVersionInfoA;
begin
  try
   verInfo.dwOSVersionInfoSize:=sizeof(verInfo);
   GetVersionEx(verInfo);
   if verInfo.dwPlatformId=VER_PLATFORM_WIN32_NT then
     CustomOrgChart1.Nodes.Root.FuckingWin95:=False
   else
     CustomOrgChart1.Nodes.Root.FuckingWin95:=True;
   OrgChart.HasW95Error:=False;
   repModified:=False;
   MasterTable.DatabaseName:=ExtractFilePath(Application.ExeName);
   RegLoadToolbarPositions(self,myRegistryKey);
   NormalExit:=False;
   FFileName:='';
   FModified:=False;
   TZAnimate.ResName:='LMOVIE';
   SetAnimation(False);
   SaveButton.Enabled:=False;
   OrfoButton.Enabled:=True;
   SaveItem.Enabled:=False;
   OrfoItem.Enabled:=True;
   s:=ExtractFilePath(Application.ExeName);
   s:=copy(s,1,length(s)-1);
   s:=ExtractFilePath(s);
   s:=s+'HTML\ochtml.tpl';
   HTMLTemplate.Strings.LoadFromFile(s);
   Caption:='  (  '+orgchartVersion+' )';
   PageControl.ActivePage:=TabSheet1;
  if ParamCount > 0 then
   begin
   fname:=ParamStr(1);
   try
    Editor.Clear;
    Editor.InputFormat:=ifRTF;
    Editor.Lines.LoadFromFile(fname);
   except
    Editor.Clear;
    Editor.InputFormat:=ifTEXT;
    Editor.Lines.LoadFromFile(fname);
    Editor.InputFormat:=ifRTF;
   end;
   Editor.SelectAll;
   Editor.SelAttributes.Hidden:=False;
   Editor.SelLength:=0;
   Editor.Modified:=False;
   FFileName:=fname;
   FModified:=FormatText;
   repModified:=FModified;
   SetZagolovok(self);
   end;
   CustomOrgChart1.Nodes.LoadLevels(GetNewFileName(FFileName,'lsa'));
{   FModified:=False;}
   Editor.Modified:=FModified;
   SaveButton.Enabled:=FModified;
   ExportButton.Enabled:=False;
   SaveItem.Enabled:=FModified;
   ExportItem.Enabled:=False;
  except
   on E:Exception do WriteLog('FormCreate',E);
  end;
end;

procedure TMainForm.PrinterSetupButtonClick(Sender: TObject);
begin
 try
 if PrinterSetupDialog.Execute then
   begin
    if PreviewForm=nil then Exit;
    CustomOrgChart1.SetPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight);
    CustomOrgChart1.SetPreviewPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight);
    CustomOrgChart1.CreatePreview(GetOChartFName(FFileName,'lsa'));
    MaxPage.ReadOnly:=False;
    MaxPage.Text:=IntToStr(CustomOrgCHart1.QPrinter.AvailablePages);
    MaxPage.ReadOnly:=True;
    PreviewForm.QRPreview.QRPrinter:=CustomOrgCHart1.QPrinter;
    PreviewForm.QRPreview.ZoomToFit;
    PreviewZoom.Text:=IntToStr(PreviewForm.QRPReview.Zoom);
   end;
  except
   on E:Exception do WriteLog('PrinterSetupButtonClick',E);
  end;
end;

procedure TMainForm.MarkUnFormated;
begin
    if repModified then
    begin
    MasterTable.Close;
    MasterTable.Open;
    MasterTable.First;
    while not(MasterTable.EOF) do
     begin
      if (MasterTable.FieldByName('FileName').AsString=FFileName) then
      begin
       MasterTable.Edit;
       MasterTable.FieldByName('Formated').AsBoolean:=False;
       MasterTable.Post;
      end;
      MasterTable.Next;
     end;
    MasterTable.Close;
    end;
end;

procedure TMainForm.SaveButtonClick(Sender: TObject);
begin
 try
 SetAnimation(True);
 SaveDialog.InitialDir:=ExtractFilePath(Application.ExeName)+'Document';
 if FFileName='' then
  begin
    if SaveDialog.Execute then
     begin
       FFileName:=SaveDialog.FileName;
       Editor.Lines.SaveToFile(FFileName);
       CustomOrgChart1.Nodes.SaveLevels(GetNewFileName(FFileName,'lsa'));
       Editor.Modified:=False;
       FModified:=False;
       SaveButton.Enabled:=False;
       SaveItem.Enabled:=False;
     end;
  end
 else
  begin
    Editor.Lines.SaveToFile(FFileName);
    MarkUnFormated;
    CustomOrgChart1.Nodes.SaveLevels(GetNewFileName(FFileName,'lsa'));
    Editor.Modified:=False;
    FModified:=False;
  end;
  SetAnimation(False);
  except
   on E:Exception do
    begin
     SetAnimation(False);
     WriteLog('SaveButtonClick',E);
    end;
  end;
end;

procedure TMainForm.EditorChange(Sender: TObject);
begin
 try
 FModified:=True;
 SaveButton.Enabled:=True;
 SaveItem.Enabled:=True;
  except
   on E:Exception do WriteLog('EditorChange',E);
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 try
 CanClose:=NormalExit;
 if CanClose then Exit;
 CanClose:=QuitQuery;
 if CanClose and (PreviewForm<>nil) then
  begin
   PreviewFOrm.Close;
   PreviewForm:=nil;
  end;
  except
   on E:Exception do
    begin
     WriteLog('FormCloseQuery',E);
     CanClose:=True;
    end;
  end;
end;

procedure TMainForm.PreviewButtonClick(Sender: TObject);
begin
 try
 if PreviewForm=nil then
  begin
   SetAnimation(True);
   PreviewButton.Enabled:=False;
   PreviewItem.Enabled:=False;
   OrfoButton.Enabled:=False;
   OrfoItem.Enabled:=False;
   Application.CreateForm(TPreviewForm, PreviewForm);
   CustomOrgChart1.SetPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight);
   CustomOrgChart1.SetPreviewPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight);
   CustomOrgChart1.CreatePreview(GetOChartFName(FFileName,'lsa'));
   MaxPage.ReadOnly:=False;
   MaxPage.Text:=IntToStr(CustomOrgCHart1.QPrinter.AvailablePages);
   MaxPage.ReadOnly:=True;
   CustomOrgChart1.QPrinter.Orientation:=Printer.Orientation;
   PreviewForm.QRPreview.QRPrinter:=CustomOrgCHart1.QPrinter;
{   PreviewZoom.Text:=IntToStr(PreviewForm.QRPReview.Zoom);}
   PageControl.Visible:=False;
   ReportToolBar.Visible:=False;
   ExitButton.Enabled:=False;
   ExitItem.Enabled:=False;
   PreviewToolBar.Visible:=True;
   SetAnimation(False);
  end;
  except
   on E:Exception do
    begin
     SetAnimation(False);
     WriteLog('PreviewButtonClick',E);
    end;
  end;
end;

procedure TMainForm.PreviewZoomChange(Sender: TObject);
begin
 try
 if PreviewForm=nil then Exit;
 PreviewForm.QRPreview.Zoom:=StrToIntDef(PreviewZoom.Text,100);
  except
   on E:Exception do WriteLog('PreviewZoomChange',E);
  end;
end;

procedure TMainForm.EndPreviewButtonClick(Sender: TObject);
begin
 try
 if PreviewForm=nil then Exit;
 PreviewForm.Close;
 PreviewForm:=nil;
 except
  on E:Exception do WriteLog('EndPreviewButtonClick',E);
 end;
end;

procedure TMainForm.FirstButtonClick(Sender: TObject);
begin
 try
 if PreviewForm=nil then Exit;
 PageEdit.ReadOnly:=False;
 PageEdit.Text:=IntToStr(1);
 PreviewForm.QRPreview.PageNumber:=1;
 PageEdit.ReadOnly:=True;
 except
   on E:Exception do WriteLog('FirstButtonClick',E);
 end;
end;

procedure TMainForm.LastButtonClick(Sender: TObject);
begin
 try
  if PreviewForm=nil then Exit;
  PageEdit.ReadOnly:=False;
  PreviewForm.QRPreview.PageNumber:=PreviewForm.QRPreview.QRPrinter.AvailablePages;
  PageEdit.Text:=IntToStr(PreviewForm.QRPreview.QRPrinter.AvailablePages);
  PageEdit.ReadOnly:=True;
  except
   on E:Exception do WriteLog('LastButtonClick',E);
  end;
end;

procedure TMainForm.PrevButtonClick(Sender: TObject);
begin
 try
 if PreviewForm=nil then Exit;
 PageEdit.ReadOnly:=False;
 if PreviewForm.QRPreview.PageNumber > 1 then
  begin
   PreviewForm.QRPreview.PageNumber:=PreviewForm.QRPreview.PageNumber-1;
   PageEdit.Text:=IntToStr(PreviewForm.QRPreview.PageNumber);
  end;
  PageEdit.ReadOnly:=True;
  except
   on E:Exception do WriteLog('PrevButtonClick',E);
  end;
end;

procedure TMainForm.NextButtonClick(Sender: TObject);
begin
 try
 if PreviewForm=nil then Exit;
 PageEdit.ReadOnly:=False;
 if PreviewForm.QRPreview.PageNumber < PreviewForm.QRPreview.QRPrinter.AvailablePages then
  begin
   PreviewForm.QRPreview.PageNumber:=PreviewForm.QRPreview.PageNumber+1;
   PageEdit.Text:=IntToStr(PreviewForm.QRPreview.PageNumber);
  end;
 PageEdit.ReadOnly:=True;
  except
   on E:Exception do WriteLog('NextButtonClick',E);
  end;
end;

function TMainForm.GetLineIndex(var S:String):String;
begin
 try
 Result:='';
 if length(S)=0 then Exit;
 S:=TrimLeft(S);
 if length(S)=0 then Exit;
    While  (((S[1] >='0') and (S[1] <='9')) or (S[1] ='.')) do
      begin
       Result:=Result+copy(S,1,1);
       S:=copy(S,2,length(S)-1);
       if length(S)=0 then Exit;
      end;
 S:=TrimLeft(S);
  except
   on E:Exception do
    begin
     WriteLog('GetLineIndex',E);
     Result:='';
    end;
  end;
end;

function TMainForm.GetNewLevel(s:String):String;
begin
 try
 Result:=s;
 if length(Result)=0 then Exit;
  while ((Result[1] >='0') and (Result[1] <='9')) do
    begin
      Result:=copy(Result,2,length(Result)-1);
      if length(Result)=0 then Exit;
    end;
  if length(Result)>0 then
    if Result[1]='.' then Result:=copy(Result,2,Length(Result)-1);
  except
   on E:Exception do
    begin
     WriteLog('GetNewLevel',E);
     Result:='';
    end;
  end;
end;

procedure TMainForm.CheckForOne(Var s:String);
Var i:Integer;
    len:Integer;
    s1:String;
 begin
   { s - index in string - replace first level to 1 }
   s1:=GetNewLevel(s);
   if (length(s1)>0) then s:='1.'+s1 else
    s:='1.';
 end;

procedure TMainForm.TransformLine(Var s:String;Var success:Boolean;Var doNotAdd:Integer;level:Integer);
Var sindex,stmp,stmp1:String;
    i:Integer;
begin
 try
 success:=False;
 sindex:=s;
 if (length(sindex)<>0) then
 begin
 if s[1]='.' then
  begin { Backward Projection }
    success:=True;
    Exit;
  end   { Backward Projection }
 else
 begin  { Levels, Captions etc }
 sindex:=GetLineIndex(sindex);
 if length(sindex)=0 then Exit;
 stmp:=sindex;
 i:=0;
 while (i<level) and (length(sindex)>0) do
   begin
     sindex:=GetNewLevel(sindex);
     inc(i);
   end;
 if (length(sindex)> 0) or (i=level) then
    begin
      if doNotAdd=0 then doNotAdd:=1; { First stage }
      if (doNotAdd=3) and (length(sindex)=0) then
         begin
         doNotAdd:=4;
         success:=False;
         Exit;
        end;
      if (doNotAdd=2) and (length(sindex)=0) then
         begin
         doNotAdd:=3;
         success:=False;
         Exit;
        end;
      if (length(sindex)=0) and (doNotAdd=1) then
        begin
         doNotAdd:=2;
         success:=False;
         Exit;
        end;
      if (doNotAdd=4) then begin success:=False; Exit; end;
      if (length(sindex)>0) then
       begin
         {CheckForOne(sindex);}
         if doNotAdd=-1 then doNotAdd:=0;
         if (FIndexList.IndexOf(sindex)<>-1) then
          begin
            doNotAdd:=2;
            success:=False;
            Exit;
          end;
         FIndexList.Append(sindex);
       end;
      if length(s)=length(stmp) then
        s:=sindex
      else
       begin
        stmp1:=copy(s,length(stmp)+1,length(s)-length(stmp));
        s:=stmp1;
       end;
      s:=sindex+s;
      success:=True;
    end;
  end; { Levels, Captions etc }
  end else success:=False;
  except
   on E:Exception do WriteLog('TransformLine',E);
  end;
end;

procedure TMainForm.TruncateButtonClick(Sender: TObject);
Var strList:TStringList;
    i:Integer;
    level:Integer;
    toAdd:Boolean;
    notAdd:Integer;
    s:String;
begin
  try
  SetAnimation(True);
  level:=TruncateLevelEdit.Value;
  if level=0 then Exit;
  strList:=TStringList.Create;
  FIndexList:=TStringList.Create;
  strList.Clear;
  FIndexList.Clear;
  strList.Append(' ');
  notAdd:=-1;
  for i:=0 to (Editor.Lines.Count-1) do
   begin
     s:=Editor.Lines.Strings[i];
     s:=TrimLeft(s);
     s:=TrimPageBreak(s);
     TransformLine(s,toAdd,notAdd,level);
     if toAdd then strList.Append(s);
   end;
  Editor.Lines.Clear;
  Editor.Lines.AddStrings(strList);
  SetZagolovok(Self);
  strList.Free;
  FIndexList.Free;
  repModified:=True;
  PageControl.ActivePage:=TabSheet1;
  SetAnimation(False);
  except
   on E:Exception do
    begin
     SetAnimation(False);
     WriteLog('TruncateButtonClick',E);
    end;
  end;
end;


procedure TMainForm.FormDestroy(Sender: TObject);
begin
  try
  RegSaveToolbarPositions(self,myRegistryKey);
  except
   on E:Exception do WriteLog('FormDestroy',E);
  end;
end;

procedure TMainForm.HelpButtonClick(Sender: TObject);
begin
  try
  Application.HelpCommand(HELP_CONTENTS, 0);
  except
   on E:Exception do WriteLog('HelpButtonClick',E);
  end;
end;

procedure TMainForm.SetAnimation(Value:Boolean);
begin
 try
  TZAnimate.Active:=Value;
  TZAnimate.Visible:=Value;
  TZImage.Visible:=not(Value);
  except
   on E:Exception do WriteLog('SetAnimation',E);
  end;
end;

procedure TMainForm.PageControlChange(Sender: TObject);
begin
 if PageControl.ActivePage=TabSheet1 then
  begin
  OrfoButton.Enabled:=True;
  OrfoItem.Enabled:=True;
  SaveAsWEBButton.Enabled:=False;
  SaveAsWEBItem.Enabled:=False;
  end;
 if PageControl.ActivePage=TabSheet2 then
  begin
  OrfoButton.Enabled:=False;
  OrfoItem.Enabled:=False;
  SaveAsWEBButton.Enabled:=True;
  SaveAsWEBItem.Enabled:=True;
  end;
end;

procedure TMainForm.OrfoButtonClick(Sender: TObject);
begin
  try
   SetAnimation(True);
   SpellChecker.Check(Editor);
   SetAnimation(False);
  except
   on E:Exception do
     begin
      SetAnimation(False);
      WriteLog('OrfoButtonClick',E);
      if E.Message='    2' then
        Application.MessageBox('   64000 .','  ',MB_OK)
      else
        Application.MessageBox('   MS Orfo','  ',MB_OK);
     end;
  end;
end;

procedure TMainForm.ExportButtonClick(Sender: TObject);
Var bm:TBitmap;
    tmp:String;
    tz:TJPEGImage;
    tg:TGIFImage;
begin
 try
 try
 SetAnimation(True);
 SaveDialog1.InitialDir:=ExtractFilePath(Application.ExeName)+'Document\';
 tmp:=ExtractFileName(FFileName);
 if Pos('.',tmp)<>0 then
  SaveDialog1.FileName:=Copy(tmp,1,Pos('.',tmp)-1){+'.bmp'}
 else
  SaveDialog1.FileName:=tmp{+'.bmp'};
 if SaveDialog1.Execute then
 begin
   case SaveDialog1.FilterIndex of
   1: begin { bmp }
       if (pos('.bmp',SaveDialog1.FileName)=0) then
        SaveDialog1.FileName:=SaveDialog1.FileName+'.bmp';
       CustomOrgChart1.CreateBitmap(bm,pf4bit);
       bm.SaveToFile(SaveDialog1.FileName);
       bm.Free;
      end;
    2: begin { jpg }
       if (pos('.jpg',SaveDialog1.FileName)=0) then
        SaveDialog1.FileName:=SaveDialog1.FileName+'.jpg';
        CustomOrgChart1.CreateBitmap(bm,pf8bit);
        tz:=TJPEGImage.Create;
        tz.Assign(bm);
        tz.Compress;
        tz.SaveToFile(SaveDialog1.FileName);
        bm.Free;
        tz.Free;
       end;
     3: begin  { GIF image }
         if (pos('.gif',SaveDialog1.FileName)=0) then
         SaveDialog1.FileName:=SaveDialog1.FileName+'.gif';
         CustomOrgChart1.CreateBitmap(bm,pf8bit);
         tg:=TGIFImage.Create;
         tg.Assign(bm);
         tg.Pack;
         tg.OptimizeColorMap;
         tg.SaveToFile(SaveDialog1.FileName);
         bm.Free;
         tg.Free;
        end;
   end; {case }
    SetAnimation(False);
    Application.MessageBox('  ',
                             ' ',MB_OK);
  end;
  finally
    SetAnimation(False);
  end;
 except
   on E:Exception do WriteLog('ExportButtonClick',E);
 end;
end;

procedure TMainForm.CreateNewItemClick(Sender: TObject);
begin
  QuitQuery;
  Editor.Lines.Clear;
  FFileName:='';
  FModified:=False;
  FModified:=False;
  repModified:=False;
  CustomOrgChart1.Nodes.Clear;
  CustomOrgChart1.Nodes.LoadLevels(GetNewFileName(FFileName,'lsa'));
  FModified:=False;
  Editor.Modified:=FModified;
  SaveButton.Enabled:=True;
  ExportButton.Enabled:=False;
  PrintButton.Enabled:=False;
  PreviewButton.Enabled:=False;
  OrfoButton.Enabled:=True;
  SaveItem.Enabled:=True;
  ExportItem.Enabled:=False;
  PrintItem.Enabled:=False;
  PreviewItem.Enabled:=False;
  OrfoItem.Enabled:=True;
end;

procedure TMainForm.OnlyNumbersClick(Sender: TObject);
begin
 if OnlyNumbers.Checked then
    OnlyNumbers.Checked:=False
 else
    OnlyNumbers.Checked:=True;
end;

procedure TMainForm.AboutItemClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.SaveAsWEBButtonClick(Sender: TObject);
Var HTMLText:String;
         tmp:String;
    tmpModel:String;
           f:TextFile;
         root:String;
 imgFileName:String;
 htmlFileName:String;
  imgW,imgH:Integer;
          bm:TBitmap;
      imgUrl:String;
          tz:TJPEGImage;
          tg:TGIFImage;
         endStr:String;
           tmp1:String;
      tcount,ic:Integer;
       HTMLLine:String;
    btstr,atstr:String;
         st,et:Integer;
 translateType:Integer;
        iWidth:Integer;
       iHeight:Integer;
         iType:Integer;

function URLEncode(Const s:string):String;
var i,len:Integer;
 begin
   Result:='';
   len:=Length(s);
   if len=0 then Exit;
   for i:=1 to len do
     if ((Byte(Ord(s[i])))>127) or ((Byte(Ord(s[i])))<=32) then
       Result:=Result+'%'+IntToHex(Ord(s[i]),2)
     else
       Result:=Result+s[i];
 end;

begin
  if length(FFileName)=0 then
    begin
      Application.MessageBox('     ',
                             '  WEB-',MB_OK or MB_ICONERROR);
      Exit;
    end;
  if QuerySaveImageDlg(translateType,iWidth,iHeight,IType) then
  begin
  SetAnimation(True);
  tmp:=ExtractFileName(FFileName);
  tmp1:=ExtractFilePath(FFileName);
  EndStr:=Chr($0D)+Chr($0A);
  if (pos('.',tmp)<>0) then tmp:=copy(tmp,1,pos('.',tmp)-1);
  root:=ExtractFilePath(Application.ExeName);
   if CompareText(tmp1,root)=0 then
     begin
       { no model }
       tmpModel:=tmp;
     end
   else
     begin
       tmpModel:=ExtractFilePath(FFileName);
       tmpModel:=copy(tmpModel,1,length(tmpModel)-1);
       tmpModel:=ExtractFileName(tmpModel);
     end;
  root:=copy(root,1,length(root)-7);
  root:=root+'HTML';
  CreateDir(root);
  root:=root+'\'+tmpModel;
  CreateDir(root);
  imgFileName:=root+'\'+tmp;
  imgURL:='/struct/'+URLEncode(tmpModel+'/'+tmp);
  htmlFileName:=root+'\'+tmp+'.HTM';
  case iType of
    0:  begin
          { BMP File }
          imgFileName:=imgFileName+'.bmp';
          imgURL:=imgURL+'.bmp';
          CustomOrgChart1.CreateBitmap(bm,pf4bit);
          bm.SaveToFile(imgFileName);
          imgW:=bm.Width;
          imgH:=bm.Height;
          bm.Free;
        end;
    1:  begin
          { JPEG File }
          imgFileName:=imgFileName+'.jpg';
          imgURL:=imgURL+'.jpg';
          CustomOrgChart1.CreateBitmap(bm,pf8bit);
          tz:=TJPEGImage.Create;
          tz.Assign(bm);
          tz.Compress;
          tz.SaveToFile(imgFileName);
          imgW:=bm.Width;
          imgH:=bm.Height;
          bm.Free;
          tz.Free;
        end;
    2:  begin
          { GIF File }
          imgFileName:=imgFileName+'.gif';
          imgURL:=imgURL+'.gif';
          CustomOrgChart1.CreateBitmap(bm,pf8bit);
          tg:=TGIFImage.Create;
          tg.Assign(bm);
          tg.Pack;
          tg.OptimizeColorMap;
          tg.SaveToFile(imgFileName);
          imgW:=bm.Width;
          imgH:=bm.Height;
          bm.Free;
          tg.Free;
        end;
  end;
  HTMLText:='';
  tcount:=HTMLTemplate.Strings.Count-1;
  for ic:=0 to tcount do
    begin
      HTMLLine:=HTMLTemplate.Strings.Strings[ic];
      case ScanKnownToken(HTMLLine,st,et) of
        octt_Unknown: begin
                        HTMLText:=HTMLText+HTMLLine+EndStr;
                      end;
        octt_PrilNumber: begin
                        btstr:=copy(HTMLLine,1,st-1);
                        atstr:=copy(HTMLLine,et+1,length(HTMLLine)-et);
                        HTMLLine:=btstr+Header.Text+atstr;
                        HTMLText:=HTMLText+HTMLLine+EndStr;
                      end;
        octt_OrgChartName: begin
                        btstr:=copy(HTMLLine,1,st-1);
                        atstr:=copy(HTMLLine,et+1,length(HTMLLine)-et);
                        HTMLLine:=btstr+tmp+atstr;
                        HTMLText:=HTMLText+HTMLLine+EndStr;
                      end;
        octt_OrgChartPicture: begin
                        btstr:=copy(HTMLLine,1,st-1);
                        atstr:=copy(HTMLLine,et+1,length(HTMLLine)-et);
                        HTMLLine:=btstr+ '<img src="'+imgURL+'" width="'+
                                  IntToStr(imgW)+'" height="'+
                                  IntToStr(imgH)+'" border="0">'+atstr;
                        HTMLText:=HTMLText+HTMLLine+EndStr;
                      end;
      end; { case }
    end;
  AssignFile(f,htmlFileName);
  Rewrite(f);
  System.Write(f,HTMLText);
  CloseFile(f);
  SetAnimation(False);
  Application.MessageBox('WEB- ',
                             ' WEB-',MB_OK);
  end;

end;

function  TMainForm.QuerySaveImageDlg(Var translateType,iWidth,iHeight,ImageType:Integer):Boolean;
 begin
{  SelWEBImageDlg.ImageWidth.Width:=400;
  SelWeBImageDlg.ImageHeight.Height:=300;
  SelWEBImageDlg.DiagramType.ItemIndex:=0;}
  SelWEBImageDlg.ImageType.ItemIndex:=1;
  Result:=(SelWEBImageDlg.ShowModal=mrOk);
  translateType:=SelWEBImageDlg.DiagramType.ItemIndex;
  iwidth:=SelWEBImageDlg.ImageWidth.Width;
  iheight:=SelWeBImageDlg.ImageHeight.Height;
  imageType:=SelWEBImageDlg.ImageType.ItemIndex;
 end;

end.
