unit OrgChart;

{$A-}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Printers,QRPrntr,Langs;

Const EM_FORMATRANGE                      = WM_USER + 57;

type

  TVAlignment =(taTopJustify,taVCenter,taBottomJustify);

  TDSStrategyType = (stHTree,stVTree,stVLRTree,stVLR2Tree);

  TDSShadowType = (shNone,shLeftBoxed,shLeftFramed,shTopPerspective,
   shInversePerspective,shRightBoxed,shRightFramed,shBottomPerspective);

  TDSRectStyle = (reNone,re1x,re2x,re3x,re4x,re2x3,re3x2,re2x4,re4x2,
                  re2x5,re5x2);
    { None        0
      1x          1
      2x          2
      3x          3
      4x          4
      2x3         2 reSpace 3
        }

 TOrgLevel = packed record
    FontName:String[255];
    FontSize:Word;
    Language:TLanguage;
    FontColor:TColor;
    Color:TColor;
    PaintColor:TColor;        {    }
    DrawColor:TColor;         {   }
    ShadowType:TDSShadowType; {   }
    ShadowColor:TColor;   {   }
    ShadowDepth:Integer;  {   }
    RectStyle:TDSRectStyle; {  }
    LineStyle:TPenStyle;    {     ;) }
    LineWidth:Integer;      {    }
    DefWidth:Integer;       {    }
    DefHeight:Integer;      {    }
    HSpacing:Integer;       {       }
    VSpacing:Integer;       {       }
    HAlign:TAlignment;      {    }
    VAlign:TVAlignment;     {    -    FAutoHeight=False}
    Warning:Boolean;          { Warning at this level }
    HInterval:Integer;
    VInterval:Integer;
    MaxWidth:Integer;         { For Level only }
    MaxHeight:Integer;        { For Level only }
    Strategy:TDSStrategyType; { Strategy for drawing tree }
    LineDepth:Integer;        { Line Depth }
    LineColor:TColor;         { Line Color }
    FontStyle:TFontStyles;    { projection font style }
    PrjFontName:String[255];  { projection font name }
    PrjFontSize:Integer;      { Projection font size }
    PrjFontColor:TColor;      { Projection font color }
    PrjFontStyle:TFontStyles; { Projection font style }
    NoControlChar:Boolean;    { Dont show control charasters }
    NumbersOnly:Boolean;      { Reserved for future }
 end;

  TCustomOrgChart = class;
  TOrgChartNode = class;
  TOrgChartNodes = class;

{ TOrgChartNode definition }
  TOrgChartNode = class(TGraphicControl)
  private
    { Private declarations }
    FUpdating:Boolean;
    FChildNode:TOrgChartNode;
    FBrotherNode:TOrgChartNode;
    FText:String;                  {   ॢ  }
    FProjection:String;            { Projection text        }
    FChildIndex:Integer;           { Child Index  0 as Root }
    FBrotherIndex:Integer;         { Brother Index 0 as Root }
    FIndex:String;                 { TextIndex for WriteNode }
      { Drawing Options }
    FPaintColor:TColor;   {    }
    FDrawColor:TColor;    {   }
    FShadowType:TDSShadowType; {   }
    FShadowColor:TColor;   {   }
    FShadowDepth:Integer;  {   }
    FRectStyle:TDSRectStyle; {  }
    FLineStyle:TPenStyle;    {     ;) }
    FLineWidth:Integer;      {    }
    FLineColor:TColor;
     {New options }
    FDefWidth:Integer;       {    }
    FDefHeight:Integer;      {    }
    FMaxWidth:Integer;
    FMaxHeight:Integer;
    FAutoHeight:Boolean;     {     }
    FAutoWidth:Boolean;      {     }
    FHSpacing:Integer;       {       }
    FVSpacing:Integer;       {       }
    FHAlign:TAlignment;      {    }
    FVAlign:TVAlignment;     {    -    FAutoHeight=False}
    FWarning:Boolean;
    {Internal variables}
    FIntervalLeft:Integer;
    FIntervalRight:Integer;
    FIntervalTop:Integer;
    FIntervalBottom:Integer;
    FShadowLeft:Integer;
    FShadowRight:Integer;
    FShadowTop:Integer;
    FShadowBottom:Integer;
    {}
    FHInterval:Integer;
    FVInterval:Integer;
    {}
    FFontDPI:Integer;
    {}
    FFuckingWin95:Boolean;
    FPrjFont:TFont;
    { New !!! }
    FNoControlChar:Boolean;
    FNumbersOnly:Boolean;
    {procedures & functions for Draw }
    procedure SetAttr(src:TOrgLevel;AWidth,AHeight:Boolean);
    procedure SetMaxAttr(src:TOrgLevel;AWidth,AHeight:Boolean);
    procedure SetUpRect(r: TRect; SubLine:Boolean; SubY:Integer); { Draw Frame with RectStyle}
    procedure DrawRect(r:TRect;val1,val2:Integer; SubLine:Boolean; SubY:Integer); {Internal Subroutine}
    function  GetRectSize:TRect; { fucking calculation function }
    function  GetProjRectSize(left,top:Integer):TRect;
    function  GetFont:TFont;
    procedure SetFont(Font:TFont);
    function  GetPrjFont:TFont;
    procedure SetPrjFont(Font:TFont);
    procedure SetText(Value: String);
    function  GetText:String;
    procedure SetProjection(Value: String);
    function  GetProjection:String;
    procedure SetRectStyle(Value: TDSRectStyle);
    procedure SetRectInterval(Value: Integer); {Internal function}
    procedure SetDrawColor(Value: TColor);
    procedure SetLineStyle(Value: TPenStyle);
    procedure SetLineWidth(Value: Integer);
    procedure SetPaintColor(Value: TColor);
    procedure SetShadowColor(Value: TColor);
    procedure SetShadowType(Value: TDSShadowType);
    procedure SetShadowInterval(Left,Right,Top,Bottom:Integer); { Internal function}
    procedure SetShadowDepth(Value: Integer);
    procedure DrawShadow;
    procedure DrawShadowLeft(Diagonal:Boolean); {Internal function }
    procedure DrawShadowRight(Diagonal:Boolean);{Internal function }
    procedure DrawShadowTop; {Internal function }
    procedure DrawShadowBottom(Diagonal:Boolean;Orient:Integer); {Internal function }
    procedure SetDefWidth(Value: Integer);
    procedure SetDefHeight(Value: Integer);
    procedure SetAutoHeight(Value: Boolean);
    procedure SetAutoWidth(Value: Boolean);
    procedure SetHAlign(Value: TAlignment);
    procedure SetVAlign(Value: TVAlignment);
    procedure SetVSpacing(Value: Integer);
    procedure SetHSpacing(Value: Integer);
    { Procedures for tree }
    procedure SetBrotherIndex(Value: Integer);
    procedure SetChildIndex(Value: Integer);
    function  GetSpaces(Count: Integer):String;
    procedure SetNode(lleft,ltop:Integer);
    procedure ClearMaxWH;
    procedure CalcMaxWH(Level:Integer);
    procedure UDError(Text:String;Level:Integer);
    {}
    function  TreeH(CurrCoord:TPoint;PWidth,PHeight,Level:Integer;HasVTree:Boolean;HasW95:Boolean):TPoint;
    function  TreeV(CurrCoord:TPoint;PWidth,PHeight,Level:Integer;HasVTree:Boolean;HasW95:Boolean):TPoint;
    procedure SetLineColor(Value: TColor);
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
    procedure   SetFontCharset(ch:TFontCharset);
    constructor Create(AOwner: TComponent);  override; { Create empty node }
    destructor  Destroy; override;             { Call only for root entry }
    function   AddChild:TOrgChartNode;        { Add only if nil }
    function   AddBrother:TOrgChartNode;      { Add only if nil }
    procedure  FullDeleteChilds;              { Destructive delete }
    procedure  FullDeleteBrothers;            { Destructive delete }
    procedure  DeleteChild;                   { Non destructive delete }
    procedure  DeleteBrother;                 { Non Destructive delete }
    procedure  SetFuckingWin95(Value:Boolean);
    procedure  WriteNode(Var F:TextFile);
    procedure  ReIndex(iChild,iBrother:Integer);
    function   SetUpTree:TPoint;
    procedure  PreSetupTree;
    function   ControlUser(Level:Integer):Boolean; { Controls User Setting for Tree }
    procedure  SetTreeColor(Value:TColor);
    procedure  SetFontDPI(Handle:HDC);
    procedure  SetFontDPI1(NewDPI:Integer);
    procedure  RestoreFontDPI;
  published
    { Published declarations }
    property Child:TOrgChartNode read FChildNode;
    property Brother:TOrgChartNode read FBrotherNode;
    property Text:String read GetText write SetText;
    property Projection:String read GetProjection write SetProjection;
    property ChildIndex:Integer read FChildIndex write SetChildIndex default 0;
    property BrotherIndex:Integer read FBrotherIndex write SetBrotherIndex default 0;
    property Index:String read FIndex write FIndex;
    property LineWidth:Integer read FLineWidth write SetLineWidth default 1;
    property LineColor:TColor read FLineColor write SetLineColor default clBlack;
    property RectLineStyle:TPenStyle read FLineStyle write SetLineStyle;
    property RectColor:TColor read FDrawColor write SetDrawColor default clWindowText;
    property PaintColor:TColor read FPaintColor write SetPaintColor default clWindow;
    property ShadowColor:TColor read FShadowColor write SetShadowColor default clWindowText;
    property ShadowType:TDSShadowType read FShadowType write SetShadowType;
    property ShadowDepth:Integer read FShadowDepth write SetShadowDepth default 4;
    property Color default clWhite;
    property RectStyle:TDSRectStyle read FRectStyle write SetRectStyle;
    property Font:TFont read getFont write SetFont;
    property PrjFont:TFont read getPrjFont write SetPrjFont;
    property FuckingWin95:Boolean read FFuckingWin95 write SetFuckingWin95 default True;
    property Height default 30;
    property Width  default 50;
    property Visible;
    property DragCursor;
    property DragMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property Hint;
    property ShowHint;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property HInterval:Integer read FHInterval write FHInterval default 10;
    property VInterval:Integer read FVInterval write FVInterval default 10;
    { New propeties }
    property DefWidth:Integer read FDefWidth write SetDefWidth default 100;
    property DefHeight:Integer read FDefHeight write SetDefHeight default 100;
    property AutoHeight:Boolean read FAutoHeight write SetAutoHeight default True;
    property AutoWidth:Boolean read FAutoWidth write SetAutoWidth default True;
    property HSpacing:Integer read FHSpacing write SetHSpacing default 8;
    property VSpacing:Integer read FVSpacing write SetVSpacing default 8;
    property HAlign:TAlignment read FHAlign write SetHAlign default taCenter;
    property VAlign:TVAlignment read FVAlign write SetVAlign default taVCenter;
    property Warning:Boolean read FWarning write FWarning default False;
    property MaxWidth:Integer read FMaxWidth default 0;
    property MaxHeight:Integer read FMaxHeight default 0;
    property NoControlChar:Boolean read FNoControlChar write FNoControlChar default True;
    property NumbersOnly:Boolean read FNumbersOnly write FNumbersOnly default False;
    property Parent;
  end;

{ TOrgChartNodes definition }
  TOrgChartNodes = class(TPersistent)
  private
    { Private declarations }
    FOwner:TCustomOrgChart;
    FCount:Integer;
    FRoot:TOrgChartNode;
    FDetailLevel:Integer;     { Max number of level for loading }
    FStrategy:TDSStrategyType; { Strategy for drawing tree }
    FHInterval:Integer;        {  H Interval in pixels }
    FVInterval:Integer;        {  V Interval in pixels }
    FLineWidth:Integer;        { Line Width}
    FOrgLevels:Array[0..10] of TOrgLevel;
    procedure SetLevelsDefault;
    function IsNextLevel(var s1:string):Integer; { Return Level, elsewise return -1 }
    function SetUpBrother(item:TOrgChartNode;iBrother:Integer):TOrgChartNode;
    function SetUpChild(item:TOrgChartNode):TOrgChartNode;
    function GetLineIndex(var S:String):String;
    procedure WriteTree(Var F:TextFile);
    procedure SetCaption(Value: String);
    function  GetCaption:String;
    function  GetOrgLevel(pIndex: Integer):TOrgLevel;
    procedure SetOrgLevel(pIndex: Integer;Value:TOrgLevel);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent);
    destructor  Destroy; override;
    function    InsertItem(Index:String;Caption:String):TOrgChartNode;
    function    LoadFromFile(FileName:String;MaxDetail:Integer;OnlyLevels:Boolean):Boolean;
    function    LoadFromTStrings(Strings:TStrings;MaxDetail:Integer;OnlyLevels:Boolean):Boolean;
    function    SaveToFile(FileName:String;MaxDetail:Integer):Boolean;
    procedure   Clear;
    function  SetUpTree:TPoint;       { Main Strategy Proc }
    procedure SaveLevels(const FileName:String);
    procedure LoadLevels(const FileName:String);
    function  ControlUser:Boolean;
    procedure PreSetupTree;
  published
    { Published declarations }
    property Root:TOrgChartNode read FRoot;
    property DetailLevel:Integer read FDetailLevel default 0;
    property Count:Integer read FCount default 1;
    property Caption:String read GetCaption write SetCaption;
    property Strategy:TDSStrategyType read FStrategy write FStrategy default stHTree;
    property HInterval:Integer read FHInterval write FHInterval default 10;
    property VInterval:Integer read FVInterval write FVInterval default 10;
    property LineWidth:Integer read FLineWidth write FLineWidth default 1;
    property Parent:TCustomOrgChart read FOwner write FOwner;
    property Levels[Index:Integer]:TOrgLevel read getOrgLevel write setOrgLevel;
  end;

{ TCustomOrgChart definition }
  TCustomOrgChart = class(TScrollingWinControl)
  private
    { Private declarations }
    FNodes:TOrgChartNodes;                         { 砥 ॢ }
    FCanvas: TCanvas;
    FPainting:Boolean; { So disable double insert in painting module }
    FHeaderText:String;
    FTitleText:String;
    FShowTitle:Boolean;
    { Page Param Options }
    FPageTop:Integer;
    FPageBottom:Integer;
    FPageLeft:Integer;
    FPageRight:Integer;
    MMMPT:Integer;
    MMMPB:Integer;
    MMMPL:Integer;
    MMMPR:Integer;
    FPrinter:TQRPrinter;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    function  CalcHeader:Integer;
    procedure PrintHeader;
    function  PreviewCalcHeader:Integer;
    procedure PreviewPrintHeader;
  protected
    { Protected declarations }
    procedure Paint; virtual;
    procedure PaintWindow(DC: HDC); override;
    procedure PaintTo(DC: HDC; X, Y: Integer);
    procedure PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect);
    procedure PrintRect(left,right,top,bottom:Integer);
    procedure PrintPageNum(x,y,left,right,top,bottom:Integer);
    procedure PreviewPrintRect(left,right,top,bottom:Integer);
    procedure PreviewPrintPageNum(x,y,left,right,top,bottom:Integer);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Print(nFileName:String);
    procedure CreatePreview(nFileName:String);
    procedure SetPageParam(var PageTop,PageBottom,PageLeft,PageRight:Integer);
    procedure SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer);
    procedure CreateBitmap(Var bm:TBitmap;pf:TPixelFormat);
    procedure CreateBitmapWithSize(Var bm:TBitmap;pf:TPixelFormat;iw,ih:Integer;nFileName:String);
    procedure CreateBitmapShit(Var bm:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer);
    function  GetOrgchartSize:TPoint;
  published
    { Published declarations }
    property Nodes:TOrgChartNodes read FNodes;                {  ஢ 
                                                       OrgChart}
    property Align default alNone;
    property Width default 100;
    property Height default 100;
    property Enabled;
    property ShowHint;
    property Visible;
    property Ctl3D;
    property TabStop;
    property TabOrder;
    property Canvas:TCanvas read FCanvas;
    property HeaderText:String read FHeaderText write FHeaderText;
    property QPrinter:TQRPrinter read FPrinter;
    property TitleText:String read FTitleText write FTitleText;
    property ShowTitle:Boolean read FShowTitle write FShowTitle default False;
  end;

procedure Register;

Const reSpace=2;
      fnLevels='DOTS\ .lsa'; { level setup attributes }


Var   HasW95Error:Boolean;

implementation

Uses PBarDlgUnit;

{ TOrgChartNode }

procedure   TOrgChartNode.SetFontCharset(ch:TFontCharset);
begin
 Font.Charset:=ch;
 if (Brother<>nil) then Brother.SetFontCharset(ch);
 if (Child<>nil) then Child.SetFontCharset(ch);
end;


procedure  TOrgChartNode.SetTreeColor(Value:TColor);
begin
 color:=Value;
 if (Brother<>nil) then Brother.SetTreeColor(Value);
 if (Child<>nil) then Child.SetTreeColor(Value);
end;

procedure TOrgChartNode.SetFuckingWin95(Value:Boolean);
 begin
   if FFuckingWin95=Value then Exit;
   FFuckingWin95:=Value;
   if (Brother<>nil) then Brother.SetFuckingWin95(Value);
   if (Child<>nil) then Child.SetFuckingWin95(Value);
 end;

procedure TOrgChartNode.SetProjection(Value: String);
Var s,s1:String;
    i:Integer;
    len:Integer;
function clearcontrolchar(s:string):string;
var i,j:integer;
    s2:TStringlist;
    ss:string;
begin
i:=1;
s2:=TStringList.create;
ss:='';
for i:=1 to length(s) do
if s[i]=#13 then
begin
s2.add(ss);
ss:=''
end
else ss:=ss+s[i];
if ss<>'' then s2.add(ss);
result:='';
for i:=0 to s2.count-1 do
begin
j:=1;
if (pos(' ',s2[i])=1)or
   (pos(' ',s2[i])=1)or
   (pos(' ',s2[i])=1)or
   (pos('$$ ',s2[i])=1)or
   (pos('~~ ',s2[i])=1)or
   (pos('@@ ',s2[i])=1)or
   (pos(':: ',s2[i])=1)
    then s2[i]:=trim(copy(s2[i],3,length(s)))
else
begin
while (j<=length(s2[i]))and(s2[i][j]='.') do inc(j);
s2[i]:=copy(s2[i],j,length(s2[i]));
end;
end;
result:='';
for i:=0 to s2.count-1 do
result:=result+s2[i]+#13;
result:=trim(result);
s2.free;
end;
function LineNumber(Const s:String;index,len:Integer):Boolean;
Var chprev:Char;
 chnext:Char;
 prevdig:Boolean;
 nextdig:Boolean;
 begin
   if index>1 then
      begin
        chprev:=s[index-1];
        if ((chprev>='0') and (chprev<='9')) then
          prevdig:=True
         else
          prevdig:=False;
      end
    else
      prevdig:=False;
   if index<len then
      begin
       chnext:=s[index+1];
       if ((chnext>='0') and (chnext<='9')) or
           (chnext=' ') or (chnext=Chr($0D)) then
          nextdig:=True
         else
          nextdig:=False;
      end
    else
      nextdig:=True;
   Result:=prevdig and nextdig;
 end;

 begin
   s:=Value;
   if FNoControlChar then
    begin
      s:=clearcontrolchar(s);
    end;
   FProjection:=s;
   if not(FUpdating) then Paint;
 end;

function  TOrgChartNode.GetProjection:String;
 begin
   Result:=FProjection;
 end;

constructor TOrgChartNode.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FNoControlChar:=True;
   FNumbersOnly:=False;
   FUpdating:=False;
   Color:=clWhite;
   FPaintColor:=clWindow;
   FDrawColor:=clWindowText;
   FShadowType:=shNone;
   FShadowDepth:=4;
   FLineStyle:=psSolid;
   FLineWidth:=1;
   FIntervalLeft:=2*FLineWidth;
   FIntervalTop:=2*FLineWidth;
   FIntervalBottom:=2*FLineWidth;
   FIntervalRight:=2*FLineWidth;
   FShadowLeft:=0;
   FFuckingWin95:=False;
   FShadowRight:=0;
   FShadowTop:=0;
   FShadowBottom:=0;
   FRectStyle:=re2x;
   FText:='';
   FProjection:='';
   FShadowColor:=clWindowText;
   FChildNode:=nil;
   FBrotherNode:=nil;
   FChildIndex:=0;
   FBrotherIndex:=0;
   FIndex:='';
   FHInterval:=10;
   FVInterval:=10;
    FDefWidth:=100;
    FDefHeight:=100;
    FAutoHeight:=True;
    FAutoWidth:=True;
    FHSpacing:=8;
    FVSpacing:=8;
    FHAlign:=taCenter;
    FVAlign:=taVCenter;
    FWarning:=False;
    FMaxWidth:=0;
    FMaxHeight:=0;
    FFontDPI:=0;
    FLineColor:=clBlack;
    FPrjFont:=TFont.Create;
    FPrjFont.Assign(Font);
    Parent:=AOwner as TCustomOrgChart; {???}
end;

destructor  TOrgChartNode.Destroy;
begin
 if (FPrjFont<>nil) then
   begin
     FPrjFont.Free;
     FPrjFont:=nil;
   end;
 if length(FProjection)>0 then
  begin
    FProjection:='';
  end;
 if (FChildNode<>nil) then FChildNode.Destroy;
 if (FBrotherNode<>nil) then FBrotherNode.Destroy;
 Parent:=nil;
 inherited Destroy;
end;

procedure TOrgChartNode.SetLineColor(Value: TColor);
begin
 FLineColor:=Value;
 if not(FUpdating) then Paint;
end;

function   TOrgChartNode.AddChild:TOrgChartNode;
begin
  if (FChildNode = nil) then
    begin
     FChildNode:=TOrgChartNode.Create(Parent);
     FChildNode.ChildIndex:=ChildIndex+1;  {  ⮬ }
    { copyAttr(FChildNode);}
    end;
  Result:=FChildNode;
end;

function   TOrgChartNode.AddBrother:TOrgChartNode;
begin
  if (FBrotherNode = nil) then
   begin
     FBrotherNode:=TOrgChartNode.Create(Parent);
     FBrotherNode.BrotherIndex:=BrotherIndex+1;
     {copyAttr(FBrotherNode);}
   end;
  Result:=FBrotherNode;
end;

procedure  TOrgChartNode.FullDeleteChilds;               { Destructive delete }
begin
  if FChildNode=nil then Exit;
  FChildNode.Destroy;
  FChildNode:=nil;
end;

procedure  TOrgChartNode.FullDeleteBrothers;             { Destructive delete }
begin
  if FBrotherNode=nil then Exit;
  FBrotherNode.Destroy;
  FBrotherNode:=nil;
end;

procedure  TOrgChartNode.DeleteChild;            { Non Destructive delete }
Var tmp:TOrgChartNode;
begin
 if FChildNode=nil then Exit;
 FChildNode.FullDeleteChilds;  { १  ⮬ 㤠塞  }
 if (FChildNode.FBrotherNode = nil) then
  begin
    FChildNode.Destroy;
    FChildNode:=nil;
  end
 else
  begin
    tmp:=FChildNode.FBrotherNode;
    FChildNode.FBrotherNode:=nil;
    FChildNode.Destroy;
    FChildNode:=tmp;
    FChildNode.BrotherIndex:=0;
  end;
end;

procedure  TOrgChartNode.DeleteBrother;             { Non Destructive delete }
Var tmp:TOrgChartNode;
begin
 if FBrotherNode=nil then Exit;
 FBrotherNode.FullDeleteChilds; { १  ⮬ 㤠塞  }
 if (FBrotherNode.FBrotherNode = nil) then
  begin
   FBrotherNode.Destroy;
   FBrotherNode:=nil;
  end
 else
  begin
    tmp:=FBrotherNode.FBrotherNode;
    FBrotherNode.FBrotherNode:=nil;
    FBrotherNode.Destroy;
    FBrotherNode:=tmp;
    FBrotherNode.BrotherIndex:=0;
  end;
end;

procedure TOrgChartNode.SetBrotherIndex(Value: Integer);
begin
 if (FBrotherNode<>nil) then
  begin
   FBrotherIndex:=Value;
   FBrotherNode.SetBrotherIndex(Value+1);
  end
 else FBrotherIndex:=0;
end;

procedure TOrgChartNode.SetChildIndex(Value:Integer);
begin
 if (FChildNode<>nil) then
  begin
   FChildIndex:=Value;
   FChildNode.SetChildIndex(Value+1);
  end
 else FChildIndex:=0;
end;

procedure  TOrgChartNode.WriteNode(Var F:TextFile);
begin
  { if (ChildIndex<>0) and (BrotherIndex<>0) then }
  Writeln(F,GetSpaces(ChildIndex)+Index+'   '+Text);
  if length(FProjection)<>0 then
   begin
     Writeln(F,FProjection);
   end;
  if (Child<>nil) then Child.WriteNode(F);
  if (Brother<>nil) then Brother.WriteNode(F);
end;

function   TOrgChartNode.GetSpaces(Count: Integer):String;
Var i:Integer;
begin
  Result:='';
  i:=0;
  while (i<=Count) do
   begin
    Inc(i);
    Result:=Result+' ';
   end;
end;

procedure  TOrgChartNode.ReIndex(iChild,iBrother:Integer);
begin
 FChildIndex:=iChild;
 FBrotherIndex:=iBrother;
 if (Child<>nil) then Child.ReIndex(iChild+1,0);
 if (Brother<>nil) then Brother.ReIndex(iChild,iBrother+1);
end;


procedure TOrgChartNode.SetFontDPI1(NewDPI:Integer);
begin
 FFontDPI:=Canvas.Font.PixelsPerInch;
 Canvas.Font.PixelsPerInch:=NewDPI;
 FPrjFont.PixelsPerInch:=NewDPI;
 if (Child <> nil) then Child.SetFontDPI1(NewDPI);
 if (Brother<>nil) then Brother.SetFontDPI1(NewDPI);
end;

procedure   TOrgChartNode.SetFontDPI(Handle:HDC);
begin
 FFontDPI:=Canvas.Font.PixelsPerInch;
 Canvas.Font.PixelsPerInch:=GetDeviceCaps(Handle,LOGPIXELSX);
 FPrjFont.PixelsPerInch:=GetDeviceCaps(Handle,LOGPIXELSX);
 if (Child <> nil) then Child.SetFontDPI(Handle);
 if (Brother<>nil) then Brother.SetFontDPI(Handle);
end;

procedure   TOrgChartNode.RestoreFontDPI;
begin
 Canvas.Font.PixelsPerInch:=FFontDPI;
 FPrjFont.PixelsPerInch:=FFontDPI;
 if (Child <> nil) then Child.RestoreFontDPI;
 if (Brother<>nil) then Brother.RestoreFontDPI;
end;

function  TOrgChartNode.GetProjRectSize(left,top:Integer):TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
    mw:Integer;
    CFont:TFont;
 begin
 {  Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
 r.Left:=left+FIntervalLeft;
 r.Top:=top;
 r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
{     }
 uf:=DT_WORDBREAK or DT_CALCRECT or DT_LEFT;
 CFont:=TFont.Create;
 CFont.Assign(Canvas.Font);
 Canvas.Font.Assign(FPrjFont);
 ht:=DrawText(Canvas.Handle,Pchar(FProjection),length(FProjection),r,uf);
 Canvas.Font.Assign(CFont);
 CFont.Free;
 r.Bottom:=ht+r.Top+FIntervalTop{+FIntervalBottom}+FVSpacing{+FPrjFont.Height+FIntervalTop+FVSpacing};   { New FIntervalTop+FVSpacing}
 r.Right:=r.Right+2*FHSpacing;
 mw:=r.Right-r.Left;
 if (mw>FMaxWidth) then FMaxWidth:=mw;
 result:=r;
 end;

procedure   TOrgChartNode.Paint;
Var r,r1:TRect;
    oldColor:TColor;
    uf:UINT;
    th:Integer;
    lenP:Integer;
    SubY:Integer;
    CFont:TFont;
    tmp:Integer;
begin
 if FUpdating then Exit;
 FMaxHeight:=0;
 FMaxWidth:=0;
 FWarning:=False;
 r:=GetRectSize; { Get Caption rect }
 lenP:=length(FProjection);
 if (lenP<>0) then
  begin
   r1:=GetProjRectSize(r.Left,r.Bottom);
   r.Bottom:=r1.Bottom;
  end else
   begin
    r1.Top:=0;
    r1.Bottom:=0;
    r1.Left:=0;
    r1.Right:=0;
   end;
 if FAutoHeight then
  begin
   th:=FVSpacing;
   r.Bottom:=r.Bottom+2*FVSpacing;
  end
 else
  begin
  th:=r.Bottom-r.Top;
  if th > (FDefHeight) then th:=FDefHeight;
  r.Bottom:=r.Top+FDefHeight+r1.Bottom-r1.Top+2*FVSpacing;
  case FVAlign of
   taTopJustify: th:=FVSpacing;
   taVCenter:    th:=FVSpacing+(FDefHeight-th) div 2;
   taBottomJustify: th:= FVSpacing+FDefHeight-th;
  end;
 end;
 r.Left:=FShadowLeft;
 r.Top:=FShadowTop;
 r.Bottom:=r.Bottom+FIntervalBottom;
 r.Right:=r.Right+FIntervalRight;
 oldColor:=Canvas.Brush.Color;
 Canvas.Brush.Color:=FPaintColor;
 Canvas.FillRect(r);    { Fill with PaintColor }
 if FAutoHeight then SubY:=r1.Top else SubY:=r.Top+FDefHeight+FHSpacing+FShadowTop+FIntervalTop+FIntervalBottom;
 SetUpRect(r,(lenP>0),SubY);          { Draw Frame with DrawColor }
 width:=r.Right+FShadowRight+1;
 Height:=r.Bottom+FShadowBottom+1;
 r.Left:=FIntervalLeft+FShadowLeft+FHSpacing;
 r.Top:=FIntervalTop+FShadowTop+th;
 tmp:=r1.Top;
 r1.Top:=SubY+FIntervalTop{-(FPrjFont.Height div 2)};
 r1.Bottom:=r1.Bottom-tmp+SubY+FIntervalTop-(FPrjFont.Height div 2);
 r.Bottom:=r.Bottom-FIntervalBottom-FVSpacing;
 r.Right:=r.Right-FIntervalRight-FHSpacing;
 { Draw Caption }
 uf:=DT_WORDBREAK;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 if length(FProjection)<>0 then
  begin
   uf:=DT_WORDBREAK or DT_LEFT;
   {r1.Top:=SubY+FIntervalTop+FHSpacing;
   r1.Bottom:=r.Bottom;
   r1.Left:=r1.Left+FIntervalLeft;}
   CFont:=TFont.Create;
   CFont.Assign(Canvas.Font);
   Canvas.Font.Assign(FPrjFont);
   DrawText(Canvas.Handle,Pchar(FProjection),length(FProjection),r1,uf);
   Canvas.Font.Assign(CFont);
   CFont.Free;
  end;
{ DT_SINGLELINE or DT_WORDBREAK ); }
 DrawShadow;
 Canvas.Brush.Color:=oldColor;
end;

procedure   TOrgChartNode.DrawRect(r:TRect;val1,val2:Integer; SubLine:Boolean; SubY:Integer);
Var i,j:Integer;
begin
 with Canvas do
  begin
   for j:=0 to Val1 do
    begin
      if (j<Val2) or (j>(Val2+reSpace-1)) then
        Pen.Color:=FDrawColor else Pen.Color:=FPaintColor;
     for i:=0 to (FLineWidth-1) do
      begin
       MoveTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Top+i+j*FLineWidth);
       LineTo(r.Right-i-j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Bottom-i-j*FLineWidth);
       LineTo(r.Left+i+j*FLineWidth,r.Top+i+j*FLineWidth);
       if SubLine then
         begin
           MoveTo(r.Left+i+j*FLineWidth,SubY+i+j*FLineWidth);
           LineTo(r.Right-i-j*FLineWidth,SubY+i+j*FLineWidth);
         end;
      end;
     end;
   end;
end;

procedure   TOrgChartNode.SetUpRect(r: TRect; SubLine:Boolean; SubY:Integer);
Var oldColor:TColor;
begin
{     }
 with Canvas do
  begin
   oldColor:=Pen.Color;
   Pen.Color:=FDrawColor;
   Pen.Style:=FLineStyle;
   case FRectStyle of
    reNone: begin end;
    re1x: DrawRect(r,0,1,SubLine,SubY);
    re2x: DrawRect(r,1,2,SubLine,SubY);
    re3x: DrawRect(r,2,3,SubLine,SubY);
    re4x: DrawRect(r,3,4,SubLine,SubY);
    re2x3: DrawRect(r,4+reSpace,2,SubLine,SubY);
    re3x2: DrawRect(r,4+reSpace,3,SubLine,SubY);
    re2x4: DrawRect(r,5+reSpace,2,SubLine,SubY);
    re4x2: DrawRect(r,5+reSpace,4,SubLine,SubY);
    re2x5: DrawRect(r,6+reSpace,2,SubLine,SubY);
    re5x2: DrawRect(r,6+reSpace,5,SubLine,SubY);
   end;
   Pen.Color:=oldColor;
  end;
end;

function   TOrgChartNode.GetRectSize:TRect;
Var r:TRect;
    ht:Integer;
    uf:UINT;
begin
 {  Left & Top to Real Starting Values,
  Right & Bottom to ClipRectangle }
 r.Left:=FIntervalLeft+FShadowLeft;
 r.Top:=FIntervalTop+FShadowTop;
 r.Right:=r.Left+FDefWidth;
 r.Bottom:=Parent.ClientRect.Bottom;
{     }
 uf:=DT_WORDBREAK or DT_CALCRECT;
 case FHAlign of
  taLeftJustify:  uf:=uf or DT_LEFT;
  taCenter:       uf:=uf or DT_CENTER;
  taRightJustify: uf:=uf or DT_RIGHT;
 end;
 ht:=DrawText(Canvas.Handle,Pchar(FText),length(FText),r,uf);
 r.Bottom:=ht+r.Top;
 FMaxWidth:=r.Right-r.Left;
 FMaxHeight:=r.Bottom-r.Top;
 if not(FAutoWidth) then
   begin
     if (r.Right>r.Left+FDefWidth) then FWarning:=True;
     r.Right:=r.Left+FDefWidth;
   end;
 if not(FAutoHeight) then
   begin
    if (r.Bottom > r.Top + FDefHeight) then FWarning:=True;
   end;
 r.Right:=r.Right+2*FHSpacing;
 result:=r;
end;

function  TOrgChartNode.GetPrjFont:TFont;
 begin
   result:=FPrjFont;
 end;

procedure TOrgChartNode.SetPrjFont(Font:TFont);
 begin
   FPrjFont:=Font;
   if not(FUpdating) then Paint;
 end;

function  TOrgChartNode.GetFont:TFont;
begin
 result:=Canvas.Font;
end;

procedure TOrgChartNode.SetFont(Font:TFont);
begin
 Canvas.Font:=Font; {Changed 15.03.98 }
 if not(FUpdating) then Paint;
end;

function  TOrgChartNode.GetText:String;
begin
 Result:=FText;
end;

procedure TOrgChartNode.SetText(Value: String);
Var s:String;
begin
 s:=Value;
 if FNoControlChar and (length(s)>0) then
   if (s[1]=Chr(167)) then
    begin
      s:=copy(s,2,length(s)-1);
      s:=TrimLeft(s);
    end;
 if FNumbersOnly then s:=FIndex;
 FText:=s;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetRectInterval(Value: Integer);
begin
 FIntervalLeft:=FLineWidth*Value;
 FIntervalRight:=FLineWidth*Value;
 FIntervalTop:=FLineWidth*Value;
 FIntervalBottom:=FLineWidth*Value;
end;

procedure TOrgChartNode.SetRectStyle(Value: TDSRectStyle);
begin
 case Value of
  reNone:     SetRectInterval(0);
  re1x:       SetRectInterval(1);
  re2x:       SetRectInterval(2);
  re3x:       SetRectInterval(3);
  re4x:       SetRectInterval(4);
  re2x3,re3x2: SetRectInterval(5+reSpace);
  re2x4,re4x2: SetRectInterval(6+reSpace);
  re2x5,re5x2: SetRectInterval(7+reSpace);
 end;
 FRectStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetDrawColor(Value: TColor);
begin
 FDrawColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetLineStyle(Value: TPenStyle);
begin
 FLineStyle:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetLineWidth(Value: Integer);
begin
 FLineWidth:=Value;
 SetRectStyle(FRectStyle);
end;

procedure TOrgChartNode.SetPaintColor(Value: TColor);
begin
 FPaintColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetShadowColor(Value: TColor);
begin
 FShadowColor:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetShadowInterval(Left,Right,Top,Bottom:Integer);
begin
 FShadowLeft:=FLineWidth*Left;
 FShadowRight:=FLineWidth*Right;
 FShadowTop:=FLineWidth*Top;
 FShadowBottom:=FLineWidth*Bottom;
end;

procedure TOrgChartNode.SetShadowType(Value: TDSShadowType);
begin
 FShadowType:=Value;
 case Value of
  shNone:                 SetShadowInterval(0,0,0,0);
  shLeftBoxed:            SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shLeftFramed:           SetShadowInterval(FShadowDepth,0,0,FShadowDepth);
  shTopPerspective:       SetShadowInterval(0,0,0,FShadowDepth);
  shInversePerspective:   SetShadowInterval(FShadowDepth,FShadowDepth,0,FShadowDepth);
  shRightBoxed:           SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shRightFramed:          SetShadowInterval(0,FShadowDepth,0,FShadowDepth);
  shBottomPerspective:    SetShadowInterval(0,0,FShadowDepth,0);
 end;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetShadowDepth(Value: Integer);
begin
 FShadowDepth:=Value;
 SetShadowType(FShadowType);
end;

procedure TOrgChartNode.DrawShadowBottom(Diagonal:Boolean;Orient:Integer);
Var r:TRect;
    h,w:Integer;
    i:Integer;
begin
{ Orient 0  - Left
         1  - Center
         2  - Right }
 with Canvas do
  Begin
   h:=self.Height;
   w:=self.Width;
   r.Left:=FShadowLeft;
   r.Top:=h-FShadowBottom;
   r.Right:=w-FShadowRight;
   r.Bottom:=h;
   Brush.Color:=self.Color;
   FillRect(r);
   Pen.Color:=FShadowColor;
    if Diagonal then
       begin
        {Diagonal}
         case Orient of
          0: {Left}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowLeft,h-i);
                   LineTo(w-FShadowLeft+i,h-i);
                 end;
              end;
          1: {Center}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowBottom-i,h-i);
                   LineTo(w-FShadowBottom+i,h-i);
                 end;
              end;
          2: {Right}
              begin
                for i:=0 to (FShadowBottom) do
                 begin
                   MoveTo(FShadowRight-i,h-i);
                   LineTo(w-FShadowRight,h-i);
                 end;
              end;
         end;
       end
     else
       begin
         case Orient of
          0: {Left}
              begin
               r.Right:=w-FShadowLeft;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          1: {Center}
              begin
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
          2: {Right}
              begin
               r.Left:=FShadowRight;
               Brush.Color:=FShadowColor;
               FillRect(r);
              end;
         end;
       end;
  end;
end;

procedure TOrgChartNode.DrawShadowTop;
Var r:TRect;
    i:Integer;
    w:Integer;
begin
{}
 with Canvas do
  begin
   w:=self.Width;
   r.Left:=0;
   r.Top:=0;
   r.Right:=w;
   r.Bottom:=FShadowTop;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
    for i:=0 to (FShadowTop) do
       begin
         MoveTo(FShadowTop-i,i);
         LineTo(w-FShadowTop+i,i);
       end;
  end;
end;

procedure TOrgChartNode.DrawShadowLeft(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h:Integer;
begin
 with Canvas do
 begin
   h:=self.Height;
   r.Left:=0;
   r.Top:=0;
   r.Right:=FShadowLeft;
   r.Bottom:=self.Height;
   Brush.Color:=self.Color;
   Pen.Color:=FShadowColor;
   FillRect(r);
 if Diagonal then
  begin
   {Left Diagonal Shadow}
    for i:=0 to (FShadowLeft-1) do
     begin
      MoveTo(i,FShadowLeft-i);
      LineTo(i,h);
     end;
  end
 else
  begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
  end;
 end;
end;

procedure TOrgChartNode.DrawShadowRight(Diagonal:Boolean);
Var r:TRect;
    i:Integer;
    h,w:Integer;
begin
 with Canvas do
 begin
    w:=self.width;
    h:=self.Height;
    r.Left:=w-FShadowRight;
    r.Top:=0;
    r.Right:=w;
    r.Bottom:=self.Height;
    Brush.Color:=self.Color;
    Pen.Color:=FShadowColor;
    FillRect(r);
 if Diagonal then
  begin
   {Right Diagonal Shadow}
    for i:=0 to (FShadowRight-1) do
     begin
      MoveTo(w-FShadowRight+i,i);
      LineTo(w-FShadowRight+i,h);
     end;
  end
 else
   begin
   {Left Framed Shadow }
    r.Top:=FShadowBottom;
    Brush.Color:=FShadowColor;
    FillRect(r);
   end;
 end;
end;

procedure TOrgChartNode.DrawShadow;
Var oldColor,oldColor1:TColor;
    penStyle:TPenStyle;
begin
{}
 with Canvas do
 begin
 oldColor:=Brush.Color;
 oldColor1:=Pen.Color;
 penStyle:=Pen.Style;
 Pen.Style:=psSolid;
 case FShadowType of
  shNone:                 begin end;
  shLeftBoxed:            begin
                            DrawShadowLeft(True);
                            DrawShadowBottom(True,0);
                          end;
  shLeftFramed:           begin
                            DrawShadowLeft(False);
                            DrawShadowBottom(False,0);
                          end;
  shTopPerspective:       DrawShadowBottom(True,1);
  shInversePerspective:   begin
                           DrawShadowLeft(True);
                           DrawShadowRight(True);
                           DrawShadowBottom(False,1);
                          end;
  shRightBoxed:           begin
                           DrawShadowRight(True);
                           DrawShadowBottom(True,2);
                          end;
  shRightFramed:          begin
                           DrawShadowRight(False);
                           DrawShadowBottom(False,2);
                          end;
  shBottomPerspective:    DrawShadowTop;

 end;
  Pen.Style:=penStyle;
  Pen.Color:=oldColor1;
  Brush.Color:=oldColor;
 end;
end;

procedure TOrgChartNode.SetDefWidth(Value: Integer);
begin
 FDefWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetDefHeight(Value: Integer);
begin
 FDefHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetAutoHeight(Value: Boolean);
begin
 FAutoHeight:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetAutoWidth(Value: Boolean);
begin
 FAutoWidth:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetHAlign(Value: TAlignment);
begin
 FHAlign:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TOrgChartNode.SetVAlign(Value: TVAlignment);
begin
 FVAlign:=Value;
 if not(FUpdating) then Paint;
end;

procedure TOrgChartNode.SetVSpacing(Value: Integer);
begin
 FVSpacing:=Value;
 if not(FUpdating) then  Paint;
end;

procedure TOrgChartNode.SetHSpacing(Value: Integer);
begin
 FHSpacing:=Value;
 if not(FUpdating) then Paint;
end;

{$A-}

procedure TOrgChartNode.ClearMaxWH;
Var Nodes:TOrgChartNodes;
    curOrgLevel:TOrgLevel;
    i:Integer;
begin
 Nodes:=(Parent as TCustomOrgChart).Nodes;
 for i:=0 to 10 do
  begin
   curOrgLevel:=Nodes.Levels[i];
   curOrgLevel.MaxWidth:=0;
   curOrgLevel.MaxHeight:=0;
   Nodes.Levels[i]:=CurOrgLevel;
  end;
end;

procedure TOrgChartNode.UDError(Text:String;Level:Integer);
Var s:String;
begin
 if level>0 then
 s:='  '+IntToStr(Level)+' "'+Text+
  '"      .'
 else
 s:='   "'+Text+
  '"      .';
 Application.MessageBox(PChar(s),'  ',MB_OK);
end;

procedure TOrgChartNode.CalcMaxWH(Level:Integer);
Var tmp:TOrgChartNode;
    Nodes:TOrgChartNodes;
    curOrgLevel:TOrgLevel;
begin
  Nodes:=(Parent as TCustomOrgChart).Nodes;
  tmp:=self;
  curOrgLevel:=Nodes.Levels[Level];
  while (tmp<>nil) do
   begin
    tmp.SetAttr(curOrgLevel,True,True);
    if tmp.MaxWidth > CurOrgLevel.MaxWidth then {       }
        begin
          CurOrgLevel.MaxWidth:=tmp.MaxWidth;
          Nodes.Levels[Level]:=CurOrgLevel;
        end;
    if tmp.MaxHeight > CurOrgLevel.MaxHeight then {       }
        begin
          CurOrgLevel.MaxHeight:=tmp.MaxHeight;
          Nodes.Levels[Level]:=CurOrgLevel;
        end;
    if (tmp.Child<> nil) then tmp.Child.CalcMaxWH(Level+1);
    tmp:=tmp.Brother;
   end;
    if CurOrgLevel.MaxWidth > CurOrgLevel.DefWidth then
        begin
          CurOrgLevel.MaxWidth:=CurOrgLevel.DefWidth;
          Nodes.Levels[Level]:=CurOrgLevel;
        end;
    if CurOrgLevel.MaxHeight > CurOrgLevel.DefHeight then
        begin
          CurOrgLevel.MaxHeight:=CurOrgLevel.DefHeight;
          Nodes.Levels[Level]:=CurOrgLevel;
        end;
end;

{ControlUser - Sets the Attributes of TreeItems to User Defined
 , also controls ovelapping texts }
function TOrgChartNode.ControlUser(Level:Integer):Boolean;
Var tmp:TOrgChartNode;
    Warn:Boolean;
    Nodes:TOrgChartNodes;
    curOrgLevel:TOrgLevel;
begin
  Nodes:=(Parent as TCustomOrgChart).Nodes;
  tmp:=self;
  curOrgLevel:=Nodes.Levels[Level];
  Warn:=False;
  while (tmp<>nil) and (not(Warn)) do
   begin
    tmp.SetAttr(curOrgLevel,False,False);
    Warn:=tmp.Warning;
    if Warn then Tmp.UDError(tmp.Text,Level);
    if (tmp.Child<> nil) and (not(Warn)) then Warn:=tmp.Child.ControlUser(Level+1);
    tmp:=tmp.Brother;
   end;
  Result:=Warn;
end;

procedure TOrgChartNode.SetNode(lleft,ltop:Integer);
begin
 FUpdating:=True;
 Left:=lleft;
 Top:= ltop;
 FUpdating:=False;
 if not(FUpdating) then Paint;
end;

function TOrgChartNode.TreeH(CurrCoord:TPoint;PWidth,PHeight,Level:Integer;HasVTree:Boolean;HasW95:Boolean):TPoint;
Var curNode:TOrgChartNode;
    w,h:Integer; { width & height of curNode}
    wi,hi:Integer; { VInterval & HInterval }
    dx,dy:Integer;
    curLevel,nextLevel,prevLevel:TOrgLevel;
    StartCoord:TPoint;
    ChildWH:TPoint; { Width & Height of SubTree }
    forCH:TPoint; { Width & Height for SubTree }
    posx,posy:Integer;
    maxy:Integer;
    Canvas:TCanvas;
    oldPenColor:TColor;
    i:Integer;
    fx,fy,fdx:Integer;
    lx,ly:Integer;
    fhook:Boolean;
    ecount:Integer;
    hvt:Boolean;
    hmax:Integer;
begin
 { Get current level Settings }
 curLevel:=(Parent as TCustomOrgChart).Nodes.Levels[Level];
 nextLevel:=(Parent as TCustomOrgChart).Nodes.Levels[Level+1];
 prevLevel:=(Parent as TCustomOrgChart).Nodes.Levels[Level-1];
 Canvas:=(Parent as TCustomOrgChart).Canvas;
 oldPenColor:=Canvas.Pen.Color;
 Canvas.Pen.Color:=FLineColor;
 { Add scrollBar positions to CurrCoord to calculate StartCoord }
 StartCoord:=CurrCoord;
 if (Parent as TCustomOrgChart).HorzScrollBar.Visible then
   posx:=(Parent as TCustomOrgChart).HorzScrollBar.ScrollPos
 else posx:=0;
 if (Parent as TCustomOrgChart).VertScrollBar.Visible then
   posy:=(Parent as TCustomOrgChart).VertScrollBar.ScrollPos
 else posy:=0;
 {Init some variables}
 curNode:=self;
 wi:=curLevel.HInterval;
 hi:=curLevel.VInterval;
 maxy:=StartCoord.y;
 fx:=0;
 fy:=0;
 lx:=0;
 ly:=0;
 h:=0;
 w:=0;
 hmax:=0;
 fhook:=False;
 ecount:=0;
 hvt:=HasVTree;
 if curLevel.Strategy=stVTree then hvt:=True;
 while (curNode<>nil) do
  begin
    {Set Level formating attributes }
    curNode.SetMaxAttr(curLevel,False,False);
    w:=curNode.Width;
    h:=curNode.Height;
    if hmax<h then hmax:=h;
    {Get SubTree Info}
    dx:=w+2*wi;
    dy:=h+2*hi;
    if (curNode.Child<>nil) then
       begin { curNode.CHild<>nil}
          case nextLevel.Strategy of
            stHTree: begin
                      forCH.x:=StartCoord.x;
                      forCH.y:=StartCoord.y+2*hi+h;
                      ChildWH:=curNode.Child.TreeH(forCH,dx,dx,Level+1,hvt,HasW95);
                      if (maxy<ChildWH.y) then maxy:=ChildWH.y;
                     end;
            stVTree:  begin
                      forCH.x:=StartCoord.x+(dx div 2);
                      forCH.y:=StartCoord.y+dy;
                      ChildWH:=curNode.Child.TreeV(forCH,dx,dy,Level+1,hvt,HasW95);
                      if (maxy<ChildWH.y) then maxy:=ChildWH.y;
                     end;
          {  stVLRTree:
            stVLR2Tree:}
           else      begin
                      forCH.x:=StartCoord.x;
                      forCH.y:=StartCoord.y+dy;
                      ChildWH:=curNode.Child.TreeH(forCH,dx,dy,Level+1,hvt,HasW95);
                      if (maxy<ChildWH.y) then maxy:=ChildWH.y;
                     end;
          end;
       end   { curNode.CHild<>nil}
    else
       begin { curNode.CHild=nil}
        ChildWH.x:=0;
        ChildWH.y:=0;
       end; { curNode.CHild=nil}
    {Set Up this node}
     if (ChildWH.x > StartCoord.x+dx) then dx:=ChildWH.x-StartCoord.x;
     case nextLevel.Strategy of
      stHTree: begin
               if not(FHook) then begin fdx:=dx; fx:=StartCoord.x+((dx-w) div 2)+(w div 2)-posx; fy:=StartCoord.y-posy; Fhook:=True; end;
               lx:=StartCoord.x+((dx-w) div 2)+(w div 2)-posx;
               ly:=StartCoord.y-posy;
               curNode.SetNode(StartCoord.x+((dx-w) div 2)-posx,StartCoord.y+hi-posy);
               if level>0 then
               begin
               for i:=1 to curLevel.LineDepth do
                   begin
                    Canvas.MoveTo(lx+i-1,ly);
                    Canvas.LineTo(lx+i-1,ly+hi);
                   end;
               if ((lx+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
               if ((ly+hi)>32767) then HasW95Error:=True;
               end;
               end;
      stVTree: begin
               if not(FHook) then begin fdx:=w+2*wi;  fx:=StartCoord.x+wi+(w div 2)-posx; fy:=StartCoord.y-posy; Fhook:=True; end;
               lx:=StartCoord.x+wi+(w div 2)-posx;
               ly:=StartCoord.y-posy;
               curNode.SetNode(StartCoord.x+wi-posx,StartCoord.y+hi-posy);
               if level>0 then
               begin
               for i:=1 to curLevel.LineDepth do
                   begin
                    Canvas.MoveTo(lx+i-1,ly);
                    Canvas.LineTo(lx+i-1,ly+hi)
                   end;
               if ((lx+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
               if ((ly+hi)>32767) then HasW95Error:=True;
               end;
               end;
     else      begin
               if not(FHook) then begin fdx:=dx;  fx:=StartCoord.x+((dx-w) div 2)+(w div 2)-posx; fy:=StartCoord.y-posy; Fhook:=True; end;
               lx:=StartCoord.x+((dx-w) div 2)+(w div 2)-posx;
               ly:=StartCoord.y-posy;
               curNode.SetNode(StartCoord.x+((dx-w) div 2)-posx,StartCoord.y+hi-posy);
               if level>0 then
               begin
               for i:=1 to curLevel.LineDepth do
                   begin
                    Canvas.MoveTo(lx+i-1,ly);
                    Canvas.LineTo(lx+i-1,ly+hi)
                   end;
               if ((lx+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
               if ((ly+hi)>32767) then HasW95Error:=True;
               end;
               end;
     end;
     if (curNode.Child<> nil) then
      begin
        for i:=1 to curLevel.LineDepth do
         begin
           Canvas.MoveTo(lx+i-1,ly+h+hi);
           Canvas.LineTo(lx+i-1,ly+h+2*hi)
         end;
        if ((lx+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
        if ((ly+h+2*hi)>32767) then HasW95Error:=True;
      end;
     StartCoord.x:=StartCoord.x+dx;
    {Get Brother node}
    curNode:=curNode.Brother;
    Inc(ecount);
  end;
   if (PrevLevel.Strategy = stVTree) then
    begin
      if (self.Brother=nil) and (level>1) then fx:= fx- (dx div 2)
      else fx:=fx - fdx div 2;
    end;
   if (PrevLevel.Strategy = stHTree) and
      (ecount=1) and (Level <> 0) and (not(hvt)) then
       begin
         if PWidth>dx then
         fx:= CurrCoord.x - posx + PWidth div 2
          else fx:= CurrCoord.x+( dx div 2)-posx;
       end;
   if (PrevLevel.Strategy = stHTree) and
      (ecount=1) and (Level <> 0) and (hvt) then
       begin
         if PWidth < dx then
         fx:= CurrCoord.x+( dx div 2)-posx
         else
         fx:= CurrCoord.x-posx+PWidth div 2;
       end;
    if level>0 then
    begin
    for i:=1 to curLevel.LineDepth do
      begin
       Canvas.MoveTo(fx,fy+i-1);
       Canvas.LineTo(lx,ly+i-1);
      end;
      if (fx>32767) then HasW95Error:=True;
      if (lx>32767) then HasW95Error:=True;
      if ((ly+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
      if ((fy+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
     end;
  if h<hmax then h:=hmax;
  StartCoord.y:=StartCoord.y+h+2*hi;
  if (StartCoord.y < maxy) then StartCoord.y:=maxy;
  Result:=StartCoord;
  Canvas.Pen.Color:=oldPenColor;
end;

function TOrgChartNode.TreeV(CurrCoord:TPoint;PWidth,PHeight,Level:Integer;HasVTree:Boolean;HasW95:Boolean):TPoint;
Var curNode:TOrgChartNode;
    w,h:Integer; { width & height of curNode}
    wi,hi:Integer; { VInterval & HInterval }
    dy,dx:Integer;
    curLevel,nextLevel:TOrgLevel;
    StartCoord:TPoint;
    ChildWH:TPoint; { Width & Height of SubTree }
    forCH:TPoint; { Width & Height for SubTree }
    posx,posy:Integer;
    maxx:Integer;
    Canvas:TCanvas;
    oldPenColor:TColor;
    i:Integer;
    fx,fy:Integer;
    lx,ly:Integer;
    fhook:Boolean;
    hvt:Boolean;
begin
 { Get current level Settings }
 curLevel:=(Parent as TCustomOrgChart).Nodes.Levels[Level];
 nextLevel:=(Parent as TCustomOrgChart).Nodes.Levels[Level+1];
 Canvas:=(Parent as TCustomOrgChart).Canvas;
 oldPenColor:=Canvas.Pen.Color;
 Canvas.Pen.Color:=FLineColor;
 { Add scrollBar positions to CurrCoord to calculate StartCoord }
 StartCoord:=CurrCoord;
 if (Parent as TCustomOrgChart).HorzScrollBar.Visible then
   posx:=(Parent as TCustomOrgChart).HorzScrollBar.ScrollPos
 else posx:=0;
 if (Parent as TCustomOrgChart).VertScrollBar.Visible then
   posy:=(Parent as TCustomOrgChart).VertScrollBar.ScrollPos
 else posy:=0;
 {Init some variables}
 curNode:=self;
 wi:=curLevel.HInterval;
 hi:=curLevel.VInterval;
 maxx:=StartCoord.x;
 fhook:=False;
 fx:=0;
 fy:=0;
 lx:=0;
 ly:=0;
 w:=0;
 hvt:=True;
 while (curNode<>nil) do
  begin
    {Set Level formating attributes }
    curNode.SetMaxAttr(curLevel,False,False);
    w:=curNode.Width;
    h:=curNode.Height;
    {Get SubTree Info}
    dy:=h+2*hi;
    dx:=w+2*wi;
    if (curNode.Child<>nil) then
       begin { curNode.CHild<>nil}
          case nextLevel.Strategy of
            stHTree: begin
                      forCH.x:=StartCoord.x+(dx div 2);
                      forCH.y:=StartCoord.y+dy;
                      ChildWH:=curNode.Child.TreeH(forCH,dx,dy,Level+1,hvt,HasW95);
                      if (maxx<ChildWH.x) then maxx:=ChildWH.x;
                     end;
            stVTree:  begin
                      forCH.x:=StartCoord.x+(dx div 2);
                      forCH.y:=StartCoord.y+dy;
                      ChildWH:=curNode.Child.TreeV(forCH,dx,dy,Level+1,hvt,HasW95);
                      if (maxx<ChildWH.x) then maxx:=ChildWH.x;
                     end;
          {  stVLRTree:
            stVLR2Tree:}
           else      begin
                      forCH.x:=StartCoord.x+dx;
                      forCH.y:=StartCoord.y+dy;
                      ChildWH:=curNode.Child.TreeH(forCH,dx,dy,Level+1,hvt,HasW95);
                      if (maxx<ChildWH.x) then maxx:=ChildWH.x;
                     end;
          end;
       end   { curNode.CHild<>nil}
    else
       begin { curNode.CHild=nil}
        ChildWH.x:=0;
        ChildWH.y:=0;
       end; { curNode.CHild=nil}
    {Set Up this node}
     if (ChildWH.y > StartCoord.y+dy) then dy:=ChildWH.y-StartCoord.y;
     case nextLevel.Strategy of
      stHTree: begin
               if not(FHook) then begin fx:=StartCoord.x-posx; fy:=StartCoord.y-posy; fhook:=True; end;
               lx:=StartCoord.x-posx; ly:=StartCoord.y+hi+(h div 2)-posy;
               curNode.SetNode(StartCoord.x+wi-posx,StartCoord.y+hi-posy);
               if level>0 then
                begin
                for i:=1 to curLevel.LineDepth do
                 begin
                  Canvas.MoveTo(lx,ly+i-1);
                  Canvas.LineTo(lx+wi,ly+i-1);
                 end;
                 if ((lx+wi)>32767) then HasW95Error:=True;
                 if ((ly+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
                 end;
               end;
      stVTree: begin
               if not(FHook) then begin fx:=StartCoord.x-posx; fy:=StartCoord.y-posy; fhook:=True;  end;
               lx:=StartCoord.x-posx; ly:=StartCoord.y+hi+(h div 2)-posy;
               curNode.SetNode(StartCoord.x+wi-posx,StartCoord.y+hi-posy);
               if level>0 then
                begin
                for i:=1 to curLevel.LineDepth do
                 begin
                  Canvas.MoveTo(lx,ly+i-1);
                  Canvas.LineTo(lx+wi,ly+i-1);
                 end;
                 if ((lx+wi)>32767) then HasW95Error:=True;
                 if ((ly+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
                 end;
               end;
     else      begin
               if not(FHook) then begin fx:=StartCoord.x-posx; fy:=StartCoord.y-posy; fhook:=True;  end;
               lx:=StartCoord.x-posx; ly:=StartCoord.y+hi+(h div 2)-posy;
               curNode.SetNode(StartCoord.x+wi-posx,StartCoord.y+hi-posy);
               if level>0 then
                begin
                for i:=1 to curLevel.LineDepth do
                 begin
                  Canvas.MoveTo(lx,ly+i-1);
                  Canvas.LineTo(lx+wi,ly+i-1);
                 end;
                 if ((lx+wi)>32767) then HasW95Error:=True;
                 if ((ly+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
                 end;
               end;
     end;
     if (curNode.Child<>nil) then
      begin
       for i:=1 to curLevel.LineDepth do
         begin
           Canvas.MoveTo(lx+wi+(w div 2)+i-1,ly+(h div 2));
           Canvas.LineTo(lx+wi+(w div 2)+i-1,ly+(h div 2)+hi+(h mod 2));
         end;
       if ((lx+wi+(w div 2)+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
       if ((ly+(h div 2)+hi+(h mod 2) )>32767) then HasW95Error:=True;
      end;
     StartCoord.y:=StartCoord.y+dy;
    {Get Brother node}
    curNode:=curNode.Brother;
  end;
   if level>0 then
   begin
   for i:=1 to curLevel.LineDepth do
     begin
       Canvas.MoveTo(fx+i-1,fy);
       Canvas.LineTo(lx+i-1,ly);
     end;
   if ((fx+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
   if ((lx+curLevel.LineDepth-1)>32767) then HasW95Error:=True;
   if (ly>32767) then HasW95Error:=True;
   if (fy>32767) then HasW95Error:=True;
   end;
  StartCoord.x:=StartCoord.x+w+2*wi;
  if (StartCoord.x < maxx) then StartCoord.x:=maxx;
  Result:=StartCoord;
  Canvas.Pen.Color:=oldPenColor;
end;

procedure  TOrgChartNode.PreSetupTree;
begin
 ClearMaxWH;  {     }
 CalcMaxWH(0);
end;

function  TOrgChartNode.SetUpTree:TPoint;
Var t:TPoint;
    i,j:Integer;
    Nodes:TOrgChartNodes;
begin
  t.x:=0;
  t.y:=0;
  i:=0;
  j:=0;
  Nodes:=(Parent as TCustomOrgChart).Nodes;
  HasW95Error:=False;
  case Nodes.Levels[0].Strategy of
   stHTree: t:=TreeH(t,i,j,0,False,Nodes.Root.FuckingWin95);
   stVTree: t:=TreeV(t,i,j,0,True,Nodes.Root.FuckingWin95);
 {  stVLRTree:
   stVLR2Tree:}
   else t:=TreeH(t,i,j,0,False,Nodes.Root.FuckingWin95);
  end;
  { startPoint,predok:TPoint  Level:Integer }
  if HasW95Error then
        Application.MessageBox('  Windows 95,98     .           Windows NT',
                               '  ',
                                MB_OK or MB_ICONERROR);
  Result:=t;
end;

procedure TOrgChartNode.SetAttr(src:TOrgLevel;AWidth,AHeight:Boolean);
begin
  FUpdating:=True;
  {Color:=self.Color;}
  RectColor:=src.DrawColor;
  PaintColor:=src.PaintColor;
  ShadowColor:=src.ShadowColor;
  LineWidth:=src.LineWidth;
  RectLineStyle:=src.LineStyle;
  ShadowType:=src.ShadowType;
  ShadowDepth:=src.ShadowDepth;
  {Font:=self.Font; }{Changed 15.03.98}
  Font.Name:=src.FontName;
  Font.Size:=src.FontSize;
  Font.Charset:=Langs.CharSetFromLocale(src.Language);
  Font.Color:=src.FontColor;
  Font.Style:=src.FontStyle;
  FPrjFont.Name:=src.PrjFontName;
  FPrjFont.Size:=src.PrjFontSize;
  FPrjFont.Charset:=Langs.CharSetFromLocale(src.Language);
  FPrjFont.Color:=src.PrjFontColor;
  FPrjFont.Style:=src.PrjFontStyle;
  RectStyle:=src.RectStyle;
  HInterval:=src.HInterval;
  VInterval:=src.VInterval;
  DefWidth:=src.DefWidth;
  DefHeight:=src.DefHeight;
  HSpacing:=src.HSpacing;
  VSpacing:=src.VSpacing;
  HAlign:=src.HAlign;
  VAlign:=src.VAlign;
  AutoWidth:=AWidth;
  AutoHeight:=AHeight;
  LineColor:=src.LineColor;
  FUpdating:=False;
  Paint;
end;

procedure TOrgChartNode.SetMaxAttr(src:TOrgLevel;AWidth,AHeight:Boolean);
begin
  FUpdating:=True;
  {Color:=self.Color;}
  RectColor:=src.DrawColor;
  PaintColor:=src.PaintColor;
  ShadowColor:=src.ShadowColor;
  LineWidth:=src.LineWidth;
  RectLineStyle:=src.LineStyle;
  ShadowType:=src.ShadowType;
  ShadowDepth:=src.ShadowDepth;
  {Font:=self.Font; }{Changed 15.03.98}
  Font.Name:=src.FontName;
  Font.Size:=src.FontSize;
 Font.Size:=src.FontSize;
  Font.Color:=src.FontColor;
  Font.Style:=src.FontStyle;
  Font.Charset:=Langs.CharSetFromLocale(src.Language);
  RectStyle:=src.RectStyle;
  HInterval:=src.HInterval;
  VInterval:=src.VInterval;
  DefWidth:=src.MaxWidth;
  DefHeight:=src.MaxHeight;
  HSpacing:=src.HSpacing;
  VSpacing:=src.VSpacing;
  HAlign:=src.HAlign;
  VAlign:=src.VAlign;
  AutoWidth:=AWidth;
  AutoHeight:=AHeight;
  LineColor:=src.LineColor;
  FUpdating:=False;
  Paint;
end;

{ TOrgChartNodes }
constructor TOrgChartNodes.Create(AOwner: TComponent);
begin
 inherited Create;
 LoadLevels(ExtractFilePath(Application.ExeName)+fnLevels);
 FRoot:=TOrgChartNode.Create(AOwner);
 FDetailLevel:=0;
 FCount:=1;
 FStrategy:=stHTree;
 FHInterval:=10;
 FVInterval:=10;
 FLineWidth:=1;
 FOwner:=nil;
end;

destructor  TOrgChartNodes.Destroy;
begin
 FOwner:=nil;
 if (FRoot<>nil) then FRoot.Destroy;
 inherited Destroy;
end;

function   TOrgChartNodes.InsertItem(Index:String;Caption:String):TOrgChartNode;
Var i:Integer;
    tmp:TOrgChartNode;
    s:String;
    Detail:Integer;
    SItem:Boolean;
    Level:Integer;
begin
  SItem:=True;
  Result:=nil;
  if (FRoot=nil) then Exit;
  if Length(Index)=0 then Exit;
  tmp:=FRoot;
  s:=Index;
  Detail:=1;
  Level:=0; { ? }
  i:=IsNextLevel(s);
   while (i>=0) and (Detail<=FDetailLevel) do
    begin
     tmp:=SetUpChild(tmp);
     tmp:=SetUpBrother(tmp,i);
     i:=IsNextLevel(s);
     Inc(Detail);
     Inc(Level);
     if (i>=0) and (Detail>FDetailLevel) then SItem:=False;
    end;
   if (tmp<>nil) and SItem then
    begin
     tmp.NoControlChar:=FOrgLevels[Level].NoControlChar;
     tmp.NumbersOnly:=FOrgLevels[Level].NumbersOnly;
     tmp.Index:=Index;
     tmp.Text:=Caption;
     tmp.ShowHint:=True;
     tmp.Hint:=Caption;
     Result:=tmp;
    end;
end;

function  TOrgChartNodes.SetUpTree:TPoint;
begin
 { Main Strategy Proc }
 Result:=Root.SetUpTree;
end;

function  TOrgChartNodes.ControlUser:Boolean;
begin
 Result:=Root.ControlUser(0);
end;

procedure TOrgChartNodes.PreSetupTree;
begin
 Root.PreSetupTree;
end;

procedure  TOrgChartNodes.Clear;
begin
 if FRoot=nil then Exit;
 if (FRoot.Brother<>nil) then FRoot.FullDeleteBrothers;
 if (FRoot.Child<>nil) then  FRoot.FullDeleteChilds;
 FCount:=1;
end;

function TOrgChartNodes.IsNextLevel(var s1:string):Integer;
Var s:String;
    ch:Char;
begin
 s:='';
 Result:=-1;
 if length(s1)=0 then Exit;
 s1:=TrimLeft(s1);
 if length(s1)=0 then Exit;
 ch:=s1[1];
 if (ch >= '0') and (ch <= '9') then
   begin
     while ((ch >='0') and (ch <='9')) do
      begin
       s:=s+s1[1];
       s1:=copy(s1,2,length(s1)-1);
       if length(s1)<>0 then ch:=s1[1] else ch:=' ';
      end;
      Result:=StrToIntDef(s,-1);
      if (length(s1)<>0) then if (s1[1]='.') then s1:=copy(s1,2,length(s1)-1);
   end;
end;

function TOrgChartNodes.SetUpChild(item:TOrgChartNode):TOrgChartNode;
Var tmp:TOrgChartNode;
begin
  Result:=nil;
  if (item=nil) then Exit;
  tmp:=item;
  if (tmp.Child=nil) then
    begin
     tmp.AddChild;
     Inc(FCount);
    end;
  tmp:=tmp.Child;
  Result:=tmp;
end;

function TOrgChartNodes.SetUpBrother(item:TOrgChartNode;iBrother:Integer):TOrgChartNode;
Var tmp:TOrgChartNode;
    i:Integer;
begin
  Result:=nil;
  if (item=nil) then Exit;
  tmp:=item;
  i:=tmp.BrotherIndex;
   while (i<(iBrother-1)) do
    begin
      if (tmp.Brother=nil) then
        begin
          tmp.AddBrother;
          inc(FCount);
        end;
      tmp:=tmp.Brother;
      Inc(i);
    end;
  Result:=tmp;
end;

function TOrgChartNodes.GetLineIndex(var S:String):String;
begin
 Result:='';
 if length(S)=0 then Exit;
 S:=TrimLeft(S);
 if length(S)=0 then Exit;
    While  (((S[1] >='0') and (S[1] <='9')) or (S[1] ='.')) do
      begin
       Result:=Result+copy(S,1,1);
       S:=copy(S,2,length(S)-1);
       if length(S)=0 then Exit;
      end;
 S:=TrimLeft(S);
end;

procedure TOrgChartNodes.WriteTree(Var F:TextFile);
begin
 if (FRoot=nil) then Exit;
 FRoot.WriteNode(F);
end;

function  TOrgChartNodes.SaveToFile(FileName:String;MaxDetail:Integer):Boolean;
Var F:TextFile;
begin
 Result:=False;
 AssignFile(F,FileName);
 {$I-}
 Rewrite(F);
 if IOResult<>0 then Exit;
 {$I+}
 FDetailLevel:=MaxDetail;
 if FRoot<>nil then FRoot.ReIndex(0,0);
 WriteTree(F);
 CloseFile(F);
 Result:=True;
end;

function  TOrgChartNodes.LoadFromTStrings(Strings:TStrings;MaxDetail:Integer;OnlyLevels:Boolean):Boolean;
Var S,SI:String;
    i:Integer;
    item:TOrgChartNode;
    projection:String;
begin
 Result:=False;
 item:=FRoot; 
 if Strings.Count=0 then Exit;
 Clear;
 FDetailLevel:=MaxDetail;
 projection:='';
  for i:=0 to (Strings.Count-1) do
   begin
     S:=string(Strings[i]);
     if s<>strings[i] then
     showmessage(inttostr(i));
     s:=Trim(strings[i]);
     if (length(s)>0) then
     begin
     if (S[1] in['.','','',''])or
         (pos('$$ ',s)=1)or
         (pos('~~ ',s)=1)or
         (pos('@@ ',s)=1)or
         (pos(':: ',s)=1)
                        then
       begin
         projection:=projection+S+Chr($0D);
       end
      else
      begin
       if ((length(projection)<>0) and (item<>nil)) then item.Projection:=trim(projection);
       projection:='';
       SI:=GetLineIndex(S);
    if (Length(SI)>0) then
     begin
      if OnlyLevels then
        item:=InsertItem(SI,SI)
      else
        item:=InsertItem(SI,S);
     end;
   end; { 'projection'}
   end;
   end;
 if (item<>nil) then
   if (length(projection)>0) then
     begin
       item.Projection:=projection;
       projection:='';
     end;
 if FRoot<>nil then FRoot.ReIndex(0,0);
 PreSetupTree;
 Result:=ControlUser;
 SetUpTree;
 FOwner.Repaint;
end;

function  TOrgChartNodes.LoadFromFile(FileName:String;MaxDetail:Integer;OnlyLevels:Boolean):Boolean;
Var F:TextFile;
    S,SI:String;
    projection:String;
    item:TOrgChartNode;
begin
 Result:=False;
 AssignFile(F,FileName);
 {$I-}
 Reset(F);
 if IOResult<>0 then Exit;
 {$I+}
 Clear;
 FDetailLevel:=MaxDetail;
 projection:='';
  while not(EOF(F)) do
   begin
    Readln(F,S);
    if length(s)>0 then
    begin
    if (s[1]='.') then
      begin
        projection:=projection+S+Chr($0D);
      end
    else
    begin
    if ((length(projection)<>0) and (item<>nil)) then item.Projection:=projection;
    projection:='';
    SI:=GetLineIndex(S);
    if (Length(SI)>0) then
     begin
      if OnlyLevels then
        item:=InsertItem(SI,SI)
      else
        item:=InsertItem(SI,S);
     end;
    end;
    end;
   end;
 CloseFile(F);
 if FRoot<>nil then FRoot.ReIndex(0,0);
 PreSetupTree;
 Result:=ControlUser;
 SetUpTree;
 FOwner.Repaint;
end;


procedure TOrgChartNodes.SetCaption(Value: String);
begin
 if FRoot=nil then Exit;
 FRoot.Text:=Value;
 FRoot.ShowHint:=True;
 FRoot.Hint:=Value;
end;

function  TOrgChartNodes.GetCaption:String;
begin
 Result:='';
 if FRoot=nil then Exit;
 Result:=FRoot.Text;
end;

procedure TOrgChartNodes.SaveLevels(const FileName:String);
Var F:File of TOrgLevel;
    I:Integer;
begin
 AssignFile(F,FileName);
 {$I-}
 Rewrite(F);
 if IOResult<>0 then Exit;
 {$I+}
 For i:=0 to 10 do
   Write(f,FOrgLevels[i]);
 CloseFile(F);
end;

procedure TOrgChartNodes.LoadLevels(const FileName:String);
Var F:File of TOrgLevel;
    FTMP:File;
    t:TOrgLevel;
    I:Integer;
    sss:String;
    len:LongInt;
    lennew:LongInt;
begin
 AssignFile(FTMP,FileName);
 {$I-}
 Reset(FTMP,1);
 if IOResult<>0 then
   begin
     CloseFile(FTMP);
     SetLevelsDefault;
     SaveLevels(FileName);
     AssignFile(FTMP,FileName);
     Reset(FTMP,1);
   end;
 len:=FileSize(FTMP);
 lenNew:=SizeOf(TOrgLevel)*11;
 if (lenNew>len) then
   begin
     CloseFile(FTMP);
     SetLevelsDefault;
     SaveLevels(FileName);
   end else CloseFile(FTMP);
 {$I+}
 AssignFile(F,FileName);
 Reset(F);
 For i:=0 to 10 do
  begin
   if eof(f) then
       begin
         sss:='  '+ExtractFileName(FileName)+'    .';
         MessageBox(0,PChar(sss),' !',MB_OK+MB_ICONWARNING);
         CloseFile(f);
         SaveLevels(FileName);
         Exit;
       end;
   read(f,t);
   if t.language=0 then t.language:=$0419;
   Levels[i]:=t;
  end;
 CloseFile(F);
end;

procedure TOrgChartNodes.SetLevelsDefault;
Var i:Integer;
begin
 For i:=0 to 10 do
  begin
    FOrgLevels[i].FontName:='Times New Roman';
    FOrgLevels[i].FontSize:=8;
    FOrgLevels[i].language:=$0419;
    FOrgLevels[i].FontColor:=clBLack;
    FOrgLevels[i].PrjFontName:='Times New Roman';
    FOrgLevels[i].PrjFontSize:=8;
    FOrgLevels[i].PrjFontColor:=clBLack;
    FOrgLevels[i].FontStyle:=[fsBold];
    FOrgLevels[i].PrjFontStyle:=[];
    FOrgLevels[i].Color:=clWhite;
    FOrgLevels[i].PaintColor:=clWhite;
    FOrgLevels[i].DrawColor:=clBlack;
    FOrgLevels[i].ShadowType:=shNone;
    FOrgLevels[i].ShadowColor:=clBlack;
    FOrgLevels[i].ShadowDepth:=4;
    FOrgLevels[i].RectStyle:=re2x;
    FOrgLevels[i].LineStyle:=psSolid;
    FOrgLevels[i].LineWidth:=1;
    FOrgLevels[i].DefWidth:=250;
    FOrgLevels[i].DefHeight:=200;
    FOrgLevels[i].HSpacing:=8;
    FOrgLevels[i].VSpacing:=8;
    FOrgLevels[i].HAlign:=taCenter;
    FOrgLevels[i].VAlign:=taVCenter;
    FOrgLevels[i].Warning:=False;
    FOrgLevels[i].HInterval:=10;
    FOrgLevels[i].VInterval:=10;
    FOrgLevels[i].MaxWidth:=0;
    FOrgLevels[i].MaxHeight:=0;
    FOrgLevels[i].Strategy:=stHTree;
    if i>2 then FOrgLevels[i].Strategy:=stVTree else
     FOrgLevels[i].Strategy:=stHTree;
    FOrgLevels[i].LineDepth:=2;
    FOrgLevels[i].LineColor:=clBlack;
    FOrgLevels[i].NoControlChar:=True;
    FOrgLevels[i].NumbersOnly:=False;
  end;
end;

function  TOrgChartNodes.GetOrgLevel(pIndex: Integer):TOrgLevel;
begin
 if (pIndex<0) or (pIndex > 10) then
   begin
    if (pIndex<0) then Result:=FOrgLevels[0] else
    Result:=FOrgLevels[10];
   end
  else
 Result:=FOrgLevels[pIndex];
end;

procedure TOrgChartNodes.SetOrgLevel(pIndex: Integer;Value:TOrgLevel);
begin
 if (pIndex<0) or (pIndex > 10) then Exit;
 FOrgLevels[pIndex]:=Value;
end;

{ TCustomOrgChart }
constructor TCustomOrgChart.Create(AOwner: TComponent);
begin
 inherited Create(AOwner);
 FPainting:=False;
 FHeaderText:='  1';
 FTitleText:='';
 FShowTitle:=False;
 FNodes:=TOrgChartNodes.Create(self);
 FNodes.Parent:=self;
 FCanvas := TControlCanvas.Create;
 FPrinter:=nil;
 TControlCanvas(FCanvas).Control := Self;
 Canvas.Brush.Color:=clWhite;
 mmmpt:=15;
 mmmpb:=15;
 mmmpl:=25;
 mmmpr:=15;
 SetPageParam(mmmpt,mmmpb,mmmpl,mmmpr);
end;

procedure TCustomOrgChart.SetPageParam(var PageTop,PageBottom,PageLeft,PageRight:Integer);
Var px,py,plofs,ptofs,pbofs,profs:Integer;
    s:String;
Const   es='      .    ';
        se=' ';
begin
 px:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
 py:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
 plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
 ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
 profs:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH)-GetDeviceCaps(Printer.Handle,HORZRES)-plofs;
 pbofs:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT)-GetDeviceCaps(Printer.Handle,VERTRES)-ptofs;
 FPageTop:=Round(PageTop*py/25.4)-ptofs;
 if FPageTop<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageTop:=0;
   PageTop:=Round(ptofs*25.4/py);
   end;
 FPageBottom:=Round(PageBottom*py/25.4)-pbofs;
  if FPageBottom<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageBottom:=0;
   PageBottom:=Round(pbofs*25.4/py);
   end;
 FPageLeft:=Round(PageLeft*px/25.4)-plofs;
  if FPageLeft<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageLeft:=0;
   PageLeft:=Round(plofs*25.4/px);
   end;
 FPageRight:=Round(PageRight*px/25.4)-profs;
  if FPageRight<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageRight:=0;
   PageRight:=Round(profs*25.4/px);
   end;
end;

procedure TCustomOrgChart.SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer);
Var px,py:Integer;
begin
 FPageTop:=PageTop;
 FPageBottom:=PageBottom;
 FPageLeft:=PageLeft;
 FPageRight:=PageRight;
end;


destructor TCustomOrgChart.Destroy;
begin
 if (FPrinter<>nil) then FPrinter.Free;
 if (FCanvas<>nil) then FCanvas.Free;
 if (FNodes<>nil) then FNodes.Destroy; {  ॢ }
 inherited Destroy;
end;

procedure TCustomOrgChart.WMPaint(var Message: TWMPaint);
begin
   PaintHandler(Message);
end;

procedure TCustomOrgChart.PaintWindow(DC: HDC);
begin
  if FPainting then Exit;
  inherited PaintWindow(DC);
  FPainting:=True;
  FCanvas.Lock;
  try
    FCanvas.Handle := DC;
    try
      Paint;
    finally
      FCanvas.Handle := 0;
    end;
  finally
    FCanvas.Unlock;
    FPainting:=False;
  end;
end;

procedure TCustomOrgChart.Paint;
begin
  Canvas.FillRect(ClientRect);
  Nodes.Root.SetUpTree;
end;


function  TCustomOrgChart.PreviewCalcHeader:Integer;
Var  hrect:TRect;
     osize:Integer;
     ofn:TFontName;
begin
 Result:=0;
 if FPrinter = nil then Exit;
 osize:=FPrinter.Canvas.Font.Size;
 ofn:=FPrinter.Canvas.Font.Name;
 FPrinter.Canvas.Font.Size:=18;
 FPrinter.Canvas.Font.Name:='Times New Roman';
 FPrinter.Canvas.Font.Charset:=RUSSIAN_CHARSET;
 FPrinter.Canvas.Font.Style:=FPrinter.Canvas.Font.Style + [fsBold];
 hrect.Left:=Fprinter.XSize(FPageLeft*10);
 hrect.Top:=Fprinter.YSize(FPageTop*10);
 hrect.Bottom:=Fprinter.YSize(FPrinter.PaperLength-FPageBottom*10);
 hrect.Right:=Fprinter.XSize(FPrinter.PaperWidth-FPageRight*10);
 Result:=DrawText(FPrinter.Canvas.Handle,PChar(FHeaderText),Length(FHeaderText),
  hrect,DT_CALCRECT or DT_CENTER or DT_SINGLELINE);
 if FShowTitle then
 begin
 hrect.Top:=Fprinter.YSize(FPageTop*10)+Result;
 hrect.Left:=Fprinter.XSize(FPageLeft*10);
 hrect.Bottom:=Fprinter.YSize(FPrinter.PaperLength-FPageBottom*10);
 hrect.Right:=Fprinter.XSize(FPrinter.PaperWidth-FPageRight*10);
 Result:=Result+DrawText(FPrinter.Canvas.Handle,PChar(FTitleText),Length(FTitleText),
  hrect,DT_CALCRECT or DT_CENTER);
 end;
 FPrinter.Canvas.Font.Style:=FPrinter.Canvas.Font.Style - [fsBold];
 FPrinter.Canvas.Font.Name:=ofn;
 FPrinter.Canvas.Font.Size:=osize;
end;

procedure TCustomOrgChart.PreviewPrintHeader;
Var  hrect:TRect;
     osize:Integer;
     ofn:TFontName;
     res:Integer;
begin
 if FPrinter = nil then Exit;
 osize:=FPrinter.Canvas.Font.Size;
 ofn:=FPrinter.Canvas.Font.Name;
 FPrinter.Canvas.Font.Size:=18;
 FPrinter.Canvas.Font.Name:='Times New Roman';
 FPrinter.Canvas.Font.Charset:=RUSSIAN_CHARSET;
 FPrinter.Canvas.Font.Style:=FPrinter.Canvas.Font.Style + [fsBold];
 hrect.Left:=Fprinter.XSize(FPageLeft*10);
 hrect.Top:=Fprinter.YSize(FPageTop*10);
 hrect.Bottom:=Fprinter.YSize(FPrinter.PaperLength-FPageBottom*10);
 hrect.Right:=Fprinter.XSize(FPrinter.PaperWidth-FPageRight*10);
 res:=DrawText(FPrinter.Canvas.Handle,PChar(FHeaderText),Length(FHeaderText),
  hrect,DT_CENTER or DT_SINGLELINE);
 if FShowTitle then
 begin
 hrect.Top:=Fprinter.YSize(FPageTop*10)+Res;
 hrect.Left:=Fprinter.XSize(FPageLeft*10);
 hrect.Bottom:=Fprinter.YSize(FPrinter.PaperLength-FPageBottom*10);
 hrect.Right:=Fprinter.XSize(FPrinter.PaperWidth-FPageRight*10);
 DrawText(FPrinter.Canvas.Handle,PChar(FTitleText),Length(FTitleText),
  hrect,DT_CENTER);
 end;
 FPrinter.Canvas.Font.Style:=FPrinter.Canvas.Font.Style - [fsBold];
 FPrinter.Canvas.Font.Name:=ofn;
 FPrinter.Canvas.Font.Size:=osize;
end;


procedure TCustomOrgChart.PrintHeader;
Var  hrect:TRect;
     osize:Integer;
     ofn:TFontName;
     res:Integer;
begin
 osize:=Printer.Canvas.Font.Size;
 ofn:=Printer.Canvas.Font.Name;
 Printer.Canvas.Font.Size:=18;
 Printer.Canvas.Font.Name:='Times New Roman';
 Printer.Canvas.Font.Charset:=RUSSIAN_CHARSET;
 Printer.Canvas.Font.Style:=Printer.Canvas.Font.Style + [fsBold];
 hrect.Left:=FPageLeft;
 hrect.Top:=FPageTop;
 hrect.Bottom:=Printer.PageHeight-FPageBottom;
 hrect.Right:=Printer.PageWidth-FPageRight;
 res:=DrawText(Printer.Canvas.Handle,PChar(FHeaderText),Length(FHeaderText),
  hrect,DT_CENTER or DT_SINGLELINE);
 if FShowTitle then
  begin
    hrect.Left:=FPageLeft;
    hrect.Top:=FPageTop+res;
    hrect.Bottom:=Printer.PageHeight-FPageBottom;
    hrect.Right:=Printer.PageWidth-FPageRight;
    DrawText(Printer.Canvas.Handle,PChar(FTitleText),Length(FTitleText),
    hrect,DT_CENTER);
  end;
 Printer.Canvas.Font.Style:=Printer.Canvas.Font.Style - [fsBold];
 Printer.Canvas.Font.Name:=ofn;
 Printer.Canvas.Font.Size:=osize;
end;

function TCustomOrgChart.CalcHeader:Integer;
Var  hrect:TRect;
     osize:Integer;
     ofn:TFontName;
begin
 Result:=0;
 osize:=Printer.Canvas.Font.Size;
 ofn:=Printer.Canvas.Font.Name;
 Printer.Canvas.Font.Size:=18;
 Printer.Canvas.Font.Name:='Times New Roman';
 Printer.Canvas.Font.Charset:=RUSSIAN_CHARSET;
 Printer.Canvas.Font.Style:=Printer.Canvas.Font.Style + [fsBold];
 hrect.Left:=FPageLeft;
 hrect.Top:=FPageTop;
 hrect.Bottom:=Printer.PageHeight-FPageBottom;
 hrect.Right:=Printer.PageWidth-FPageRight;
 Result:=DrawText(Printer.Canvas.Handle,PChar(FHeaderText),Length(FHeaderText),
  hrect,DT_CALCRECT or DT_CENTER or DT_SINGLELINE);
 if FShowTitle then
  begin
    hrect.Left:=FPageLeft;
    hrect.Top:=FPageTop+result;
    hrect.Bottom:=Printer.PageHeight-FPageBottom;
    hrect.Right:=Printer.PageWidth-FPageRight;
    Result:=Result+DrawText(Printer.Canvas.Handle,PChar(FTitleText),Length(FTitleText),
    hrect,DT_CALCRECT or DT_CENTER);
  end;
 Printer.Canvas.Font.Style:=Printer.Canvas.Font.Style - [fsBold];
 Printer.Canvas.Font.Name:=ofn;
 Printer.Canvas.Font.Size:=osize;
end;


procedure TCustomOrgChart.PreviewPrintRect(left,right,top,bottom:Integer);
Var oldStyle:TPenStyle;
begin
 if FPrinter = nil then Exit;
 oldStyle:=FPrinter.Canvas.Pen.Style;
 FPrinter.Canvas.Pen.Style:=psDot;
 FPrinter.Canvas.MoveTo(Left,Top);
 FPrinter.Canvas.LineTo(Right,Top);
 FPrinter.Canvas.LineTo(Right,Bottom);
 FPrinter.Canvas.LineTo(Left,Bottom);
 FPrinter.Canvas.LineTo(Left,Top);
 FPrinter.Canvas.Pen.Style:=oldStyle;
end;

procedure TCustomOrgChart.PreviewPrintPageNum(x,y,left,right,top,bottom:Integer);
Var s:String;
    r:TRect;
    oldFontName:TFontName;
    oldFontSize:Integer;
    oldFontStyle:TFontStyles;
    h:Integer;
begin
 if FPrinter = nil then Exit;
 oldFontName:=FPrinter.Canvas.Font.Name;
 oldFontSize:=FPrinter.Canvas.Font.Size;
 oldFontStyle:=FPrinter.Canvas.Font.Style;
 FPrinter.Canvas.Font.Name:='MS Sans Serif';
 FPrinter.Canvas.Font.Size:=10;
 FPrinter.Canvas.Font.Style:=[];
 FPrinter.Canvas.Font.Charset:=RUSSIAN_CHARSET;
 s:=FHeaderText+' : '+IntToStr(x)+'-'+IntToStr(y);
 r.Top:=0;
 r.Left:=left;
 r.Bottom:=bottom;
 r.Right:=right;
 h:= DrawText(FPrinter.Canvas.Handle,Pchar(s),Length(s),r,
  DT_RIGHT or DT_SINGLELINE or DT_WORDBREAK or DT_CALCRECT);
 r.Top:=bottom-h-1;
 r.Bottom:=bottom;
 DrawText(FPrinter.Canvas.Handle,Pchar(s),Length(s),r,
  DT_RIGHT or DT_SINGLELINE or DT_WORDBREAK);
 FPrinter.Canvas.Font.Name:=oldFontName;
 FPrinter.Canvas.Font.Size:=oldFontSize;
 FPrinter.Canvas.Font.Style:=oldFontStyle;
end;



procedure TCustomOrgChart.PrintRect(left,right,top,bottom:Integer);
Var oldStyle:TPenStyle;
begin
 oldStyle:=Printer.Canvas.Pen.Style;
 Printer.Canvas.Pen.Style:=psDot;
 Printer.Canvas.MoveTo(Left,Top);
 Printer.Canvas.LineTo(Right,Top);
 Printer.Canvas.LineTo(Right,Bottom);
 Printer.Canvas.LineTo(Left,Bottom);
 Printer.Canvas.LineTo(Left,Top);
 Printer.Canvas.Pen.Style:=oldStyle;
end;

procedure TCustomOrgChart.PrintPageNum(x,y,left,right,top,bottom:Integer);
Var s:String;
    r:TRect;
    oldFontName:TFontName;
    oldFontSize:Integer;
    oldFontStyle:TFontStyles;
    h:Integer;
begin
 oldFontName:=Printer.Canvas.Font.Name;
 oldFontSize:=Printer.Canvas.Font.Size;
 oldFontStyle:=Printer.Canvas.Font.Style;
 Printer.Canvas.Font.Name:='MS Sans Serif';
 Printer.Canvas.Font.Size:=10;
 Printer.Canvas.Font.Style:=[];
 Printer.Canvas.Font.Charset:=RUSSIAN_CHARSET;
 s:=FHeaderText+' : '+IntToStr(x)+'-'+IntToStr(y);
 r.Top:=0;
 r.Left:=left;
 r.Bottom:=bottom;
 r.Right:=right;
 h:= DrawText(Printer.Canvas.Handle,Pchar(s),Length(s),r,
  DT_RIGHT or DT_SINGLELINE or DT_WORDBREAK or DT_CALCRECT);
 r.Top:=bottom-h-1;
 r.Bottom:=bottom;
 DrawText(Printer.Canvas.Handle,Pchar(s),Length(s),r,
  DT_RIGHT or DT_SINGLELINE or DT_WORDBREAK);
 Printer.Canvas.Font.Name:=oldFontName;
 Printer.Canvas.Font.Size:=oldFontSize;
 Printer.Canvas.Font.Style:=oldFontStyle;
end;

procedure TCustomOrgChart.Print(nFileName:String);
var i,j:Integer;
    pixprn,pixscr:Integer;
    dc:HDC;
    ratio:Double;
    t:TOrgLevel;
    prnx,prny:Integer;
    wh:TPoint;
    headh:Integer;
    fAborted:Boolean;
    cr:TRect;
    clx,cly,dx,dy,ofsx,ofsy:Integer;
    incpos:Double;
    ppos:Integer;
begin
   faborted:=False;
   ppos:=0;
   self.Visible:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   dc:=GetDC(self.Handle);
   pixprn:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
   pixscr:=GetDeviceCaps(dc,LOGPIXELSX);
   ReleaseDC(self.Handle,dc);
   ratio:=pixprn / pixscr;
   For i:=0 to 10 do
    begin
     t:=Nodes.Levels[i];
     t.LineWidth:=Round(t.LineWidth*ratio);
     t.LineDepth:=Round(t.LineDepth*ratio);
     t.DefWidth:=Round(t.DefWidth*ratio);
     t.DefHeight:=Round(t.DefHeight*ratio);
     t.HSpacing:=Round(t.HSpacing*ratio);
     t.VSpacing:=Round(t.VSpacing*ratio);
     t.HInterval:=Round(t.HInterval*ratio);
     t.VInterval:=Round(t.VInterval*ratio);
     Nodes.Levels[i]:=t;
    end;
    Nodes.Root.SetFontDPI(Printer.Handle);
    Nodes.PreSetupTree;
    wh:=Nodes.SetUpTree;
    Repaint;
    while FPainting do;
   try
   Printer.BeginDoc;
   headh:=CalcHeader;
   prnx:=(Printer.PageWidth-FPageLeft-FPageRight-wh.x) div 2;
   prny:=(Printer.PageHeight-FPageTop-FPageBottom-headh-wh.y) div 2;
   if (prnx<0) or (prny<0) then
     begin
      j:=Application.MessageBox('     .   ?',' !',MB_YESNO);
      if j=ID_YES then
         begin
            clx:= (wh.x div (Printer.PageWidth-FPageLeft-FPageRight))+1;
            cly:= (wh.y div (Printer.PageHeight-FPageTop-FPageBottom))+1;
            incpos:=100.0/(clx*cly);
            ofsx:= (clx*(Printer.PageWidth-FPageLeft-FPageRight)-wh.x) div 2;
            ofsy:= (cly*(Printer.PageHeight-FPageTop-FPageBottom)-wh.y) div 2;
            cr.Left:=-ofsx;
            cr.Right:=Printer.PageWidth-FPageLeft-FPageRight-ofsx;
             for dx:=1 to clx do
              begin
               cr.Top:=-ofsy;
               cr.Bottom:=Printer.PageHeight-FPageTop-FPageBottom-ofsy;
               for dy:=1 to cly do
                begin
                 while FPainting do;
                 PaintPageTo(Printer.Handle,FPageLeft,FPageTop,cr);
                 PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
                 PrintPageNum(dx,dy,FPageLeft,Printer.PageWidth-FPageRight,
                         FPageTop,FPageTop);
                 ppos:=ppos+Round(incpos);
                 while FPainting do;
                 PBarDlg.UpdateVars(ppos);
                 cr.Top:=cr.Bottom;
                 cr.Bottom:=cr.Bottom+Printer.PageHeight-FPageTop-FPageBottom;
                 if cr.Bottom > wh.y then cr.Bottom:=wh.y;
                 if ((dx<>clx) or (dy<>cly)) then Printer.NewPage;
                end;
                cr.Left:=cr.Right;
                cr.Right:=cr.Right+Printer.PageWidth-FPageLeft-FPageRight;
                if cr.Right > wh.x then cr.Right:=wh.x;
              end;
         end
       else FAborted:=True;
     end
     else
     begin
      while FPainting do;
      PrintHeader;
      while FPainting do;
      { Perform(WM_PAINT,Printer.Handle,0);}
      PaintTo(Printer.Handle,prnx+FPageLeft,prny+FPageTop+headh);
      while FPainting do;
      PBarDlg.UpdateVars(100);
     end;
   finally
    if not(fAborted) then Printer.EndDoc else Printer.Abort;
    Nodes.LoadLevels(nFileName);
    Nodes.Root.RestoreFontDPI;
    Nodes.PreSetupTree;
    Nodes.SetUpTree;
    self.Visible:=True;
    Repaint;
   end;
end;

procedure TCustomOrgChart.CreatePreview(nFileName:String);
var i,j:Integer;
    t:TOrgLevel;
    prnx,prny:Integer;
    wh:TPoint;
    headh:Integer;
    cr,qcr:TRect;
    clx,cly,dx,dy,ofsx,ofsy:Integer;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    savedOrd:TPrinterOrientation;
    aSize:Integer;
    tmpi:TQRPaperSize;
    incpos:Double;
    ppos:Integer;
begin
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   FPrinter:=TQRPrinter.Create;
   ppos:=0;
   try
   FPrinter.Cleanup;
   FPrinter.BeginDoc;
   FPrinter.Orientation:=savedOrd;
   Printer.Orientation:=savedOrd;
   FPrinter.PrinterIndex:=Printer.PrinterIndex;
   aSize:=Printer.PaperSize;
   FPrinter.PaperSize:=Default;
   for tmpi:= Default to Custom do
    begin
     if aSize=cQRPaperTranslate[tmpI] then
          FPrinter.PaperSize := tmpI;
    end;
   FPrinter.PaperLength:=Printer.PaperLength;
   FPrinter.PaperWidth:=Printer.PaperWidth;
   FPrinter.NewPage;
   if SavedOrd=poPortrait then
   begin
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   Nodes.PreSetupTree;
   wh:=Nodes.SetUpTree;
   Repaint;
   while FPainting do;
   headh:=PreviewCalcHeader;
   prnx:=(pw-fpl-fpr-wh.x) div 2;
   prny:=(ph-fpt-fpb-headh-wh.y) div 2;
   if (prnx<0) or (prny<0)  then
     begin
       clx:= (wh.x div (pw-fpl-fpr))+1;
       cly:= (wh.y div (ph-fpt-fpb))+1;
       incpos:=100.0/(clx*cly);
       ofsx:= (clx*(pw-fpl-fpr)-wh.x) div 2;
       ofsy:= (cly*(ph-fpt-fpb)-wh.y) div 2;
       cr.Left:=-ofsx;
       cr.Right:=pw-fpl-fpr-ofsx;
        while FPainting do;
          for dx:=1 to clx do
              begin
               cr.Top:=-ofsy;
               cr.Bottom:=ph-fpt-fpb-ofsy;
               for dy:=1 to cly do
                begin
                 PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt,cr);
                 PreviewPrintRect(fpl,pw-fpr,
                           fpt,ph-fpb);
                 PreviewPrintPageNum(dx,dy,fpl,pw-fpr,
                         fpt,fpt);
                 ppos:=ppos+Round(incpos);
                 while FPainting do;
                 PBarDlg.UpdateVars(ppos);
                 cr.Top:=cr.Bottom;
                 cr.Bottom:=cr.Bottom+ph-fpt-fpb;
                 if cr.Bottom > wh.y then cr.Bottom:=wh.y;
                 if ((dx<>clx) or (dy<>cly)) then FPrinter.NewPage;
                end;
                cr.Left:=cr.Right;
                cr.Right:=cr.Right+pw-fpl-fpr;
                if cr.Right > wh.x then cr.Right:=wh.x;
              end;
         end
     else
     begin
      PreviewPrintHeader;
      while FPainting do;
      { Perform(WM_PAINT,Printer.Handle,0);}
      PaintTo(FPrinter.Canvas.Handle,prnx+fpl,prny+fpt+headh);
      while FPainting do;
      PBarDlg.UpdateVars(100);
     end;
   finally
    FPrinter.EndDoc;
    Nodes.LoadLevels(nFileName);
    Nodes.PreSetupTree;
    Nodes.SetUpTree;
    Repaint;
   end;
end;

procedure TCustomOrgChart.PaintTo(DC: HDC; X, Y: Integer);
var
  SaveIndex: Integer;
begin
{  Include(self.FControlState, csPaintCopy);}
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X, Y);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
{  Exclude(FControlState, csPaintCopy);}
end;

procedure TCustomOrgChart.PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect);
var
  I, EdgeFlags, BorderFlags, SaveIndex: Integer;
  R: TRect;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X-PageClipRect.Left, Y-PageClipRect.Top);
  IntersectClipRect(DC, PageClipRect.Left, PageClipRect.Top, PageClipRect.Right, PageClipRect.Bottom);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TCustomOrgChart.CreateBitmap(Var bm:TBitmap;pf:TPixelFormat);
Var wh:TPoint;
begin
   Visible:=False;
   Nodes.PreSetupTree;
   wh:=Nodes.SetUpTree;
   Repaint;
   while FPainting do;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Repaint;
   while FPainting do;
   bm:=TBitmap.Create;
   bm.PixelFormat:=pf;
   bm.Width:=wh.x;
   bm.Height:=wh.y;
   while FPainting do;
   PaintTo(bm.Canvas.Handle,0,0);
   Visible:=True;
end;

procedure TCustomOrgChart.CreateBitmapWithSize(Var bm:TBitmap;pf:TPixelFormat;iw,ih:Integer;nFileName:String);
var ratio:Double;
    t:TOrgLevel;
    wh:TPoint;
    cr:TRect;
    pixscr:Integer;
    dc:HDC;
    rw,rh:Double;
    i:Integer;
 begin
   {}
   Visible:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   try
   Nodes.PreSetupTree;
   wh:=Nodes.SetUpTree;
   Repaint;
   while FPainting do;
   rw:= iw/wh.x;
   rh:= ih/wh.y;
   if rw<rh then ratio:=rw else ratio:=rh; {     }
   For i:=0 to 10 do
    begin
     t:=Nodes.Levels[i];
     t.LineWidth:=Round(t.LineWidth*ratio);
{     if (t.LineWidth=0) then t.LineWidth:=1;}
     t.LineDepth:=Round(t.LineDepth*ratio);
{     if (t.LineDepth=0) then t.LineDepth:=1;}
     t.DefWidth:=Round(t.DefWidth*ratio);
{     if (t.DefWidth=0) then t.DefWidth:=1;}
     t.DefHeight:=Round(t.DefHeight*ratio);
{     if (t.DefHeight=0) then t.DefHeight:=1;}
     t.HSpacing:=Round(t.HSpacing*ratio);
     t.VSpacing:=Round(t.VSpacing*ratio);
     t.HInterval:=Round(t.HInterval*ratio);
     t.VInterval:=Round(t.VInterval*ratio);
     Nodes.Levels[i]:=t;
    end;
    { Hm ! }
    dc:=GetDC(self.Handle);
    pixscr:=GetDeviceCaps(dc,LOGPIXELSX);
    ReleaseDC(self.Handle,dc);
    pixscr:=Round(ratio*pixscr); { NewDPI }
    if (pixscr<=0) then pixscr:=1;
    Nodes.Root.SetFontDPI1(pixscr);
    Nodes.PreSetupTree;
    Nodes.SetUpTree;
    Repaint;
    while FPainting do;
    bm:=TBitmap.Create;
    bm.PixelFormat:=pf;
    bm.Width:=iw;
    bm.Height:=ih;
    while FPainting do;
    PaintTo(bm.Canvas.Handle,0,0);
    while FPainting do;
   finally
    Nodes.LoadLevels(nFileName);
    Nodes.Root.RestoreFontDPI;
    Nodes.PreSetupTree;
    Nodes.SetUpTree;
    Repaint;
    Visible:=True;
   end;
 end;

procedure TCustomOrgChart.CreateBitmapShit(Var bm:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer);
var wh:TPoint;
    cr:TRect;
    ofsx,ofsy:Integer;
 begin
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   try
   Visible:=False;
   Nodes.PreSetupTree;
   wh:=Nodes.SetUpTree;
   Repaint;
   while FPainting do;
   ofsx:= (maxshitw*iw-wh.x) div 2;
   ofsy:= (maxshith*ih-wh.y) div 2;
   cr.Left:=-ofsx+shitw*iw;
   cr.Right:=(shitw+1)*iw-ofsx;
   cr.Top:=shith*ih-ofsy;
   cr.Bottom:=(shith+1)*ih-ofsy;
   bm:=TBitmap.Create;
   bm.PixelFormat:=pf;
   bm.Width:=iw;
   bm.Height:=ih;
   while FPainting do;
   PaintPageTo(bm.Canvas.Handle,0,0,cr);
   while FPainting do;
   finally
    Nodes.PreSetupTree;
    Nodes.SetUpTree;
    Repaint;
    Visible:=True;
   end;
 end;

function  TCustomOrgChart.GetOrgchartSize:TPoint;
 begin
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Repaint;
   while FPainting do;
   Nodes.PreSetupTree;
   Result:=Nodes.SetUpTree;
   Repaint;
   while FPainting do;
 end;

procedure Register;
begin
  RegisterComponents('DeadSouls', [TCustomOrgChart]);
end;
end.
