unit PageSetupFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TPageSetupForm = class(TForm)
    GroupBox1: TGroupBox;
    LeftEdit: TSpinEdit;
    RightEdit: TSpinEdit;
    TopEdit: TSpinEdit;
    BottomEdit: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DefaultButton: TButton;
    OKButton: TButton;
    CancelButton: TButton;
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DefaultButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PageSetupForm: TPageSetupForm;

implementation

uses MainFormUnit, DebugUnit;

{$R *.DFM}

procedure TPageSetupForm.CancelButtonClick(Sender: TObject);
begin
 try
 close;
 except
  on E:Exception do WriteLog('TPageSetupForm:CancelButtonClick',E);
 end;
end;

procedure TPageSetupForm.OKButtonClick(Sender: TObject);
begin
 try
 MainForm.FPageLeft:=LeftEdit.Value;
 MainForm.FPageRight:=RightEdit.Value;
 MainForm.FPageTop:=TopEdit.Value;
 MainForm.FPageBottom:=BottomEdit.Value;
 MainForm.CustomOrgChart1.SetPageParam(MainForm.FPageTop,MainForm.FPageBottom,
 MainForm.FPageLeft,MainForm.FPageRight);
 close;
 except
  on E:Exception do WriteLog('TPageSetupForm:OKButtonClick',E);
 end;
end;

procedure TPageSetupForm.FormCreate(Sender: TObject);
begin
 try
  LeftEdit.Value:=MainForm.FPageLeft;
  RightEdit.Value:=MainForm.FPageRight;
  TopEdit.Value:=MainForm.FPageTop;
  BottomEdit.Value:=MainForm.FPageBottom;
 except
  on E:Exception do WriteLog('TPageSetupForm:FormCreate',E);
 end;
end;

procedure TPageSetupForm.DefaultButtonClick(Sender: TObject);
begin
 try
  LeftEdit.Value:=25;
  RightEdit.Value:=20;
  TopEdit.Value:=20;
  BottomEdit.Value:=20;
 except
  on E:Exception do WriteLog('TPageSetupForm:DefaultButtonClick',E);
 end;
end;

procedure TPageSetupForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 try
 Action:=caFree;
 except
  on E:Exception do
   begin
    WriteLog('TPageSetupForm:FormClose',E);
    Action:=caFree;
   end;
 end;
end;

end.
