unit PreviewFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  qrprntr, ExtCtrls, StdCtrls;

type
  TPreviewForm = class(TForm)
    QRPreview: TQRPreview;
    Label1: TLabel;
    Image1: TImage;
    UpdateTimer: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure QRPreviewPageAvailable(Sender: TObject; PageNum: Integer);
    procedure UpdateTimerTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PreviewForm: TPreviewForm;

implementation

uses MainFormUnit, DebugUnit;

{$R *.DFM}

procedure TPreviewForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
  MainForm.PreviewButton.Enabled:=True;
  MainForm.PreviewToolbar.Visible:=False;
  MainForm.ReportToolbar.Visible:=True;
  MainForm.ExitButton.Enabled:=True;
  MainForm.PageControl.Visible:=True;
  Action:=caFree;
  except
   on E:Exception do WriteLog('TPreviewForm:FormClose',E);
  end;
end;

procedure TPreviewForm.FormCreate(Sender: TObject);
begin
 try
 QRPReview.PageNumber:=1;
 QRPreview.ZoomToFit;
{ MainForm.PreviewZoom.Text:=IntToStr(QRPReview.Zoom);}
  except
   on E:Exception do WriteLog('TPreviewForm:FormCreate',E);
  end;
end;

procedure TPreviewForm.QRPreviewPageAvailable(Sender: TObject;
  PageNum: Integer);
begin
  try
   MainForm.PreviewZoom.Text:=IntToStr(QRPReview.Zoom);
   if (PageNum=QRPreview.QRPrinter.AvailablePages-1) then QRPreview.ZoomToFit;
  except
   on E:Exception do WriteLog('TPreviewForm:QRPreviewPageAvailable',E);
  end;
end;

procedure TPreviewForm.UpdateTimerTimer(Sender: TObject);
begin
   UpdateTimer.Enabled:=False;
   QRPreview.ZoomToFit;
   MainForm.PreviewZoom.Text:=IntToStr(QRPReview.Zoom);
end;

end.
