unit SetupLevelsFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, Buttons, RXCtrls,OrgChart,Printers;

type
  TLevelSetupForm = class(TForm)
    GroupBox1: TGroupBox;
    Label7: TLabel;
    LevelComboBox: TComboBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    FontColor: TColorComboBox;
    PaintColor: TColorComboBox;
    FontSize: TComboBox;
    GroupBox3: TGroupBox;
    rNone: TSpeedButton;
    r1x: TSpeedButton;
    r2x: TSpeedButton;
    r3x: TSpeedButton;
    r4x: TSpeedButton;
    r2x3: TSpeedButton;
    r2x4: TSpeedButton;
    r2x5: TSpeedButton;
    r3x2: TSpeedButton;
    r4x2: TSpeedButton;
    r5x2: TSpeedButton;
    Label5: TLabel;
    lsSolid: TSpeedButton;
    lsDot: TSpeedButton;
    lsDashDot: TSpeedButton;
    DrawColor: TColorComboBox;
    GroupBox5: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    DefWidth: TSpinEdit;
    DefHeight: TSpinEdit;
    HSpacing: TSpinEdit;
    VSpacing: TSpinEdit;
    VAlign: TRadioGroup;
    HAlign: TRadioGroup;
    GroupBox6: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    HInterval: TSpinEdit;
    VInterval: TSpinEdit;
    GroupBox4: TGroupBox;
    sNone: TSpeedButton;
    sLeftFramed: TSpeedButton;
    sLeftBoxed: TSpeedButton;
    sRightFramed: TSpeedButton;
    sRightBoxed: TSpeedButton;
    sBottom: TSpeedButton;
    sTop: TSpeedButton;
    sInverse: TSpeedButton;
    Label6: TLabel;
    ShadowColor: TColorComboBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox7: TGroupBox;
    ssHTree: TSpeedButton;
    ssVTree: TSpeedButton;
    Label17: TLabel;
    ShadowDepth: TSpinEdit;
    FontName: TComboBox;
    CBold: TCheckBox;
    CItalic: TCheckBox;
    CUnderline: TCheckBox;
    GroupBox8: TGroupBox;
    Label18: TLabel;
    LineColor: TColorComboBox;
    Label15: TLabel;
    LineDepth: TSpinEdit;
    useToAll: TCheckBox;
    procedure LevelComboBoxChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FontNameChange(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure FontColorChange(Sender: TObject);
    procedure PaintColorChange(Sender: TObject);
    procedure rectTypeChange(Sender: TObject);
    procedure DrawColorChange(Sender: TObject);
    procedure lineStyleChange(Sender: TObject);
    procedure shadowChange(Sender: TObject);
    procedure ShadowColorChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DefWidthChange(Sender: TObject);
    procedure DefHeightChange(Sender: TObject);
    procedure HSpacingChange(Sender: TObject);
    procedure VSpacingChange(Sender: TObject);
    procedure HIntervalChange(Sender: TObject);
    procedure VIntervalChange(Sender: TObject);
    procedure VAlignClick(Sender: TObject);
    procedure HAlignClick(Sender: TObject);
    procedure strategyChange(Sender: TObject);
    procedure ShadowDepthChange(Sender: TObject);
    procedure LineColorChange(Sender: TObject);
    procedure backColorChange(Sender: TObject);
    procedure CBoldClick(Sender: TObject);
    procedure CItalicClick(Sender: TObject);
    procedure CUnderlineClick(Sender: TObject);
    procedure LineDepthChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    Levels:Array[0..10] of TOrgLevel;
    CurLevel:Integer;
    DPMratio:Double;
  public
    { Public declarations }
  end;

var
  LevelSetupForm: TLevelSetupForm;

implementation

uses MainFormUnit, FileNameUnit, DebugUnit;

{$R *.DFM}

procedure TLevelSetupForm.LevelComboBoxChange(Sender: TObject);
Var i:Integer;
    t:TOrgLevel;
begin
  try
  i:=StrToIntDef(LevelComboBox.Text,0);
  CurLevel:=i;
  t:=Levels[i];
  FontName.Text:=t.FontName;
  FontSize.Text:=IntToStr(t.FontSize);
  FontColor.ColorValue:=t.FontColor;
  PaintColor.ColorValue:=t.PaintColor;
  case t.RectStyle of
  reNone: rNone.Down:=True;
  re1x:   r1x.Down:=True;
  re2x:   r2x.Down:=True;
  re3x:   r3x.Down:=True;
  re4x:   r4x.Down:=True;
  re2x3:  r2x3.Down:=True;
  re2x4:  r2x4.Down:=True;
  re2x5:  r2x5.Down:=True;
  re3x2:  r3x2.Down:=True;
  re4x2:  r4x2.Down:=True;
  re5x2:  r5x2.Down:=True;
  end;
  DrawColor.ColorValue:=t.DrawColor;
  case t.LineStyle of
   psSolid: lsSolid.Down:=True;
   psDot:   lsDot.Down:=True;
   psDashDot:  lsDashDot.Down:=True;
  end;
  case t.ShadowType of
   shNone:              sNone.Down:=True;
   shLeftBoxed:         sLeftBoxed.Down:=True;
   shLeftFramed:        sLeftFramed.Down:=True;
   shRightBoxed:        sRightBoxed.Down:=True;
   shRightFramed:       sRightFramed.Down:=True;
   shTopPerspective:    sTop.Down:=True;
   shBottomPerspective: sBottom.Down:=True;
   shInversePerspective: SInverse.Down:=True;
  end;
   ShadowColor.ColorValue:=t.ShadowColor;
   DefWidth.Value:=t.DefWidth;
   DefHeight.Value:=t.DefHeight;
   VSpacing.Value:=t.VSpacing;
   HSpacing.Value:=t.HSpacing;
   VInterval.Value:=t.VInterval;
   HInterval.Value:=t.HInterval;
  case t.VAlign of
   taTopJustify:   VAlign.ItemIndex:=0;
   taVCenter:      VAlign.ItemIndex:=1;
   taBottomJustify:  VAlign.ItemIndex:=2;
  end;
  case t.HAlign of
   taLeftJustify:   HAlign.ItemIndex:=0;
   taCenter:        HAlign.ItemIndex:=1;
   taRightJustify:  HAlign.ItemIndex:=2;
  end;
  case t.Strategy of
   stHTree:         ssHTree.Down:=True;
   stVTree:         ssVTree.Down:=True;
   else       ssHTree.Down:=True;
  end;
   ShadowDepth.Value:=t.ShadowDepth;
   LineColor.ColorValue:=t.LineColor;
   if fsBold in t.FontStyle then CBold.Checked:=True
    else CBold.Checked:=False;
   if fsItalic in t.FontStyle then CItalic.Checked:=True
    else CItalic.Checked:=False;
   if fsUnderline in t.FontStyle then CUnderline.Checked:=True
    else CUnderline.Checked:=False;
   LineDepth.Value:=t.LineDepth;
   except
    on E:Exception do WriteLog('TLevelSetupForm:LevelComboBoxChange',E);
   end;
end;

procedure TLevelSetupForm.Button1Click(Sender: TObject);
Var i:Integer;
    bl:Boolean;
    fname:String;
begin
 try
 MainForm.SetAnimation(True);
 for i:=0 to 10 do
  begin
    Levels[i].DefWidth:=Round(Levels[i].DefWidth/DPMRatio);
    Levels[i].DefHeight:=Round(Levels[i].DefHeight/DPMRatio);
    Levels[i].HSpacing:=Round(Levels[i].HSpacing/DPMRatio);
    Levels[i].VSpacing:=Round(Levels[i].VSpacing/DPMRatio);
    Levels[i].HInterval:=Round(Levels[i].HInterval/DPMRatio);
    Levels[i].VInterval:=Round(Levels[i].VInterval/DPMRatio);
    MainForm.CustomOrgChart1.Nodes.Levels[i]:=Levels[i];
  end;
 fname:=GetOChartFName(MainForm.FFileName,'lsa');
 MainForm.CustomOrgChart1.Nodes.SaveLevels(fname);
 MainForm.CustomOrgChart1.Nodes.PreSetupTree;
 bl:=MainForm.CustomOrgChart1.Nodes.ControlUser;
 MainForm.CustomOrgChart1.Nodes.SetUpTree;
 MainForm.CustomOrgChart1.Repaint;
 MainForm.SetAnimation(False);
 if not(bl) then
    begin
     MainForm.PageControl.ActivePage:=MainForm.TabSheet2;
     MainForm.PrintButton.Enabled:=True;
     MainForm.PreviewButton.Enabled:=True;
     MainForm.ExportButton.Enabled:=True;
     close;
    end
  else
   begin
    for i:=0 to 10 do
    begin
     Levels[i].DefWidth:=Round(Levels[i].DefWidth*DPMRatio);
     Levels[i].DefHeight:=Round(Levels[i].DefHeight*DPMRatio);
     Levels[i].HSpacing:=Round(Levels[i].HSpacing*DPMRatio);
     Levels[i].VSpacing:=Round(Levels[i].VSpacing*DPMRatio);
     Levels[i].HInterval:=Round(Levels[i].HInterval*DPMRatio);
     Levels[i].VInterval:=Round(Levels[i].VInterval*DPMRatio);
    end;
   end;
   except
    on E:Exception do
     begin
      MainForm.SetAnimation(False);
      WriteLog('TLevelSetupForm:Button1Click',E);
     end;
   end;
end;

procedure TLevelSetupForm.Button2Click(Sender: TObject);
begin
   try
     close;
   except
    on E:Exception do WriteLog('TLevelSetupForm:Button2Click',E);
   end;
end;

procedure TLevelSetupForm.FontNameChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].FontName:=FontName.Text
 else
  for i:=0 to 10 do Levels[i].FontName:=FontName.Text;
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontNameChange',E);
 end;
end;

procedure TLevelSetupForm.FontSizeChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].FontSize:=StrToIntDef(FontSize.Text,10)
 else
  for i:=0 to 10 do Levels[i].FontSize:=StrToIntDef(FontSize.Text,10);
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontSizeChange',E);
 end;
end;

procedure TLevelSetupForm.FontColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].FontColor:=FontColor.ColorValue
 else
  for i:=0 to 10 do Levels[i].FontColor:=FontColor.ColorValue;
 except
  on E:Exception do WriteLog('TLevelSetupForm:FontColorChange',E);
 end;
end;

procedure TLevelSetupForm.PaintColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].PaintColor:=PaintColor.ColorValue
 else
  for i:=0 to 10 do  Levels[i].PaintColor:=PaintColor.ColorValue;
 except
  on E:Exception do WriteLog('TLevelSetupForm:PaintColorChange',E);
 end;
end;

procedure TLevelSetupForm.rectTypeChange(Sender: TObject);
Var i,j:Integer;
begin
 try
 i:=(Sender as TSpeedButton).Tag-1;
 if not(useToAll.Checked) then
 begin
 case i of
  0:  Levels[CurLevel].RectStyle:=reNone;
  1:  Levels[CurLevel].RectStyle:=re1x;
  2:  Levels[CurLevel].RectStyle:=re2x;
  3:  Levels[CurLevel].RectStyle:=re3x;
  4:  Levels[CurLevel].RectStyle:=re4x;
  5:  Levels[CurLevel].RectStyle:=re2x3;
  6:  Levels[CurLevel].RectStyle:=re2x4;
  7:  Levels[CurLevel].RectStyle:=re2x5;
  8:  Levels[CurLevel].RectStyle:=re3x2;
  9:  Levels[CurLevel].RectStyle:=re4x2;
  10: Levels[CurLevel].RectStyle:=re5x2;
 end;
 end
 else
   begin
    case i of
     0:  for j:=0 to 10 do Levels[j].RectStyle:=reNone;
     1:  for j:=0 to 10 do Levels[j].RectStyle:=re1x;
     2:  for j:=0 to 10 do Levels[j].RectStyle:=re2x;
     3:  for j:=0 to 10 do Levels[j].RectStyle:=re3x;
     4:  for j:=0 to 10 do Levels[j].RectStyle:=re4x;
     5:  for j:=0 to 10 do Levels[j].RectStyle:=re2x3;
     6:  for j:=0 to 10 do Levels[j].RectStyle:=re2x4;
     7:  for j:=0 to 10 do Levels[j].RectStyle:=re2x5;
     8:  for j:=0 to 10 do Levels[j].RectStyle:=re3x2;
     9:  for j:=0 to 10 do Levels[j].RectStyle:=re4x2;
    10:  for j:=0 to 10 do Levels[j].RectStyle:=re5x2;
    end;
   end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:RectTypeChange',E);
 end;
end;

procedure TLevelSetupForm.DrawColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].DrawColor:=DrawColor.ColorValue
 else
  for i:=0 to 10 do Levels[i].DrawColor:=DrawColor.ColorValue;
 except
  on E:Exception do WriteLog('TLevelSetupForm:DrawColorChange',E);
 end;
end;

procedure TLevelSetupForm.lineStyleChange(Sender: TObject);
Var i,j:Integer;
begin
 try
 i:=(Sender as TSpeedButton).Tag-1;
 if not(useToAll.Checked) then
 begin
 case i of
  0: Levels[CurLevel].LineStyle:=psSolid;
  1: Levels[CurLevel].LineStyle:=psDot;
  2: Levels[CurLevel].LineStyle:=psDashDot;
 end;
 end
 else
 begin
 case i of
  0: for j:=0 to 10 do Levels[j].LineStyle:=psSolid;
  1: for j:=0 to 10 do Levels[j].LineStyle:=psDot;
  2: for j:=0 to 10 do Levels[j].LineStyle:=psDashDot;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:LineStyleChange',E);
 end;
end;

procedure TLevelSetupForm.shadowChange(Sender: TObject);
Var i,j:Integer;
begin
 try
 i:=(Sender as TSpeedButton).Tag-1;
 if not(useToAll.Checked) then
 begin
 case i of
  0: Levels[CurLevel].ShadowType:=shNone;
  1: Levels[CurLevel].ShadowType:=shLeftFramed;
  2: Levels[CurLevel].ShadowType:=shRightFramed;
  3: Levels[CurLevel].ShadowType:=shBottomPerspective;
  4: Levels[CurLevel].ShadowType:=shLeftBoxed;
  5: Levels[CurLevel].ShadowType:=shRightBoxed;
  6: Levels[CurLevel].ShadowType:=shTopPerspective;
  7: Levels[CurLevel].ShadowType:=shInversePerspective;
 end;
 end
 else
 begin
 case i of
  0: for j:=0 to 10 do Levels[j].ShadowType:=shNone;
  1: for j:=0 to 10 do Levels[j].ShadowType:=shLeftFramed;
  2: for j:=0 to 10 do Levels[j].ShadowType:=shRightFramed;
  3: for j:=0 to 10 do Levels[j].ShadowType:=shBottomPerspective;
  4: for j:=0 to 10 do Levels[j].ShadowType:=shLeftBoxed;
  5: for j:=0 to 10 do Levels[j].ShadowType:=shRightBoxed;
  6: for j:=0 to 10 do Levels[j].ShadowType:=shTopPerspective;
  7: for j:=0 to 10 do Levels[j].ShadowType:=shInversePerspective;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:ShadowChange',E);
 end;
end;

procedure TLevelSetupForm.ShadowColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].ShadowColor:=ShadowColor.ColorValue
 else
  for i:=0 to 10 do Levels[i].ShadowColor:=ShadowColor.ColorValue;
 except
  on E:Exception do WriteLog('TLevelSetupForm:ShadowColorChange',E);
 end;
end;

procedure TLevelSetupForm.FormCreate(Sender: TObject);
Var i,k:Integer;
    dc:HDC;
begin
 try
 dc:=GetDC(Application.Handle);
 k:=GetDeviceCaps(dc,LOGPIXELSY);
 ReleaseDC(Application.Handle,dc);
 DPMratio:=25.4 / k; { pixels to mm -> * DPMRatio }
 FontName.Items.Clear;
 FontName.Items.AddStrings(Printer.Fonts);
 for i:=0 to 10 do
   begin
    Levels[i]:=MainForm.CustomOrgChart1.Nodes.Levels[i];
    Levels[i].DefWidth:=Round(Levels[i].DefWidth*DPMRatio);
    Levels[i].DefHeight:=Round(Levels[i].DefHeight*DPMRatio);
    Levels[i].HSpacing:=Round(Levels[i].HSpacing*DPMRatio);
    Levels[i].VSpacing:=Round(Levels[i].VSpacing*DPMRatio);
    Levels[i].HInterval:=Round(Levels[i].HInterval*DPMRatio);
    Levels[i].VInterval:=Round(Levels[i].VInterval*DPMRatio);
   end;
 CurLevel:=0;
 LevelComboBoxChange(Self);
 except
  on E:Exception do WriteLog('TLevelSetupForm:FormCreate',E);
 end;
end;

procedure TLevelSetupForm.DefWidthChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].DefWidth:=DefWidth.Value
 else
  for i:=0 to 10 do Levels[i].DefWidth:=DefWidth.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:DefWidthChange',E);
 end;
end;

procedure TLevelSetupForm.DefHeightChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].DefHeight:=DefHeight.Value
 else
  for i:=0 to 10 do Levels[i].DefHeight:=DefHeight.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:DefHeightChange',E);
 end;
end;

procedure TLevelSetupForm.HSpacingChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].HSpacing:=HSpacing.Value
 else
 for i:=0 to 10 do Levels[i].HSpacing:=HSpacing.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:HSpacingChange',E);
 end;
end;

procedure TLevelSetupForm.VSpacingChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].VSpacing:=VSpacing.Value
 else
  for i:=0 to 10 do Levels[i].VSpacing:=VSpacing.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:VSpacingChange',E);
 end;
end;

procedure TLevelSetupForm.HIntervalChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].HInterval:=HInterval.Value
 else
  for i:=0 to 10 do Levels[i].HInterval:=HInterval.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:HIntervalChange',E);
 end;
end;

procedure TLevelSetupForm.VIntervalChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].VInterval:=VInterval.Value
 else
  for i:=0 to 10 do Levels[i].VInterval:=VInterval.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:VIntervalChange',E);
 end;
end;

procedure TLevelSetupForm.VAlignClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 case VAlign.ItemIndex of
  0: Levels[CurLevel].VAlign:=taTopJustify;
  1: Levels[CurLevel].VAlign:=taVCenter;
  2: Levels[CurLevel].VAlign:=taBottomJustify;
 end;
 end
 else
 begin
 case VAlign.ItemIndex of
  0: for i:=0 to 10 do Levels[i].VAlign:=taTopJustify;
  1: for i:=0 to 10 do Levels[i].VAlign:=taVCenter;
  2: for i:=0 to 10 do Levels[i].VAlign:=taBottomJustify;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:VAlignClick',E);
 end;
end;

procedure TLevelSetupForm.HAlignClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 case HAlign.ItemIndex of
  0: Levels[CurLevel].HAlign:=taLeftJustify;
  1: Levels[CurLevel].HAlign:=taCenter;
  2: Levels[CurLevel].HAlign:=taRightJustify;
 end;
 end
 else
 begin
 case HAlign.ItemIndex of
  0: for i:=0 to 10 do Levels[i].HAlign:=taLeftJustify;
  1: for i:=0 to 10 do Levels[i].HAlign:=taCenter;
  2: for i:=0 to 10 do Levels[i].HAlign:=taRightJustify;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:HAlignClick',E);
 end;
end;

procedure TLevelSetupForm.strategyChange(Sender: TObject);
Var i,j:Integer;
begin
 try
 i:=(Sender as TSpeedButton).Tag-1;
 if not(useToAll.Checked) then
 begin
 case i of
  0: Levels[CurLevel].Strategy:=stHTree;
  1: Levels[CurLevel].Strategy:=stVTree;
  2: Levels[CurLevel].Strategy:=stVLRTree;
  3: Levels[CurLevel].Strategy:=stVLR2Tree;
 end;
 end
 else
 begin
 case i of
  0: for j:=0 to 10 do Levels[j].Strategy:=stHTree;
  1: for j:=0 to 10 do Levels[j].Strategy:=stVTree;
  2: for j:=0 to 10 do Levels[j].Strategy:=stVLRTree;
  3: for j:=0 to 10 do Levels[j].Strategy:=stVLR2Tree;
 end;
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:StrategyChange',E);
 end;
end;

procedure TLevelSetupForm.ShadowDepthChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
  Levels[CurLevel].ShadowDepth:=ShadowDepth.Value
 else
  for i:=0 to 10 do Levels[i].ShadowDepth:=ShadowDepth.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:ShadowDepthChange',E);
 end;
end;

procedure TLevelSetupForm.LineColorChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
  Levels[CurLevel].LineColor:=LineColor.ColorValue
 else
 for i:=0 to 10 do Levels[i].LineColor:=LineColor.ColorValue;
 except
  on E:Exception do WriteLog('TLevelSetupForm:LineColorChange',E);
 end;
end;

procedure TLevelSetupForm.BackColorChange(Sender: TObject);
begin
 try
{ MainForm.CustomOrgChart1.Canvas.Brush.Color:=backColor.ColorValue;
 MainForm.CustomOrgChart1.Nodes.Root.SetTreeColor(backColor.ColorValue);
 MainForm.CustomOrgChart1.Repaint;}
 except
  on E:Exception do WriteLog('TLevelSetupForm:BackColorChange',E);
 end;
end;

procedure TLevelSetupForm.CBoldClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if CBold.Checked then Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle+[fsBold]
  else Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle-[fsBold];
 end
 else
 begin
 if CBold.Checked then for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle+[fsBold]
  else for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle-[fsBold];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CBoldClick',E);
 end;
end;

procedure TLevelSetupForm.CItalicClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if CItalic.Checked then Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle+[fsItalic]
  else Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle-[fsItalic];
 end
 else
 begin
 if CItalic.Checked then for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle+[fsItalic]
  else for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle-[fsItalic];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CItalicClick',E);
 end;
end;

procedure TLevelSetupForm.CUnderlineClick(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 begin
 if CUnderline.Checked then Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle+[fsUnderline]
  else Levels[CurLevel].FontStyle:=Levels[CurLevel].FontStyle-[fsUnderline];
 end
 else
 begin
 if CUnderline.Checked then for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle+[fsUnderline]
  else for i:=0 to 10 do Levels[i].FontStyle:=Levels[i].FontStyle-[fsUnderline];
 end;
 except
  on E:Exception do WriteLog('TLevelSetupForm:CUnderlineClick',E);
 end;
end;

procedure TLevelSetupForm.LineDepthChange(Sender: TObject);
Var i:Integer;
begin
 try
 if not(useToAll.Checked) then
 Levels[CurLevel].LineDepth:=LineDepth.Value
 else
  for i:=0 to 10 do Levels[i].LineDepth:=LineDepth.Value;
 except
  on E:Exception do WriteLog('TLevelSetupForm:LineDepthChange',E);
 end;
end;


procedure TLevelSetupForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 try
 Action:=caFree;
 except
  on E:Exception do
   begin
    WriteLog('TLevelSetupForm:FormClose',E);
    Action:=caFree;
   end;
 end;
end;

end.
