unit AFSetupFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, DBCtrls, RXCtrls, Mask, Db, DBTables, Buttons,
  RXLookup;

type
  TAFSetupForm = class(TForm)
    Bevel1: TBevel;
    AFTable: TTable;
    DataSource1: TDataSource;
    FontSize: TDBComboBox;
    FontColor: TColorComboBox;
    GroupBox1: TGroupBox;
    DBCheckBox1: TDBCheckBox;
    DBCheckBox2: TDBCheckBox;
    DBCheckBox3: TDBCheckBox;
    DBRadioGroup1: TDBRadioGroup;
    GroupBox2: TGroupBox;
    FirstIndEdit: TDBEdit;
    LeftIndEdit: TDBEdit;
    RightIndEdit: TDBEdit;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    SpinButton3: TSpinButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    DBCheckBox4: TDBCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    OkBtn: TBitBtn;
    FontName: TComboBox;
    Label4: TLabel;
    LUTable: TTable;
    DataSource2: TDataSource;
    RxDBLookupList1: TRxDBLookupList;
    Label8: TLabel;
    DBText1: TDBText;
    DBCheckBox5: TDBCheckBox;
    BackColor: TColorComboBox;
    Label11: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label13: TLabel;
    Bevel4: TBevel;
    Label14: TLabel;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    SpaceBefore: TDBEdit;
    SpinButton4: TSpinButton;
    Label10: TLabel;
    SpaceAfter: TDBEdit;
    SpinButton5: TSpinButton;
    Label12: TLabel;
    SpaceLine: TDBEdit;
    SpinButton6: TSpinButton;
    LineSpacingRule: TComboBox;
    Label15: TLabel;
    DBCheckBox6: TDBCheckBox;
    Label16: TLabel;
    Bevel5: TBevel;
    AFTableLabel: TLabel;
    Button1: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FontNameChange(Sender: TObject);
    procedure FontColorChange(Sender: TObject);
    procedure AFTableAfterScroll(DataSet: TDataSet);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton3DownClick(Sender: TObject);
    procedure SpinButton3UpClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DBEdit1DblClick(Sender: TObject);
    procedure SpinButton4DownClick(Sender: TObject);
    procedure SpinButton5DownClick(Sender: TObject);
    procedure SpinButton4UpClick(Sender: TObject);
    procedure SpinButton5UpClick(Sender: TObject);
    procedure BackColorChange(Sender: TObject);
    procedure SpinButton6DownClick(Sender: TObject);
    procedure SpinButton6UpClick(Sender: TObject);
    procedure LineSpacingRuleChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
   procedure GetFontNames;
  public
    { Public declarations }
  end;

var
  AFSetupForm: TAFSetupForm;

implementation

uses DebugUnit, MasterOFormUnit, SelAFTableDlgUnit;

{$R *.DFM}

procedure TAFSetupForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 try
 if AFTable.Modified then AFTable.Post;
 AFTable.close;
 LUTable.close;
 Action:=caHide;
 except
  on E:Exception do WriteLog('AFSetupForm:FormClose',E);
 end;
end;

procedure TAFSetupForm.FontNameChange(Sender: TObject);
begin
try
 AFTable.Edit;
 AFTable.FieldByName('FontName').AsString:=FontName.Items[FontName.ItemIndex];
 AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:FontNameChange',E);
 end;
end;

procedure TAFSetupForm.FontColorChange(Sender: TObject);
begin
 try
 AFTable.Edit;
 AFTable.FieldByName('FontColor').AsInteger:=Integer(FontColor.ColorValue);
 AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:FontColorChange',E);
 end;
end;

procedure TAFSetupForm.AFTableAfterScroll(DataSet: TDataSet);
Var i:Integer;
begin
 try
 FontName.Text:=AFTable.FieldByName('FontName').AsString;
 FontColor.ColorValue:=TColor(AFTable.FieldByName('FontColor').AsInteger);
 BackColor.ColorValue:=TColor(AFTable.FieldByName('BackColor').AsInteger);
 LineSpacingRule.ItemIndex:=AFTable.FieldByName('LineSpacingRule').AsInteger;
{ LineSpacingRule.Text}
 i:=AFTable.FieldByName('Level').AsInteger;
 DBRadioGroup1.Enabled:=True;
 GroupBox2.Enabled:=True;
 DBCheckBox5.Enabled:=True;
  { DBCheckBox4.Enabled:=True;}
 except
  on E:Exception do WriteLog('AFSetupForm:AFTableAfterScroll',E);
 end;
end;

procedure TAFSetupForm.SpinButton1UpClick(Sender: TObject);
Var i:Integer;
begin
 try
  if (FirstIndEdit.Field.AsInteger >= 153) then Exit;
  AFTable.Edit;
  FirstIndEdit.Field.AsInteger:=FirstIndEdit.Field.AsInteger+1;
  AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton1UpClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton1DownClick(Sender: TObject);
begin
 try
  if FirstIndEdit.Field.AsInteger <= 0 then Exit;
  AFTable.Edit;
  FirstIndEdit.Field.AsInteger:=FirstIndEdit.Field.AsInteger-1;
  AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton1DownClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton2DownClick(Sender: TObject);
begin
 try
  if LeftIndEdit.Field.AsInteger <= 0 then Exit;
  AFTable.Edit;
  LeftIndEdit.Field.AsInteger:=LeftIndEdit.Field.AsInteger-1;
  AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton2DownClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton2UpClick(Sender: TObject);
begin
 try
   if LeftIndEdit.Field.AsInteger >= 153 then Exit;
   AFTable.Edit;
   LeftIndEdit.Field.AsInteger:=LeftIndEdit.Field.AsInteger+1;
   AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton2UpClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton3DownClick(Sender: TObject);
begin
 try
  if RightIndEdit.Field.AsInteger <= 0 then Exit;
  AFTable.Edit;
  RightIndEdit.Field.AsInteger:=RightIndEdit.Field.AsInteger-1;
  AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton3DownClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton3UpClick(Sender: TObject);
begin
 try
   if RightIndEdit.Field.AsInteger >= 153 then Exit;
   AFTable.Edit;
   RightIndEdit.Field.AsInteger:=RightIndEdit.Field.AsInteger+1;
   AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton3UpClick',E);
 end;
end;

procedure TAFSetupForm.OkBtnClick(Sender: TObject);
begin
 try
 if AFTable.Modified then AFTable.Post;
 LUTable.close;
 AFTable.close;
 Hide;
 except
  on E:Exception do WriteLog('AFSetupForm:OKBtnClick',E);
 end;
end;

procedure TAFSetupForm.FormCreate(Sender: TObject);
begin
 try
 AFTable.Close;
 AFTable.DatabaseName:=ExtractFilePath(Application.ExeName)+'DOTS\';
 AFTable.TableName:=MasterForm.repAFTableName;
 LUTable.DatabaseName:=ExtractFilePath(Application.ExeName);
 GetFontNames;
 except
  on E:Exception do WriteLog('AFSetupForm:FormCreate',E)
 end;
end;


procedure TAFSetupForm.GetFontNames;
var
  DC: HDC;
begin
  try
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(FontName.Items));
  ReleaseDC(0, DC);
  FontName.Sorted := True;
 except
  on E:Exception do WriteLog('AFSetupForm:GetFontNames',E);
 end;
end;

procedure TAFSetupForm.DBEdit1DblClick(Sender: TObject);
begin
 try
{ DBListBox.ReadOnly:=not(DBListBox.ReadOnly);}
 except
  on E:Exception do WriteLog('AFSetupForm:GetFontNames',E);
 end;
end;

procedure TAFSetupForm.SpinButton4DownClick(Sender: TObject);
begin
 try
  if SpaceBefore.Field.AsInteger <= 0 then Exit;
  AFTable.Edit;
  SpaceBefore.Field.AsInteger:=SpaceBefore.Field.AsInteger-1;
  AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton4DownClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton5DownClick(Sender: TObject);
begin
 try
  if SpaceAfter.Field.AsInteger <= 0 then Exit;
  AFTable.Edit;
  SpaceAfter.Field.AsInteger:=SpaceAfter.Field.AsInteger-1;
  AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton5DownClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton4UpClick(Sender: TObject);
begin
 try
   if SpaceBefore.Field.AsInteger >= 200 then Exit;
   AFTable.Edit;
   SpaceBefore.Field.AsInteger:=SpaceBefore.Field.AsInteger+1;
   AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton4UpClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton5UpClick(Sender: TObject);
begin
 try
   if SpaceAfter.Field.AsInteger >= 200 then Exit;
   AFTable.Edit;
   SpaceAfter.Field.AsInteger:=SpaceAfter.Field.AsInteger+1;
   AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton5UpClick',E);
 end;
end;

procedure TAFSetupForm.BackColorChange(Sender: TObject);
begin
 try
 AFTable.Edit;
 AFTable.FieldByName('BackColor').AsInteger:=Integer(BackColor.ColorValue);
 AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:BackColorChange',E);
 end;
end;

procedure TAFSetupForm.SpinButton6DownClick(Sender: TObject);
begin
 try
  if SpaceLine.Field.AsInteger <= 0 then Exit;
  AFTable.Edit;
  SpaceLine.Field.AsInteger:=SpaceLine.Field.AsInteger-1;
  AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton6DownClick',E);
 end;
end;

procedure TAFSetupForm.SpinButton6UpClick(Sender: TObject);
begin
 try
   if SpaceLine.Field.AsInteger >= 200 then Exit;
   AFTable.Edit;
   SpaceLine.Field.AsInteger:=SpaceLine.Field.AsInteger+1;
   AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:SpinButton6UpClick',E);
 end;
end;

procedure TAFSetupForm.LineSpacingRuleChange(Sender: TObject);
begin
 try
 AFTable.Edit;
 AFTable.FieldByName('LineSpacingRule').AsInteger:=LineSpacingRule.ItemIndex;
 AFTable.Post;
 except
  on E:Exception do WriteLog('AFSetupForm:LineSpacingRuleChange',E);
 end;

end;

procedure TAFSetupForm.Button1Click(Sender: TObject);
Var hm:Integer;
    s,s1:String;
begin
  SelAFTableDlg.EnumAFTables(MasterForm.repAFTableName);
  hm:=SelAFTableDlg.ShowModal;
  if hm=mrOK then
   begin
      s:=SelAFTableDlg.ListBox.Items[SelAFTableDlg.ListBox.ItemIndex]+'.DB';
      s1:=ExtractFilePath(Application.ExeName)+'DOTS\';
      if not(FileExists(s1+s)) then s:=' .DB';
      MasterForm.repAFTableName:=s;
      MasterForm.AFLoadTable.Close;
      MasterForm.AFLoadTable.TableName:=s;
      MasterForm.LoadAFStyles;
      MasterForm.rModified:=True;
      if AFTable.Modified then AFTable.Post;
      AFTable.Close;
      LuTable.Close;
      AFTable.TableName:=s;
      AFTableLabel.Caption:=copy(s,1,length(s)-3);
      LuTable.Open;
      AFTable.Open;
   end;
end;

end.
