unit AutoFormatFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables,ComCtrls, StdCtrls,RichEdit,RichEdit2, TFlatProgressBarUnit,
  ExtCtrls;

type
  TAutoFormatForm = class(TForm)
    AFTable: TTable;
    CancelButton: TButton;
    ProgressBar: TFlatProgressBar;
    ProgLabel: TLabel;
    procedure AFLoadStyles(Sender: TObject);
    procedure FormatText(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CancelButtonClick(Sender: TObject);
    function  CheckForOneParagraph:Boolean;
  private
    { Private declarations }
     AFStyleLevel:Array[0..49] of Integer;
     AFStyleName:Array[0..49] of String;
     AFFontName:Array[0..49] of String;
     AFFontSize:Array[0..49] of Integer;
     AFFontColor:Array[0..49] of TColor;
     AFBackColor:Array[0..49] of TColor;
     AFFontAttr:Array[0..49] of TFontStyles;
     AFParaAlign:Array[0..49] of TAlignment98;
     AFParaFirstInd:Array[0..49] of Integer;
     AFParaLeftInd:Array[0..49] of Integer;
     AFParaRightInd:Array[0..49] of Integer;
     AFParaNumbering:Array[0..49] of TNumberingStyle;
     AFParaTabPos:Array[0..49] of Integer;
     AFParaSpaceBefore:Array[0..49] of Integer;
     AFParaSpaceAfter:Array[0..49] of Integer;
     AFParaSpaceLine:Array[0..49] of Integer;
     AFPageBreakBefore:Array[0..49] of Boolean;
     AFLineSpacingRule:Array[0..49] of TLineSpacingRule;
     AFNoControlChar:Array[0..49] of Boolean;
     NumCount:WORD;
     OldCount:Integer;
     Index:Integer;
     LevelMinus:Integer;
     PrjLevelMinus:Integer;
     ObrPrjLevelMinus:Integer;
     {}
     NextStrStart:Integer;{ i+1 }
     StrStart:Integer; { i }
     StrLength:Integer; { i }
     StoreStrStart:Integer; { for tmp storing StrStart }
     StoreStrLength:Integer;
     AllText:WideString;
     AllLength:Integer;
     OldStartI:Integer; { i-1 }
     OldLengthI:Integer; { i-1 }
     FLineComment:Boolean;
     FInLineFile:Boolean;
     {}
     FObjPosList:TStringList;
      { New from txthtml.pas }
      function    GetParaID(Var source:String;Var dest:String;Var id:Integer;Var syslen:Integer):Boolean;
      function    GetFontID(Var source:String;Var dest:String;Var id:Integer;Var syslen:Integer):Boolean;

      function    CheckForPrjHeader(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForSubHeader(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForRazdel(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForLevel(Var dest:String;Var level:Integer;Var slen:Integer):Boolean;
      function    CheckForPrj(Var dest:String;Var level:Integer;Var slen:Integer):Boolean;
      function    CheckForObrPrj(Var dest:String;Var level:Integer;Var slen:Integer):Boolean;
      function    CheckForComment(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForCommentHeader(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForDirHeader(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForLinkName(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForIndex(Var dest:String;Var slen:Integer):Boolean;
      function    IsNextLevel(var s1:string):Boolean;
      function    HasNext(Var s:String;id:Integer):Integer;
      procedure   CopySD(Var source:String;Var dest:String;count:Integer);
      function    CheckForDetail(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForLineComment(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForSecondLine(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForPosType(Var dest:String;Var slen:Integer):Boolean;
      function    CheckForInLineFile(Var dest:String;var slen:Integer):Boolean;
      function    CheckForEndInLineFile(Var dest:String;var slen:Integer):Boolean;
      { End from txthtml.pas }
    procedure SetSelAttr(Editor:TRichEdit98; AttrIndex:Integer; SetPara:Boolean;HasOLEObject:Boolean;AllText:WideString;SetParNumbers:Boolean;EnUnderline:Boolean;StID:Integer);
    procedure SetDefAttr(Editor:TRichEdit98);
    procedure SetHidden(SelStart,SelLength:LongInt;Editor:TRichEdit98;HasOLEObject:Boolean;AllText:WideString);
    procedure SetSecondLineTabPos(Editor:TRichEdit98; AttrIndex:Integer;Indent:Integer);
    function  CheckNotPB:Boolean;
    function  CheckNotFirstMainHeader:Boolean;
    procedure SetLevelMinus;
    procedure SetPrjLevelMinus;
    procedure SetObrPrjLevelMinus;
{    procedure SetNewString(editor:TRichEdit98;SelStart,SelLength:LongInt;HasOLEObject:Boolean;AllText:WideString;NewString:WideString);}
    { new code to support not wordwrap switch }
    function  GetString(var s:String;var HasOLE:Boolean;var numOleObj:Integer):Boolean;
  public
    { Public declarations }
  end;

var
  AutoFormatForm: TAutoFormatForm;
  cancelFormat:Boolean;


Const RulerAdj=4/3;
      start_com='(*';   { Definition start of multi-line comment block }
      end_com='*)';     { Definition end of multi-line comment block }
      start_comh='* ';
      start_dirheader='::';
      start_index='@@';
      end_comh=' *';
// modified 25/07/2k by Alexey  Zabloczkiy
      start_linkname='~~';
      start_second=#09+'||';
      start_secondl='||';
      start_prjheader='%%%';
      start_razdel='$$';
      start_postype='##';
      start_linecomment='/*';
      start_header=' ';
      start_obrprj='.';
      start_detail2='// ';
      start_inlinefile='<PREAMBULA>';
      end_inlinefile='</PREAMBULA>';

      MIDRazdel=43;
      MIDLevel1=1;
      MIDLevel15=15;
      MIDObrPrj1=16;
      MIDObrPrj15=30;
      MIDPrjHeader=31;
      MIDComment=33;
      MIDCommentHeader=34;
      MIDDirHeader=35;
      MIDIndex=36;
      MIDLinkName=38;
      MIDPrjDetail=39;
      MIDPrjLevel1=40;
      MIDSubHeader=0;
      MIDPosType=37;
      MIDSecondLine=32;




implementation

uses MasterOFormUnit, DebugUnit, FormatDebugDlgUnit;

{$R *.DFM}

function    TAutoFormatForm.HasNext(Var s:String;id:Integer):Integer;
var i,j,k,l,m:Integer;
    s1:String;
 begin
   result:=pos(start_linkname,s);
   if (result>0) and (id<>MIDLinkName) then exit;
   result:=pos(start_detail2,s);
   if (result>0) and (id<>MIDPrjDetail) then exit;
   result:=pos(start_index,s);
   if (result>0) and (id<>MIDIndex) then exit;
   result:=pos(start_dirheader,s);
   if (result>0) and (id<>MIDDirHeader) then exit;
   result:=pos(start_postype,s);
   if (result>0) and (id<>MIDPosType) then exit;
   result:=pos(start_secondl,s);
   if (result>0) and (id<>MIDSecondLine) then exit;
   result:=pos(start_linecomment,s);
   if (result>0) and (id<>MIDComment) then exit;
   result:=0;
 end;

function    TAutoFormatForm.CheckForInLineFile(Var dest:String;var slen:Integer):Boolean;
Var j:Integer;
 begin
   j:=pos(start_inlinefile,dest);
   if j=1 then
    begin
     Result:=True;
     slen:=length(start_inlinefile);
    end
   else
    begin
     Result:=False;
     slen:=0;
    end;
 end;

function    TAutoFormatForm.CheckForEndInLineFile(Var dest:String;var slen:Integer):Boolean;
Var j:Integer;
 begin
   j:=pos(end_inlinefile,dest);
   if j=1 then
     begin
      slen:=length(end_inlinefile);
      Result:=True;
     end
   else
     begin
      slen:=0;
      Result:=False;
     end;
 end;

function    TAutoFormatForm.CheckForPrjHeader(Var dest:String;Var slen:Integer):Boolean;
Var j:Integer;
 begin
  j:=pos(start_prjheader,dest);
  if j=1 then
    begin
      Result:=True;
      if AFNoControlChar[MIDPrjHeader] then
       begin
        dest:=copy(dest,length(start_prjheader)+1,length(dest));
        slen:=length(start_prjheader);
       end else slen:=0;
    end
   else Result:=False;
 end;

function    TAutoFormatForm.CheckForSubHeader(Var dest:String;Var slen:Integer):Boolean;
Var j:Integer;
 begin
  {}
   j:=pos(start_header,dest);
   if j=1 then
    begin
      Result:=True;
      if AFNoControlChar[MIDSubHeader] then
       begin
        dest:=copy(dest,length(start_header)+1,length(dest));
        slen:=length(start_header);
       end else slen:=0;
    end
   else Result:=False;
 end;

function    TAutoFormatForm.CheckForRazdel(Var dest:String;Var slen:Integer):Boolean;
 begin
  {}
   Result:=False;
   if Length(dest)<2 then Exit;
   If pos(start_razdel,dest)=1 then
     begin
       if AFNoControlChar[MIDRazdel] then
        begin
         dest:=copy(dest,length(start_razdel)+1,length(dest));
         slen:=length(start_razdel);
        end else slen:=0;
       Result:=True;
     end;
 end;

function TAutoFormatForm.IsNextLevel(var s1:string):Boolean;
var ss:string;
    c:char;
begin
 ss:=s1;
 Result:=False;
 if length(s1)=0 then Exit;
 s1:=TrimLeft(s1);
 if length(s1)=0 then Exit;
 if (s1[1] >= '0') and (s1[1] <= '9') then
   begin
     Result:=True;
     while (length(s1)>0)and(((s1[1] >='0') and (s1[1] <='9'))or(s1[1]='.')) do
      begin
      c:=s1[1];
       s1:=copy(s1,2,length(s1)-1);
      end;
      if c<>'.' then result:=false;
   end;
if not result then s1:=ss;
end;




function    TAutoFormatForm.CheckForLevel(Var dest:String;Var level:Integer;Var slen:Integer):Boolean;
Var s1:String;
    c:char;
    inclen:Integer;
 begin
    Result:=False;
   level:=0;
   s1:=dest;
   inclen:=0;
 {   -   }
  if length(s1)=0 then Exit;
  if s1[1]='A' then begin delete(s1,1,1); inc(inclen); end;
  if length(s1)=0 then Exit;
  if (s1[1] in ['0'..'9']) then
begin
   while (length(s1)>0)and((s1[1] in ['0'..'9'])or(s1[1]='.')) do
   begin
   result:=true;
   if (s1[1]='.')or(dest[1]='A') then inc(level);
   c:=s1[1];
   delete(s1,1,1);
   inc(inclen);
   end;
if (c<>'.')and not((dest[1]='A')and(c in ['0'..'9'])) then result:=false;
if (level > 15) then level:=15;
end;
  level:=level-LevelMinus;
  if AFNoControlChar[MIDLevel1+level-1] or MasterForm.afDontUseStyleNumbers then
   begin
    dest:=copy(dest,inclen+1,length(dest)-inclen);
    slen:=inclen;
   end else slen:=0;
 end;

function    TAutoFormatForm.CheckForPrj(Var dest:String;Var level:Integer;Var slen:Integer):Boolean;
Var tmp:String;
    i:Integer;
    ind:Integer;
 begin
  Result:=False;
  level:=0;
  if Length(dest)=0 then Exit;
  tmp:=dest;
  ind:=MIDPrjLevel1+PrjLevelMinus;
  if (ind>(MIDPrjLevel1+2)) then ind:=MIDPrjLevel1+2;
  if tmp[1]='' then
                begin
                   if AFNoControlChar[ind] then
                    begin
                     dest:=copy(dest,2,length(dest)-1);
                     slen:=1;
                    end else slen:=0;
                   Result:=True;
                   level:=1+PrjLevelMinus;
                   if level>3 then level:=3;
                   Exit;
                end;
  if tmp[1]='' then
                begin
                   inc(ind);
                   if (ind>(MIDPrjLevel1+2)) then ind:=MIDPrjLevel1+2;
                   if AFNoControlChar[ind] then
                    begin
                     dest:=copy(dest,2,length(dest)-1);
                     slen:=1;
                    end else slen:=0;
                   Result:=True;
                   level:=2+PrjLevelMinus;
                   if level>3 then level:=3;
                   Exit;
                end;
  if tmp[1]='' then
                begin
                   inc(ind,2);
                   if (ind>(MIDPrjLevel1+2)) then ind:=MIDPrjLevel1+2;
                   if AFNoControlChar[ind] then
                    begin
                     dest:=copy(dest,2,length(dest)-1);
                     slen:=1;
                    end else slen:=0;
                   Result:=True;
                   level:=3+PrjLevelMinus;
                   if level>3 then level:=3;
                   Exit;
                end;
  {}
 end;

function    TAutoFormatForm.CheckForObrPrj(Var dest:String;Var level:Integer;Var slen:Integer):Boolean;
Var tmp,tmp1,tmp2:String;
      i:Integer;
 begin
 {}
 Result:=False;
 level:=0;
 if Length(dest)=0 then Exit;
 tmp:=dest;
 if (tmp[1]<>start_ObrPrj) then Exit;
 i:=1;
 while ((tmp[i]=start_ObrPrj) and (i<=Length(tmp))) do
  begin
    inc(level);
    inc(i);
  end;
 slen:=level+1;
 level:=level-ObrPrjLevelMinus;
 if AFNoControlChar[MIDObrPrj1+level-1] then
  begin
    dest:=copy(dest,i+1,length(dest)-i);
  {  slen:=level+1;}
  end else slen:=0;
 Result:=True;
 end;

function    TAutoFormatForm.CheckForComment(Var dest:String;Var slen:Integer):Boolean;
 begin
 {}
  Result:=False;
  if Length(dest)=0 then Exit;
  if pos(start_com,dest)=1 then
     begin
       FLineComment:=False;
       if AFNoControlChar[MIDComment]then
       begin
       dest:=copy(dest,3,length(dest)-2);
       dest:=copy(dest,1,length(dest)-3);
       slen:=5;
       end else slen:=0;
       Result:=True;
     end;
 end;

function    TAutoFormatForm.CheckForCommentHeader(Var dest:String;Var slen:Integer):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_comh,dest)=1 then
     begin
       if AFNoControlChar[MIDCommentHeader] then
        begin
         dest:=copy(dest,3,length(dest)-2);
         slen:=2;
        end else slen:=0;
       Result:=True;
     end;
 end;

function    TAutoFormatForm.CheckForDirHeader(Var dest:String;Var slen:Integer):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_dirheader,dest)=1 then
     begin
       if AFNoControlChar[MIDDirHeader] then
        begin
         dest:=copy(dest,4,length(dest)-3);
         slen:=3;
        end else slen:=0;
       Result:=True;
     end;
 end;

function    TAutoFormatForm.CheckForLinkName(Var dest:String;Var slen:Integer):Boolean;
 begin
 {}
    Result:=False;
    if Length(dest)<2 then Exit;
    If pos(start_linkname,dest)=1 then
     begin
       if AFNoControlChar[MIDLinkName] then
        begin
         dest:=copy(dest,4,length(dest)-3);
         slen:=3;
        end else slen:=0;
       Result:=True;
     end;
 end;

function    TAutoFormatForm.CheckForIndex(Var dest:String;Var slen:Integer):Boolean;
 begin
 {}
   Result:=False;
   if Length(dest)=0 then Exit;
   If pos(start_index,dest)=1 then
     begin
       if AFNoCOntrolChar[MIDIndex] then
        begin
         dest:=copy(dest,4,length(dest)-3);
         slen:=3;
        end else slen:=0;
       Result:=True;
     end;
 end;

procedure  TAutoFormatForm.CopySD(Var source:String;Var dest:String;count:Integer);
 begin
   if count=0 then count:=length(dest)+1;
   source:=copy(dest,count,length(dest));
   dest:=copy(dest,1,count-1);
   if count=0 then source:='';
 end;

function  TAutoFormatForm.GetParaID(Var source:String;Var dest:String;Var id:Integer;Var syslen:Integer):Boolean;
Var level:Integer;
    n:Integer;
    src:String;
    indlen:Integer;
 begin
  syslen:=0;
  src:=TrimLeft(source);
  syslen:=length(source)-length(src);
  source:=src;
  dest:=source;
  Result:=True;
  if CheckForSubHeader(dest,indlen) then
                             begin
                               ID:=MIDSubHeader;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForRazdel(dest,indlen) then
                             begin
                               ID:=MIDRazdel;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForLevel(dest,level,indlen) then
                             begin
                               ID:=MIDLevel1+level-1;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForPrj(dest,level,indlen) then
                             begin
                               ID:=MIDPrjLevel1+level-1;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForObrPrj(dest,level,indlen) then
                             begin
                               ID:=MIDObrPrj1+level-1;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForComment(dest,indlen) then
                             begin
                               ID:=MIDComment;
                               CopySD(source,dest,length(source)+1);
                               source:='';
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForCommentHeader(dest,indlen) then
                             begin
                               ID:=MIDCommentHeader;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForDirHeader(dest,indlen) then
                             begin
                               ID:=MIDDirHeader;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForLinkName(dest,indlen) then
                             begin
                               ID:=MIDLinkName;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForIndex(dest,indlen) then
                             begin
                               ID:=MIDIndex;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForPrjHeader(dest,indlen) then
                             begin
                               ID:=MIDPrjHeader;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  ID:=MIDPrjHeader;
  n:=HasNext(dest,ID);
  if (n<>0) then CopySD(source,dest,n);
 end;

function  TAutoFormatForm.CheckForDetail(Var dest:String;Var slen:Integer):Boolean;
var res:Integer;
 begin
   Result:=False;
       if (pos(start_detail2,dest)=1) then
          begin
            if AFNoControlChar[MIDPrjDetail] then
             begin
              dest:=copy(dest,length(start_detail2)+1,length(dest));
              slen:=length(start_detail2);
             end else slen:=0;
            Result:=True;
          end;
end;
function  TAutoFormatForm.CheckForLineComment(Var dest:String;Var slen:Integer):Boolean;
var res:Integer;
 begin
   Result:=False;
       if (pos(start_linecomment,dest)=1) then
          begin
            FLineComment:=True;
            if AFNoControlChar[MIDComment] then
             begin
              dest:=copy(dest,length(start_linecomment)+1,length(dest));
              slen:=length(start_linecomment);
             end else slen:=0;
            Result:=True;
          end;
end;

function  TAutoFormatForm.CheckForSecondLine(Var dest:String;Var slen:Integer):Boolean;
Var res:Integer;
 begin
   Result:=False;
   Res:=pos(start_second,dest);
   if Res=0 then Res:=pos(start_secondl,dest);
   if (Res=1) then
     begin
      if AFNoControlChar[MIDSecondLine] then
       begin
        dest:=copy(dest,length(start_secondl)+1,length(dest));
        slen:=length(start_secondl);
       end else slen:=0;
      Result:=True;
     end;
 end;

function  TAutoFormatForm.CheckForPosType(Var dest:String;Var slen:Integer):Boolean;
 begin
  Result:=False;
  if pos(start_postype,dest)=1 then
    begin
      if AFNoControlChar[MIDPosType] then
       begin
        dest:=copy(dest,length(start_postype)+1,length(dest));
        slen:=length(start_postype);
       end else slen:=0;
      Result:=True;
    end;
 end;


function  TAutoFormatForm.GetFontID(Var source:String;Var dest:String;Var id:Integer;Var syslen:Integer):Boolean;
Var n,level:Integer;
    src:String;
    indlen:Integer;
 begin
   Result:=False;
   src:=TrimLeft(source);
   syslen:=length(source)-length(src);
   source:=src;
   dest:=source;
   id:=-1;
  if CheckForPrj(dest,level,indlen) then
                             begin
                               ID:=MIDPrjLevel1+level-1;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;
  if CheckForObrPrj(dest,level,indlen) then
                             begin
                               ID:=MIDObrPrj1+level-1;
                               n:=HasNext(dest,ID);
                               CopySD(source,dest,n);
                               inc(syslen,indlen);
                               Exit;
                             end;

   if CheckForLinkName(dest,indlen)    then
                                  begin
                                   ID:=MIDLinkName;
                                   n:=HasNext(dest,ID);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   inc(syslen,indlen);
                                   Result:=True;
                                   Exit;
                                  end;
   if CheckForPrjHeader(dest,indlen)    then
                                  begin
                                   ID:=MIDPrjHeader;
                                   n:=HasNext(dest,ID);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   inc(syslen,indlen);
                                   Result:=True;
                                   Exit;
                                  end;

   if CheckForDetail(dest,indlen) then
                                  begin
                                   ID:=MIDPrjDetail;
                                   n:=HasNext(dest,ID);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   inc(syslen,indlen);
                                   Result:=True;
                                   Exit;
                                  end;

   if CheckForIndex(dest,indlen)      then
                                  begin
                                   ID:=MIDIndex;
                                   n:=HasNext(dest,ID);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   inc(syslen,indlen);
                                   Result:=True;
                                   Exit;
                                  end;
  if CheckForDirHeader(dest,indlen) then
                             begin
                               ID:=MIDDirHeader;
                               n:=HasNext(dest,ID);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   inc(syslen,indlen);
                                   Result:=True;
                               Exit;
                             end;


   if CheckForPosType(dest,indlen)     then
                                  begin
                                   ID:=MIDPosType;
                                   n:=HasNext(dest,ID);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   inc(syslen,indlen);
                                   Result:=True;
                                   Exit;
                                  end;

   if CheckForSecondLine(dest,indlen)  then
                                  begin
                                   ID:=MIDSecondLine;
                                   n:=HasNext(dest,ID);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   inc(syslen,indlen);
                                   Result:=True;
                                   Exit;
                                  end;
   if CheckForlinecomment(dest,indlen)     then
                                  begin
                                   ID:=MIDComment;
                                   n:=HasNext(dest,ID);
                                   if (n<>0) then CopySD(source,dest,n) else
                                   source:='';
                                   inc(syslen,indlen);
                                   Result:=True;
                                   Exit;
                                  end;
 end;




procedure TAutoFormatForm.SetHidden(SelStart,SelLength:LongInt;Editor:TRichEdit98;HasOLEObject:Boolean;AllText:WideString);
Var i:Integer;
    cnt:Integer;
    ss,sl,oleobj:Integer;
    endpos:Integer;
 begin
  try
   i:=SelStart;
   if HasOLEObject then
   begin
   FObjPosList.Clear;
   endpos:=SelStart+SelLength;
    while (i<endpos) do
     begin
       if (Word(AllText[i])=$FFFC) then
           begin
              FObjPosList.Append(IntToStr(i));
              inc(endpos);
           end;
       inc(i);
     end;
   end;
   if HasOLEObject then
    begin
     cnt:=FObjPosList.Count-1;
     ss:=SelStart;
     sl:=SelLength;
     for i:=0 to cnt do
      begin
       oleobj:=StrToIntDef(FObjPosList.Strings[i],-1);
       editor.SelStart:=ss;
       editor.SelLength:=oleobj-ss;
       editor.SelAttributes.Hidden:=True;
       ss:=oleobj{+1};
       if (ss>=endpos) then Exit;
      end;
      if (ss<endpos) then
        begin
          editor.SelStart:=ss;
          editor.SelLength:=endpos-ss;
          editor.SelAttributes.Hidden:=True;
          Editor.SelStart:=SelStart;
          Editor.SelLEngth:=SelLEngth;
        end else
         begin
          Editor.SelStart:=SelStart;
          Editor.SelLEngth:=SelLEngth;
         end;
    end
   else
    begin
     editor.SelStart:=SelStart;
     editor.SelLength:=SelLength;
     editor.SelAttributes.Hidden:=True;
    end;
  except
   on E:Exception do WriteLog('AutoFormatForm:SetHidden',E);
  end;
 end;

procedure TAutoFormatForm.AFLoadStyles(Sender: TObject);
Var i:Integer;
    tmpAttr:TFontStyles;
    dm:Extended;
    tmpI:Integer;
begin
{}
 try
 dm:= Screen.Width / 210; { Hm - Who know how MS calculate this }
 AFTable.close;
 AFTable.open;
 AFTable.First;
 i:=0;
  while not(AFTable.EOF) do
   begin
    AFStyleLevel[i]:=AFTable.FieldByName('Level').AsInteger;
    AFStyleName[i]:=AFTable.FieldByName('Name').AsString;
    AFFontName[i]:=AFTable.FieldByName('FontName').AsString;
    AFFontSize[i]:=AFTable.FieldByName('FontSize').AsInteger;
    AFFontColor[i]:=TColor(AFTable.FieldByName('FontColor').AsInteger);
    AFBackColor[i]:=TColor(AFTable.FieldByName('BackColor').AsInteger);
    tmpAttr:=[];
    if AFTable.FieldByName('Bold').AsBoolean then tmpAttr:=tmpAttr+[fsBold];
    if AFTable.FieldByName('Italic').AsBoolean then tmpAttr:=tmpAttr+[fsItalic];
    if AFTable.FieldByName('Underline').AsBoolean then tmpAttr:=tmpAttr+[fsUnderline];
    AFFontAttr[i]:=tmpAttr;
     case (AFTable.FieldByName('Align').AsInteger) of
      0: AFParaAlign[i]:=taLeft;
      1: AFParaAlign[i]:=taCenter;
      2: AFParaAlign[i]:=taRight;
      else AFParaAlign[i]:=taLeft;
     end;
    AFParaFirstInd[i]:=Round(AFTable.FieldByName('FirstInd').AsInteger*dm/RulerAdj);
    AFParaLeftInd[i]:=Round(AFTable.FieldByName('LeftInd').AsInteger*dm/RulerAdj);
    tmpI:=Round((153-AFTable.FieldByName('RightInd').AsInteger)*dm);
    AFParaRightInd[i]:=Round(tmpI/RulerAdj);
    AFParaNumbering[i]:=TNumberingStyle(AFTable.FieldByName('Bullets').AsBoolean);
    AFParaTabPos[i]:=Round(AFTable.FieldByName('TabPos').AsInteger*dm);
    AFParaSpaceBefore[i]:=AFTable.FieldByName('SpaceBefore').AsInteger;
    AFParaSpaceAfter[i]:=AFTable.FieldByName('SpaceAfter').AsInteger;
    AFParaSpaceLine[i]:=AFTable.FieldByName('SpaceLine').AsInteger;
    AFPageBreakBefore[i]:=AFTable.FieldByName('PageBreak').AsBoolean;
    AFLineSpacingRule[i]:=TLineSpacingRule(AFTable.FieldByName('LineSpacingRule').AsInteger);
    AFNoControlChar[i]:=AFTable.FieldByName('NoControlChar').AsBoolean;
    i:=i+1;
    AFTable.Next;
   end;
 except
 on E:Exception do WriteLog('AutoFormatForm:AFLoadStyles',E);
 end;
end;

procedure TAutoFormatForm.SetSecondLineTabPos(Editor:TRichEdit98; AttrIndex:Integer;Indent:Integer);
begin
 { Sets tab attributes }
 try
{  editor.Lines.BeginUpdate;}
  editor.Paragraph.SetTab(0,AFParaFirstInd[AttrIndex]-indent,tbaLeft,tblNone);
{  editor.Paragraph.TabCount:=1;
  editor.Paragraph.Tab[0]:=AFParaFirstInd[AttrIndex]-indent;}
{  Editor.Lines.EndUpdate;}
 except
  on E:Exception do writeLog('AutoFormatForm:SetSecondLineTabPos',E);
 end;
end;

procedure TAutoFormatForm.SetDefAttr(Editor:TRichEdit98);
 begin
 { Sets default attributes }
 try
     editor.DefAttributes.Name:=TFontName(AFFontName[0]);
     editor.DefAttributes.Size:=AFFontSize[0];
     editor.DefAttributes.Color:=AFFontColor[0];
     editor.DefAttributes.BackColor:=AFBackColor[0];
     editor.DefAttributes.Language:=LANG_RUSSIAN;
     editor.DefAttributes.Style:= AFFontAttr[0];
     editor.DefAttributes.Style:=editor.DefAttributes.Style-[fsUnderline];
     editor.DefAttributes.UnderlineType:=ultNone;
 except
  on E:Exception do writeLog('AutoFormatForm:SetDefAttr',E);
 end;
 end;

procedure TAutoFormatForm.SetSelAttr(Editor:TRichEdit98; AttrIndex:Integer; SetPara:Boolean;HasOLEObject:Boolean;AllText:WideString;SetParNumbers:Boolean;EnUnderline:Boolean;StID:Integer);
Var SelStart,SelLength:Integer;
    i:Integer;
    oleobj:Integer;
    ss,sl,cnt:Integer;
    endpos:Integer;
    pthbn:Boolean;
begin
 { Sets selected attributes }
 try
{   editor.Lines.BeginUpdate;}
   pthbn:=MasterForm.afPthBlockNumbering;
   i:=SelStart;
   if HasOLEObject then
   begin
   SelStart:=editor.SelStart;
   SelLEngth:=editor.SelLength;
   i:=SelStart;
   FObjPosList.Clear;
   endpos:=SelStart+SelLength;
    while (i<endpos) do
     begin
       if (Word(AllText[i])=$FFFC) then
        begin
          FObjPosList.Append(IntToStr(i));
          inc(endpos);
        end;
       inc(i);
     end;
   end;
   if HasOLEObject then
    begin
     cnt:=FObjPosList.Count-1;
     ss:=SelStart;
     sl:=SelLength;
     for i:=0 to cnt do
      begin
       oleobj:=StrToIntDef(FObjPosList.Strings[i],-1);
       editor.SelStart:=ss;
       editor.SelLength:=oleobj-ss;
       { Next Pass }
{       Old block - We now hidding paragraph char
         if (editor.Paragraph.Numbering=nsUpperRoman) then AttrIndex:=0;
          }
       editor.SelAttributes.StyleHandle:=AttrIndex;
       editor.SelAttributes.Name:=TFontName(AFFontName[AttrIndex]);
       editor.SelAttributes.Size:=AFFontSize[AttrIndex];
       editor.SelAttributes.Color:=AFFontColor[AttrIndex];
       editor.SelAttributes.BackColor:=AFBackColor[AttrIndex];
       editor.SelAttributes.Language:=LANG_RUSSIAN;
       editor.SelAttributes.Style:= AFFontAttr[AttrIndex];
       if enUnderline then
       begin
       if (fsUnderline in AFFontAttr[AttrIndex]) then
        editor.SelAttributes.UnderlineType:=ultSingle
       else
        editor.SelAttributes.UnderlineType:=ultNone;
       end
       else
        begin
          editor.SelAttributes.Style:=editor.SelAttributes.Style-[fsUnderline];
          editor.SelAttributes.UnderlineType:=ultNone;
        end;
       editor.Paragraph.SetTab(StID,AttrIndex,tbaLeft,tblNone);
       editor.Paragraph.SetTab(StID-1,255,tbaLeft,tblNone);
       if SetPara then
        begin
          editor.Paragraph.Style:=AttrIndex;
         { editor.Paragraph.SetTab(31,AttrIndex,tbaLeft,tblNone);}
          editor.Paragraph.Alignment:= AFParaAlign[AttrIndex];
       if ((Boolean(AFParaNumbering[AttrIndex])) and (SetParNumbers)) and (pthbn) then
         begin
           editor.Paragraph.NumberingStart:=NumCount;
           editor.Paragraph.NumberingFollow:=nfParenthesis;
           editor.Paragraph.Numbering:= nsUpperRoman;
           index:=0;
        end
         else  editor.Paragraph.Numbering:= nsNone;
         editor.Paragraph.FirstIndent:=AFParaFirstInd[AttrIndex];
         editor.Paragraph.LeftIndent:=AFParaLeftInd[AttrIndex]-editor.Paragraph.FirstIndent;
         editor.Paragraph.RightIndent:=AFParaRightInd[AttrIndex];
         editor.Paragraph.SpaceBefore:=AFParaSpaceBefore[AttrIndex];
         editor.Paragraph.SpaceAfter:=AFParaSpaceAfter[AttrIndex];
         editor.Paragraph.SetLineSpacing(AFLineSpacingRule[AttrIndex],AFParaSpaceLine[AttrIndex]);
       end;
       ss:=oleobj{+1};
       if (ss>=endpos) then Exit;
      end;
      if (ss<endpos) then
        begin
          editor.SelStart:=ss;
          editor.SelLength:=endpos-ss;
          { Last pass }
{      Old block - We now hidding paragraph char
                 if (editor.Paragraph.Numbering=nsUpperRoman) then AttrIndex:=0;
                 }
       editor.SelAttributes.StyleHandle:=AttrIndex;
       editor.SelAttributes.Name:=TFontName(AFFontName[AttrIndex]);
       editor.SelAttributes.Size:=AFFontSize[AttrIndex];
       editor.SelAttributes.Color:=AFFontColor[AttrIndex];
       editor.SelAttributes.BackColor:=AFBackColor[AttrIndex];
       editor.SelAttributes.Language:=LANG_RUSSIAN;
       editor.SelAttributes.Style:= AFFontAttr[AttrIndex];
       if enUnderline then
       begin
       if (fsUnderline in AFFontAttr[AttrIndex]) then
        editor.SelAttributes.UnderlineType:=ultSingle
       else
        editor.SelAttributes.UnderlineType:=ultNone;
       end
       else
        begin
          editor.SelAttributes.Style:=editor.SelAttributes.Style-[fsUnderline];
          editor.SelAttributes.UnderlineType:=ultNone;
        end;
       editor.Paragraph.SetTab(StID,AttrIndex,tbaLeft,tblNone);
       editor.Paragraph.SetTab(StID-1,255,tbaLeft,tblNone);
       if SetPara then
        begin
          editor.Paragraph.Style:=AttrIndex;
        {  editor.Paragraph.SetTab(31,AttrIndex,tbaLeft,tblNone);}
          editor.Paragraph.Alignment:= AFParaAlign[AttrIndex];
       if ((Boolean(AFParaNumbering[AttrIndex])) AND (SetParNumbers)) and (pthbn) then
         begin
           editor.Paragraph.NumberingStart:=NumCount;
           editor.Paragraph.NumberingFollow:=nfParenthesis;
           editor.Paragraph.Numbering:= nsUpperRoman;
           inc(NumCount);
           index:=0;
        end
         else  editor.Paragraph.Numbering:= nsNone;
         editor.Paragraph.FirstIndent:=AFParaFirstInd[AttrIndex];
         editor.Paragraph.LeftIndent:=AFParaLeftInd[AttrIndex]-editor.Paragraph.FirstIndent;
         editor.Paragraph.RightIndent:=AFParaRightInd[AttrIndex];
         editor.Paragraph.SpaceBefore:=AFParaSpaceBefore[AttrIndex];
         editor.Paragraph.SpaceAfter:=AFParaSpaceAfter[AttrIndex];
         editor.Paragraph.SetLineSpacing(AFLineSpacingRule[AttrIndex],AFParaSpaceLine[AttrIndex]);
       end;
          Editor.SelStart:=SelStart;
          Editor.SelLEngth:=SelLEngth;
        end else
         begin
          Editor.SelStart:=SelStart;
          Editor.SelLEngth:=SelLEngth;
         end;
    end
   else
    begin
{   if (editor.Paragraph.Numbering=nsUpperRoman) then AttrIndex:=0;}
   editor.SelAttributes.StyleHandle:=AttrIndex;
   editor.SelAttributes.Name:=TFontName(AFFontName[AttrIndex]);
   editor.SelAttributes.Size:=AFFontSize[AttrIndex];
   editor.SelAttributes.Color:=AFFontColor[AttrIndex];
   editor.SelAttributes.BackColor:=AFBackColor[AttrIndex];
   editor.SelAttributes.Language:=LANG_RUSSIAN;
   editor.SelAttributes.Style:= AFFontAttr[AttrIndex];
   if enUnderline then
   begin
   if (fsUnderline in AFFontAttr[AttrIndex]) then
    editor.SelAttributes.UnderlineType:=ultSingle
   else
    editor.SelAttributes.UnderlineType:=ultNone;
   end
   else
    begin
      editor.SelAttributes.Style:=editor.SelAttributes.Style-[fsUnderline];
      editor.SelAttributes.UnderlineType:=ultNone;
    end;
   editor.Paragraph.SetTab(StID,AttrIndex,tbaLeft,tblNone);
   editor.Paragraph.SetTab(StID-1,255,tbaLeft,tblNone);
   if SetPara then
   begin
      editor.Paragraph.Style:=AttrIndex;
{      editor.Paragraph.SetTab(31,AttrIndex,tbaLeft,tblNone);}
      editor.Paragraph.Alignment:= AFParaAlign[AttrIndex];
      if ((Boolean(AFParaNumbering[AttrIndex])) and (SetParNumbers)) and (pthbn) then
       begin
        editor.Paragraph.NumberingStart:=NumCount;
        editor.Paragraph.NumberingFollow:=nfParenthesis;
        editor.Paragraph.Numbering:= nsUpperRoman;
        inc(NumCount);
        index:=0;
       end
      else  editor.Paragraph.Numbering:= nsNone;
      editor.Paragraph.FirstIndent:=AFParaFirstInd[AttrIndex];
      editor.Paragraph.LeftIndent:=AFParaLeftInd[AttrIndex]-editor.Paragraph.FirstIndent;
      editor.Paragraph.RightIndent:=AFParaRightInd[AttrIndex];
      editor.Paragraph.SpaceBefore:=AFParaSpaceBefore[AttrIndex];
      editor.Paragraph.SpaceAfter:=AFParaSpaceAfter[AttrIndex];
      editor.Paragraph.SetLineSpacing(AFLineSpacingRule[AttrIndex],AFParaSpaceLine[AttrIndex]);
   end;

   end; { ole object }
{   Editor.Lines.EndUpdate;}
 except
  on E:Exception do writeLog('AutoFormatForm:SetSelAttr',E);
 end;
end;

{procedure TAutoFormatForm.WriteText(Editor:TRichEdit98);
Var f:TextFile;
    i:Integer;
    totalLength:Integer;
 begin
   assignFile(f,'text.log');
   rewrite(f);
   totalLength:=Length(editor.text);
    for i:=0 to (totalLength-1) do
     write(f,editor.Text[i]);
   closeFile(f);
 end;}

function TAutoFormatForm.CheckNotPB:Boolean;
Var s:String;
    NSS:Integer;
    HOB:Boolean;
    NOO:Integer;
begin
 {}
  Result:=True;
  StoreStrStart:=StrStart;
  StoreStrLength:=StrLength;
  NSS:=NextStrStart;
  NextStrStart:=OldStartI;
  GetString(s,HOB,NOO);
  if length(s)=0 then
   begin
     StrStart:=StoreStrStart;
     StrLength:=StoreStrLength;
     NextStrStart:=NSS;
     Exit;
   end;
  if (s[length(s)]=Chr($0C)) then Result:=False;
  StrStart:=StoreStrStart;
  StrLength:=StoreStrLength;
  NextStrStart:=NSS;
end;

function TAutoFormatForm.CheckNotFirstMainHeader:Boolean;
 begin
  if ((index=0) and (NumCount<=2)) then Result:=False
  else Result:=True;
 end;

function TAutoFormatForm.CheckForOneParagraph:Boolean;
Var s:String;
    j:Integer;
    flag:Boolean;
    NSS:Integer;
    HOB:Boolean;
    NOO:Integer;
    ParLen:Integer;
    ParCount:Integer;
begin
 {}
 try
  Result:=False;
  ParCount:=0;
  flag:=True;
  StoreStrStart:=StrStart;
  StoreStrLength:=StrLength;
  NSS:=NextStrStart;
  while (GetString(s,HOB,NOO)) and (flag) do
   begin
    s:=TrimLeft(s);
    if CheckForSubHeader(s,ParLen) then inc(ParCount);
   end;
 finally
  StrStart:=StoreStrStart;
  StrLength:=StoreStrLength;
  NextStrStart:=NSS;
  Result:=(ParCount>1);
 end;
end;

procedure TAutoFormatForm.SetPrjLevelMinus;
Var s:String;
    j,k:Integer;
    flag:Boolean;
    mh:Boolean;
    NSS:Integer;
    HOB:Boolean;
    NOO:Integer;
    ParLen:Integer;
    IndLen:Integer;
 begin
  {}
  PrjLevelMinus:=0;
  flag:=True;
  k:=0;
 { Save}
  StoreStrStart:=StrStart;
  StoreStrLength:=StrLength;
  NSS:=NextStrStart;
   while (GetString(s,HOB,NOO)) and (flag) do
    begin
     s:=TrimLeft(s);
     mh:=CheckForSubHeader(s,ParLen);
     if (mh) then
      begin
         StrStart:=StoreStrStart;
         StrLength:=StoreStrLength;
         NextStrStart:=NSS;
         PrjLevelMinus:=MIDPrjLevel1+2-k;
         Exit;
      end;
     CheckForPrj(s,j,IndLen);
     if (j<>0) then
       begin
      {  flag:=False;
        PrjLevelMinus:=j-AFSpecIndex1;     }
        if j>k then k:=j;
       end;
    end;
   StrStart:=StoreStrStart;
   StrLength:=StoreStrLength;
   NextStrStart:=NSS;
   PrjLevelMinus:=MIDPrjLevel1+2-k;
 end;

procedure TAutoFormatForm.SetObrPrjLevelMinus;
Var s:String;
    j:Integer;
    flag:Boolean;
    mh:Boolean;
    NSS:Integer;
    HOB:Boolean;
    NOO:Integer;
    ParLen:Integer;
    IndLen:Integer;
 begin
  {}
  ObrPrjLevelMinus:=0;
  flag:=True;
 { Save}
  StoreStrStart:=StrStart;
  StoreStrLength:=StrLength;
  NSS:=NextStrStart;
   while (GetString(s,HOB,NOO)) and (flag) do
    begin
     s:=TrimLeft(s);
     mh:=CheckForSubHeader(s,ParLen);
     if (mh) then
      begin
         StrStart:=StoreStrStart;
         StrLength:=StoreStrLength;
         NextStrStart:=NSS;
         Exit;
      end;
     CheckForObrPrj(s,j,IndLen);
     if (j<>0) then
       begin
        flag:=False;
        ObrPrjLevelMinus:=j-1;
       end;
    end;
   StrStart:=StoreStrStart;
   StrLength:=StoreStrLength;
   NextStrStart:=NSS;
 end;


procedure TAutoFormatForm.SetLevelMinus;
Var s:String;
    j:Integer;
    flag:Boolean;
    mh:Boolean;
    NSS:Integer;
    HOB:Boolean;
    NOO:Integer;
    ParLen:Integer;
    IndLen:Integer;
 begin
  {}
  LevelMinus:=0;
  flag:=True;
 { Save}
  StoreStrStart:=StrStart;
  StoreStrLength:=StrLength;
  NSS:=NextStrStart;
   while (GetString(s,HOB,NOO)) and (flag) do
    begin
     s:=TrimLeft(s);
     mh:=CheckForSubHeader(s,ParLen);
     if (mh) then
      begin
         StrStart:=StoreStrStart;
         StrLength:=StoreStrLength;
         NextStrStart:=NSS;
         Exit;
      end;
     CheckForLevel(s,j,IndLen);
     if (j<>0) then
       begin
        flag:=False;
        LevelMinus:=j-1;
       end;
    end;
   StrStart:=StoreStrStart;
   StrLength:=StoreStrLength;
   NextStrStart:=NSS;
 end;

procedure TAutoFormatForm.FormatText(Sender: TObject);
Var editor:TRichEdit98;
    i,j,k,l,m,n,o:Integer;
    s,s1:String;
    pr:Extended;
    start_mc:Boolean;
    sec_col:Integer;
    first_col:Integer;
    f:TextFile;
    mh:Boolean;
    shidden:Boolean;
    newk:Integer;
    dotLen,dl:Integer;
    ms,spbsel:WideString;
    mindex:Integer;
    mlens:Integer;
    NAllLength:Integer;
    HasOleObject:Boolean;
    OldHasOleObject:Boolean;
    numOleObj:Integer;
    Len1,Len2,Len3,Len4,Len5:Integer;
    oldComLen,oldComLen1:Integer;
    oldComStart,oldComStart1:Integer;
    ttt:String;
    OnePar:Boolean;
    slm,splm,soplm:Boolean;
    oindex:Integer;
    ptlen:Integer;
    { New vars }
    dest:String;
    parafont:Boolean;
    res:Boolean;
    indLen:Integer;
    oldSelStart:Integer;
    oldparafont:Boolean;
    mSelStart,mSelLength:Integer;
    smes:String;
    styleid:Integer;
    maindebug:Boolean;
    hidefdebug:Boolean;
    fdhr:Integer;
    dfroml:Integer;
    dtol:Integer;
    dontshowdebug:Boolean;
    strinlinefile:Boolean;
    triginlinefile:Boolean;
    inlen,inlen1:Integer;
begin
 try
 maindebug:=MasterForm.afDebugFormatUnit;
 dontshowdebug:=False;
 slm:=MasterForm.afSetLevelMinus;
 splm:=MasterForm.afSetPrjLevelMinus;
 soplm:=MasterForm.afSetObrPrjLevelMinus;
 NumCount:=1;
 LevelMinus:=0;
 PrjLevelMinus:=0;
 ObrPrjLevelMinus:=0;
 oindex:=0;
 MasterForm.SetActiveAnimate(True);
 cancelFormat:=False;
 Start_mc:=False;
 AFTable.close;
 AFTable.DatabaseName:=ExtractFilePath(Application.ExeName)+'DOTS\';
 AFTable.TableName:=MasterForm.repAFTableName;
 AFLoadStyles(Self);
 ProgressBar.Position:=0;
 ProgLabel.Caption:=' 0 %';
 show;
 editor:=(Sender as TRichEdit98);
 pr:=100/editor.WideLines.Count;
 k:=editor.WideLines.Count{-1};
 { Init FormatDebugDlg }
 if maindebug then
  begin
    dfroml:=0;
    dtol:=k-1;
    hidefdebug:=False;
  end else hidefdebug:=True;
 i:=0;
 indlen:=0;
 NextStrStart:=0;
 StrStart:=0;
 StrLength:=0;
 StoreStrStart:=0;
 StoreStrLength:=0;
 OldStartI:=0;
 OldLengthI:=0;
 OldHasOLEObject:=False;
 HasOLEObject:=False;
 AllText:=editor.WideText;
 AllLength:=editor.WideTextLength;
 OnePar:=CheckForOneParagraph;
 SetDefAttr(editor);
 editor.SelectAll;
{editor.SelStart:=0;
 editor.SelLength:=AllLength;}
 SetSelAttr(editor,0,False,editor.ObjectSelected,AllText,OnePar,False,31);
 editor.SelAttributes.Hidden:=False;
 editor.SelLength:=0;
 editor.SelStart:=0;
 Application.ProcessMessages;
{ First Pass }
  while (GetString(s,HasOLEObject,numOleObj)) and (not(cancelFormat)) do
   begin
     { new code - formating OLE }
       { new code - support for inline files }
       strinlinefile:=CheckForInlineFile(s,inlen);
       if strinlinefile then
        begin
          FInLineFile:=True;
          TrigInlineFile:=True;
          SetHidden(StrStart,inlen,Editor,HasOLEObject,AllText);
        end;
       if not(FInLineFile) then
       begin
       { end new code - support for inline files }
       parafont:=True;
       res:=GetParaID(s,dest,index,indlen);
       styleid:=31;
       while res do
        begin
          if parafont then
            begin
             oldparafont:=True;
             parafont:=False;
               { Check for LEVEL ADJUSTMENT }
               if index=MIDSubHeader then
                begin
                 if slm then SetLevelMinus;
                 if splm then SetPrjLevelMinus;
                 if soplm then SetObrPrjLevelMinus;
                end;
               editor.SelStart:=StrStart;
               editor.SelLength:=length(dest)+indlen;
               oldSelStart:=editor.SelLength+editor.SelStart;
               mSelStart:=StrStart;
               mSelLength:=indlen;
            end
          else
            begin
             editor.SelStart:=oldSelStart;
             editor.SelLength:=length(dest)+indlen;
             mSelStart:=oldSelStart;
             mSelLength:=indlen;
             oldSelStart:=editor.SelLength+editor.SelStart;
            end;
         { Debug }
         if (i<dfroml) or (i>dtol) then hidefdebug:=True
         else if maindebug then hidefdebug:=False;
         if (not(hidefdebug)) and (not(dontshowdebug)) then
         begin
         FormatDebugDlg.FromLine.Text:=IntToStr(dfroml);
         FormatDebugDlg.ToLine.Text:=IntToStr(dtol);
         FormatDebugDlg.Caption:=AFStyleName[index];
         FormatDebugDlg.Dest.Caption:=dest;
         FormatDebugDlg.DestLength.Caption:=IntToStr(length(dest));
         FormatDebugDlg.syslen.Caption:=IntToStr(indlen);
         if AFNoControlChar[index] then
            FormatDebugDlg.hSys.Caption:='True'
         else
            FormatDebugDlg.hSys.Caption:='False';
         if oldparafont then
            FormatDebugDlg.Parafont.Caption:='True'
         else
            FormatDebugDlg.Parafont.Caption:='False';
         FormatDebugDlg.SelLength.Caption:=IntToStr(editor.SelLength);
         FormatDebugDlg.hSelLen.Caption:=IntToStr(mSelLength);
         FormatDebugDlg.CurLine.Caption:=IntToStr(i);
         Application.ProcessMessages;
         fdhr:=FormatDebugDlg.ShowModal;
         Application.ProcessMessages;
         if fdhr=mrCancel then dontshowdebug:=True
         else begin
                dfroml:=StrToIntDef(FormatDebugDlg.FromLine.Text,0);
                dtol:=StrToIntDef(FormatDebugDlg.ToLine.Text,k-1);
                if (i<dfroml) or (i>dtol) then hidefdebug:=True;
              end;
         end;
         { Set attributes }
         if (editor.SelLength>0) then
           begin
             SetSelAttr(editor,index,oldparafont,HasOLEObject,AllText,OnePar,True,styleid);
             dec(styleid);
             if (not(hidefdebug)) and (not(dontshowdebug)) then sleep(1000);
             if index=MIDSecondLine then SetSecondLineTabPos(editor,index,0);
           end;
         { Hide symbols }
         if (AFNoControlChar[index] and (mSelLength>0)) or
            ((index>0) and (index<16) and (MasterForm.afDontUseStyleNumbers) and (mSelLength>0)) then
           begin
             if (index<>MIDComment) or FLineComment then
              begin
               SetHidden(mSelStart,mSelLength,editor,HasOLEObject,AllText);
               if (not(hidefdebug)) and (not(dontshowdebug)) then sleep(1000);
              end
              else
               begin
                dec(mSelLength,3);
                SetHidden(mSelStart,mSelLength,editor,HasOLEObject,AllText);
                if (not(hidefdebug)) and (not(dontshowdebug)) then sleep(1000);
                mSelStart:=oldSelStart-2;
                mSelLength:=2;
                SetHidden(mSelStart,mSelLength,editor,HasOLEObject,AllText);
                if (not(hidefdebug)) and (not(dontshowdebug)) then sleep(1000);
               end;
           end;
       if oldparafont then oldparafont:=false;
       res:=GetFontID(s,dest,index,indlen);
     { Page Breaking }
     if (index<>-1) then
       begin
         if (AFPageBreakBefore[index]) and (i>1) then
          begin
           if CheckNotFirstMainHeader and CheckNotPB then
            begin
             editor.SelStart:=StrStart-2;
             editor.SelLength:=1;
             SpbSel:=editor.WideSelText;
             SetLength(SpbSel,Length(SpbSel)+1);
             SpbSel[Length(SpbSel)]:=WideChar($000C);
             editor.WideSelText:=SpbSel;
             editor.SelLength:=0;
             AllText:=editor.WideText;
             NAllLength:=editor.WideTextLength;
              if (NAllLength>AllLength) then
                begin
                 inc(NextStrStart,NAllLength-AllLength);
                 inc(StrStart,NAllLength-AllLength);
                 inc(StrLength,NAllLength-AllLength);
                 inc(i);
                 AllLength:=NAllLength;
                end;
            end;
          end;
       end;
     end; { while res do }
     { New code support for inline files }
     end {not(FinlineFIle)}
     else
      begin
        if TrigInlineFile then TrigInLineFile:=False
        else
         begin
           Editor.SelStart:=StrStart;
           editor.SelLength:=Length(s);
           SetSelAttr(Editor,MIDComment,True,HasOLEObject,AllText,False,False,31);
         end;
        strinlinefile:=CheckForEndInlineFIle(s,inlen1);
        if strinlinefile then
          begin
            FInlineFIle:=False;
            SetHidden(StrStart,inlen1,Editor,HasOLEObject,AllText);
          end;
      end;
     { End new code support for inline files }
     OldStartI:=StrStart;
     oindex:=index;
     OldLengthI:=StrLength;
     OldHasOLEObject:=HasOLEObject;
     ProgressBar.Position:=Round(i*pr);
     ProgLabel.Caption:=' '+IntToStr(ProgressBar.Position)+' %';
     ProgressBar.Update;
     ProgLabel.Update;
     CancelButton.Update;
     Application.ProcessMessages;
     inc(i);
   end; { while getstring do }
{ editor.WordWrap:=True;}
 if cancelFormat then
   begin
    {MasterForm.RModified:=False;}
    try
    SendMessage(MasterForm.tEditor.Handle,EM_EXLIMITTEXT,0,4096*1024);
    MasterForm.tEditor.InputFormat:=ifRTF;
    MasterForm.tEditor.Lines.LoadFromFile(MasterForm.repFileName);
    except
     SendMessage(MasterForm.tEditor.Handle,EM_EXLIMITTEXT,0,4096*1024);
     MasterForm.tEditor.InputFormat:=ifTEXT;
     MasterForm.tEditor.Lines.LoadFromFile(MasterForm.repFileName);
     MasterForm.tEditor.InputFormat:=ifRTF;
    end;
    MasterForm.Formated:=False;
    mindex:=1;
    ms:=MasterForm.tEditor.WideText;
    mlens:=MasterForm.tEditor.WideTextLength;
    while (Word(ms[mindex])<>$000D) and (mindex<=mlens) do
     begin
       inc(mindex);
     end;
    MasterForm.tEditor.SelStart:=0;
    MasterForm.tEditor.SelLength:=mindex;
    MasterForm.tEditor.ClearSelection;
    MasterForm.tEditor.SelLength:=0;
    MasterForm.tEditor.Modified:=False;
   end else
    begin
     MasterForm.RepLinesCount:=0;
     MasterForm.Formated:=True;
     MasterForm.tEditor.SetCaret(0,1);
    end;
{ editor.Lines.EndUpdate;}
{ editor.Visible:=True;}
 hide;
 self.Update;
 MasterForm.SetActiveAnimate(False);
 except
 on E:Exception do
     begin
     MasterForm.SetActiveAnimate(False);
     WriteLog('AutoFormatForm:FormatText',E);
     end;
 end;
end;

procedure TAutoFormatForm.FormCreate(Sender: TObject);
begin
 try
  FObjPosList:=TStringList.Create;
  FObjPosList.Clear;
  FInLineFile:=False;
  FormatText(MasterForm.tEditor);
  close;
 except
 on E:Exception do WriteLog('AutoFormatForm:FormCreate',E);
 end;
end;

procedure TAutoFormatForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 try
 if Assigned(FObjPosList) then
   begin
     FObjPosList.Clear;
     FObjPosList.Free;
   end;
 Action:=caFree;
 except
  on E:Exception do WriteLog('AutoFormatForm:FormClose',E);
 end;
end;

procedure TAutoFormatForm.CancelButtonClick(Sender: TObject);
begin
 cancelFormat:=True;
end;


function  TAutoFormatForm.GetString(var s:String;var HasOLE:Boolean;var numOleObj:Integer):Boolean;
Var s1:WideString;
    reps:String;
    l:Integer;
begin
 reps:=Chr($b9);
 StrStart:=NextStrStart;
 Result:=True; { Opti ! }
 s:='';
 l:=0;
 HasOLE:=False;
 NumOLEObj:=0;
 SetLength(s1,l);
 while (Word(AllText[NextStrStart+1])<>$000D) and (NextStrStart<AllLength) do
  begin
   if (Word(AllText[NextStrStart+1])<>$FFFC) then
    begin
     inc(l);
     SetLength(s1,l);
     s1[l]:=AllText[NextStrStart+1];
    end else
     begin
      HasOLE:=True;
      inc(numOleObj);
     end;
   inc(NextStrStart);
  end;
  s:=WideCharToString(PWideChar(s1));
  StrLength:=Length(s);
  if (StrStart<AllLength) then inc(NextStrStart) else Result:=False;
  if (StrStart>=AllLength) then Result:=False;
end;


end.
