unit ColoredGrid;
{
(c) . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,Items,Utils,DB,FileUtil,stdctrls,comctrls,menus, RxCtrls, RXSpin,myLists,otherlists;

type
TGetHintEvent=function(hintid:integer):string of object;
TOnCEEvent=procedure(Sender:TObject;recursive:boolean) of object;
TListSortKind=(lsNumber,lsName,lsPictogram,lsScale,lsScale2);
TMyInplaceEditor=class(TInplaceEdit)
protected
procedure doEnter; override;
procedure doExit; override;
procedure WndProc(var Message: TMessage); override;
end;
  TColoredGrid = class(TStringGrid)
  private
    { Private declarations }
    curabsid:integer;
    curhintpos:integer;
    curhintcol:integer;
    foldhintcell:TPoint;
    fOnMouseenter,fOnMouseExit,fOnStartEditing,fOnfinishEditing,fOnChanging: TNotifyEvent;
    fShowMarked:TMenuItem;
    fOnNeedHint:TGetHintEvent;
    fnamecol:integer;
    fsmap,ffiltered,fdisprow,fisleaf:TList;
    flinkedcontrols:TList;
    finsource,ownins:TOMItems;
    fprocsource:TOMItems;
    fprocselected:boolean;
    fmaxlevel:integer;
    flevelControl:TRXSpinEdit;
    fUpdating:integer;
    fOnRebuild:TNotifyEvent;
    inhint:boolean;
    fTreeView:TTreeView;
    fmenu:TPopupMenu;
    fMenuParent:TStringGrid;
    fshowmarkedonly:boolean;
    fprocess:integer;
    foldroot:integer;
    {fHasPictograms,
    fHasScales:boolean;}
    CurrentIndex:integer;
  protected
    { Protected declarations }
    procedure DrawCell(ACol,ARow:LongInt;ARect:TRect;AState:TGridDrawState);override;
//    procedure Loaded;override;

    function GetEditLimit: Integer; override;
    procedure DoMouseEnter(var Message:TMessage);message CM_MOUSEENTER;
    procedure DoMouseExit(var Message:TMessage);message CM_MOUSELEAVE;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    function GetSelIndex:integer;
    function GetRowIndex(r:integer):integer;
    function GetSelItem:TOMItem;
    function getfiltered(index:integer):boolean;
    procedure setfiltered(index:integer;value:boolean);
    function getIsLeaf(index:integer):boolean;
    procedure setIsLeaf(index:integer;value:boolean);
    function getDisprow(index:integer):integer;
    procedure setDisprow(index:integer;value:integer);

    function GetEditText(ACol, ARow: Longint): string; override;
    function GetEditMask(ACol, ARow: Longint): string; override;
    procedure SetEditText(ACol, ARow: Longint; const Value: string); override;
    procedure SizeChanged(OldColCount,OldRowCount:integer);override;
    function  GetSMap(index:integer):integer;
    procedure setSM(sm:boolean);
    procedure setInsource(ins:TOMItems);
    function SelectCell(ACol, ARow: Longint): Boolean;override;
    procedure MoveColRow(ACol, ARow: Longint; MoveAnchor,  Show: Boolean);
    function CanEditShow:boolean;override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;override;
    function getSourceFiltered:TOMItems;
    function isUpdating:boolean;
    procedure SetFontLevelParams(Font:TFont;level:integer);
    function RescaleRow(Arow:integer):integer;
    procedure RescaleRows;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure DoShowEditor(Sender:TObject);
    procedure DoHideEditor(Sender:TObject);
    function CreateEditor:TInplaceEdit;override;
    procedure DrawRow(ARow:integer;select:boolean);
    procedure Click;override;
    procedure invalidatechildren(id:integer;select:boolean);
  public
    { Public declarations }
  Root:integer;
  selcount:boolean;
  selparent:longint;
  FileType:integer;
  Caption:string;
  Author:string;
  showdeleted:boolean;
  lastpos:integer;
  checkmark: TBitMap;
  rootname:string;
  UseFiltering:boolean;
  procedure Repaint;override;
  procedure Reset;
  procedure startUpdate;
  procedure endUpdate;
  procedure exitupdate;
  property insource:TOMItems read finsource write setInsource;
  property SourceFiltered:TOMItems read getSourceFiltered;
  property smap[index:integer]:integer read GetSmap;
  property UpDating:boolean read isUpdating;
  property Filtered[index:integer]:boolean read getfiltered write setfiltered;
  property IsLeaf[index:integer]:boolean read getIsLeaf write setIsLeaf;
  property Disprow[index:integer]:integer read getdisprow write setdisprow;
  function Rebuild(total,disponly:boolean):boolean;
  procedure UpDate(id:integer);
  procedure UpDateAll;
  procedure ApplyWidth;
  procedure ShowNumbers;
  function selectedtext:string;
  procedure modifytext(s:string);
  procedure SWAPsource;
  procedure resetSource;
  procedure resetState;
  constructor Create(AOwner:TComponent);override;
  constructor CreateFromSource(AOwner:TComponent;source:TOMItems);
  destructor Destroy;override;
  function calcMaxLevel:integer;
  procedure filterposition(pos:integer);
  procedure setProcess(procN:integer;bpclass:TOMItems;procFilter:TLiteLinks);
//-------------ClipBoard operations
  procedure CopyToClipBoard;
  procedure CutToClipBoard;
  procedure PasteFromClipBoard;
  property SelectedIndex:integer read GetSelIndex;
  property IndexOfRow[index:integer]:integer read GetRowIndex;
  property SelectedItem:TOMItem  read GetSelItem;
  function RowItem(row:integer):TOMItem;
  property showmarkedonly:boolean read fshowmarkedonly  write setSM;
  property MaxExpanded:integer read fmaxlevel;
  Property Process:integer read fProcess write fProcess;
  property NameCol:integer read fNameCol;
{  property HasPictograms:boolean read fHasPictograms write fHasPictograms;
  property HasScales:boolean read fHasScales write fHasScales;}

  published
    { Published declarations }
    property LevelControl:TRXSpinEdit read flevelcontrol write flevelcontrol;
    property TreeView:TTreeView read ftreeview write ftreeview;
    property OnMouseEnter:TNotifyEvent read fOnMouseEnter write fOnMouseEnter;
    property OnMouseExit:TNotifyEvent read fOnMouseExit write fOnMouseExit;
    property OnStartEdit:TNotifyEvent read fOnstartediting write fonstartediting;
    property OnEndEdit:TNotifyEvent read fOnfinishediting write fonfinishediting;
    property OnNeedHint:TGetHintEvent read fOnneedhint write fonneedhint;
    property OnChanging:TNotifyEvent read fOnChanging write fOnChanging;
    property OnRebuild:TNotifyEvent read fonRebuild write fonRebuild;
    property ShowMarkedMenuItem:TMenuItem read fshowmarked write fshowmarked;
    property OnMouseWheel;

  end;

procedure Register;

implementation
uses math,logs, itUtils, appConst,clipbrd;
procedure Register;
begin
  RegisterComponents('Samples', [TColoredGrid]);
end;
procedure TColoredGrid.DrawCell(ACol,ARow:LongInt;ARect:TRect;AState:TGridDrawState);
var i,j:integer;
    isselected,ispsel:boolean;
    rect,rect2:TRect;
    s:string;
    sRect:TRect;
begin
if insource=nil then exit;
 canvas.font.assign(font);
i:=smap[ARow];
if  DefaultDrawing and (i>0)and(i<=insource.count) then
 begin
j:=i;
isselected:=false;
while (j<>0) and not isselected  do
begin
isselected:=j=CurrentIndex;
j:=insource[j].intparent;
end;
ispsel:=false;
j:=Currentindex;
while (j>0)and not ispsel do
begin
 ispsel:=i=j;
 j:=insource[j].intparent;
end;
rect:=ARect;
rect2.left:=rect.left+1;
rect2.top:=rect.top+1;
rect2.right:=rect.right-1;
rect2.bottom:=rect.bottom-1;

if (gdFixed in AState) then
begin
if (acol=0)or(arow=0) then
 begin
 if insource[i].marked and $1=$1 then
 Canvas.Brush.color:=clInfoBk
 else
   Canvas.Brush.Color:=fixedColor;
  if Ctl3D then
   begin
    canvas.Pen.Color:=cl3DLight;
    canvas.Polyline([Point(rect2.right,rect2.top),rect2.topleft,Point(rect2.left,rect2.bottom)]);
    canvas.Pen.Color:=cl3DDkShadow;
    canvas.Polyline([Point(rect2.right,rect2.top),rect2.BottomRight,Point(Rect2.left,rect2.bottom)]);
    canvas.FillRect(rect2);
    end
                      else
   begin
    canvas.FillRect(rect);
   end;
if insource[i].deleted>0 then
canvas.font.color:=clMaroon
else
canvas.font.color:=clBlack;
if ispsel then
canvas.Font.Style:=[fsBold]
else
canvas.Font.Style:=[];
if EditorMode and (Arow=Row) then
canvas.Font.style:=[fsItalic,fsBold];
if font.Size<8 then Canvas.font.style:=[];
 canvas.TextRect(Rect2,
    rect2.left+canvas.textwidth('* ')+3,
    rect2.top+(Rect2.Bottom-Rect2.top-canvas.textHeight('A'))div 2,cells[ACol,ARow]);
    if EditorMode and (Arow=Row) then
    begin
     canvas.font.assign(font);
     canvas.font.Color:=clRed;
     canvas.Textout(rect2.left,rect2.top+(Rect2.Bottom-Rect2.top-canvas.textHeight('A'))div 2,'<');
     canvas.font.Color:=font.Color;
    end

    else
    if (isselected) then
    begin
     canvas.font.assign(font);
     canvas.font.Color:=clRed;
     canvas.Textout(rect2.left,rect2.top+(Rect2.Bottom-Rect2.top-canvas.textHeight('A'))div 2,'*');
     canvas.font.Color:=font.Color;
    end;
   if insource[i].Closed then
       begin
     canvas.font.assign(font);
     canvas.font.Color:=clRed;
     canvas.Textout(rect2.right-canvas.textWidth('-'),rect2.top+(Rect2.Bottom-Rect2.top-canvas.textHeight('A'))div 2,'-');
     canvas.font.Color:=font.Color;
    end
   else
   if not ((insource[i].expanded)or(isleaf[i])) then
    begin
     canvas.font.assign(font);
     canvas.font.Color:=clRed;
     canvas.Textout(rect2.right-canvas.textWidth('+'),rect2.top+(Rect2.Bottom-Rect2.top-canvas.textHeight('A'))div 2,'+');
     canvas.font.Color:=font.Color;
    end;

 end
   else
  begin
  Inherited DrawCell(ACol,ARow,ARect,AState);
   if assigned(OnDrawCell) then
    OnDrawCell(self,ACol,ARow,ARect,AState);
  end;

end
else
begin
 Canvas.Brush.Color:=Color;
   if isselected and(ACOL=fnamecol)then
    begin
     canvas.brush.Color:=cl3DLight;

    end
                          else
    begin

         canvas.brush.Color:=color;

    end;
     canvas.FillRect(rect);
 if (gdFocused in AState) then
  begin
   canvas.brush.Color:=clActiveCaption;
   canvas.Fillrect(rect);
   canvas.font.Color:=clCaptionText;
  end ;
if (gdSelected in AState)and not (gdFocused in AState) then
  begin
   canvas.brush.Color:=clInActiveCaption;
   canvas.Fillrect(rect);
   canvas.font.Color:=clInactiveCaptionText;
  end ;
 if (acol=fnamecol) then
 begin
 if ([gdFocused,gdSelected]*AState=[]) then
 begin
 if appconst.sysinfo.LevelFormat then
 begin
 SetFontLevelParams(Canvas.Font,Insource[i].level);
   if insource[i].changed then
      canvas.font.Color:=clGreen
      else
   if insource[i].new then
      canvas.font.Color:=TColor($D80000);
 end;
   if insource[i].deleted<>0 then
    begin
     canvas.font.color:=clMaroon;
     canvas.font.Style:= canvas.font.Style+[fsStrikeOut]
    end;
  end;
 s:=cells[ACol,ARow];
 sRect:=classes.Rect(rect.left+min(insource[i].level*6+3,(Rect.Right-Rect.Left)shr 2),Rect.Top+2,rect.Right-1,rect.Bottom);
 if appconst.sysinfo.MultiLine then
 DrawText(Canvas.Handle,PChar(s),-1,sRect,DT_WORDBREAK)
 else
 Canvas.TextRect(Rect,sRect.Left,sRect.Top,s);
 if (ClearSpaces(insource[i].comment)<>'') then
  begin
   canvas.Pen.color:=clRed;
   canvas.brush.color:=clRed;
   canvas.Polygon([Point(rect.right-5,rect.top+1),
                   Point(rect.right-1,rect.top+5),
                   Point(rect.right-1,rect.top+1)]);
  end;
 end
else
 canvas.TextRect(rect,rect.right-canvas.textWidth(cells[acol,arow]),rect.top+(Rect.Bottom-Rect.top-canvas.textHeight('A'))div 2,cells[ACol,ARow]);
end

end
else
  begin
  Inherited DrawCell(ACol,ARow,ARect,AState);
   if assigned(OnDrawCell) then
    OnDrawCell(self,ACol,ARow,ARect,AState);
  end;
end;
function TColoredGrid.Rebuild(total,disponly:boolean):boolean;
var i,j,fnr,lp:integer;
    curitem:integer;
    awc:TWinControl;
    newit:TOMItem;
    newnode:TTreeNode;
    cr:integer;
    froot:integer;
    markedCount:integer;
function getPos(id:integer):integer;
begin
 if not fprocselected then result:=id
                  else result:=fprocSource[id].idloaded;
end;
function BuildList(level,root:integer;disp:boolean;inum:string;var fnrow:integer;disponly:boolean):integer;
var
 pos,realpos:integer;
 nit:integer;
 newinum:string;
 inside:boolean;

begin
nit:=0;
pos:=root;
result:=fnrow;
if (pos<=0) or (pos>insource.count) then exit;
repeat
realpos:=getPos(pos);
inc(lp);
insource[realpos].listpos:=lp;
isleaf[realpos]:=true;
insource[realpos].isleaf:=true;
inside:=false;
if  not fshowmarkedonly or  insource.canshow(realpos,3) then
begin
//if (insource[pos].deleted>0) then showmessage(insource[pos].s);
if  insource[realpos].displayed and (not UseFiltering or fprocselected or filtered[realpos]) then
begin
if UseFiltering and fprocselected then
filtered[realpos]:=true;
if disp  then
begin
if insource[realpos].marked and 1 =1 then inc(markedCount);
inc(fnrow);
inc(nit);
inside:=true;
fsmap[fnrow-1]:=pointer(realpos);
if inum<>'' then
  newinum:=inum+'.'+inttostr(nit)
 else
  newinum:=inttostr(nit);
insource[realpos].Visible:=true;
insource[realpos].curdisplayed:=true;
end;
insource[realpos].level:=level;
disprow[realpos]:=fnrow;
if insource[realpos].intparent<>0 then
begin
Isleaf[insource[realpos].intparent]:=false;
insource[insource[realpos].intparent].isleaf:=false;
end;
end;
IsLeaf[realpos]:=true;
end;

if fprocselected then
begin
if not (fprocsource[pos].firstchild=0)  then
 buildlist(level+1,fprocsource[pos].firstchild,
 disp and (insource[realpos].expanded or not inside and  fshowmarkedonly),newinum,fnrow,disponly);

end
else
begin
if not (insource[realpos].firstchild=0)  then
 buildlist(level+1,insource[realpos].firstchild,
 disp and (insource[realpos].expanded or not inside and  fshowmarkedonly),newinum,fnrow,disponly);

end;

if not insource.rootonly or (realpos<>insource.root) then
begin
if fprocselected then
 pos:=fprocsource[pos].nextitem
else
if insource[pos].nextitem<>pos then
pos:=insource[pos].nextitem
else
 begin
 pos:=0;
 insource[pos].nextitem:=0;
 end
end
else pos:=0;
until pos=0;
result:=fnrow;
end;
function getActiveControl:TWincontrol;
var ow:TComponent;
begin
result:=nil;
ow:=owner;
while (ow<>nil)and not (ow is TCustomForm) do ow:=ow.owner;
if ow=nil then exit;
result:=TcustomForm(ow).activecontrol;
end;

begin
if root=0 then root:=insource.root;
if foldroot<>insource.Root then    root:=insource.root;
foldroot:=insource.root;
awc:=GetActiveControl;
cr:=row;
logs.startproc('CG','Rebuild',inttostr(integer(total)),inttostr(integer(disponly)),28);
curitem:= selectedIndex;
if curitem=0 then curitem:=insource.index;
if curitem>insource.Count then curitem:=0;
//if insource.root=0 then
// insource.buildlinks(0,0,0);
for i:=fsmap.count to insource.count-1 do
begin
 fsmap.add(pointer(0));
end;
for i:=fsmap.count-1 downto insource.count do
begin
 fsmap.Delete(i);
end;
for i:=0 to fsmap.count-1 do fsmap[i]:=pointer(0);
fdisprow.Clear;
j:=0;
for i:=1 to Insource.count do
begin disprow[i]:=-1;
      insource[i].WParam:=0;
      Insource[i].listpos:=0;
if filtered[i] and insource[i].displayed then inc(j);
insource[i].curdisplayed:=false;
end;
if (j=0)and not fprocselected  then USEFiltering:=false;
fnr:=FixedRows-1;
curabsid:=0;
caption:=insource.caption;
cells[fnamecol,0]:=caption;
fmaxlevel:=0;
colcount:=2;
if not fprocselected then
begin
if root<>0 then
froot:=root
else
froot:=insource.root;
if (froot>0)and not filtered[froot] then
begin
 while (froot>0)and not  filtered[froot] do froot:=insource[froot].nextitem;
if froot=0 then
froot:=insource.getGlobalRoot;
end;
end
else froot:=fprocsource.Root;
markedCount:=0;
lp:=0;
if (froot>0) then
BuildList(0,froot,true,rootname,fnr,disponly);
rowcount:=max(fnr+1,2);
if total and (fnr=fixedrows-1) then
begin
if  not fshowmarkedonly then
begin
newit:=insource.ADDItem(0,'');
if ftreeview<>nil then
begin
newnode:=ftreeview.items.addobject(nil,newit.s,newit);
newit.samenode:=newnode;
end;
end
else begin fshowmarkedonly:=false; if fshowmarked <>nil then fshowmarked.checked:=false; end;
rebuild(total,disponly);
result:=false;
exit
end;
result:=true;
 for i:=1 to insource.count do
   begin
  insource[i].selected:=false;
   end;

//ColWidths[0]:=ids;
//enabled:=(fnr>=1);
startupdate;
cells[0,0]:='*'+inttostr(rowcount-1){+'/'+inttostr(markedCount)}+'*';
UpDateAll;
shownumbers;
applywidth;
if enabled  then
begin
col:=fnamecol;
if (curitem<>0)then
if (disprow[curitem]>0)  then
row:=disprow[curitem]
else begin while cr>fnr do dec(cr); row:=cr;end
ELSE
begin
row:=1;
end;
insource.selectchildren(selectedIndex,true);
end
else
begin
end;
endupdate;
repaint;
SelectCell(Col,Row);


if (row<toprow)or(row>toprow+visiblerowcount-1) then toprow:=row;
startProc('CGfinal',insource.caption,inttostr(insource.count),inttostr(froot),5);
//application.processmessages;
if (froot>0)and(awc<>nil) then awc.setfocus;
end;
constructor TColoredGrid.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
 logs.startproc('CG','Create','','',10);
curhintpos:=-1;
curhintcol:=-1;
inhint:=false;
 fixedrows:=1;
 fixedcols:=1;
 fsmap:=TList.create;
 ffiltered:=TList.Create;
 fdisprow:=TList.Create;
 fisleaf:=TList.Create;
 flinkedcontrols:=TList.create;
 ownins:=TOMItems.create;
 ownins.ADDItem(0,'');
 fprocsource:=TOMItems.create;
 finsource:=ownins;
 defaultdrawing:=true;
 selcount:=true;
 colwidths[1]:=25;
 colwidths[2]:=25;
 colwidths[3]:=25;
 selparent:=0;
 col:=2;
 row:=1;
 fnamecol:=1;
 rowcount:=2;
 colcount:=4;
 fixedcols:=1;
 fupdating:=0;
 fprocselected:=false;
// cells[2,1]:='DesignMode';
 options:=[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,goTabs,goThumbTracking];
 logs.startproc('CG','Created','','',10);
defaultrowheight:=abs(font.height)+4;
ftreeview:=nil;
end;
constructor TColoredGrid.CreateFromSource(AOwner:TComponent;source:TOMItems);
begin
 inherited Create(AOwner);
 logs.startproc('CG','Create','','',10);
curhintpos:=-1;
curhintcol:=-1;
inhint:=false;
 fixedrows:=1;
 fixedcols:=1;
 fsmap:=TList.create;
  ffiltered:=TList.Create;
 fdisprow:=TList.Create;
 fisleaf:=TList.Create;
  flinkedcontrols:=TList.create;
 ownins:=nil;
 finsource:=source;
 fprocsource:=TOMItems.create;
 defaultdrawing:=true;
 selcount:=true;
 colwidths[1]:=25;
 colwidths[2]:=25;
 colwidths[3]:=25;
 selparent:=0;
 col:=2;
 row:=1;
 fnamecol:=1;
 rowcount:=2;
 colcount:=4;
 fixedcols:=1;
 fupdating:=0;
// cells[2,1]:='DesignMode';
 options:=[goFixedVertLine,goFixedHorzLine,goVertLine,goHorzLine,goTabs,goThumbTracking];
 logs.startproc('CG','Created','','',10);
 fprocselected:=false;
 ftreeview:=nil;
end;

destructor TColoredGrid.Destroy;
begin

logs.startproc('CG','Destroy',name,'',10);

//application.processmessages;
sleep(0);
fsmap.clear;
fsmap.free;
ffiltered.free;
fisleaf.Free;
fdisprow.free;
flinkedcontrols.free;
fprocsource.free;
if ownins<>nil then
 ownins.Free;
 inherited destroy;
end;
function TColoredGrid.GetRowIndex(r:integer):integer;
begin
if row<=fsmap.count then
result:=integer(fsmap[r-1])
else
result:=0;
end;
 function TColoredGrid.GetSelIndex:integer;
begin
if (row<=fsmap.count)and(row>0) then
result:=integer(fsmap[row-1])
else
result:=0;
end;
function TcoloredGrid.GetSelItem:TOMItem;
var spos:integer;
begin
spos:=GetSelIndex;
 if spos<>0 then
  result :=insource[spos]
                 else
  result:=nil;
end;
procedure TColoredGrid.SizeChanged(OldColCount,OldRowCount:integer);
begin
 inherited SizeChanged(Oldcolcount,oldrowcount);
// ApplyWidth;
end;
procedure TColoredGrid.DoMouseEnter(var Message:TMessage);
begin
application.processmessages;
foldhintcell:=point(-1,-1);
application.processmessages;
if assigned(fonmouseenter) then fonmouseenter(self);
end;
procedure TColoredGrid.DoMouseExit(var Message:TMessage);
begin
curhintpos:=-1;
curhintcol:=-1;
inhint:=false;
foldhintcell:=point(-1,-1);
if assigned(fonmouseexit) then fonmouseexit(self);
application.processmessages;
end;
{procedure TColoredGrid.Loaded;
begin

//logs.startproc('CG','LOADED',name,'',10);
inherited Loaded;
calccolumns;
ApplyWidth;
end;
}
procedure TColoredGrid.ApplyWidth;
var
 i,len,len2:integer;
 delta:integer;
begin
logs.startproc('CG','APPLYWIDTH',name,'',10);
len2:=0;
len:=0;
for i:=0 to fnamecol-1 do
 inc(len,colwidths[i]+gridlinewidth);
 if  assigned(Parent)and(RowCount>VisibleRowCount) then delta:=3
 else delta:=0;
if (fnamecol<colcount) and assigned(Parent) then
begin
 if clientwidth>len shl 1 then
 colwidths[fnamecol]:=clientwidth-len-len2-delta
 else
 colwidths[fnamecol]:=clientwidth-len-delta;
end;
 for i:=1 to RowCount-1 do
   RescaleRow(i);
end;
Procedure TColoredGrid.ShowNumbers;
var i:integer;
    maxSize,s:integer;
begin
logs.startproc('CG','SNum',name,'',10);
maxsize:=0;
canvas.font.assign(font);
 for i:=0 to RowCount-1 do
 begin
 s:=canvas.textWidth(cells[0,i]+'*  +');
  if s>maxSize then
   maxSize:=s;
 end;
Colwidths[0]:=min(maxsize,clientwidth shr 1);
end;
procedure TColoredGrid.MouseMove(Shift: TShiftState; X, Y: Integer);
const boolstr:array[boolean]of string=('false','true');
var cc,cr,pos:integer;
    hintstr:string;
    maxw:integer;
    r:TRect;
begin
inherited MouseMove(Shift,x,y);
application.processmessages;
if not ShowHint  or editormode then
begin
hint:='';
application.CancelHint;
exit;
end;
MouseToCell(X,Y,cc,cr);
r:=cellRect(cc,cr);
if (cc<1) then
begin
hint:='';
application.CancelHint;
exit;
end;
if (cr<1) then
begin
if (foldhintcell.x=cc)and(foldhintcell.Y=cr) then exit;
foldhintcell:=point(cc,cr);
if cc=0 then hintstr:=''
else
if cc=fnamecol then
 hintstr:=''
else hintstr:='';
hint:=hintstr;
if hintstr='' then application.CancelHint
else application.ActivateHint(ClientToScreen(point(x,y)));
exit;
end;
pos:=smap[cr];
if pos=0 then
begin
foldhintcell:=point(-1,-1);
hint:='';
application.CancelHint;
exit;
end;
if cellrect(cc,cr).Right-x>20 then
begin
hint:='';
application.CancelHint;
foldhintcell:=point(-1,-1);
exit;
end;
if (foldhintcell.x=cc)and(foldhintcell.Y=cr) then exit;
foldhintcell:=point(cc,cr);
application.CancelHint;
if (cc=fnamecol)and(insource[pos].comment<>'')then
begin
//fhintlabel.wordwrap:=false;
hint:=ClearSpaces(copy(insource[pos].comment,1,512));
//else exit;
application.ActivateHint(ClientToScreen(point(x,y)));
end
else
begin
hint:='';
application.CancelHint;
exit;
end;
inhint:=false;
end;
function  TColoredGrid.GetSMap(index:integer):integer;
begin
 if (index<1)or(index>fsmap.count) then result:=0
                                   else result:=integer(fsmap[index-1]);
end;
procedure TColoredgrid.setSM(sm:boolean);
begin
 fshowmarkedonly:=sm;
// rebuild(false,true);
end;
procedure TColoredgrid.setInsource(ins:TOMItems);
begin
logs.startproc('CG','SINs',name,'',10);
finsource:=ins;
 fprocselected:=false;
resetState;
end;
procedure TColoredGrid.UpDateAll;
var pos,i:integer;
    flc:TNotifyEvent;
    lmax,maxe,mine:integer;
    cachedcolumns:array[0..31] of TStringList;
begin
 mine:=1000;
 maxe:=0;
 logs.startProc('CG',name,'UPdateAll','Start',20);
 for i:=0 to colcount-1 do
 begin
 cachedcolumns[i]:=TStringList.Create;
 cachedcolumns[i].add(cells[i,0]);
 cachedcolumns[i].Capacity:=rowcount;
 end;
 try
// if ftreeview<>nil then ftreeview.items.beginUpdate;
logs.startProc('CG','UPdateAll',inttostr(rowcount),name+':'+inttostr(insource.count),20);
{for i:=1 to insource.count do
 if insource[i].samenode<>nil then
begin
 insource[i].samenode.StateIndex:=-1;
insource[i].samenode.text:=insource[i].s;
if insource[i].marked and $1=$1 then
insource[i].samenode.StateIndex:=4
else
insource[i].samenode.Stateindex:=5;
end;}
// if ftreeview<>nil then ftreeview.items.EndUpdate;
for i:=1 to Rowcount-1 do
if smap[i]<>0 then
begin
pos:=smap[i];

if  (maxe<insource[pos].level) then maxe:=insource[pos].level;
if  not isleaf[pos] and not insource[pos].expanded and (mine>insource[pos].level) then
mine:=insource[pos].level;
begin
cachedcolumns[fnamecol].add(insource[pos].s);
cachedcolumns[0].add(insource.getfullnumber(pos,0));
end;
end;
for i:=0 to colcount-1 do
 cols[i].Assign(cachedcolumns[i]);
finally
 for i:=0 to colcount-1 do cachedcolumns[i].Free;
end;
lmax:=maxe;
for i:=1 to insource.count do if insource[i].level>lmax then lmax:=insource[i].level;
if flevelcontrol<>nil then
begin
flc:=flevelcontrol.onchange;
flevelcontrol.onchange:=nil;
flevelcontrol.width:=45;
flevelcontrol.Alignment:=taRightJustify;
flevelcontrol.AutoSize:=true;

 flevelcontrol.MaxValue:=lmax+1;
flevelcontrol.MinValue:=1;
if maxe>lmax then
maxe:=lmax;
flevelcontrol.AsInteger:=maxe+1;
if maxe<=mine then flevelcontrol.font.color:=clBlack
              else flevelcontrol.font.color:=clGray;
flevelcontrol.onchange:=flc;
end;
{for i:=1 to RowCount-1 do
RescaleRow(i); }
end;
procedure TColoredGrid.UpDate(id:integer);
var pos,fnrow:integer;
begin
logs.startProc('CG','UPdate','','',20);
if id =0 then exit;
pos:=id;
fnrow:=disprow[id];
if fnrow=-1 then exit;
cells[fnamecol,fnrow]:=insource[pos].s;
cells[0,fnrow]:=insource.getfullnumber(pos,0);
if insource[pos].samenode<>nil then insource[pos].samenode.text:=insource[pos].s;
RescaleRow(fnrow);
UpDate(insource[id].intparent);
end;
function TColoredgrid.SelectCell(ACol, ARow: Longint): Boolean;
var i:integer;
begin
result:=true;
if Updating then exit;
editormode:=false;
logs.startproc('ColoredGrid','SelectCell',inttostr(row)+':'+inttostr(col),insource.caption,30);
if selecteditem=nil then exit;
i:=selectedindex;
currentindex:=0;
invalidatechildren(i,false);
logs.startproc('ColoredGrid','SelectCell',inttostr(row)+':'+inttostr(col),'InvalidateOld',30);
while i>0 do
begin
if disprow[i]>0 then
DrawRow(disprow[i],false);
i:=finsource[i].intparent;
end;
//currentindex:=selectedIndex;
if assigned(fonchanging) then fonchanging(self);
result:=inherited selectcell(ACol,Arow) and (ACol>=namecol);
i:=indexofrow[arow];
if result and (finsource<>nil) then
begin
finsource.index:=i;
finsource.selected:=finsource[finsource.index];
end;

end;
function TColoredGrid.CanEditShow:boolean;
begin
result := (inherited caneditshow )and
          ((col=namecol));
end;
procedure TColoredGrid.KeyDown(var Key: Word; Shift: TShiftState);
var i:integer;
begin
Logs.startproc('ColoredGrid',Name,'KeyDown',Inttostr(key),25);
//if ssCtrl in shift then showmessage(inttohex(key,2));
if (key=27)and(Editormode)and(col=fnamecol) then
begin
//showmessage('esc');
cells[col,row]:=insource[smap[row]].s;
EditorMode:=false;
update(smap[row]);
exit;
end;
{if (key=VK_F2) then
begin
if goediting in options then
begin
options:=options-[goEditing];
if assigned(fonrebuild) then fonrebuild(self);
end
else
options:=options+[goEditing];
key:=0;
inherited keydown(key,[]);
exit;
end;}

if (key=VK_F4)and(shift=[]) then
begin
selecteditem.marked:=selecteditem.marked xor $1;
repaint;
key:=0;
inherited keydown(key,[]);
exit;
end;
if not editormode and(ssAlt in Shift) and (key in [$26,$28]) then
begin

case key of
 $26:begin   // Up
      for i:=row-1 downto 1 do
       if insource[smap[i]].marked and $1=$1 then break;
      if i>0 then row:=i;
     end;
 $28:begin  // Down
      for i:=row+1 to rowcount-1 do
       if insource[smap[i]].marked and $1=$1 then break;
      if i<rowcount then row:=i;
     end;
end;
key:=0;
end
else
if not EditorMode and (ssShift in Shift) and (key in [$26,$25,$28]) then
begin
case key of
 $25:begin  //Left
      i:=smap[row];
      i:=insource[i].intparent;
      if (i<>0)and(i<>insource[insource.root].intparent) then
      if disprow[i]>0 then
       row:=disprow[i];
     end;
 $26:begin  //Up
     i:=smap[row];
     i:=insource[i].previtem;
     while (i<>0)and(disprow[i]<=0) do i:=insource[i].prevItem;
     if i<>0 then row:=disprow[i];
     end;
 $28:begin  //Down
     i:=smap[row];
     i:=insource[i].nextitem;
     while (i<>0)and(disprow[i]<=0) do i:=insource[i].nextItem;
     if i<>0 then row:=disprow[i];
     end;
end;

key:=0;
end
else
if not editormode and(ssCtrl in Shift)and(key in [$21,$22,188,190]) then
begin
 if (key in [$22]) then
begin
    i:=selectedindex;
    insource[i].expanded:=true;
    if insource[i].samenode<>nil then
     insource[i].samenode.expanded:=true;
    if ssShift in Shift then insource.expandfull(i,true);
    rebuild(false,true);
    if assigned(fonrebuild) then
    fonrebuild(self);
     key:=0;
end
else if (key in [$21]) then
begin
    i:=selectedindex;
    insource[i].expanded:=false;
    if insource[i].samenode<>nil then
     insource[i].samenode.expanded:=false;
    if ssShift in Shift then insource.expandfull(i,false);
    rebuild(false,true);
    if assigned(fonrebuild) then
    fonrebuild(self);
    key:=0;
end
end
else inherited KeyDown(key,Shift);
if canfocus then setfocus;
application.ProcessMessages;
//showmessage(inttostr(integer(editormode))+':'+chr(key)+'#'+inttohex(key,2));
end;
function TColoredGrid.GetEditLimit: Integer;
begin
result:=0;
end;
function TColoredGrid.selectedtext:string;
begin
logs.startproc('CG','ST',name,'',10);
result:='';
if (inplaceeditor=nil)or not inplaceeditor.visible then exit;
result:=inplaceeditor.SelText;
end;
procedure TColoredGrid.modifytext(s:string);
begin
logs.startproc('CG','modText',name,'',10);
if (inplaceeditor=nil)or not inplaceeditor.visible then exit;
inplaceeditor.seltext:=s;
selecteditem.s:=inplaceeditor.Text;
end;
procedure TColoredGrid.resetState;
begin
StartUpDate;
try
fsmap.Clear;
ffiltered.Clear;
fisleaf.Clear;
rowcount:=2;
showHint:=insource.commentvisible;
finally
EndUpdate;
end;
end;
procedure TColoredGrid.resetSource;
begin
StartUpDate;
try
 fprocselected:=false;
finsource:=ownins;
resetstate;
finally
EndUpdate;
end;
end;
procedure TColoredGrid.SWAPsource;
var s:TOMItems;
begin
logs.startproc('CG','SWSource',name,'',10);
StartUpDate;
try
 fprocselected:=false;
s:=ownins;
ownins:=finsource;
finsource:=s;
resetstate;
finally
EndUpDate;
end;
end;
procedure TColoredGrid.MoveColRow(ACol, ARow: Longint; MoveAnchor,  Show: Boolean);
begin
inherited MoveColRow(acol,arow,moveanchor,show);
repaint;
end;
function TColoredGrid.getfiltered(index:integer):boolean;
begin
result:=true;
if not usefiltering then exit;
if (index>0)and(index<=ffiltered.count) then
 result:=boolean(ffiltered[index-1])
 else
 result:=true;
end;
procedure TColoredGrid.setfiltered(index:integer;value:boolean);
var i:integer;
begin
if index<=0 then exit;
for i:=ffiltered.count to insource.count do ffiltered.add(nil);
ffiltered[index-1]:=pointer(value);
end;
function TColoredGrid.getIsLeaf(index:integer):boolean;
begin
if index<=fisleaf.count then
 result:=boolean(fisleaf[index-1])
 else
 result:=true;
end;
procedure TColoredGrid.setIsLeaf(index:integer;value:boolean);
var i:integer;
begin
for i:=fisleaf.count to insource.count do fisleaf.add(nil);
fisleaf[index-1]:=pointer(value);
end;

function TColoredGrid.getDisprow(index:integer):integer;
begin
if index<=fdisprow.count then
 result:=integer(fdisprow[index-1])
 else
 result:=-1;
end;
procedure TColoredGrid.setDisprow(index:integer;value:integer);
begin
while index>fdisprow.count do
 fdisprow.add(nil);
fdisprow[index-1]:=pointer(value);
end;
function TColoredGrid.calcMaxLevel:integer;
var i,maxl:integer;
begin
maxl:=0;
for i:=1 to insource.count do
 if (disprow[i]>0)and(maxl<insource[i].level) then
 maxl:= insource[i].level;
 result:=maxl;
end;
procedure TColoredgrid.filterposition(pos:integer);
var i:integer;
procedure filterlevel(pos:integer);
begin
if pos=0 then exit;
while pos>0 do
begin
 filtered[pos]:=true;
 filterlevel(insource[pos].firstchild);
 pos:=insource[pos].nextitem;
end;
end;
begin
i:=pos;
while i>0 do
begin
filtered[i]:=true;
i:=insource[i].intparent;
end;
if pos=0 then exit;
filterlevel(insource[pos].firstchild);
end;
function TColoredgrid.GetEditText(ACol, ARow: Longint): string;
begin
if ACol=fNameCol then
cells[0,ARow]:=inttostr(length(cells[ACol,ARow]));
result:= inherited GetEditText(ACol,Arow);
end;
procedure TColoredgrid.SetEditText(ACol, ARow: Longint; const Value: string);
begin
inherited setEditText(ACol,ARow,Value);
if ACol=fNameCol then
cells[0,ARow]:=inttostr(length(cells[ACol,ARow]));
end;
function TColoredGrid.GetEditMask(ACol, ARow: Longint): string;
begin
  result:='';
end;
procedure TColoredGrid.setProcess(procN:integer;bpclass:TOMItems;procFilter:TLiteLinks);
var oldps:boolean;
    i:integer;
    froot:integer;
    FCount:integer;
begin
oldps:=fprocselected;
fprocess:=procN;
//while insource.Pop do;
if (procN>0) then
begin
fprocselected:=true;
fprocsource.clear;
while insource.PopRoot do;
if root>0 then
froot:=root
else
froot:=insource.root;
FCount:=itutils.FilterWithProTotal(procN,bpclass,finsource,procfilter);
UseFiltering:=true;
if (FCount=0)and(ProcN>0) then
begin
 setprocess(0,nil,nil);
 exit;
end;

itutils.copyParams(fprocsource,finsource);
itutils.SelectByBPTotal(finsource,fprocsource,bpclass,procfilter,froot,0,ProcN,true,0);
itutils.clearWP(finsource);
for i:=1 to fprocsource.count do
 begin
 fprocsource[i].WParam:=0;
 filtered[fprocsource[i].idloaded]:=true;
 end;
end
else
fprocselected:=false;
UseFiltering:=false;
if oldps<>fprocselected then
rebuild(false,true);
end;
function TColoredGrid.getSourceFiltered:TOMItems;
begin
if not fprocselected then result:=finsource
                     else result:=fprocSource;
end;
procedure TColoredGrid.startUpdate;
begin
 inc(fupdating);
end;
procedure TColoredGrid.endUpdate;
begin
 if fupdating>0 then
 dec(fupdating);
 if fupdating=0 then
 try
 logs.startProc('ColoredGrid','EndUpDate',inttostr(RowCount)+'('+inttostr(Col)+','+inttostr(row)+')',insource.caption,20);
  //UpDateAll;
  currentindex:=selectedIndex;
  Click;
 except
 on e:exception do
 begin
  logs.OnException(self,e);
  row:=1;
  try
  Click;
  except
     on e:exception do   logs.OnException(self,e);
  end;
  Repaint;
 end;
 end;
end;
procedure TColoredGrid.exitupdate;
begin
 fupdating:=0;
 currentindex:=selectedIndex;
 Click;
end;
function TColoredGrid.isUpdating:boolean;
begin
 result:=fupdating>0;
end;
procedure TColoredGrid.Reset;
begin
logs.startproc('ColoredGrid',name,'Reset',inttostr(rowcount),12);
startUpdate;
try
curhintpos:=-1;
curhintcol:=-1;
inhint:=false;
 fixedrows:=1;
 fixedcols:=1;
 fsmap.Clear;
 ffiltered.Clear;
 fdisprow.Clear;
 fisleaf.Clear;
 flinkedcontrols.Clear;
 ownins.clear;;
 fprocsource.clear;
 finsource:=ownins;
 defaultdrawing:=true;
 selcount:=true;
 selparent:=0;
 col:=FNAMECOL;
 row:=1;
  rowcount:=2;
 fupdating:=0;
 fprocselected:=false;
// cells[2,1]:='DesignMode';
finally
 EndUpdate;
end;
end;
function TColoredGrid.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
var i:integer;
begin
 if Shift=[] then
 result:=inherited doMouseWheelDown(Shift,MousePos)
 else if ssAlt in Shift then
 begin
 for i:=row+1 to RowCount-1 do
       if insource[smap[i]].marked and $1=$1 then break;
      if i<RowCount then row:=i;
      result:=true;
 end
 else if ssShift in Shift then
 begin
     i:=smap[row];
     i:=insource[i].nextitem;
     while (i<>0)and(disprow[i]<=0) do i:=insource[i].nextItem;
     if i<>0 then row:=disprow[i];
     result:=true;
 end;

end;
function TColoredGrid.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
var i:integer;
begin
 if Shift=[] then
 result:=inherited doMouseWheelUp(Shift,MousePos)
 else if ssAlt in Shift then
 begin
 for i:=row-1 downto 1 do
       if insource[smap[i]].marked and $1=$1 then break;
      if i>0 then row:=i;
      result:=true;
 end
 else if ssShift in Shift then
 begin
     i:=smap[row];
     i:=insource[i].previtem;
     while (i<>0)and(disprow[i]<=0) do i:=insource[i].prevItem;
     if i<>0 then row:=disprow[i];
     result:=true;
 end;

end;
procedure TColoredGrid.CopyToClipBoard;
begin
if editorMode then
 InplaceEditor.CopyToClipboard;
end;
procedure TColoredGrid.CutToClipBoard;
begin
if editorMode then
 InplaceEditor.CutToClipboard;
end;

procedure TColoredGrid.PasteFromClipBoard;
var p:integer;
    s:string;
begin
if editorMode then
begin
 s:=utils.removeCR(ClipBoard.AsText);
 //InplaceEditor.PasteFromClipBoard;
  p:=InplaceEditor.SelStart;
  InplaceEditor.SelText:=s;
 InplaceEditor.SelStart:=p;
end;
end;
function TColoredGrid.RescaleRow(Arow:integer):integer;
var r:TRect;
    i:integer;
    s:String;
    oldheight:integer;
begin
 Result:=RowHeights[Arow];
 oldheight:=result;
 try
 if not appconst.sysinfo.MultiLine then
 begin
 Result:= DefaultRowHeight;
 RowHeights[Arow]:=Result;
 exit;
 end;
 i:=SMap[Arow];
 if i=0 then exit;
 r:=classes.Rect(0,0,ColWidths[fNameCol]-1,DefaultRowHeight);
 r.Right:=r.Right-min(insource[i].level*6+3,ColWidths[fNameCol] shr 2);
 s:=insource[i].s;
 Canvas.Font.Assign(font);
 SetFontLevelParams(Canvas.Font,insource[i].level);
 DrawText(Canvas.Handle,PChar(s),length(s),r,DT_CALCRECT or DT_WORDBREAK	);
 RowHeights[Arow]:=Min(Max(DefaultRowHeight,r.Bottom-r.Top+5),ClientHeight-2-DefaultRowHeight);
 Result:=RowHeights[Arow];
 finally
 if result<>oldHeight then invalidate;
 end;
end;
procedure TColoredGrid.RescaleRows;
var i:integer;
begin
 for i:=1 to RowCount-1 do
  RescaleRow(i);
end;
procedure TColoredGrid.SetFontLevelParams(Font:TFont;level:integer);
begin
  if appconst.sysinfo.levelformat then
   case level of
   0:font.Style:= [fsbold,fsunderline];
   1:font.Style:= [fsbold];
   2:font.Style:= [fsunderline];
   else canvas.font.Style:= [fsitalic];
   end;
if font.Size<8 then font.style:=[];

end;
procedure TColoredGrid.MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
var c,r:integer;
begin
 if Button=mbRight then
 begin
  MouseToCell(X,Y,c,r);
  if (c<>Col)or(r<>Row) then
  inherited MouseUp(mbLeft,Shift,X,Y);
 end;
 inherited MouseUp(Button,Shift,X,Y);
end;
procedure TColoredGrid.MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
var c,r:integer;
begin
 if Button=mbRight then
 begin
 MouseToCell(X,Y,c,r);
  if (c<>Col)or(r<>Row) then
  inherited MouseDown(mbLeft,Shift,X,Y);
 end
 else
 begin
 MouseToCell(X,Y,c,r);
 end;
 inherited MouseDown(Button,Shift,X,Y);
end;
function TColoredGrid.CreateEditor:TInplaceEdit;
begin
 result:=TMyinplaceEditor.Create(self);
 TEdit(result).OnEnter:=DoShowEditor;
 TEdit(result).OnExit:=DoHideEditor;
end;
procedure TColoredGrid.DoShowEditor(Sender:TObject);
begin
if fmenu=nil then
begin
fMenuParent:=self;
While (fMenuParent<>nil)and(fMenuParent.popupmenu=nil) do
fMenuParent:=TStringGrid(fMenuParent.Parent);
if fmenuParent<>nil then
begin
fmenu:=fMenuParent.PopUpMenu;
fMenuParent.popUpMenu:=nil;
end;
end;
if assigned(FOnstartediting) then Fonstartediting(self);
end;
procedure TColoredGrid.DoHideEditor(Sender:TObject);
begin
if fmenuparent<>nil then
fmenuparent.popUpMenu:=fmenu;
fmenu:=nil;
if assigned(FOnfinishediting) then
 Fonfinishediting(self);
 update(smap[row]);
end;
procedure TMyInplaceEditor.doEnter;
begin
 inherited doEnter;
end;
procedure TMyInplaceEditor.doExit;
begin
 inherited doExit;
end;
procedure TMyInplaceEditor.WndProc(var Message: TMessage);
begin
 if Message.Msg=WM_SETFOCUS then
 doEnter;
 if Message.Msg=WM_KILLFOCUS then
 doexit;
 inherited WndProc(Message);
end;
procedure TColoredGrid.DrawRow(ARow:integer;select:boolean);
var i:integer;
    DrawState:TGridDrawState;
begin
for i:=0 to FixedCols-1 do
begin
 Drawstate:=[gdFixed];
 DrawCell(i,ARow,self.CellRect(i,ARow),DrawState);
end;

for i:=FixedCols to ColCount-1 do
begin
if (Row=ARow)and(Col=i) then
 if focused then DrawState:=[gdFocused]
            else DrawState:=[gdSelected]
            else DrawState:=[];
 invalidateCell(i,ARow);
end;
end;
procedure TColoredGrid.Click;
var R,i:integer;
begin
 inherited Click;
 R:=Row;
if selecteditem=nil then exit;
currentindex:=selectedIndex;
i:=selectedindex;
invalidatechildren(i,true);
while i>0 do
begin
if disprow[i]>0 then
DrawRow(disprow[i],true);
i:=finsource[i].intparent;
end;
repaint;
end;
procedure TColoredGrid.invalidatechildren(id:integer;select:boolean);
var i,dr:integer;
begin
logs.startproc('ColoredGrid','invalidateChildren',inttostr(id),inttostr(integer(select)),50);

 if id<=0 then exit;
 if not insource[id].expanded then exit;
 i:=insource[id].firstchild;
 while i>0 do
 begin
 dr:=disprow[i];
 if dr>0 then begin
 if (dr>=TopRow-1)And(Dr<=TopRow+VisibleRowCount) then
 drawrow(dr,select);
 if insource[i].expanded then
 invalidatechildren(i,select);
 end;
 i:=insource[i].nextitem;
 end;
end;
procedure TColoredGrid.Repaint;
begin
if Updating then exit;
 CurrentIndex:=SelectedIndex;
 inherited repaint;
end;
function TColoredGrid.RowItem(row:integer):TOMItem;
var i:integer;
begin
 i:=GetRowIndex(row);
 if i>0 then result:=insource[i]
        else result:=nil;
end;
end.
