unit StrTab;
{
(c) . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, ImgList, OtherLists,myLists, items, dcommon, gauges;

type
  TSTRTables = class(TDataModule)
    NewPos: TOpenDialog;
    ModelT: TTable;
    Spr_2: TTable;
    Spr: TTable;
    ModelTName: TStringField;
    ModelTType: TFloatField;
    ModelTSPRType: TFloatField;
    ModelTMbData: TBlobField;
    ModelTN: TAutoIncField;
    ModelTSp1: TIntegerField;
    ModelTSp2: TIntegerField;
    ModelTComm: TStringField;
    ModelTMDate: TDateField;
    ModelTAvtor: TStringField;
    ModelTPrsN: TSmallintField;
    ModelTIdxN: TSmallintField;
    ModelTGrpNum: TSmallintField;
    ModelTPrsSubstN: TSmallintField;
    Spr_2Name: TStringField;
    Spr_2Type: TFloatField;
    Spr_2SPRType: TFloatField;
    Spr_2MbData: TBlobField;
    Spr_2N: TAutoIncField;
    Spr_2Sp1: TIntegerField;
    Spr_2Sp2: TIntegerField;
    Spr_2Comm: TStringField;
    Spr_2MDate: TDateField;
    Spr_2Avtor: TStringField;
    Spr_2PrsN: TSmallintField;
    Spr_2IdxN: TSmallintField;
    Spr_2GrpNum: TSmallintField;
    Spr_2PrsSubstN: TSmallintField;
    SprName: TStringField;
    SprType: TFloatField;
    SprSPRType: TFloatField;
    SprMbData: TBlobField;
    SprN: TAutoIncField;
    SprSp1: TIntegerField;
    SprSp2: TIntegerField;
    SprComm: TStringField;
    SprMDate: TDateField;
    SprAvtor: TStringField;
    SprPrsN: TSmallintField;
    SprIdxN: TSmallintField;
    SprGrpNum: TSmallintField;
    SprPrsSubstN: TSmallintField;
    procedure STRTablesDestroy(Sender: TObject);
    procedure MODELTBeforePost(DataSet: TDataSet);
    procedure MODELTEditError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure MODELTAfterScroll(DataSet: TDataSet);
    procedure MODELTUpdateError(DataSet: TDataSet; E: EDatabaseError;
      UpdateKind: TUpdateKind; var UpdateAction: TUpdateAction);
    procedure MODELTBeforeDelete(DataSet: TDataSet);
    procedure MODELTAfterPost(DataSet: TDataSet);
  private
    { Private declarations }
    RecordPos:TBookMark;
  public
    { Public declarations }
    pwdprotected:boolean;
    sprCache:TSprCache;
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure ConnectModel;
    Procedure DisconnectModel;
    procedure reConnectModel;
    function open_Spr(id:integer;Data:TStream;Compress:boolean):boolean;
    function write_spr(id:integer;Data:TStream;Compress:boolean):boolean;
    function Load_Spr(id:integer;Spr:TOMItems):boolean;
    function Save_Spr(id:integer;Spr:TOMItems;Status:TGauge):boolean;
    function Load_SprFromFile(id:integer;SprFile:string):boolean;
    function Save_SprToFile(id:integer;SprFile:string):boolean;
    function BackUp(id:integer):integer;
    function Open_pro(id:integer;var idleft,idright,idlinks:integer):boolean;
    function Locate_MdlObj(id:integer):boolean;
    function definewereused(id:integer;l:TList):integer;
    function FillData(id:integer;Spr:TOMItems;ModelContense:TModelArray):boolean;
    procedure CheckReady;
    procedure LoadHistory(ID:integer;List:TStrings);
    procedure updateHistory(ID:integer;Reason:string);
  end;

var
  STRTables: TSTRTables;

implementation
uses appconst, Logs, utils, F25, fileutil, PackT, Umessages, BdeUtils, variants,ZLibEx;
{$R *.DFM}
procedure TSTRTables.ConnectModel;
var s,path,alias:string;
begin
s:=extractFileName(ModelT.TableName);
Path:=extractFilePath(ModelT.TableName);
alias:='ORGMASTER';
logs.startproc('TSTRTables','STRTables','ConnectModel',modelT.tablename,3);
setcurrentdir(appconst.sysinfo.datadir);
Spr.tablename:=modelt.tablename;
Spr_2.tablename:=modelt.tablename;
//mainform.comp.active:=false;
Spr.active:=true;
logs.startproc('TSTRTables','STRTables','ConnectModel','Spr.Active=OK',3);
Spr_2.active:=true;
ModelT.active:=true;
end;
Procedure TSTRTables.DisconnectModel;
begin
logs.startproc('TSTRTables','STRTables','DisconnectModel','',3);
Spr.active:=false;
Spr_2.active:=false;
ModelT.active:=false;
//Session1.DeleteAlias('ORGMASTER');
//ModelT.tablename:='sys\modeltmp.$$$';
end;
function TSTRTables.Load_SprFromFile(id:integer;SprFile:string):boolean;
var fs:TFileStream;
begin
 fs:=TFileStream.Create(SprFile,fmOpenRead);
 try
 Write_Spr(id,fs,false);
 finally
 fs.free;
 end;
end;
function TSTRTables.Save_SprToFile(id:integer;SprFile:string):boolean;
var fs:TFileStream;
begin
 fs:=TFileStream.Create(SprFile,fmCreate);
 try
 Open_Spr(id,fs,false);
 finally
 fs.free;
 end;
end;

function TSTRTables.Load_Spr(id:integer;Spr:TOMItems):boolean;
var ms:TMemoryStream;
begin
ms:=TMemoryStream.Create;
try
result:=open_Spr(id,ms,true);
if ms.Size=0 then exit;
if result then
begin
Spr.Reload(ms)
end
else
Spr.clear;
finally
ms.free;
end;
end;
function TSTRTables.Save_Spr(id:integer;Spr:TOMItems;Status:TGauge):boolean;
var ms:TMemoryStream;
begin
ms:= TMemoryStream.Create;
try
Spr.saveTotal(ms,status);
result:=write_Spr(id,ms,true);
finally
ms.free;
end;
end;

function TSTRTables.open_Spr(id:integer;Data:TStream;Compress:boolean):boolean;
var bs:TBlobStream;
begin
setCurrentdir(appconst.sysinfo.datadir);
logs.startProc('STRTables','open_spr',inttostr(id),'',6);

//modelT.active:=false;
//modelT.active:=true;
result:=false;
if id=0 then exit;
result:=true;
if ModelT.locate('n;type',vararrayof([id,SPRID]),[]) then
begin
try
if ModelTType.asInteger<>appconst.SPRID then exit;
 modelt.Refresh;
 if not Compress then
 ModelTMbData.SaveToStream(Data)
 else
 begin
 bs:=TBlobStream.Create(ModelTMBData,bmRead);
 ZLibEx.ZDecompressStream(bs,Data);
 bs.free;
 end;
 sleep(10);
 finally
 end
 end
 else result:=false;
ModelT.locate('n;type',vararrayof([id,SPRID]),[]);
modelt.refresh;
end;
function TSTRTables.write_spr(id:integer;Data:TStream;Compress:boolean):boolean;
var bs:TBlobStream;
begin
setCurrentdir(appconst.sysinfo.datadir);
result:=false;
if id=0 then exit;
logs.startProc('STRTables','save_spr',inttostr(id),'',6);
result:=true;
 if ModelT.locate('n',id,[]) then
begin
Data.Seek(0,soFromBeginning);
ModelT.edit;
modelTMDate.AsDateTime:=Now;
 modelT.edit;
 if not compress then
 ModelTMbData.LoadfromStream(Data)
 else
 begin
 bs:=TBlobStream.Create(ModelTMbData,bmWrite);
 ZLibEx.ZCompressStream(Data,bs,zcMax);
 bs.free;
 end;
 ModelTAvtor.AsString:=appconst.sysinfo.defavtor;
 ModelT.post;
end
// showmessage('4');
 else result:=false;
modelt.refresh;
ModelT.FlushBuffers;
logs.startProc('STRTables','save_spr-f',inttostr(id),'',7);
end;
function TSTRTables.open_pro(id:integer;var idleft,idright,idlinks:integer):boolean;
begin
modelT.refresh;
setCurrentdir(appconst.sysinfo.datadir);
 result:=true;
 if modelt.locate('n',id,[]) then
  try
   idleft:=Modeltsp1.asinteger;
   idright:=Modeltsp2.asinteger;
   idlinks:=ModelTSprType.AsInteger;
  except
 on e:exception do
 begin
 logs.OnException(self,e);
 result:=false;
 end;
  end
 else result:=false;
 modelt.refresh;
end;
function TSTRTables.Locate_MdlObj(id:integer):boolean;
begin
if id=0 then result:=false
else
begin
 ModelT.Refresh;
 ModelT.FlushBuffers;
 result:=ModelT.locate('N',id,[]);
 sleep(10);
if not result then
 logs.startproc('STRTab','Locating',inttostr(id),'Unsuccessful',8)
end;
end;
procedure TSTRTables.STRTablesDestroy(Sender: TObject);
begin
disconnectmodel;
ModelT.FreeBookmark(recordpos);
end;
function TSTRTables.definewereused(id:integer;l:TList):integer;
begin
result:=1;
end;
function TStrTables.BackUp(id:integer):integer;
var name:string;
    t:TDateTime;
    base1,base2:TMemoryStream;
begin
{$IFNDEF VIEW}
 ModelT.locate('n',id,[]);
 base1:=TMemoryStream.Create;
 base2:=TMemoryStream.Create;
 try
 name:=ModelTName.asString;
 T:=ModelTMDAte.asDateTime;
 ModelTMBData.SaveToStream(base2);
 ModelT.edit;
 MODELTMDate.AsDateTime:=now;
 ModelT.Post;
 if not ModelT.locate('Type;SPRType',VarArrayOf([BACKUPID,id]),[]) then
 begin
 ModelT.Append;
// showmessage('1-a');

 ModelT.edit;
STRTables.MODELTMDate.asDateTime:=t;
 ModelTType.asInteger:=BACKUPID;
 MODELTSPRType.asInteger:=id;
 MODELTName.asString:=': '+name;
 end
 else ModelT.edit;
//  showmessage('1-lbc');
 base1.Seek(0,soFromBeginning);
 base2.Seek(0,soFromBeginning);
 ModelTMBData.loadfromStream(base2);
 ModelT.post;
 result:=ModelTN.asInteger;
 finally
 base1.free;
 base2.Free;
// showmessage('1-e');
 end;
// showmessage('2');
 ModelT.locate('n',id,[]);
{$ENDIF}
end;
function TSTRTables.FillData(id:integer;Spr:TOMItems;ModelContense:TModelArray):boolean;
var m:PModelObject;
    tempStr:TMemoryStream;
begin

spr.dirid:=0;
Spr.caption:='';
spr.ComTitle:='';
m:=ModelContense.GetModelObjectByID(id);
result:=false;
if m= nil then exit;
spr.clsflags:=m^.prs;
spr.dirid:=m^.n;
spr.caption:=cutnumbers(m^.name);
logs.startProc('STRTables','fillSprData',spr.caption,inttostr(id),5);
if m^.n>0 then
begin
 Locate_MdlObj(m^.n);
result:=sprCache.Get(spr);
if not result then
begin
tempStr:=TMemoryStream.Create;
try
result:=Load_spr(spr.dirid,Spr);
finally
tempStr.free;
end;
sprCache.Put(spr);
end;
items.UpdateFromMBuffer(spr);
end
else
begin
end;
//showmessage(spr.comTitle);
locate_MdlObj(spr.diriD);
end;

constructor TSTRTables.Create(AOwner:TComponent);
begin
 inherited Create(AOwner);
 sprCache:=TSprCache.create;
end;

destructor TSTRTables.Destroy;
begin
 sprCache.free;
 inherited Destroy;
end;

procedure TSTRTables.MODELTBeforePost(DataSet: TDataSet);
begin
MODELTMDate.AsDateTime:=Now;
sleep(10);
end;
procedure TSTRTables.MODELTEditError(DataSet: TDataSet; E: EDatabaseError;
  var Action: TDataAction);
begin
logs.OnException(DataSet,E);
MessageDlg('    .'#13#10+E.Message+#13#10'  ',mtError,[mbOK],0);
disconnectmodel;
connectModel;
ModelT.GotoBookmark(recordPos);
end;

procedure TSTRTables.MODELTAfterScroll(DataSet: TDataSet);
begin
if recordPos<>nil then
ModelT.FreeBookmark(recordpos);
recordPos:= ModelT.getBookmark;
end;

procedure TSTRTables.MODELTUpdateError(DataSet: TDataSet;
  E: EDatabaseError; UpdateKind: TUpdateKind;
  var UpdateAction: TUpdateAction);
begin
logs.OnException(DataSet,E);
MessageDlg('    .'#13#10+E.Message+#13#10'  ',mtError,[mbOK],0);
disconnectmodel;
connectModel;
ModelT.GotoBookmark(recordPos);
end;
procedure TSTRTables.CheckReady;
begin
ModelT.GotoBookmark(recordPos);
ModelT.edit;
ModelT.Cancel;
end;
procedure TSTRTables.MODELTBeforeDelete(DataSet: TDataSet);
begin
if (ModelTN.AsInteger<>0)and
   (ModelTType.AsInteger<>appconst.HistoryID)and(ModelTType.asInteger>0) then
begin
 if Spr.Locate('TYPE;SP1',vararrayof([appconst.historyID, ModelTN.asInteger]),[]) then
 Spr.Delete;
end;
end;
procedure TSTRTables.LoadHistory(ID:integer;List:TStrings);
var bs:TStream;
begin
List.Clear;
 if Spr.Locate('TYPE;SP1',vararrayof([appconst.historyID, ID]),[]) then
 begin
 bs:=Spr.CreateBlobStream(SprMbData,bmRead);
 try
 List.LoadFromStream(bs);
 finally
 bs.free;
 end;
 end;
end;
procedure TSTRTables.updateHistory(ID:integer;Reason:string);
var hist:TStringList;
    bs:TStream;
begin
{$IFNDEF VIEW}
if id=0 then exit;
if not Locate_MdlObj(ID) then exit;
ModelT.Edit;
ModelTAvtor.AsString:=appconst.sysinfo.defavtor;
ModelT.Post;
if not Spr.Locate('TYPE;SP1',vararrayof([appconst.historyID, ID]),[]) then
 begin
 Spr.Append;
 SprType.AsInteger:=appconst.HistoryID;
 SprSp1.AsInteger:=ID;
 end
 else
 Spr.Edit;
 Hist:=TStringList.Create;
 try
 bs:=Spr.CreateBlobStream(SprMbData,bmRead);
 try
 try
 Hist.LoadFromStream(bs);
 except
 disconnectModel;
 ConnectModel;
 raise;
 end;
 finally
 bs.free;
 end;
 Hist.Add(DateTimeToStr(Now)+'// '+reason+'## '+appconst.sysinfo.defAvtor);
  bs:=Spr.CreateBlobStream(SprMbData,bmWrite);
 try
 try
 Hist.SaveToStream(bs);
 except
 disconnectModel;
 ConnectModel;
 raise;
 end;
 finally
 bs.free;
 end;
 finally
 Hist.free;
 end;
 Spr.Post;
{$ENDIF} 
end;
procedure TSTRTables.MODELTAfterPost(DataSet: TDataSet);
begin
ModelT.FlushBuffers;
end;
procedure TSTRTables.reConnectModel;
var n:Integer;
begin
try
n:=ModelTN.AsInteger;
except
n:=0;
end;
 disconnectModel;
 ConnectModel;
 if n>0 then
Locate_MdlObj(n);
end;
end.
