Unit BPRename;
{
(c) . , ..  1997,2006
}
{$INCLUDE Compmode.inc}
Interface

Uses Windows,SysUtils,BPDef,Debug,classes;

Type TBPRename=class
      private
       FTree,FOpTree:TList;
       FNodesCount:integer;
       FLinksCount:integer;
       FCurLevel:LongInt;
       FCurSSLevel:ShortString;
       FParentLevel:LongInt;
       FNodes:TList;
       FLinks:TList;
       FMinLevel:LongInt;
       FMaxLevel:LongInt;
       procedure InitializeNodes(nodes:TList;ncount:integer;level:integer);
       procedure FinalizeNodes;
       procedure InitializeLinks(links:TList;lcount:integer;level:integer;TopStart,TopEnd:integer);
       procedure FinalizeLinks;
       function    GetTreeLevel(level:ShortString):LongInt;
       function    GetMaxLevel:LongInt;
       function    GetMinLevel(MaxLevel:LongInt):LongInt;
       procedure   TraceLinks;
      public
       constructor Create(Tree,OpTree:TList);
       destructor  Destroy; override;
       procedure   RenameLinks;
     end;

Implementation
uses otherlists,utils;

function    TBPRename.GetTreeLevel(level:ShortString):LongInt; { Corrected }
Var ilev:Integer;
    i:Integer;
    s:String;
 begin
   Result:=-2;
   if length(level)=0 then Exit;
   Result:=StrToIntDef(level,-2); { Try -1,0  }
   if (Result<>-2) then
      begin
       if (Result=-1) or (Result=0) then
         Exit
        else
         begin
           Result:=1;
           Exit;
         end;
      end;
   { level is in x.x.x.x.x }
     ilev:=1;
     s:=level;
     i:=1;
     while (length(s)>0) do
      begin
        if (s[1]='.') then inc(ilev);
        s:=copy(s,2,length(s)-1);
      end;
     Result:=ilev;
 end;

constructor TBPRename.Create(Tree,Optree:TList); { Corrected }
 begin
  FTree:=Tree;
  FOpTree:=OpTree;
  FNodesCount:=0;
  FLinksCount:=0;
  FNodes:=nil;
  FLinks:=nil;
  FMinLevel:=-1;
  FMaxLevel:=0;
  FCurLevel:=-1;
  FCurSSLevel:='-1';
  inherited Create;
 end;

destructor  TBPRename.Destroy;  { Corrected }
 begin
  FTree:=nil;
  FOPTree:=nil;
  inherited Destroy;
 end;

procedure TBPRename.InitializeNodes(nodes:TList;ncount:integer;level:integer); { Corrected }
Var i:Integer;
    oldNode,tmpNode:PBPNodeRenameStructure;
    tmpNode1:PBPNode;
 begin
//   FinalizeNodes;
   if (ncount=0) or (nodes=nil) then Exit;
   oldNode:=nil;
   for i:=0 to (nodes.count-1) do
    begin
    tmpNode1:=PBPNode(nodes[i]);
      tmpNode:=PBPNodeRenameStructure(AllocMem(sizeof(TBPNodeRenameStructure)));
      tmpNode^.dwNodeNumber:=tmpNode1^.dwNodeNumber;
      tmpNode^.ssNodeNumber:=tmpNode1^.ssNodeNumber;
      tmpNode^.LinksLeft:=0;
      tmpNode^.LinksRight:=0;
      tmpNode^.LinksTop:=0;
      tmpNode^.LinksBottom:=0;
      tmpNode^.LinksBottomDFD:=0;
      tmpNode^.level:=level;
      FNodes.add(tmpNode);
    end;
    FNodesCount:=FNodes.count;
 end;
procedure TBPRename.FinalizeNodes; { Corrected }
Var i:integer;
 begin
   if (FNodes=nil) then exit;
   for i:=0 to fnodes.count-1 do
    begin
  FreeMem(PBPNodeRenameStructure(fnodes[i]));
    end;
   FNodesCount:=0;
 end;

function   TBPRename.GetMaxLevel:LongInt; { Corrected }
 Var tmpTree:PBPTree;
     lev,i:Integer;
  begin
    Result:=-2;
    if (FTree=nil) then Exit;
    for i:=0 to ftree.count-1 do
     begin
     tmpTree:=PBPTree(ftree[i]);
       lev:=GetTreeLevel(tmpTree^.ssLevel);
         if (lev>Result) then
           Result:=lev;
     end;
  end;

 function    TBPRename.GetMinLevel(MaxLevel:LongInt):LongInt; { Corrected }
 Var tmpTree:PBPTree;
     lev,i:Integer;
  begin
    Result:=MaxLevel;
    if (FTree=nil) then Exit;
    for i:=0 to ftree.count-1 do
     begin
     tmpTree:=PBPTree(ftree[i]);
       lev:=GetTreeLevel(tmpTree^.ssLevel);
         if (lev<Result) then
           Result:=lev;
     end;
  end;
function sidesCompatible(toside,fromside:longword):boolean;
begin
 result:=(fromside=BP_FROMNODE_LEFT)and(toside=BP_TONODE_RIGHT)or
         (fromside=BP_FROMNODE_RIGHT)and(toside=BP_TONODE_LEFT)or
         (fromside=BP_FROMNODE_TOP)and(toside=BP_TONODE_BOTTOM)or
         (fromside=BP_FROMNODE_BOTTOM)and(toside=BP_TONODE_TOP);
end;
procedure TBPRename.InitializeLinks(links:TList;lcount:integer;level:integer;TopStart,TopEnd:integer); { Corrected }
Var i,j,k:Integer;
    tmpLink,pTmpLink:PBPLinkRenameStructure;
    tmpLink1:PBPLink;
    oldlc:integer;
 begin
//   FinalizeLinks;
   if (lcount=0) or (links=nil) then Exit;
   oldlc:=flinks.count;
   for i:=0 to (links.count-1) do
    begin
    tmpLink1:=PBPLink(links[i]);
      tmpLink:=PBPLinkRenameStructure(AllocMem(sizeof(TBPLinkRenameStructure)));
      tmpLink^.link:=tmpLink1;
      tmpLink^.FromLinkNumber:=0;
      tmpLink^.ToLinkNumber:=0;
      tmpLink^.LinkRenamedFrom:=False;
      tmpLink^.LinkRenamedTo:=False;
      tmplink^.level:=level;
      tmplink^.forkfrom:=false;
      tmplink^.forkto:=false;
      FLinks.add(tmpLink);
      tmplink^.parent:=nil;
      tmplink^.next:=nil;
      tmplink^.prev:=nil;
    end;

  for i:=oldlc to FLinks.count-1 do
  begin
  tmplink:=PBPLinkRenameStructure(FLinks[i]);
  if (tmplink^.link^.dwFromNodeNumber and BPGlobalMask<>0)and(tmplink^.link^.IP_SRC=0) then
  for j:=TopStart to TopEnd do
  begin
  ptmplink:=PBPLinkRenameStructure(FLinks[j]);
  if (ptmplink^.link^.dwToNodeNumber=tmplink^.link^.dwFromNodeNumber  and BPNotGlobalMask)and
     (ptmplink^.link^.dwToLinkNumber=tmplink^.link^.dwFromLinkNumber)and
     sidesCompatible(ptmplink^.link^.dwflags and BP_TOMASK,tmplink^.link^.dwflags and BP_FROMMASK) then
     begin
     ptmplink^.sameParentL:=tmplink^.parent;
     tmplink^.parent:=ptmplink;

     for k:=i-1 downto oldlc do
      if PBPLinkRenameStructure(FLinks[k])^.parent=tmplink^.parent then
      begin
        PBPLinkRenameStructure(FLinks[k])^.next:=tmplink;
        tmplink^.prev:=PBPLinkRenameStructure(FLinks[k]);
        break;
      end;
     end;
  end
  else
 if (tmplink^.link^.dwToNodeNumber and BPGlobalMask<>0)and(tmplink^.link^.IP_DST=0) then
  for j:=TopStart to TopEnd do
  begin
  ptmplink:=PBPLinkRenameStructure(FLinks[j]);
  if (ptmplink^.link^.dwFromNodeNumber=tmplink^.link^.dwToNodeNumber and BPNotGlobalMask)and
     (ptmplink^.link^.dwFromLinkNumber=tmplink^.link^.dwToLinkNumber)and
     sidesCompatible(tmplink^.link^.dwflags and BP_TOMASK,ptmplink^.link^.dwflags and BP_FROMMASK) then
     begin
     ptmplink^.sameParentR:=tmplink^.parent;
     tmplink^.parent:=ptmplink;
     for k:=i-1 downto oldlc do
      if PBPLinkRenameStructure(FLinks[k])^.parent=tmplink^.parent then
      begin
        PBPLinkRenameStructure(FLinks[k])^.next:=tmplink;
        tmplink^.prev:=PBPLinkRenameStructure(FLinks[k]);
        break;
      end;

     //break;
     end;
  end
  else
   if (tmplink^.link^.IP_SRC<>0) then
   begin
    for k:=i-1 downto oldlc do
      if (PBPLinkRenameStructure(FLinks[k])^.link^.IP_SRC=tmplink^.link^.IP_SRC)and
         (PBPLinkRenameStructure(FLinks[k])^.link^.dwFromNodeNumber=tmplink^.link^.dwFromNodeNumber)and
         (tmplink.link.dwFlags and BP_FROMMask= PBPLinkRenameStructure(FLinks[k])^.link^.dwFlags and BP_FROMMASK) then
      begin
        PBPLinkRenameStructure(FLinks[k])^.next:=tmplink;
        tmplink^.prev:=PBPLinkRenameStructure(FLinks[k]);
        tmplink^.forkfrom:=true;
        tmplink^.prev.forkfrom:=true;
        break;
      end;
    end
  else
   if (tmplink^.link^.IP_DST<>0) then
   begin
    for k:=i-1 downto oldlc do
      if (PBPLinkRenameStructure(FLinks[k])^.link^.IP_DST=tmplink^.link^.IP_DST)and
         (PBPLinkRenameStructure(FLinks[k])^.link^.dwToNodeNumber=tmplink^.link^.dwToNodeNumber)and
         (tmplink.link.dwFlags and BP_TOMask= PBPLinkRenameStructure(FLinks[k])^.link^.dwFlags and BP_TOMASK) then
      begin
        PBPLinkRenameStructure(FLinks[k])^.next:=tmplink;
        tmplink^.prev:=PBPLinkRenameStructure(FLinks[k]);
        tmplink^.forkto:=true;
        tmplink^.prev.forkto:=true;
        break;
      end;
    end;

  if tmplink.forkfrom and tmplink.forkTo then continue;
  tmplink1:=tmpLink^.link;
  if not tmplink.forkfrom then
  for j:=i+1 to FLinks.count-1 do
   if (PBPLinkRenameStructure(FLinks[j])^.link^.dwFromNodeNumber=tmplink1^.dwFromNodeNumber)and
      (PBPLinkRenameStructure(FLinks[j])^.link^.dwFromLinkNumber=tmplink1^.dwFromLinkNumber) then
      begin
      PBPLinkRenameStructure(FLinks[j])^.forkfrom:=true;
      tmplink.forkfrom:=true;
      end;
  if not tmplink.forkto then
  for j:=i+1 to FLinks.count-1 do
   if (PBPLinkRenameStructure(FLinks[j])^.link^.dwToNodeNumber=tmplink1^.dwToNodeNumber)and
      (PBPLinkRenameStructure(FLinks[j])^.link^.dwToLinkNumber=tmplink1^.dwToLinkNumber) then
      begin
      PBPLinkRenameStructure(FLinks[j])^.forkTo:=true;
      tmplink.forkTo:=true;
      end;
  end;
    FLinksCount:=FLinks.count;
 end;

procedure TBPRename.FinalizeLinks; { Corrected }
Var i:integer;
 begin
   if (FLinks=nil) then Exit;
   for i:=0 to FLinks.count-1 do
    begin
    FreeMem(PBPLinkRenameStructure(FLinks[i]));
    end;

   FLinks.clear;
   FLinksCount:=0;
 end;

procedure TBPRename.TraceLinks; { Checked }
Type TWeight=record PointID:Int64;weight,count:integer;end;
Var i,j,k,curN:integer;
    tmpLink,tmplink2,tmplinkP:PBPLinkRenameStructure;
    tmpNode,FictiveNode:PBPNodeRenameStructure;
    fork,sameTop:Boolean;
    Links_left,Links_right,Links_top,links_Bottom,
    Links_From,Links_To:TList;
    grpcap,scap:string;
    pointweights:array[1..512] of TWeight;
    NPoints:integer;
    rcap:string;
    IPSRCNodePos,IPDSTNodePos:TIntList;
    OpIn,OpOut:TList;
function getPos(l:TIntList;ID:integer):integer;
var i:integer;
begin
 for i:=0 to l.Count-1 do
  if l[i]=ID then begin result:=i+1; exit; end;
 l.add(ID);
 result:=l.Count; 
end;
procedure fillweights(l:TList;node:PBPNodeRenameStructure);
var i,ps,j:integer;
    lnk:PBPLinkRenameStructure;
    w:TWeight;
begin
ps:=0;
 for i:=0 to l.Count-1 do
 begin
  lnk:=PBPLinkRenameStructure(l[i]);
  if lnk^.link.dwFromNodeNumber=node^.dwNodeNumber then
  begin
  j:=ps+1;
  for j:=1 to ps do
   if pointweights[j].PointID=lnk^.link.dwFromLinkNumber then break;
  if j>ps then
  begin
  ps:=j;
  pointweights[ps].PointID:=lnk^.link.dwFromLinkNumber;
  pointweights[ps].weight:=0;
  pointweights[ps].count:=0;
  end;
  pointweights[j].weight:=pointweights[j].weight+lnk^.fromWeight+i;
  pointweights[j].count:=pointweights[j].count+1;
  end
  else
  begin
  j:=ps+1;
  for j:=1 to ps do
   if pointweights[j].PointID=lnk^.link.dwToLinkNumber then break;
  if j>ps then
  begin
  ps:=j;
  pointweights[ps].PointID:=lnk^.link.dwToLinkNumber;
  pointweights[ps].weight:=0;
  pointweights[ps].count:=0;
  end;
  pointweights[j].weight:=pointweights[j].weight+lnk^.toWeight+i;
  pointweights[j].count:=pointweights[j].count+1;
  end
 end;
 for i:=1 to ps-1 do
   begin
    for j:=i+1 to ps do
    if pointweights[i].weight/pointweights[i].count>pointweights[j].weight/pointweights[j].count then
    begin
    w:=pointweights[i];
    pointweights[i]:=pointweights[j];
    pointweights[j]:=w;
    end;
   end;

 NPoints:=ps;
end;
function CompareLeft(p1,p2:PBPLinkRenameStructure):boolean;
var node1,node2:integer;
begin
if p1.link.dwToNodeNumber=tmpnode^.dwNodeNumber then
 node1:=p1.link.dwFromNodeNumber
 else
 node1:=p1.link.dwToNodeNumber;
if p2.link.dwToNodeNumber=tmpnode^.dwNodeNumber then
 node2:=p2.link.dwFromNodeNumber
 else
 node2:=p2.link.dwToNodeNumber;
if node2 = node1 then result:=p1^.link.dwFromLinkNumber>p2^.link.dwFromLinkNumber
else

 if node1 and BPGlobalMask<>0 then
  if node2 and BPGlobalMask=0 then
   if node2<tmpnode^.dwNodeNumber then result:=true
                                  else result:=false
  else result:= node2<node1
 else if node2 and BPGlobalMask<>0 then
 result:=node1>tmpnode^.dwNodeNumber
 else if  node1<tmpnode^.dwNodeNumber then
      if  node2<tmpnode^.dwNodeNumber then
      result:= node2<node1
      else result:=false
      else
      if node2>tmpnode^.dwNodeNumber then
       result:= node2>node1
      else result:=true;
end;
function CompareRight(p1,p2:PBPLinkRenameStructure):boolean;
const comparematrix:array[boolean,boolean,boolean,boolean]of integer=
(  (((2,0),(1,3)),((0,0),(0,3))),(((1,1),(1,2)),((3,1),(0,3))));
var node1,node2:integer;
     r:integer;
function sidesequence(side1,side2:word):boolean;
begin
if side1<>side2 then
case side1 of
$10:result:=side2 in [$20,$80];
$40:result:=side2 in [$10,$20,$80];
$80:result:=side2 in [$80];
else result:=false;
end
else result:=p1^.link.dwToLinkNumber<p2^.link.dwToLinkNumber;
end;
begin
if p1.link.dwFromNodeNumber=tmpnode^.dwNodeNumber then
 node1:=p1.link.dwToNodeNumber
 else
 node1:=p1.link.dwFromNodeNumber;
if p2.link.dwFromNodeNumber=tmpnode^.dwNodeNumber then
 node2:=p2.link.dwToNodeNumber
 else
 node2:=p2.link.dwFromNodeNumber;
result:=false;
if node2 = node1 then result:=not sidesequence(p1.link.dwFlags and BP_TOMASK,p2.link.dwFlags and BP_TOMASK)
else
if ((node1 and BPGlobalMask)=0)and((node2 and BPGlobalMask)=0) then
begin
r:=compareMatrix[p2.link.dwFlags and BP_TOMASK=BP_TONODE_TOP,
                 p1.link.dwFlags and BP_TOMASK=BP_TONODE_TOP,
                 node2>tmpnode^.dwNodeNumber,
                 node1>tmpnode^.dwNodeNumber];
case r of
0:result:=false;
1:result:=true;
2:result:=node2<node1;
3:result:=node2>node1;
end
end
else if ((node1 and BPGlobalMask)<>0)and((node2 and BPGlobalMask)=0) then
 result:=(node2<tmpnode^.dwNodeNumber)and(p2.link.dwFlags and BP_TOMASK=BP_TONODE_TOP)
else if ((node1 and BPGlobalMask)=0)and((node2 and BPGlobalMask)<>0) then
result:=not((node1<tmpnode^.dwNodeNumber)and(p1.link.dwFlags and BP_TOMASK=BP_TONODE_TOP))
else result:=(node2<node1);
end;
function CompareTop(p1,p2:PBPLinkRenameStructure):boolean;
var node1,node2:integer;
begin
if p1.link.dwToNodeNumber=tmpnode^.dwNodeNumber then
 node1:=p1.link.dwFromNodeNumber
 else
 node1:=p1.link.dwToNodeNumber;
if p2.link.dwToNodeNumber=tmpnode^.dwNodeNumber then
 node2:=p2.link.dwFromNodeNumber
 else
 node2:=p2.link.dwToNodeNumber;
if node2 = node1 then result:=p1^.link.dwFromLinkNumber>p2^.link.dwFromLinkNumber
else

 if node1 and BPGlobalMask<>0 then
  if node2 and BPGlobalMask=0 then
   if node2<tmpnode^.dwNodeNumber then result:=true
                                  else result:=false
  else result:= node2<node1 else
  if node2 and BPGlobalMask<>0 then
 result:=node1>tmpnode^.dwNodeNumber
 else if  node1<tmpnode^.dwNodeNumber then
      if  node2<tmpnode^.dwNodeNumber then
      result:= node2>node1
      else result:=false
      else
      if node2>tmpnode^.dwNodeNumber then
       result:= node2>node1
      else result:=true;
end;
function CompareBottom(p1,p2:PBPLinkRenameStructure):boolean;
var node1,node2:integer;
begin
if p1.link.dwToNodeNumber=tmpnode^.dwNodeNumber then
 node1:=p1.link.dwFromNodeNumber
 else
 node1:=p1.link.dwToNodeNumber;
if p2.link.dwToNodeNumber=tmpnode^.dwNodeNumber then
 node2:=p2.link.dwFromNodeNumber
 else
 node2:=p2.link.dwToNodeNumber;
if node2 = node1 then result:=p1^.link.dwFromLinkNumber>p2^.link.dwFromLinkNumber
else

 if node1 and BPGlobalMask<>0 then
  if node2 and BPGlobalMask=0 then
   if node2<tmpnode^.dwNodeNumber then result:=true
                                  else result:=false
  else result:= false else
  if node2 and BPGlobalMask<>0 then
 result:=node1>tmpnode^.dwNodeNumber
 else if  node1<tmpnode^.dwNodeNumber then
      if  node2<tmpnode^.dwNodeNumber then
      result:= node2<node1
      else result:=false
      else
      if node2>tmpnode^.dwNodeNumber then
       result:= node2>node1
      else result:=true;
end;

function Linkedsidesfrom(node1:DWORD;flags1,flags:integer):boolean;
begin
case flags and BP_FROMMASK of
BP_FROMNODE_LEFT:result:=(node1=BPGlobalNodeLeft){ or (node1=BPGlobalNodeInProcess) and (flags1 and BP_TOMASK=BP_TONODE_Right)};
BP_FROMNODE_Right:result:=(node1=BPGlobalNodeRight){  or (node1=BPGlobalNodeInProcess) and (flags1 and BP_TOMASK=BP_TONODE_Left)};
BP_FROMNODE_Top:result:=node1=BPGlobalNodeTop;
BP_FROMNODE_Bottom:result:=node1=BPGlobalNodeBottom;
end;
end;
function LinkedsidesTo(node1:DWORD;flags1,flags:integer):boolean;
begin
case flags and BP_TOMASK of
BP_TONODE_LEFT:result:=(node1=BPGlobalNodeLeft){  or (node1=BPGlobalNodeInProcess) and (flags1 and BP_FROMMASK=BP_FROMNODE_Right)};
BP_TONODE_Right:result:=(node1=BPGlobalNodeRight){  or (node1=BPGlobalNodeInProcess) and (flags1 and BP_FROMMASK=BP_FROMNODE_Left)};
BP_TONODE_Top:result:=node1=BPGlobalNodeTop;
BP_TONODE_Bottom:result:=node1=BPGlobalNodeBottom;
end;
end;
procedure calcfirst;
var i,j:integer;
    found:boolean;
    tmplink, tmplink2:PBPLinkRenameStructure;
begin
for i:=0 to FLinksCount-1 do
begin
tmplink:=PBPLinkRenameStructure(FLinks[i]);
if (tmplink^.link.dwFromNodeNumber and BPGlobalMask=0)and
   (tmplink^.link.dwToNodeNumber and BPGlobalMask<>0) then
   begin
    found:=false;
    for j:=0 to FLinksCount-1 do
    begin
    tmplink2:=PBPLinkRenameStructure(FLinks[j]);
    if (tmplink2^.link.dwToNodeNumber=tmplink^.link.dwToNodeNumber)and
       ((tmplink2^.link.dwToLinkNumber=tmplink^.link.dwToLinkNumber)or
        (tmplink2^.link.IP_DST=tmplink^.link.IP_DST)and(tmplink^.link.IP_DST<>0))and
       (tmplink2.link.dwFromNodeNumber<tmplink.link.dwFromNodeNumber) then
       begin
       found:=true;
       break;
       end;
      end;
       if not found then tmplink^.firstFrom:=true
                    else tmplink^.firstFrom:=false;
   end
else
if (tmplink^.link.dwFromNodeNumber and BPGlobalMask<>0)and
   (tmplink^.link.dwToNodeNumber and BPGlobalMask=0) then
   begin
    found:=false;
    for j:=0 to FLinksCount-1 do
    begin
    tmplink2:=PBPLinkRenameStructure(FLinks[j]);
    if (tmplink2^.link.dwFromNodeNumber=tmplink^.link.dwFromNodeNumber)and
       ((tmplink2^.link.dwFromLinkNumber=tmplink^.link.dwFromLinkNumber)or
        (tmplink2^.link.IP_SRC=tmplink^.link.IP_SRC)and(tmplink^.link.IP_SRC<>0))and
       (tmplink2.link.dwToNodeNumber<tmplink.link.dwToNodeNumber) then
       begin
       found:=true;
       break;
       end;
    end;   
       if not found then tmplink^.firstTo:=true
                    else tmplink^.firstTo:=false;

   end

end;

end;
 begin
new(FictiveNode);
FictiveNode^.dwNodeNumber:=0;
FictiveNode^.ssNodeNumber:='GLOBAL';
FictiveNode^.LinksLeft:=0;
FictiveNode^.LinksRight:=0;
FictiveNode^.LinksTop:=0;
FictiveNode^.LinksBottom:=0;
FictiveNode^.LinksBottomDFD:=0;
Links_left:=TList.create;
Links_right:=TList.create;
Links_top:=TList.create;
Links_bottom:=TList.create;
calcFirst;
for i:=0 to FLinksCount-1 do
begin
tmplink:=PBPLinkRenameStructure(FLinks[i]);
 tmplink^.toWeight:=0;
 tmplink^.fromWeight:=0;
if (tmplink^.link.dwFromNodeNumber and BPGlobalMask=0)and
   (tmplink^.link.dwToNodeNumber and BPGlobalMask=0) then
   begin
   if tmplink^.link.dwFromNodeNumber<tmplink^.link.dwToNodeNumber then
   tmplink^.fromWeight:=5
   else
   case tmplink^.link.dwFlags and BP_TOMASK of
       BP_TONODE_LEFT: tmplink^.fromWeight:=10;
       BP_TONODE_RIGHT:tmplink^.fromWeight:=2;
       BP_TONODE_TOP:tmplink^.fromWeight:=-10;
       BP_TONODE_BOTTOM:tmplink^.fromWeight:=15;
   end;
   end
   else if (tmplink^.link.dwFromNodeNumber and BPGlobalMask=0)and(tmplink^.firstFrom) then
            tmplink^.fromWeight:=1
   else if (tmplink^.link.dwToNodeNumber and BPGlobalMask=0)and(tmplink^.firstTo) then
            tmplink^.toWeight:=1;

end;
 for j:=0 to FLinksCount-1 do
  if (PBPLinkRenameStructure(FLinks[j]).link.dwFromNodeNumber and BPNotGlobalMask=0){or
     (PBPLinkRenameStructure(FLinks[j]).link.dwFromNodeNumber and BPGlobalMask=BPGlobalNodeInProcess)and
     (PBPLinkRenameStructure(FLinks[j]).level=0)} then
   case  PBPLinkRenameStructure(FLinks[j]).link.dwFlags and BP_FROMMASK of
   BP_FROMNODE_RIGHT:Links_right.add(FLinks[j]);
   BP_FROMNODE_BOTTOM: if PBPLinkRenameStructure(FLinks[j]).link^.dwToNodeNumber and BPGlobalNodeOperation=0 then
                         Links_bottom.add(FLinks[j]);
   BP_FROMNODE_LEFT:Links_left.add(FLinks[j]);
   BP_FROMNODE_TOP:Links_top.add(FLinks[j]);
   end
  else
    if (PBPLinkRenameStructure(FLinks[j]).link.dwToNodeNumber and BPNotGlobalMask=0){or
     (PBPLinkRenameStructure(FLinks[j]).link.dwToNodeNumber and BPGlobalMask=BPGlobalNodeInProcess)and
     (PBPLinkRenameStructure(FLinks[j]).level=0)} then
   case  PBPLinkRenameStructure(FLinks[j]).link.dwFlags and BP_TOMASK of
   BP_TONODE_RIGHT:Links_right.add(FLinks[j]);
   BP_TONODE_BOTTOM: if PBPLinkRenameStructure(FLinks[j]).link^.dwFromNodeNumber and BPGlobalNodeOperation=0 then
                       Links_bottom.add(FLinks[j]);
   BP_TONODE_LEFT:Links_left.add(FLinks[j]);
   BP_TONODE_TOP:Links_top.add(FLinks[j]);
   end;
for j:=0 to Links_left.Count-1 do
if PBPLinkRenameStructure(Links_Left[j]).link.dwFromNodeNumber and BPNotGlobalMask=0 then
   PBPLinkRenameStructure(Links_Left[j]).FromLinkNumber:=j+1
   else
   PBPLinkRenameStructure(Links_Left[j]).ToLinkNumber:=j+1;
for j:=0 to Links_Right.Count-1 do
if PBPLinkRenameStructure(Links_Right[j]).link.dwFromNodeNumber and BPNotGlobalMask=0 then
   PBPLinkRenameStructure(Links_Right[j]).FromLinkNumber:=j+1
   else
   PBPLinkRenameStructure(Links_Right[j]).ToLinkNumber:=j+1;
for j:=0 to Links_Top.Count-1 do
if PBPLinkRenameStructure(Links_Top[j]).link.dwFromNodeNumber and BPNotGlobalMask=0 then
   PBPLinkRenameStructure(Links_Top[j]).FromLinkNumber:=j+1
   else
   PBPLinkRenameStructure(Links_Top[j]).ToLinkNumber:=j+1;
for j:=0 to Links_Bottom.Count-1 do
if PBPLinkRenameStructure(Links_Bottom[j]).link.dwFromNodeNumber and BPNotGlobalMask=0 then
   PBPLinkRenameStructure(Links_Bottom[j]).FromLinkNumber:=j+1
   else
   PBPLinkRenameStructure(Links_Bottom[j]).ToLinkNumber:=j+1;

for i:=0 to FNodesCount-1 do
begin
tmpnode:=PBPNodeRenameStructure(FNodes[i]);
Links_left.clear;
Links_right.clear;
Links_top.clear;
Links_bottom.clear;
OpIn:=TList.create;
OpOut:=TList.create;
try
 k:=0;
 for j:=0 to FLinksCount-1 do
  if PBPLinkRenameStructure(FLinks[j]).link.dwFromNodeNumber=tmpnode^.dwNodeNumber then
   case  PBPLinkRenameStructure(FLinks[j]).link.dwFlags and BP_FROMMASK of
   BP_FROMNODE_RIGHT:Links_right.add(FLinks[j]);
   BP_FROMNODE_BOTTOM: if PBPLinkRenameStructure(FLinks[j]).link^.dwToNodeNumber and BPGlobalNodeOperation=0 then
                          Links_bottom.add(FLinks[j])
                          else
                          begin
                          opOut.add(FLinks[j]);

                          end;
   BP_FROMNODE_LEFT:Links_left.add(FLinks[j]);
   BP_FROMNODE_TOP:Links_top.add(FLinks[j]);
   end
  else
    if PBPLinkRenameStructure(FLinks[j]).link.dwToNodeNumber=tmpnode^.dwNodeNumber then
   case  PBPLinkRenameStructure(FLinks[j]).link.dwFlags and BP_TOMASK of
   BP_TONODE_RIGHT:Links_right.add(FLinks[j]);
   BP_TONODE_BOTTOM: if PBPLinkRenameStructure(FLinks[j]).link^.dwFromNodeNumber and BPGlobalNodeOperation=0 then
                         Links_bottom.add(FLinks[j])
                           else
                          begin
                          opin.add(FLinks[j]);
                          end;
   BP_TONODE_LEFT:Links_left.add(FLinks[j]);
   BP_TONODE_TOP:Links_top.add(FLinks[j]);
   end;
for k:=0 to opIn.Count-1 do
with PBPLinkRenameStructure(opIn[k])^ do
begin
 FromLinkNumber:=k+1;
 ToLinkNumber:=k+1;
end;
for k:=0 to opOut.Count-1 do
with PBPLinkRenameStructure(opOut[k])^ do
begin
 FromLinkNumber:=k+1+Opin.Count;
 ToLinkNumber:=k+1+Opin.Count;
end;

finally
opin.Free;
opout.free;
end;
for j:=0  to Links_Left.count-2 do
 for  k:=j+1 to Links_Left.count-1 do
  if CompareLeft(PBPLinkRenameStructure(Links_Left[j]),PBPLinkRenameStructure(Links_Left[k])) then
  begin
  tmplink:=PBPLinkRenameStructure(Links_Left[j]);
  Links_Left[j]:=Links_Left[k];
  Links_Left[k]:=tmplink;
  end;


  curN:=0;
fillweights(links_Left,tmpNode);
for j:=0 to Links_Left.count-1 do
begin
tmplink:=PBPLinkRenameStructure(Links_Left[j]);
if (tmplink^.FromLinkNumber=0)and (tmplink^.link.dwFromNodeNumber=tmpNode^.dwNodeNumber) then
begin
for k:=1 to NPoints do
 if pointweights[k].PointID=tmplink^.link.dwFromLinkNumber then break;
 tmplink^.FromLinkNumber:=k;
end
else
begin
for k:=1 to NPoints do
 if pointweights[k].PointID=tmplink^.link.dwToLinkNumber then break;
 tmplink^.ToLinkNumber:=k;
end
end;
for j:=1 to NPoints do
 begin
  rcap:='';
  fork:=false;
  for k:=0 to Links_Left.count-1 do
   begin
   tmplink:=PBPLinkRenameStructure(Links_Left[k]);
   if tmplink^.ToLinkNumber=j then
    if rcap='' then rcap:='-'
               else
               begin  tmplink^.link.ssToCaption:='';tmplink^.link.ssUnMovedTo:='';tmplink^.link.ssToPath:=''; end;
   end;

 end;
for j:=0  to Links_Top.count-2 do
 for  k:=j+1 to Links_Top.count-1 do
  if CompareTop(PBPLinkRenameStructure(Links_Top[j]),PBPLinkRenameStructure(Links_Top[k])) then
  begin
  tmplink:=PBPLinkRenameStructure(Links_Top[j]);
  Links_Top[j]:=Links_Top[k];
  Links_Top[k]:=tmplink;
  end;
fillweights(Links_top,tmpNode);
for j:=0 to Links_top.count-1 do
begin
tmplink:=PBPLinkRenameStructure(Links_top[j]);
if (tmplink^.FromLinkNumber=0)and (tmplink^.link.dwFromNodeNumber=tmpNode^.dwNodeNumber) then
begin
for k:=1 to NPoints do
 if pointweights[k].PointID=tmplink^.link.dwFromLinkNumber then break;
 tmplink^.FromLinkNumber:=k;
end
else
begin
for k:=1 to NPoints do
 if pointweights[k].PointID=tmplink^.link.dwToLinkNumber then break;
 tmplink^.ToLinkNumber:=k;
end
end;
for j:=1 to NPoints do
 begin
  rcap:='';
  fork:=false;
  for k:=0 to Links_Top.count-1 do
   begin
   tmplink:=PBPLinkRenameStructure(Links_Top[k]);
   if tmplink^.ToLinkNumber=j then
    if rcap='' then rcap:='-'
               else
               begin  tmplink^.link.ssToCaption:='';tmplink^.link.ssUnMovedTo:='';tmplink^.link.ssToPath:='';end;
   end;

 end;
for j:=0  to Links_Right.count-2 do
 for  k:=j+1 to Links_Right.count-1 do
  if CompareRight(PBPLinkRenameStructure(Links_Right[j]),PBPLinkRenameStructure(Links_Right[k])) then
  begin
  tmplink:=PBPLinkRenameStructure(Links_Right[j]);
  Links_Right[j]:=Links_Right[k];
  Links_Right[k]:=tmplink;
  end;
  curN:=0;
fillweights(Links_Right,tmpNode);
for j:=0 to Links_Right.count-1 do
begin
tmplink:=PBPLinkRenameStructure(Links_Right[j]);
if (tmplink^.FromLinkNumber=0)and (tmplink^.link.dwFromNodeNumber=tmpNode^.dwNodeNumber) then
begin
for k:=1 to NPoints do
 if pointweights[k].PointID=tmplink^.link.dwFromLinkNumber then break;
 tmplink^.FromLinkNumber:=k;
end
else
begin
for k:=1 to NPoints do
 if pointweights[k].PointID=tmplink^.link.dwToLinkNumber then break;
 tmplink^.ToLinkNumber:=k;
end
end;


 for j:=1 to NPoints do
 begin
  rcap:='';
  fork:=false;
  for k:=0 to Links_Right.count-1 do
   begin
   tmplink:=PBPLinkRenameStructure(Links_Right[k]);
   if (tmplink^.FromLinkNumber=j) {and(tmplink^.link.dwToNodeNumber and BPGlobalMask =0)} then
    if rcap='' then rcap:=tmplink^.link.ssToCaption
               else begin
                fork:=rcap<>tmplink^.link.ssToCaption;
                {tmplink^.link.ssFromCaption:='';
                tmplink^.link.ssUnMovedFrom:='';
                tmplink^.link.ssFromPath:='';}
                 end;
   end;
{   if not fork then
   begin
   for k:=0 to FLinksCount-1 do
   if (PBPLinkRenameStructure(FLinks[k])<>tmplink)and
   (PBPLinkRenameStructure(FLinks[k]).link.dwToNodeNumber=tmplink^.link.dwToNodeNumber)and
   (PBPLinkRenameStructure(FLinks[k]).link.dwToLinkNumber=tmplink^.link.dwToLinkNumber) then
   begin
    fork:=true;
    break;
   end;
   end;}
   rcap:='';
  {if not fork and (tmpNode^.level<>-1)then
for k:=0 to Links_Right.count-1 do
   begin
   tmplink:=PBPLinkRenameStructure(Links_Right[k]);
   if tmplink^.forkTo then continue;
   if (tmplink^.FromLinkNumber=j) then
   begin
   if rcap='' then
   begin
   if tmplink^.link.ssFromCaption='' then
   tmplink^.link.ssFromCaption:=tmplink^.link.ssToCaption
   else
   if tmplink^.link.ssFromCaption[1] in ['<','['] then
    tmplink^.link.ssFromCaption:=tmplink^.link.ssToCaption+tmplink^.link.ssFromCaption
   else
   tmplink^.link.ssFromCaption:=tmplink^.link.ssFromCaption+tmplink^.link.ssToCaption;
   if tmplink^.link.ssFromPath='' then tmplink^.link.ssFromPath:=tmplink^.link.ssToPath;
   end;
   rcap:=tmplink^.link.ssFromCaption;
  tmplink^.link.ssToCaption:='';
   tmplink^.link.ssToPath:='';
      end;
   end;}
 end;
for j:=0  to Links_Bottom.count-2 do
 for  k:=j+1 to Links_Bottom.count-1 do
  if CompareBottom(PBPLinkRenameStructure(Links_Bottom[j]),PBPLinkRenameStructure(Links_Bottom[k])) then
  begin
  tmplink:=PBPLinkRenameStructure(Links_Bottom[j]);
  Links_Bottom[j]:=Links_Bottom[k];
  Links_Bottom[k]:=tmplink;
  end;
  curN:=0;
fillweights(Links_Bottom,tmpNode);

for j:=0 to Links_Bottom.count-1 do
begin
tmplink:=PBPLinkRenameStructure(Links_Bottom[j]);
if (tmplink^.FromLinkNumber=0)and (tmplink^.link.dwFromNodeNumber=tmpNode^.dwNodeNumber) then
begin
for k:=1 to NPoints do
 if pointweights[k].PointID=tmplink^.link.dwFromLinkNumber then break;
 tmplink^.FromLinkNumber:=k;
end
else
begin
for k:=1 to NPoints do
 if pointweights[k].PointID=tmplink^.link.dwToLinkNumber then break;
 tmplink^.ToLinkNumber:=k;
end
end;
 for j:=1 to NPoints do
 begin
  rcap:='';
  fork:=false;
  for k:=0 to Links_Bottom.count-1 do
   begin
   tmplink:=PBPLinkRenameStructure(Links_Bottom[k]);
   if tmplink^.ToLinkNumber=j then
    if rcap='' then rcap:='-'
               else
               begin  tmplink^.link.ssToCaption:='';tmplink^.link.ssUnMovedTo:='';tmplink^.link.ssToPath:=''; end;
   end;

 end;

end;
Links_left.free;
Links_right.free;
Links_top.free;
Links_bottom.free;
Links_from:=TList.Create;
Links_to:=TList.create;
for i:=0 to FLinksCount-1 do
begin
tmpLink:=PBPLinkRenameStructure(FLinks[i]);

if tmplink^.link.dwFromNodeNumber and BPGlobalMask<>0 then
begin
tmpLinkP:=tmplink^.parent;
while tmplinkP<>nil do
begin
tmplinkP^.link^.dwFlags:=tmplinkP^.link^.dwFlags and not BP_NOTUSED_TO;
tmplink^.FromLinkNumber:=tmplink^.parent^.ToLinkNumber;
tmplinkP:=tmpLinkP^.sameParentL;
end;
fork:=tmplink^.forkfrom;
sameTop:=true;
if fork then
begin
grpcap:=tmplink^.link^.ssToCaption;
scap:=tmplink^.link^.ssFromCaption;
fork:=false;
tmplink2:=tmplink^.next;

while (tmplink2<>nil) do
begin
fork:=fork or(tmplink2^.link^.ssToCaption<>grpcap){and(tmplink2^.link^.ssToCaption<>'')};
sametop:=sametop and (tmplink2^.link^.dwFromLinkNumber=tmplink^.link^.dwFromLinkNumber);
tmplink2:=tmplink2^.next;
end;
tmplink2:=tmplink^.prev;
while (tmplink2<>nil) do
begin
fork:=fork or(tmplink2^.link^.ssToCaption<>grpcap){and(tmplink2^.link^.ssToCaption<>'')};
sametop:=sametop and (tmplink2^.link^.dwFromLinkNumber=tmplink^.link^.dwFromLinkNumber);
tmplink2:=tmplink2^.prev;
end;
end;
if not fork then
begin
 tmplink^.link^.ssFromCaption:=combinestring(tmplink^.link^.ssFromCaption,':',tmplink^.link^.ssToCaption);
 if tmplink^.link^.ssFromPath='' then tmplink^.link^.ssFromPath:=tmplink^.link^.sstoPath;
tmplink^.link^.ssToCaption:='';
tmplink^.link^.ssToPath:='';
end;
if not SameTop then
begin
//tmplink^.link^.ssToPath:=tmplink^.link^.ssFromPath+tmplink^.link^.ssToPath;
tmplink^.link^.ssToCaption:=combinestring(tmplink^.link^.ssFromCaption,':',tmplink^.link^.ssToCaption);
tmplink^.link^.ssFromCaption:='';
end;
end;
if tmplink^.link.dwToNodeNumber and BPGlobalMask<>0 then
begin
tmpLinkP:=tmplink^.parent;
while tmplinkP<>nil do
begin
tmplinkP^.link^.dwFlags:=tmplinkP^.link^.dwFlags and not BP_NOTUSED_FROM;
tmplink^.ToLinkNumber:=tmplink^.parent^.FromLinkNumber;
tmpLinkP:=tmpLinkP^.sameParentR;
end;
fork:=tmplink^.forkto;
sametop:=true;
if fork then
begin
grpcap:=tmplink^.link^.ssFromCaption;
fork:=false;
tmplink2:=tmplink^.next;
while (tmplink2<>nil) do
begin
fork:=fork or(tmplink2^.link^.ssFromCaption<>grpcap)and(tmplink2^.link^.ssFromCaption<>'');
sametop:=sametop and (tmplink2^.link^.dwToLinkNumber=tmplink^.link^.dwToLinkNumber);
tmplink2:=tmplink2^.next;
end;
tmplink2:=tmplink^.prev;
while (tmplink2<>nil) do
begin
fork:=fork or(tmplink2^.link^.ssFromCaption<>grpcap)and(tmplink2^.link^.ssFromCaption<>'');
sametop:=sametop and (tmplink2^.link^.dwToLinkNumber=tmplink^.link^.dwToLinkNumber);
tmplink2:=tmplink2^.prev;
end;
end;
if not fork then
begin
 tmplink^.link^.ssToCaption:=combinestring(tmplink^.link^.ssFromCaption,':',tmplink^.link^.ssToCaption);
 if tmplink^.link^.ssToPath='' then tmplink^.link^.ssToPath:=tmplink^.link^.ssFromPath;
tmplink^.link^.ssfromCaption:='';
tmplink^.link^.ssfromPath:='';
end;
if not SameTop then
begin
//tmplink^.link^.ssToPath:=tmplink^.link^.ssFromPath+tmplink^.link^.ssToPath;
tmplink^.link^.ssFromCaption:=combinestring(tmplink^.link^.ssFromCaption,':',tmplink^.link^.ssToCaption);
tmplink^.link^.ssToCaption:='';
end;

end;

links_from.clear;
links_to.clear;
{if tmplink^.link.dwFromNodeNumber and BPGlobalMask=0 then
begin
 for j:=0 to FLinksCount-1 do
 begin
 tmpLink2:=PBPLinkRenameStructure(FLinks[j]);
 if (tmplink2^.level=tmplink^.level+1)and
    linkedsidesfrom(tmplink2^.link.dwToNodeNumber and BPGLOBALMASK,tmplink2^.link.dwFlags,tmplink^.Link.dwFlags)and
     (tmplink2^.link.dwToLinkNumber=tmplink^.link.dwFromLinkNumber)and
    ((tmplink2^.link.dwToNodeNumber and BPNOTGLOBALMASK=tmplink^.link.dwFromNodeNumber)) then
    links_to.add(tmplink2);
 end;
 fork:=false;
  for j:=0 to links_to.count-1 do
  begin
   tmplink^.link.dwFlags:=tmplink^.link.dwFlags and not(BP_NOTUSED_FROM);
   tmplink2:=PBPLinkRenameStructure(links_to[j]);
   tmplink2^.toLinkNumber:=tmplink^.FromLinkNumber;
     if (j=0) then  grpcap:=tmplink2^.link.ssFromCaption
            else fork:=fork or (grpcap<>tmplink2^.link.ssFromCaption);
  end;
if not fork and ((pos('<',grpcap)=0)or (tmplink^.link.dwFlags and BP_FROMMASK<>BP_FROMNODE_RIGHT)) then
   for j:=0 to links_to.count-1 do
  begin
   tmplink2:=PBPLinkRenameStructure(links_to[j]);
      if tmplink2^.link.ssToCaption='' then
   tmplink2^.link.sstoCaption:=tmplink2^.link.ssFromCaption
   else
   if tmplink2^.link.ssToCaption[1] in ['<','['] then
    tmplink2^.link.ssToCaption:=tmplink2^.link.ssFromCaption+tmplink2^.link.ssToCaption;
   if tmplink2^.link.ssToPath='' then tmplink2^.link.ssToPath:=tmplink2^.link.ssFromPath;
   tmplink2^.link.ssFromCaption:='';
   tmplink2^.link.ssFromPath:='';
  end;

  end;
if tmplink^.link.dwToNodeNumber and BPGlobalMask=0 then
begin
 for j:=0 to FLinksCount-1 do
 begin
 tmpLink2:=PBPLinkRenameStructure(FLinks[j]);
 if (tmplink2^.level=tmplink^.level+1)and
    linkedsidesTo(tmplink2^.link.dwFromNodeNumber and BPGLOBALMASK,tmplink2^.link.dwFlags,tmplink^.Link.dwFlags)and
    (tmplink2^.link.dwFromLinkNumber=tmplink^.link.dwToLinkNumber)and
    ((tmplink2^.link.dwFromNodeNumber and BPNOTGLOBALMASK=tmplink^.link.dwToNodeNumber)) then
      links_from.add(tmplink2);
 end;
  fork:=false;
  for j:=0 to links_from.count-1 do
  begin
   tmplink^.link.dwFlags:=tmplink^.link.dwFlags and not(BP_NOTUSED_TO);
   tmplink2:=PBPLinkRenameStructure(links_from[j]);
   tmplink2^.FromLinkNumber:=tmplink^.ToLinkNumber;
   if (j=0) then  grpcap:=tmplink2^.link.ssToCaption
            else fork:=fork or (grpcap<>tmplink2^.link.ssToCaption);
  end;
if not fork then
   for j:=0 to links_from.count-1 do
  begin
   tmplink2:=PBPLinkRenameStructure(links_from[j]);
   tmplink2^.link.ssFromCaption:=tmplink2^.link.ssFromCaption+tmplink2^.link.ssToCaption;
   if tmplink2^.link.ssFromPath='' then tmplink2^.link.ssFromPath:=tmplink2^.link.ssToPath;
   tmplink2^.link.ssToCaption:='';
   tmplink2^.link.ssToPath:='';
  end;

end;}
end;
links_to.free;
Links_from.Free;
IPSRCNodePos:=TIntList.Create;
IPDSTNodePos:=TIntList.Create;
try
for i:=0 to FLinksCount -1 do
begin
  tmpLink:=PBPLinkRenameStructure(FLinks[i]);
  j:=tmpLink^.link^.dwFromLinkNumber;
  if tmplink^.link^.dwfromNodeNumber and BPGlobalMask=BPGlobalNodeOperation then
tmpLink^.link^.dwFromLinkNumber:=tmpLink^.toLinkNumber
else if tmplink^.link^.IP_SRC<>0 then
begin
tmpLink^.link^.dwFromLinkNumber:=GetPos(IPSRCNodePos,tmplink^.link^.IP_SRC);
end
else
{if tmplink^.link^.dwFromNodeNumber and BPGlobalMask=BPGlobalNodeInProcess then
  tmpLink^.link^.dwFromLinkNumber:=1
else}
  tmpLink^.link^.dwFromLinkNumber:=tmpLink^.FromLinkNumber;
  if (tmpLink^.link^.dwFromNodeNumber and BPGlobalMask<>0) then
  begin
  if tmpLink^.link^.dwFromLinkNumber>0 then
  tmpLink^.link^.ssGlobalCaption:=tmpLink^.link^.ssGlobalCaption+inttostr(tmpLink^.link^.dwFromLinkNumber)
  else
   begin
   tmpLink^.link^.dwFromLinkNumber:=-j;
   tmpLink^.link^.dwFlags:=tmpLink^.link^.dwFlags or BP_NOTUSED_FROM;
   tmpLink^.link^.ssGlobalCaption:='';
   end;
  end;
  j:=tmpLink^.link^.dwtoLinkNumber;
  if tmplink^.link^.dwtoNodeNumber and BPGlobalMask=BPGlobalNodeOperation then
tmpLink^.link^.dwtoLinkNumber:=tmpLink^.fromLinkNumber
else if tmplink^.link^.IP_DST<>0 then
begin
tmpLink^.link^.dwToLinkNumber:=GetPos(IPDSTNodePos,tmplink^.link^.IP_DST);
end
else
{if tmplink^.link^.dwToNodeNumber and BPGlobalMask=BPGlobalNodeInProcess then
  tmpLink^.link^.dwToLinkNumber:=1
else}
  tmpLink^.link^.dwToLinkNumber:=tmpLink^.ToLinkNumber;
  if (tmpLink^.link^.dwToNodeNumber and BPGlobalMask<>0) then
  begin
  if tmpLink^.link^.dwToLinkNumber>0 then
  tmpLink^.link^.ssGlobalCaption:=tmpLink^.link^.ssGlobalCaption+inttostr(tmpLink^.link^.dwtoLinkNumber)
  else
  begin
  tmpLink^.link^.dwtoLinkNumber:=-j;
   tmpLink^.link^.dwFlags:=tmpLink^.link^.dwFlags or BP_NOTUSED_TO;
   tmpLink^.link^.ssGlobalCaption:='';
  end;
  end;
end;
finally
IPSRCNodePos.Free;
IPDSTNodePos.Free
end;
dispose(fictiveNode);

 end;

procedure TBPRename.RenameLinks;  { Checked }
Var j:LongInt;
    tmpTree:PBPTree;
    links:TList;
    nodes:TList;
    lev:Integer;
    linklimitstack:array[0..63] of record start,stop:integer;end;
    pstart,pstop:integer;
    oldcount:integer;
 begin
   // WriteTree(FTree);
    FMaxLevel:=GetMaxLevel;
    if (FMaxLevel=-2) then Exit; { No levels found }
    FMinLevel:=GetMinLevel(FMaxLevel); { Corrected }
       FNodes:=TList.create;
       FLinks:=TList.create;
//initializeOpNodes(foptree,foptree.count);
      { Main circle for levels }
      for j:=0 to FTree.count-1 do
       begin
        tmpTree:=PBPTree(FTree[j]);
        lev:=tmpTree^.dwDepth; { Corrected }
        if lev>0 then
        begin
        pstart:=linklimitstack[lev-1].start;
        pstop:=linklimitstack[lev-1].stop;
        end
        else
        begin
        pstart:=0;
        pstop:=-1;
        end;
             links:=tmpTree^.lpLinks;
             nodes:=tmpTree^.lpNodes;
             if (tmpTree^.dwLinksCount<>0) and (tmpTree^.dwNodesCount<>0) then
              begin { Level }
                InitializeNodes(nodes,tmpTree^.dwNodesCount,tmptree^.dwLevel); { Corrected }
                oldcount:=flinks.count;
                InitializeLinks(links,tmpTree^.dwLinksCount,lev,pstart,pstop); { Corrected }
                linklimitstack[lev].start:=oldcount;
                linklimitstack[lev].stop:=Flinks.Count-1;
                 { Let's rename }
                FCurSSLevel:=tmpTree^.ssLevel;
                FCurLevel:=tmpTree^.dwLevel;
                FParentLevel:=tmpTree^.dwParent;
               end
               else
               begin
                linklimitstack[lev].start:=0;
                linklimitstack[lev].stop:=-1;
               end;
       end; { for }
//    WriteTree(FTree);
 TraceLinks;
                FinalizeNodes;                 { Corrected }
                FinalizeLinks;                 { Corrected }

 end;

end.
