unit newpdot;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, RXLookup, ComCtrls, StdCtrls, ExtCtrls, Mask, ToolEdit,
  Buttons, ImgList;

type
  TNewFromDOT = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    PageControl1: TPageControl;
    StandardShab: TTabSheet;
    ListView1: TListView;
    GroupBox2: TGroupBox;
    PrjName: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    IsDefault: TCheckBox;
    VarFileName: TEdit;
    primsheet: TTabSheet;
    ListView2: TListView;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton4: TSpeedButton;
    ModelTV: TTreeView;
    Label6: TLabel;
    Avtor: TEdit;
    Label7: TLabel;
    Dates: TDateEdit;
    Prim: TMemo;
    Label8: TLabel;
    Preview: TCheckBox;
    ShModel: TTable;
    ShModelName: TStringField;
    ShModelType: TFloatField;
    ShModelSPRType: TFloatField;
    ShModelN: TAutoIncField;
    ShModelSp1: TIntegerField;
    ShModelSp2: TIntegerField;
    ShModelComm: TStringField;
    ShModelMDate: TDateField;
    ShModelAvtor: TStringField;
    procedure FormActivate(Sender: TObject);
    procedure ListView1Changing(Sender: TObject; Item: TListItem;
      Change: TItemChange; var AllowChange: Boolean);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure FormDeactivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure PrjNameChange(Sender: TObject);
    procedure IsDefaultClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView2Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ListView2Changing(Sender: TObject; Item: TListItem;
      Change: TItemChange; var AllowChange: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure PreviewClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
    curshblname:string;
    curfilename:string;
    xxx:integer;
    autoinsert:boolean;
    classroot,proroot,reproot,bproot:TTreeNode;
    modelNumbers:array[0..100] of integer;
    msize:integer;
    procedure doPreview;
  public
    { Public declarations }
  end;

var
  NewFromDOT: TNewFromDOT;

implementation

{$R *.DFM}
uses fileutil,utils,compops,main, prnprv, Logs, appConst, Umessages;
procedure TNewFromDOT.FormActivate(Sender: TObject);
var i,found:integer;
    r:TSearchRec;
begin
i:=1;
setcurrentdir(appconst.sysinfo.datadir);
deletefile('sys\temp.$$$');
deletefile('sys\temp'+MBEXT);

autoinsert:=true;
found:=findfirst(appconst.sysinfo.dotpath+'*'+BDTEXT,faarchive,r);

ListView1.Items.Clear;
ListView1.items.BeginUpdate;
while found=0 do
begin
with ListView1.Items.Add do
begin
  caption:=CutFileExt(r.Name);
  subitems.Add(DateTimeTostr(trunc((FileDateToDateTime(r.Time)))));
end;
found:=findnext(r);
end;
findclose(r);
i:=1;
found:=findfirst(appconst.sysinfo.sampath+'*'+BDTEXT,faarchive,r);
ListView1.items.endUpdate;
ListView2.items.BeginUpdate;
ListView2.Items.Clear;
while found=0 do
begin
with ListView2.Items.Add do
begin
 caption:=CutFileExt(r.Name);
 subitems.Add(DateTimeTostr(trunc(FileDateToDateTime(r.Time))));
end;
found:=findnext(r);
end;
findclose(r);
ListView2.items.endUpdate;
autoinsert:=false;
if listview1.Items.Count>0 then
listview1.Selected:=listview1.Items[0];
if listview2.Items.Count>0 then
listview2.Selected:=listview2.Items[0];
Dates.date:=now;
PageControl1.activePage:=primsheet;
activecontrol:=prjName;

end;
procedure TNewFromDOT.ListView1Changing(Sender: TObject; Item: TListItem;
  Change: TItemChange; var AllowChange: Boolean);
begin
AllowChange:=not(item=nil);
end;

procedure TNewFromDOT.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
if autoinsert then exit;
ModelTV.enabled:=true;
modelTV.Items.BeginUpdate;
 classroot.DeleteChildren;
 proroot.DeleteChildren;
 reproot.DeleteChildren;
 bproot.DeleteChildren;

curfilename:=appconst.sysinfo.dotpath+Item.Caption;
ShModel.Active:=false;
if preview.checked then
begin
utils.copySTRfile(appconst.sysinfo.dotpath+Item.Caption+BDTEXT,'SYS\temp.$$$',OrgMasterMain.PB);
ShModel.TableName:='SYS\temp.$$$';
curshblname:=item.Caption;
dopreview;
end
else
 begin
 ModelTV.enabled:=false;
 end;
modelTV.Items.EndUpdate;
OrgMasterMain.PB.Progress:=0;
end;

procedure TNewFromDOT.FormDeactivate(Sender: TObject);

begin
ShModel.Active:=false;
setcurrentdir(appconst.sysinfo.datadir);
end;

procedure TNewFromDOT.Button1Click(Sender: TObject);
var   newComps,Folder:TTreeNode;
      Sname,DName:string;
begin
if PrjName.Text='' then
begin
MessageDlg(umessages.enterthename,mtError,[mbOk],0);
activecontrol:=prjName;
exit;
end;
if curfilename='' then
begin
 MessageDlg(umessages.selecttemplate,mtError,[mbOk],0);
exit;
end;
ShModel.Active:=false;
SName:=curfilename;
setCurrentDir(appconst.sysinfo.LocalDataDir);
if pos('DATA\',ansiuppercase(currCompDir))=1 then
 CurrCompDir:=Copy(CurrCompDir,6,length(CurrCompDir));
CurrCompDir:=ExpandFileName(CurrCompDir);
DName:=NormalDir(CurrCompDir)+normalfilename(VarFileNAme.Text);
if fileexists(Dname) then
begin
  MessageDlg(umessages.OverWriteError,mtError,[mbOK],0);
  activecontrol:=varfilename;
  exit;
end;
utils.copySTRfile(SName+BDTEXT,DName,OrgMasterMain.PB);

OrgMasterMain.Comp.Append;
OrgMasterMain.Comp.FieldByName('ItemName').AsString:=PrjName.Text;
OrgMasterMain.Comp.FieldByName('IsGroup').AsBoolean:=false;
OrgMasterMain.Comp.FieldByName('FileName').AsString:=extractfilename(DName);
OrgMasterMain.Comp.FieldByName('Comment').AsString:=prim.text;
if dates.date<>0 then
OrgMasterMain.Comp.FieldByName('CrDate').AsDateTime:=Dates.Date
else
OrgMasterMain.Comp.FieldByName('CrDate').AsDateTime:=Now;
if dates.date<>0 then
OrgMasterMain.Comp.FieldByName('MdfDate').AsDateTime:=Dates.Date
else
OrgMasterMain.Comp.FieldByName('MdfDate').AsDateTime:=Now;
OrgMasterMain.Comp.FieldByName('Tag').AsInteger:=CurrComp;
OrgMasterMain.Comp.FieldByName('Avtor').AsString:=avtor.Text;
OrgMasterMain.Comp.Post;
OrgMasterMain.Comp.Refresh;
Folder:=FindCompNode(OrgMasterMain.CompView,CurrComp);
NewComps:=OrgMasterMain.CompView.Items.AddChild(Folder,PrjName.Text);
New(PComp);
PComp.Tag:=CurrComp;
PComp.FileName:=ExtractFileName(DName);
PComp.IsGroup:=false;
//PComp.ParentGroup:=CurrComp;
PComp.N:=OrgMasterMain.Comp.FieldByName('N').AsInteger;

NewComps.Data:=PComp;
if  (pos(appconst.sysinfo.LocalDataDir,expandfilename(TPComp(Folder.Data)^.FileName))=1) then
begin
NewComps.ImageIndex:=1;
NewComps.SelectedIndex:=1;
end
else
begin
NewComps.ImageIndex:=5;
NewComps.SelectedIndex:=5;
end;
 OrgMasterMain.PB.Progress:=0;
Close;


end;

procedure TNewFromDOT.Button2Click(Sender: TObject);
begin
close;
end;



procedure TNewFromDOT.PrjNameChange(Sender: TObject);
begin
if IsDefault.Checked then
VarFileName.Text:=NormalFilename(PrjName.Text)+BPJEXT;
end;

procedure TNewFromDOT.IsDefaultClick(Sender: TObject);
begin
VarFileName.Enabled:=not IsDefault.Checked;
if IsDefault.Checked then
VarFileName.Text:=PrjName.Text+BPJEXT;

end;

procedure TNewFromDOT.FormCreate(Sender: TObject);
begin
inherited;
classroot:=ModelTV.Items[0];
proroot:=ModelTV.Items[2];
reproot:=ModelTV.Items[3];
bproot:=ModelTV.Items[1];
avtor.text:=appconst.sysinfo.defavtor;
end;

procedure TNewFromDOT.ListView2Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
if autoinsert then exit;
ModelTV.enabled:=true;
modelTV.Items.BeginUpdate;
 classroot.DeleteChildren;
 proroot.DeleteChildren;
 reproot.DeleteChildren;
 bproot.DeleteChildren;
ShModel.Active:=false;
curfilename:=appconst.sysinfo.sampath+Item.Caption;
if preview.checked then
begin
utils.copySTRfile(appconst.sysinfo.sampath+Item.Caption+BDTEXT,'sys\temp.$$$',OrgMasterMain.PB);
ShModel.TableName:='Sys\temp.$$$';
curshblname:=item.Caption;
dopreview;
end
else
begin
ModelTV.enabled:=false;
end;
modelTV.Items.EndUpdate;
OrgMasterMain.PB.Progress:=0;
end;

procedure TNewFromDOT.SpeedButton3Click(Sender: TObject);
begin
if (Sender as TSpeedButton).down then
 begin
 ListView1.ViewStyle:=vsIcon;
 ListView2.ViewStyle:=vsIcon;
 end;
end;

procedure TNewFromDOT.SpeedButton2Click(Sender: TObject);
begin
if (Sender as TSpeedButton).down then
 begin
 ListView1.ViewStyle:=vsSmallIcon;
 ListView2.ViewStyle:=vsSmallIcon;
 end;

end;

procedure TNewFromDOT.SpeedButton4Click(Sender: TObject);
begin
if (Sender as TSpeedButton).down then
 begin
 ListView1.ViewStyle:=vsReport;
 ListView2.ViewStyle:=vsReport;
 end;

end;

procedure TNewFromDOT.SpeedButton1Click(Sender: TObject);
begin
if (Sender as TSpeedButton).down then
 begin
 ListView1.ViewStyle:=vsList;
 ListView2.ViewStyle:=vsList;
 end;

end;

procedure TNewFromDOT.PageControl1Change(Sender: TObject);
begin
if (PageControl1.ActivePage=primsheet)and(listview2.Selected<>nil) then curshblname:=listview2.Selected.Caption;
if (PageControl1.ActivePage=StandardShab)and(listview1.Selected<>nil) then curshblname:=listview1.Selected.Caption;
end;

procedure TNewFromDOT.ListView2Changing(Sender: TObject; Item: TListItem;
  Change: TItemChange; var AllowChange: Boolean);
begin
allowchange:=not(item=nil);
end;


procedure TNewFromDOT.FormDestroy(Sender: TObject);
begin
autoinsert:=true;
end;

procedure TNewFromDOT.PreviewClick(Sender: TObject);
var c:TItemChange;
begin
c:=ctState;
if pagecontrol1.ActivePage=primsheet then listview2.OnChange(sender,ListView2.selected,c)
else
if pagecontrol1.ActivePage=standardShab then listview1.OnChange(sender,ListView1.selected,c);

end;

procedure TNewFromDOT.FormHide(Sender: TObject);
begin
setcurrentdir(appconst.sysinfo.datadir);
ShModel.active:=false;
deletefile('sys\temp.$$$');
deletefile('sys\temp'+MBEXT);
end;
procedure TNewFromDOT.doPreview;
var newnode:TTreeNode;
begin
msize:=0;
ModelTV.Items.BeginUpdate;
try
ShModel.Active:=true;
ShModel.first;
while not ShModel.eof do
 begin
 begin
 inc(msize);
 case ShModeltype.asinteger of
  SPRID: begin
     newnode:=ModelTV.Items.AddChildObject(classroot,ShModelName.asstring,@ModelNumbers[msize]);
     newnode.ImageIndex:=0;
     newnode.SelectedIndex:=0;
     end;
  PROID: begin
     newnode:=ModelTV.Items.AddChildObject(proroot,ShModelName.asstring,@ModelNumbers[msize]);
     if shModelSprType.asInteger=0 then
     begin
     newnode.ImageIndex:=1;
     newnode.SelectedIndex:=1;
     end
     else
     begin
     newnode.ImageIndex:=6;
     newnode.SelectedIndex:=6;
     end
     end;
  REPID: begin
     newnode:=ModelTV.Items.AddChildObject(reproot,ShModelName.asstring,@ModelNumbers[msize]);
     newnode.ImageIndex:=2;
     newnode.SelectedIndex:=2;
     end;
  NEWBPID: begin
     newnode:=ModelTV.Items.AddChildObject(bproot,ShModelName.asstring,@ModelNumbers[msize]);
     newnode.ImageIndex:=5;
     newnode.SelectedIndex:=5;
     end;
 end;
 end;
  ShModel.next;
 end;
ModelTV.FullExpand;
finally
ShModel.Active:=false;
ModelTV.Items.EndUpdate;
end

end;
end.
