unit otherLists;
{
(c) . .   1997,2006
}
{$INCLUDE Compmode.inc}

interface
uses classes,otherlisttypes,DB,DBTables,controls;
type

TIntList=class(TList)//   
protected
fSorted:boolean;
function getI(index:integer):integer;
procedure setI(index:integer;value:integer);
public
function add(value:integer):integer;
function IndexOf(value:integer):integer;
property intArray[index:integer]:integer read getI write setI;default;
property Sorted:boolean read fSorted;
procedure Sort;
procedure Clear;
end;
PSingle=^Single;
TFloatList=class(TList) //   
protected
function getF(index:integer):single;
procedure setF(index:integer;value:single);
public
function add(value:single):integer;
procedure delete(index:integer);
procedure Clear;
destructor Destroy;override;
property FloatArray[index:integer]:single read getF write setF;default;
procedure Assign(source:TFloatList);
end;
THistory=class  //   
private
 fBData,fFData:TIntList;
 fData:integer;
public
 function Back:integer;
 function Forward:integer;
 function CanBack:boolean;
 function CanForward:boolean;
 procedure Append(id:integer);
 procedure Clear;
 constructor Create;
 destructor Destroy;override;
end;
procedure push(s:string;data:integer;level:integer);
function Pop(n:integer):integer;
function PopL(level:integer):integer;
procedure FloodOut(l:TStrings);
procedure InitCache;
procedure ClearCache;
procedure CloseCache;
procedure addComment(s:TStrings);
procedure addCommentLine(s:String);

type TCashRecord =Record
                   level,o:integer;
                  end;
     PCashRecord=^TCashRecord;

var
    linesCash:TSTrings;
    cashPtr,curlevel:integer;

implementation
uses inifiles,utils,graphics,logs,sysutils,fileutil;
procedure push(s:string;data:integer;level:integer);
var d:PCashRecord;
begin
inc(cashPtr);
new(d);
d^.level:=level;
d^.o:=data;
linesCash.AddObject(s,TObject(d));
end;
procedure addCommentLine(s:String);
var d:PCashRecord;
begin
inc(cashPtr);
new(d);
d^.level:=-1;
d^.o:=0;
linesCash.AddObject(s,TObject(d));
end;

procedure addComment(s:TStrings);
var i:integer;
begin
 for i:=0 to s.Count-1 do
 begin
 AddCommentLine(s[i]);
  end;
end;
function PopL(level:integer):integer;
var i:integer;
    d:PCashRecord;
begin
result:=level+1;
while (cashPtr>0)and(i>0) do
begin
d:=PCashRecord(LinesCash.Objects[cashPtr-1]);
if (d^.level<level)and(d^.level>=0) then break;
if d^.level<>-1 then begin dec(i); result:=d^.level;end;
dispose(d);
linesCash.Delete(cashPtr-1);
dec(cashPtr);
end;

if cashPtr<0 then cashPtr:=0;

end;

function Pop(n:integer):integer;
var i:integer;
    d:PCashRecord;
begin
i:=n;
result:=0;
while (cashPtr>0)and(i>0) do
begin
d:=PCashRecord(LinesCash.Objects[cashPtr-1]);
if d^.level<>-1 then begin dec(i); result:=d^.level;end;
dispose(d);
linesCash.Delete(cashPtr-1);
dec(cashPtr);
end;

if cashPtr<0 then cashPtr:=0;

end;
procedure FloodOut(l:TStrings);
var i:integer;
begin

 for i:=1 to cashPtr do
 begin
  l.AddObject(linesCash[i-1],pointer(PCashRecord(linesCash.Objects[i-1])^.o));
end;
ClearCache;
end;
procedure InitCache;
begin
LinesCash:=TStringList.Create;
ClearCache;
end;
procedure ClearCache;
var i:integer;
begin
CashPtr:=0;
Curlevel:=-1;
for i:=LinesCash.count-1 downto 0 do
dispose(PCashRecord(linesCash.Objects[i]));
LinesCash.clear;
end;
procedure CloseCache;
begin
ClearCache;
LinesCash.Free;
end;
function TIntList.getI(index:integer):integer;
begin
result:=integer(items[index]);
end;
procedure TIntList.setI(index:integer;value:integer);
begin
items[index]:=pointer(value);
end;
function TIntList.add(value:integer):integer;
begin
result:=inherited add(pointer(value));
fsorted:=false;
end;
function TIntList.IndexOf(value:integer):integer;
function findRange(RStart,RFinish:integer;Value:integer):integer;
var Middle:integer;
begin

 if RFinish-RStart<3 then
 begin
 result:=-1;
  for Middle:=RStart to RFinish do
  if integer(Items[middle])=value then
   begin
    result:=middle;
    exit;
   end;
 end
 else
 begin
 Middle:=(RStart+RFinish)div 2;
 if integer(Items[middle])>Value then
  result:=findrange(RStart,Middle,Value)
 else
 if integer(Items[middle])<Value then
  result:=findrange(Middle,RFinish,Value)
 else
  result:=middle;
 end;
end;
begin
result:=-1;
if not sorted then
result :=inherited indexof(pointer(value))
else
 if count>0 then
 begin
 if (value<integer(items[0]))or
    (value>integer(items[Count-1])) then
    begin
     result:=-1;
     exit;
    end;
   result:=findrange(0,Count-1,value);
 end;
end;
procedure TIntList.Sort;
begin
inherited Sort(utils.pointerCompare);
fsorted:=true;
end;
procedure TIntList.Clear;
begin
inherited clear;
fsorted:=true;
end;

function THistory.Back:integer;
begin
 if FBData.Count>0 then
 begin
  result:=FBData[FBData.count-1];
  FBData.delete(FBData.Count-1);
  FFData.add(fData);
  fData:=result;
 end
 else result:=-1;
end;
function THistory.Forward:integer;
begin
if FFData.Count>0 then
begin
  result:=FFData[FFData.count-1];
  FFData.delete(FFData.Count-1);
  FBData.add(fData);
  fData:=result;
end
else
result:=-1;
end;
function THistory.CanBack:boolean;
begin
 result:=FBData.count>0;
end;
function THistory.CanForward:boolean;
begin
 result:=FFData.count>0;
end;
procedure THistory.Append(id:integer);
begin
if id=0 then exit;
 if fData>=0 then
 FBData.add(fData);
 fData:=id;
 FFData.clear;
end;
procedure THistory.Clear;
begin
 fBData.clear;
 fFData.clear;
 fData:=-1;
end;
constructor THistory.Create;
begin
 inherited Create;
 fBData:=TIntList.Create;
 fFData:=TIntList.Create;
 fData:=-1;
end;
destructor THistory.Destroy;
begin
 fBData.free;
 fFData.free;
 inherited Destroy;
end;
function TFloatList.getF(index:integer):Single;
var p:Psingle;
begin
p:=Items[index];
if p<>nil then result:=p^
          else result:=0;
end;
procedure TFloatList.setF(index:integer;value:Single);
var p:PSingle;
begin
p:=Items[index];
if p<>nil then p^:=value
          else begin new(p); p^:=value; Items[index]:=p;end;
end;
function TFloatList.add(value:Single):integer;
var p:PSingle;
begin
 new(p);
 p^:=value;
 result:=inherited Add(p);
end;
procedure TFloatList.delete(index:integer);
var p:PSingle;
begin
 p:=Items[index];
 dispose(p);
 inherited Delete(index);
end;
procedure TFloatList.Clear;
var i:integer;
    p:PSingle;
begin
 for i:=0 to Count-1 do
 begin
  p:=Items[i];
  dispose(p);
 end;
 inherited Clear; 
end;
destructor TFloatList.Destroy;
begin
 Clear;
 inherited Destroy;
end;
procedure TFloatList.Assign(source:TFloatList);
var i:integer;
begin
 if self=source then exit;
 Clear;
 for i:=0 to Source.count-1 do
  Add(Source.FloatArray[i]);
end;

end.
