Unit StyleStr;

{ Modified 14-03-2001 }
{
(c) . 1997,2006
}
{$INCLUDE Compmode.inc}
Interface

Uses  Windows,SysUtils,StyleDef;


Type

       PSTStyleRecord = ^TSTStyleRecord;
       TSTStyleRecord = packed record
          StyleName:TStyleString; { Style Name in CSS }

          { Font Setting }
          FontEnabled:Boolean;    { Enable Font-family subtag }
          Font:TStyleString;      { font-family: "Arial"; }

          FontSizeEnabled:Boolean;      { Enable Font-Size subtag }
          FontSize:Word;                { font-size : 14pt; }
          Flags:Word;                   { For A.Zablozky only }
          FontSizeUnits:TFontSizeUnits; { w/o fsu,smallcaps }

          FontWeightEnabled:Boolean;  { Enable Font-Weight subtag }
          FontWeight:TFontWeight;     { font-weight : extra-light; }

          FontStyleEnabled:Boolean;   { Enable font-style subtag }
          FontStyle:TFontStyle;       { font-style : italic; }

          TextDecorationEnabled:Boolean; { Enable text-decoration subtag }
          TextDecoration:TTextDecoration; { text-decoration : underline; }

          TextTransformEnabled:Boolean;   { Enabled text-transform subtag }
          TextTransform:TTextTransform;   { text-transform : capitalize;  }

          FontColorEnabled:Boolean;       { enable color subtag }
          FontColor:DWORD;                { color : #0099FF; }

          BackColorEnabled:Boolean;       { enable background subtag }
          BackColor:DWORD;                { background : #00FF00; }

          { Align Settings }
          TextIndentEnabled:Boolean;
          TextIndent:Integer;              { text-indent : 8pt; }

          LeadingSpaceEnabled:Boolean;
          LeadingSpace:Integer;           { leading-space : 12pt; }

          WordSpacingEnabled:Boolean;
          WordSpacing:Integer;            { word-spacing : 8pt; }

          LetterSpacingEnabled:Boolean;
          LetterSpacing:Integer;          { letter-spacing : 10pt; }

          VerticalAlignEnabled:Boolean;
          VerticalAlign:TVerticalAlign;   { vertical-align : baseline; }

          TextAlignEnabled:Boolean;
          TextAlign:TTextAlign;           { text-align : center; }

          { Position settings }

          PositionEnabled:Boolean;
          Position:TPosition;             { position : relative; }

          LeftPosEnabled:Boolean;
          LeftPos:Integer;                { left : 8pt; }
          LeftUnits:TFontSizeUnits;

          TopPosEnabled:Boolean;
          TopPos:Integer;                 { top : 8pt; }
          TopUnits:TFontSizeUnits;

          WidthPosEnabled:Boolean;
          WidthPos:Integer;               { width : 8pt; }
          WidthUnits:TFontSizeUnits;

          HeightPosEnabled:Boolean;
          HeightPos:Integer;              { height : 8pt; }
          HeightUnits:TFontSizeUnits;

          ZIndexEnabled:Boolean;
          ZIndex:Integer;                 { z-index : 8; }

          OverflowEnabled:Boolean;
          Overflow:TOverflow;             { overflow : visible; }

          { Borders setting }
          LeftMarginEnabled:Boolean;
          LeftMargin:Integer;             { margin-left : 1pt; }
          LeftMarginUnits:TFontSizeUnits; { in @page }

          RightMarginEnabled:Boolean;
          RightMargin:Integer;             { margin-right : 1pt; }
          RightMarginUnits:TFontSizeUnits; { in @page }

          BottomMarginEnabled:Boolean;
          BottomMargin:Integer;             { margin-bottom : 1pt; }
          BottomMarginUnits:TFontSizeUnits; { in @page }

          TopMarginEnabled:Boolean;
          TopMargin:Integer;                { margin-top : 1pt; }
          TopMarginUnits:TFontSizeUnits;    { in @page }

          LeftBorderEnabled:Boolean;
          LeftBorder:TBorderType;            { border-left : dotted; }

          RightBorderEnabled:Boolean;
          RightBorder:TBorderType;           { border-right : dotted; }

          TopBorderEnabled:Boolean;
          TopBorder:TBorderType;             { border-top : dotted; }

          BottomBorderEnabled:Boolean;
          BottomBorder:TBorderType;           { border-bottom : dotted; }

          { Filter setting }

          TransitionEnabled:Boolean;
          TransitionType:Integer;              { filter : revealtrans(duration=1 transition=1); }
          TransitionDuration:Integer;          { types 0..23 }

          { Special effects settings - may be not need }


          { Printing settings - only with @page StyleName }

          MarksEnabled:Boolean;
          MarksType:TMarksType;               { marks : crop; }

          OrientationEnabled:Boolean;
          Orientation:TOrientation;           { size : portrait; }

          PBBEnabled:Boolean;
          PageBreakBefore:TPageBreak;         { page-break-before : right; }

          PBAEnabled:Boolean;
          PageBreakAfter:TPageBreak;          { page-break-after : right; }

          { Advanced settings }
          LineHeightEnabled:Boolean;
          LineHeight:Integer;                 { line-height : 8pt; }
          LineHeightUnits:TFontSizeUnits;

          PaddingEnabled:Boolean;
          Padding:Integer;
          PaddingUnits:TFontSizeUnits;       { padding : 8pt; }

          VisibilityEnabled:Boolean;
          Visibility:TVisibilityType;        { visibility : inherit; }

          ListStyleEnabled:Boolean;
          ListStyle:TListStyle;              { list-style : circle; }

          FloatEnabled:Boolean;
          FloatType:TDirectionType;          { float : left }

          ClearEnabled:Boolean;
          ClearType:TDirectionType;          { clear : left }

          WhiteSpaceEnabled:Boolean;
          WhiteSpace:TWhiteSpace;            { white-space : nowrap }

          ShowSystemChars:Boolean;           { Show/hide system chars }

          StartNewTable:Boolean;
          StartNewRow:Boolean;
          StartNewColumn:Boolean;
          ShowBorder:Boolean;                { Only if StartNewTable enabled }
          TableWidth:Word;
          ColumnWidth:Word;

          { Reserved for future }

          ShowColumnHeader:Boolean;
          ColumnHeader:TStyleString;
          Show2ColumnHeader:Boolean;
          Style2ColumnHeader:TStyleString;

          Reserved2:TReservedString;

          Style2Column:Boolean;               { Subdivive style to 2 columns }
          FirstColumnWidth:WORD;

          ShowColumnHeaderAtLevel2:Boolean;

          EnableHeaderHeight:Boolean;
          HeaderHeight:WORD;

          Reserved4:Boolean;
          ID:DWORD;
          Reserved6:DWORD;
          Reserved7:DWORD;
          Reserved8:DWORD;
          Reserved9:DWORD;

       end;


       POldSTStyleRecord = ^TOldSTStyleRecord;
       TOldSTStyleRecord = packed record
          StyleName:TStyleString; { Style Name in CSS }

          { Font Setting }
          FontEnabled:Boolean;    { Enable Font-family subtag }
          Font:TStyleString;      { font-family: "Arial"; }

          FontSizeEnabled:Boolean;      { Enable Font-Size subtag }
          FontSize:Word;                { font-size : 14pt; }
          Flags:Word;                   { For A.Zablozky only }
          FontSizeUnits:TFontSizeUnits; { w/o fsu,smallcaps }

          FontWeightEnabled:Boolean;  { Enable Font-Weight subtag }
          FontWeight:TFontWeight;     { font-weight : extra-light; }

          FontStyleEnabled:Boolean;   { Enable font-style subtag }
          FontStyle:TFontStyle;       { font-style : italic; }

          TextDecorationEnabled:Boolean; { Enable text-decoration subtag }
          TextDecoration:TTextDecoration; { text-decoration : underline; }

          TextTransformEnabled:Boolean;   { Enabled text-transform subtag }
          TextTransform:TTextTransform;   { text-transform : capitalize;  }

          FontColorEnabled:Boolean;       { enable color subtag }
          FontColor:DWORD;                { color : #0099FF; }

          BackColorEnabled:Boolean;       { enable background subtag }
          BackColor:DWORD;                { background : #00FF00; }

          { Align Settings }
          TextIndentEnabled:Boolean;
          TextIndent:Integer;              { text-indent : 8pt; }

          LeadingSpaceEnabled:Boolean;
          LeadingSpace:Integer;           { leading-space : 12pt; }

          WordSpacingEnabled:Boolean;
          WordSpacing:Integer;            { word-spacing : 8pt; }

          LetterSpacingEnabled:Boolean;
          LetterSpacing:Integer;          { letter-spacing : 10pt; }

          VerticalAlignEnabled:Boolean;
          VerticalAlign:TVerticalAlign;   { vertical-align : baseline; }

          TextAlignEnabled:Boolean;
          TextAlign:TTextAlign;           { text-align : center; }

          { Position settings }

          PositionEnabled:Boolean;
          Position:TPosition;             { position : relative; }

          LeftPosEnabled:Boolean;
          LeftPos:Integer;                { left : 8pt; }
          LeftUnits:TFontSizeUnits;

          TopPosEnabled:Boolean;
          TopPos:Integer;                 { top : 8pt; }
          TopUnits:TFontSizeUnits;

          WidthPosEnabled:Boolean;
          WidthPos:Integer;               { width : 8pt; }
          WidthUnits:TFontSizeUnits;

          HeightPosEnabled:Boolean;
          HeightPos:Integer;              { height : 8pt; }
          HeightUnits:TFontSizeUnits;

          ZIndexEnabled:Boolean;
          ZIndex:Integer;                 { z-index : 8; }

          OverflowEnabled:Boolean;
          Overflow:TOverflow;             { overflow : visible; }

          { Borders setting }
          LeftMarginEnabled:Boolean;
          LeftMargin:Integer;             { margin-left : 1pt; }
          LeftMarginUnits:TFontSizeUnits; { in @page }

          RightMarginEnabled:Boolean;
          RightMargin:Integer;             { margin-right : 1pt; }
          RightMarginUnits:TFontSizeUnits; { in @page }

          BottomMarginEnabled:Boolean;
          BottomMargin:Integer;             { margin-bottom : 1pt; }
          BottomMarginUnits:TFontSizeUnits; { in @page }

          TopMarginEnabled:Boolean;
          TopMargin:Integer;                { margin-top : 1pt; }
          TopMarginUnits:TFontSizeUnits;    { in @page }

          LeftBorderEnabled:Boolean;
          LeftBorder:TBorderType;            { border-left : dotted; }

          RightBorderEnabled:Boolean;
          RightBorder:TBorderType;           { border-right : dotted; }

          TopBorderEnabled:Boolean;
          TopBorder:TBorderType;             { border-top : dotted; }

          BottomBorderEnabled:Boolean;
          BottomBorder:TBorderType;           { border-bottom : dotted; }

          { Filter setting }

          TransitionEnabled:Boolean;
          TransitionType:Integer;              { filter : revealtrans(duration=1 transition=1); }
          TransitionDuration:Integer;          { types 0..23 }

          { Special effects settings - may be not need }


          { Printing settings - only with @page StyleName }

          MarksEnabled:Boolean;
          MarksType:TMarksType;               { marks : crop; }

          OrientationEnabled:Boolean;
          Orientation:TOrientation;           { size : portrait; }

          PBBEnabled:Boolean;
          PageBreakBefore:TPageBreak;         { page-break-before : right; }

          PBAEnabled:Boolean;
          PageBreakAfter:TPageBreak;          { page-break-after : right; }

          { Advanced settings }
          LineHeightEnabled:Boolean;
          LineHeight:Integer;                 { line-height : 8pt; }
          LineHeightUnits:TFontSizeUnits;

          PaddingEnabled:Boolean;
          Padding:Integer;
          PaddingUnits:TFontSizeUnits;       { padding : 8pt; }

          VisibilityEnabled:Boolean;
          Visibility:TVisibilityType;        { visibility : inherit; }

          ListStyleEnabled:Boolean;
          ListStyle:TListStyle;              { list-style : circle; }

          FloatEnabled:Boolean;
          FloatType:TDirectionType;          { float : left }

          ClearEnabled:Boolean;
          ClearType:TDirectionType;          { clear : left }

          WhiteSpaceEnabled:Boolean;
          WhiteSpace:TWhiteSpace;            { white-space : nowrap }


       end;


     PSTFileHeader =^TSTFileHeader;
     TSTFileHeader = packed record
      dwSignature:DWORD;      { File signature }
      dwCSSCount:Integer;     { CSS Count }
     end;

     TSTStreamOpenMode = ( stRead,stWrite);

      TStyleStream = class
       private
        FFileName:String;                { File Name }
        FFile:File;                      { Internal variable }
        FBuf:PByte;                      { Internal variable }
        FFileSize:DWORD;
        FOpened:Boolean;
        FMode:TSTStreamOpenMode;
        FCSSCount:Integer;
        FOldFormat:Boolean;
        procedure    AssignCSStoST(var CSS:PStyleRecord;var ST:PSTStyleRecord);
        procedure    AssignSTtoCSS(var ST:PSTStyleRecord;var CSS:PStyleRecord);
        procedure    AssignOldSTtoCSS(var ST:POldSTStyleRecord;var CSS:PStyleRecord);
        function    ReadFileHeader:TSTFileHeader;
        procedure   WriteFileHeader(Value: TSTFileHeader);
        function    CalcCSSCount(Var CSSList:PStyleRecord):Integer;
        function    WriteCSSList(var CSSList:PStyleRecord):Boolean;
        function    ReadCSSList(var CSSList:PStyleRecord):Boolean;
       public
        constructor Create;
        destructor  Destroy; override;
        function    OpenStream(oFileName:String;mode:TSTStreamOpenMode):Boolean;
        procedure   CloseStream;
        function   WriteStream(Var CSSList:PStyleRecord):Boolean;
        function   ReadStream(Var CSSList:PStyleRecord):Boolean;
        procedure    ClearCSSList(var CSSList:PStyleRecord);
      end;

Const    OldSTSignature=$54535343;
         STSignature=$544D4641;
Procedure ClearStyle(style:PStyleRecord);
Procedure AddStyle(style,ss:PStyleRecord);
procedure CombineStyles(Styles:array of PStyleRecord;Combo:PStyleRecord);
Implementation

function   TStyleStream.WriteCSSList(Var CSSList:PStyleRecord):Boolean;
Var tmp:PStyleRecord;
    tmpST:PSTStyleRecord;
    Ptr:PByte;
 begin
    Result:=False;
    tmp:=CSSList;
    Ptr:=FBuf;
    inc(Ptr,sizeOf(TSTFileHeader));
    tmpST:=PSTStyleRecord(Ptr);
    While (tmp<>nil) do
      begin
        AssignCSStoST(tmp,tmpST);
        inc(tmpST);
        tmp:=tmp^.Next;
      end;
    Result:=True;
 end;

function   TStyleStream.ReadCSSList(Var CSSList:PStyleRecord):Boolean;
Var tmp,tmp1,tmp2:PSTStyleRecord;
    tmpo,tmp1o,tmp2o:POldSTStyleRecord;
    i:Integer;
    tmpCSS,tmpCSSOld:PStyleRecord;
    Ptr:PByte;
 begin
    Result:=False;
    ClearCSSList(CSSList);
    if (FCSSCount<=0) then Exit;
    if FOldFormat then
      begin
    { Start read old CSS List }
    tmpo:=POldSTStyleRecord(AllocMem(FCSSCount*SizeOf(TOldSTStyleRecord)));
    tmp1o:=tmpo;
    tmpCSS:=nil;
    tmpCSSOld:=nil;
    Ptr:=FBuf;
    inc(Ptr,sizeOf(TSTFileHeader));
    tmp2o:=POldSTStyleRecord(Ptr);
    System.Move(tmp2o^,tmpo^,FCSSCount*SizeOf(TOldSTStyleRecord));
    for i:=0 to (FCSSCount-1) do
     begin
        tmpCSS:=PStyleRecord(AllocMem(SizeOf(TStyleRecord)));
       AssignOldSTtoCSS(tmp1o,tmpCSS);
              if (i>=23)and(i<=37) then
       tmpcss^.StyleName:='   '+inttostr(i-22)
       else if i=57 then
       tmpcss^.StyleName:='';

       tmpCSS^.Next:=nil;
       if (i=0) then
          begin
            CSSList:=tmpCSS;
          end
        else
          begin
            tmpCSSOld^.Next:=TmpCSS;
          end;
       tmpCSSOld:=tmpCSS;
       inc(tmp1o);
     end;
    FreeMem(tmpo,FCSSCount*SizeOf(TOldSTStyleRecord));
    { End Read Old CSS List }
      end
    else
    begin
    { Start Read New CSS List }
    tmp:=PSTStyleRecord(AllocMem(FCSSCount*SizeOf(TSTStyleRecord)));
    tmp1:=tmp;
    tmpCSS:=nil;
    tmpCSSOld:=nil;
    Ptr:=FBuf;
    inc(Ptr,sizeOf(TSTFileHeader));
    tmp2:=PSTStyleRecord(Ptr);
    System.Move(tmp2^,tmp^,FCSSCount*SizeOf(TSTStyleRecord));
    for i:=0 to (FCSSCount-1) do
     begin
       tmpCSS:=PStyleRecord(AllocMem(SizeOf(TStyleRecord)));
       AssignSTtoCSS(tmp1,tmpCSS);
       if (i>=23)and(i<=37) then
       tmpcss^.StyleName:='   '+inttostr(i-22)
       else if i=57 then
       tmpcss^.StyleName:=''
       else
       if (i=58)and(tmpCSS^.LeadingSpace=150) then
        tmpCSS^.LeadingSpace:=0;
       tmpCSS^.Next:=nil;
       if (i=0) then
          begin
            CSSList:=tmpCSS;
          end
        else
          begin
            tmpCSSOld^.Next:=TmpCSS;
          end;
       tmpCSSOld:=tmpCSS;
       inc(tmp1);
     end;
    FreeMem(tmp,FCSSCount*SizeOf(TSTStyleRecord));
    { End Read New CSS List }
    end;
    Result:=True;
 end;

procedure   TStyleStream.ClearCSSList(var CSSList:PStyleRecord);
Var tmp,tmp1:PStyleRecord;
 begin
   tmp:=CSSList;
   tmp1:=nil;
   While (tmp<>nil) do
    begin
      tmp1:=tmp^.Next;
      FreeMem(tmp,SizeOf(TStyleRecord));
      tmp:=nil;                          { BugFix for Delphi 3.0 }
      tmp:=tmp1;
    end;
 end;

procedure    TStyleStream.AssignCSStoST(var CSS:PStyleRecord;var ST:PSTStyleRecord);
  begin
          ST^.ID:=                    CSS^.ID;
          ST^.StyleName:=             CSS^.StyleName;
          ST^.FontEnabled:=           CSS^.FontEnabled;
          ST^.Font:=                  CSS^.Font;
          ST^.FontSizeEnabled:=       CSS^.FontSizeEnabled;
          ST^.FontSize:=              CSS^.FontSize;
          ST^.Flags:=                 CSS^.Flags;
          ST^.FontSizeUnits:=         CSS^.FontSizeUnits;
          ST^.FontWeightEnabled:=     CSS^.FontWeightEnabled;
          ST^.FontWeight:=            CSS^.FontWeight;
          ST^.FontStyleEnabled:=      CSS^.FontStyleEnabled;
          ST^.FontStyle:=             CSS^.FontStyle;
          ST^.TextDecorationEnabled:= CSS^.TextDecorationEnabled;
          ST^.TextDecoration:=        CSS^.TextDecoration;
          ST^.TextTransformEnabled:=  CSS^.TextTransformEnabled;
          ST^.TextTransform:=         CSS^.TextTransform;
          ST^.FontColorEnabled:=      CSS^.FontColorEnabled;
          ST^.FontColor:=             CSS^.FontColor;
          ST^.BackColorEnabled:=      CSS^.BackColorEnabled;
          ST^.BackColor:=             CSS^.BackColor;
          ST^.TextIndentEnabled:=     CSS^.TextIndentEnabled;
          ST^.TextIndent:=            CSS^.TextIndent;
          ST^.LeadingSpaceEnabled:=   false;
          ST^.LeadingSpace:=          0;
          ST^.WordSpacingEnabled:=    CSS^.WordSpacingEnabled;
          ST^.WordSpacing:=           CSS^.WordSpacing;
          ST^.LetterSpacingEnabled:=  CSS^.LetterSpacingEnabled;
          ST^.LetterSpacing:=         CSS^.LetterSpacing;
          ST^.VerticalAlignEnabled:=  CSS^.VerticalAlignEnabled;
          ST^.VerticalAlign:=         CSS^.VerticalAlign;
          ST^.TextAlignEnabled:=      CSS^.TextAlignEnabled;
          ST^.TextAlign:=             CSS^.TextAlign;
          ST^.PositionEnabled:=       false;
          ST^.LeftPosEnabled:=        false;
          ST^.LeftPos:=               0;
          ST^.LeftUnits:=             fsuPt;
          ST^.TopPosEnabled:=         false;
          ST^.TopPos:=                0;
          ST^.TopUnits:=              fsuPt;
          ST^.WidthPosEnabled:=       false;
          ST^.WidthPos:=              0;
          ST^.WidthUnits:=            fsuPt;
          ST^.HeightPosEnabled:=      false;
          ST^.HeightPos:=             0;
          ST^.HeightUnits:=           fsuPt;
          ST^.ZIndexEnabled:=         false;
          ST^.ZIndex:=                0;
          ST^.OverflowEnabled:=       false;
          ST^.LeftMarginEnabled:=     CSS^.LeftMarginEnabled;
          ST^.LeftMargin:=            CSS^.LeftMargin;
          ST^.LeftMarginUnits:=       CSS^.LeftMarginUnits;
          ST^.RightMarginEnabled:=    CSS^.RightMarginEnabled;
          ST^.RightMargin:=           CSS^.RightMargin;
          ST^.RightMarginUnits:=      CSS^.RightMarginUnits;
          ST^.BottomMarginEnabled:=   CSS^.BottomMarginEnabled;
          ST^.BottomMargin:=          CSS^.BottomMargin;
          ST^.BottomMarginUnits:=     CSS^.BottomMarginUnits;
          ST^.TopMarginEnabled:=      CSS^.TopMarginEnabled;
          ST^.TopMargin:=             CSS^.TopMargin;
          ST^.TopMarginUnits:=        CSS^.TopMarginUnits;
          ST^.LeftBorderEnabled:=     CSS^.LeftBorderEnabled;
          ST^.LeftBorder:=            CSS^.LeftBorder;
          ST^.RightBorderEnabled:=    CSS^.RightBorderEnabled;
          ST^.RightBorder:=           CSS^.RightBorder;
          ST^.TopBorderEnabled:=      CSS^.TopBorderEnabled;
          ST^.TopBorder:=             CSS^.TopBorder;
          ST^.BottomBorderEnabled:=   CSS^.BottomBorderEnabled;
          ST^.BottomBorder:=          CSS^.BottomBorder;
          ST^.MarksEnabled:=          CSS^.MarksEnabled;
          ST^.MarksType:=             CSS^.MarksType;
          ST^.OrientationEnabled:=    false;
          ST^.PBBEnabled:=            CSS^.PBBEnabled;
          ST^.PageBreakBefore:=       CSS^.PageBreakBefore;
          ST^.PBAEnabled:=            CSS^.PBAEnabled;
          ST^.PageBreakAfter:=        CSS^.PageBreakAfter;
          ST^.LineHeightEnabled:=     false;
          ST^.LineHeight:=            0;
          ST^.LineHeightUnits:=       fsuPt;
          ST^.PaddingEnabled:=        false;
          ST^.Padding:=               0;
          ST^.PaddingUnits:=          fsuPt;
          ST^.VisibilityEnabled:=     false;
          ST^.ListStyleEnabled:=      CSS^.ListStyleEnabled;
          ST^.ListStyle:=             CSS^.ListStyle;
          ST^.FloatEnabled:=          false;
          ST^.FloatType:=             dtLeft;
          ST^.ClearEnabled:=          false;
          ST^.ClearType:=             dtLeft;
          ST^.WhiteSpaceEnabled:=     CSS^.WhiteSpaceEnabled;
          ST^.WhiteSpace:=            CSS^.WhiteSpace;
          ST^.ShowSystemChars:=       CSS^.ShowSystemChars;
          ST^.StartNewTable:=         false;
          ST^.StartNewRow:=           false;
          ST^.StartNewColumn:=        false;
          ST^.ShowBorder:=            false;
          ST^.TableWidth:=            0;
          ST^.ColumnWidth:=           0;
          ST^.Style2Column:=          false;
          ST^.FirstColumnWidth:=      0;
          ST^.ShowColumnHeader:=      false;
          ST^.ColumnHeader:=          '';
          ST^.Show2ColumnHeader:=     false;
          ST^.Style2ColumnHeader:=    '';
          ST^.HeaderHeight:=          0;
          ST^.EnableHeaderHeight:=    false;
          ST^.ShowColumnHeaderAtLevel2:=false;

  end;

procedure    TStyleStream.AssignOldSTtoCSS(var ST:POldSTStyleRecord;var CSS:PStyleRecord);
  begin
          CSS^.StyleName:=             ST^.StyleName;
          CSS^.FontEnabled:=           ST^.FontEnabled;
          CSS^.Font:=                  ST^.Font;
          CSS^.FontSizeEnabled:=       ST^.FontSizeEnabled;
          CSS^.FontSize:=              ST^.FontSize;
          CSS^.Flags:=                 ST^.Flags;
          CSS^.FontSizeUnits:=         ST^.FontSizeUnits;
          CSS^.FontWeightEnabled:=     ST^.FontWeightEnabled;
          CSS^.FontWeight:=            ST^.FontWeight;
          CSS^.FontStyleEnabled:=      ST^.FontStyleEnabled;
          CSS^.FontStyle:=             ST^.FontStyle;
          CSS^.TextDecorationEnabled:= ST^.TextDecorationEnabled;
          CSS^.TextDecoration:=        ST^.TextDecoration;
          CSS^.TextTransformEnabled:=  ST^.TextTransformEnabled;
          CSS^.TextTransform:=         ST^.TextTransform;
          CSS^.FontColorEnabled:=      ST^.FontColorEnabled;
          CSS^.FontColor:=             ST^.FontColor;
          CSS^.BackColorEnabled:=      ST^.BackColorEnabled;
          CSS^.BackColor:=             ST^.BackColor;
          CSS^.TextIndentEnabled:=     ST^.TextIndentEnabled;
          CSS^.TextIndent:=            ST^.TextIndent;
          CSS^.LeadingSpaceEnabled:=   false;
          CSS^.LeadingSpace:=          0;
          CSS^.WordSpacingEnabled:=    ST^.WordSpacingEnabled;
          CSS^.WordSpacing:=           ST^.WordSpacing;
          CSS^.LetterSpacingEnabled:=  ST^.LetterSpacingEnabled;
          CSS^.LetterSpacing:=         ST^.LetterSpacing;
          CSS^.VerticalAlignEnabled:=  ST^.VerticalAlignEnabled;
          CSS^.VerticalAlign:=         ST^.VerticalAlign;
          CSS^.TextAlignEnabled:=      ST^.TextAlignEnabled;
          CSS^.TextAlign:=             ST^.TextAlign;
          CSS^.LeftMarginEnabled:=     ST^.LeftMarginEnabled;
          CSS^.LeftMargin:=            ST^.LeftMargin;
          CSS^.LeftMarginUnits:=       ST^.LeftMarginUnits;
          CSS^.RightMarginEnabled:=    ST^.RightMarginEnabled;
          CSS^.RightMargin:=           ST^.RightMargin;
          CSS^.RightMarginUnits:=      ST^.RightMarginUnits;
          CSS^.BottomMarginEnabled:=   ST^.BottomMarginEnabled;
          CSS^.BottomMargin:=          ST^.BottomMargin;
          CSS^.BottomMarginUnits:=     ST^.BottomMarginUnits;
          CSS^.TopMarginEnabled:=      ST^.TopMarginEnabled;
          CSS^.TopMargin:=             ST^.TopMargin;
          CSS^.TopMarginUnits:=        ST^.TopMarginUnits;
          CSS^.LeftBorderEnabled:=     ST^.LeftBorderEnabled;
          CSS^.LeftBorder:=            ST^.LeftBorder;
          CSS^.RightBorderEnabled:=    ST^.RightBorderEnabled;
          CSS^.RightBorder:=           ST^.RightBorder;
          CSS^.TopBorderEnabled:=      ST^.TopBorderEnabled;
          CSS^.TopBorder:=             ST^.TopBorder;
          CSS^.BottomBorderEnabled:=   ST^.BottomBorderEnabled;
          CSS^.BottomBorder:=          ST^.BottomBorder;
          CSS^.MarksEnabled:=          ST^.MarksEnabled;
          CSS^.MarksType:=             ST^.MarksType;
          CSS^.OrientationEnabled:=    ST^.OrientationEnabled;
          CSS^.Orientation:=           ST^.Orientation;
          CSS^.PBBEnabled:=            ST^.PBBEnabled;
          CSS^.PageBreakBefore:=       ST^.PageBreakBefore;
          CSS^.PBAEnabled:=            ST^.PBAEnabled;
          CSS^.PageBreakAfter:=        ST^.PageBreakAfter;
          CSS^.ListStyleEnabled:=      ST^.ListStyleEnabled;
          CSS^.ListStyle:=             ST^.ListStyle;
          CSS^.WhiteSpaceEnabled:=     ST^.WhiteSpaceEnabled;
          CSS^.WhiteSpace:=            ST^.WhiteSpace;
          CSS^.ShowSystemChars:=((ST^.Flags and 1)=1);
  end;


procedure    TStyleStream.AssignSTtoCSS(var ST:PSTStyleRecord;var CSS:PStyleRecord);
  begin
          CSS^.ID:=                    ST^.ID;
          CSS^.StyleName:=             ST^.StyleName;
          CSS^.FontEnabled:=           ST^.FontEnabled;
          CSS^.Font:=                  ST^.Font;
          CSS^.FontSizeEnabled:=       ST^.FontSizeEnabled;
          CSS^.FontSize:=              ST^.FontSize;
          CSS^.Flags:=                 ST^.Flags;
          CSS^.FontSizeUnits:=         ST^.FontSizeUnits;
          CSS^.FontWeightEnabled:=     ST^.FontWeightEnabled;
          CSS^.FontWeight:=            ST^.FontWeight;
          CSS^.FontStyleEnabled:=      ST^.FontStyleEnabled;
          CSS^.FontStyle:=             ST^.FontStyle;
          CSS^.TextDecorationEnabled:= ST^.TextDecorationEnabled;
          CSS^.TextDecoration:=        ST^.TextDecoration;
          CSS^.TextTransformEnabled:=  ST^.TextTransformEnabled;
          CSS^.TextTransform:=         ST^.TextTransform;
          CSS^.FontColorEnabled:=      ST^.FontColorEnabled;
          CSS^.FontColor:=             ST^.FontColor;
          CSS^.BackColorEnabled:=      ST^.BackColorEnabled;
          CSS^.BackColor:=             ST^.BackColor;
          CSS^.TextIndentEnabled:=     ST^.TextIndentEnabled;
          CSS^.TextIndent:=            ST^.TextIndent;
          CSS^.LeadingSpaceEnabled:=   false;
          CSS^.LeadingSpace:=          0;
          CSS^.WordSpacingEnabled:=    ST^.WordSpacingEnabled;
          CSS^.WordSpacing:=           ST^.WordSpacing;
          CSS^.LetterSpacingEnabled:=  ST^.LetterSpacingEnabled;
          CSS^.LetterSpacing:=         ST^.LetterSpacing;
          CSS^.VerticalAlignEnabled:=  ST^.VerticalAlignEnabled;
          CSS^.VerticalAlign:=         ST^.VerticalAlign;
          CSS^.TextAlignEnabled:=      ST^.TextAlignEnabled;
          CSS^.TextAlign:=             ST^.TextAlign;
          CSS^.LeftMarginEnabled:=     ST^.LeftMarginEnabled;
          CSS^.LeftMargin:=            ST^.LeftMargin;
          CSS^.LeftMarginUnits:=       ST^.LeftMarginUnits;
          CSS^.RightMarginEnabled:=    ST^.RightMarginEnabled;
          CSS^.RightMargin:=           ST^.RightMargin;
          CSS^.RightMarginUnits:=      ST^.RightMarginUnits;
          CSS^.BottomMarginEnabled:=   ST^.BottomMarginEnabled;
          CSS^.BottomMargin:=          ST^.BottomMargin;
          CSS^.BottomMarginUnits:=     ST^.BottomMarginUnits;
          CSS^.TopMarginEnabled:=      ST^.TopMarginEnabled;
          CSS^.TopMargin:=             ST^.TopMargin;
          CSS^.TopMarginUnits:=        ST^.TopMarginUnits;
          CSS^.LeftBorderEnabled:=     ST^.LeftBorderEnabled;
          CSS^.LeftBorder:=            ST^.LeftBorder;
          CSS^.RightBorderEnabled:=    ST^.RightBorderEnabled;
          CSS^.RightBorder:=           ST^.RightBorder;
          CSS^.TopBorderEnabled:=      ST^.TopBorderEnabled;
          CSS^.TopBorder:=             ST^.TopBorder;
          CSS^.BottomBorderEnabled:=   ST^.BottomBorderEnabled;
          CSS^.BottomBorder:=          ST^.BottomBorder;
          CSS^.MarksEnabled:=          ST^.MarksEnabled;
          CSS^.MarksType:=             ST^.MarksType;
          CSS^.OrientationEnabled:=    false;
          CSS^.PBBEnabled:=            ST^.PBBEnabled;
          CSS^.PageBreakBefore:=       ST^.PageBreakBefore;
          CSS^.PBAEnabled:=            ST^.PBAEnabled;
          CSS^.PageBreakAfter:=        ST^.PageBreakAfter;
          CSS^.ListStyleEnabled:=      ST^.ListStyleEnabled;
          CSS^.ListStyle:=             ST^.ListStyle;
          CSS^.WhiteSpaceEnabled:=     ST^.WhiteSpaceEnabled;
          CSS^.WhiteSpace:=            ST^.WhiteSpace;
          CSS^.ShowSystemChars:=       ST^.ShowSystemChars;
  end;

function   TStyleStream.WriteStream(Var CSSList:PStyleRecord):Boolean;
Var tmp:TSTFileHeader;
 begin
   Result:=False;
   if (FBuf<>nil) then FreeMem(FBuf);
   FCSSCount:=CalcCSSCount(CSSList);
   if (FCSSCount<=0) then Exit;
   FFileSize:=SizeOf(TSTFileHeader)+FCSSCount*SizeOf(TSTStyleRecord);
   FBuf:=PByte(AllocMem(FFileSize));
   tmp.dwSignature:=STSignature;
   tmp.dwCSSCount:=FCSSCount;
   WriteFileHeader(tmp);
   Result:=WriteCSSList(CSSList);
 end;

function   TStyleStream.ReadStream(Var CSSList:PStyleRecord):Boolean;
Var tmp:TSTFileHeader;
 begin
    Result:=False;
    if not(FOpened) then Exit;
    tmp:=ReadFileHeader;
    if ((tmp.dwSignature<>STSignature) and
       (tmp.dwSignature<>OldSTSignature)) then Exit;
    Result:=ReadCSSList(CSSList);
 end;

function    TStyleStream.CalcCSSCount(Var CSSList:PStyleRecord):Integer;
Var tmpCSS:PStyleRecord;
 begin
   Result:=0;
   tmpCSS:=CSSList;
   While (tmpCSS<>nil) do
    begin
      tmpCSS:=tmpCSS^.Next;
      Inc(Result);
    end;
 end;

constructor TStyleStream.Create;
 begin
    inherited Create;
    FFileName:='';
    FFileSize:=0;
    FOpened:=False;
    FBuf:=nil;
    FMode:=stRead;
    FCSSCount:=0;
    FOldFormat:=False;
 end;

destructor  TStyleStream.Destroy;
 begin
   if FOpened then CloseStream;
   inherited Destroy;
 end;

function    TStyleStream.OpenStream(oFileName:String;mode:TSTStreamOpenMode):Boolean;
 begin
 FFileName:=oFileName;
 Result:=False;
 AssignFile(FFile,FFileName);
 {$I-}
 FMode:=mode;
 case (mode) of
  stRead: Reset(FFile,1);
  stWrite: Rewrite(FFile,1);
 end;
 {$I+}
 if IOResult<>0 then Exit;
 FFileSize:=System.FileSize(FFile);
 if mode = stRead then
     begin
       if (FBuf<>nil) then FreeMem(FBuf);
       FBuf:=PByte(AllocMem(FFileSize));
       System.Seek(FFile,0);
       BlockRead(FFile,FBuf^,FFileSize);
     end
   else
    begin
     FBuf:=nil;
     FFileSize:=0;
    end;
 FOpened:=True;
 Result:=True;
 end;

procedure   TStyleStream.CloseStream;
 begin
 if FOpened then
   begin
     if (FMode=stWrite) and (FBuf<>nil) then
        begin
         System.Seek(FFile,0);
         BlockWrite(FFile,FBuf^,FFileSize);
         FreeMem(FBuf);
         FBuf:=nil;
        end;
     if (FMode=stRead) and (FBuf<>nil) then
        begin
          FreeMem(FBuf);
          FBuf:=nil;
        end;
     CloseFile(FFile);
     FOpened:=False;
   end;
 end;

function   TStyleStream.ReadFileHeader:TSTFileHeader;
Var tmpPtr:PSTFileHeader;
 begin
   tmpPtr:=PSTFileHeader(FBuf);
   System.Move(tmpPtr^,Result,sizeOf(TSTFileHeader));
   FCSSCount:=Result.dwCSSCount;
   if (Result.dwSignature=OldSTSignature) then
        FOldFormat:=True
   else
        FOldFormat:=False;
 end;

procedure   TStyleStream.WriteFileHeader(Value: TSTFileHeader);
Var tmpPtr:PSTFileHeader;
 begin
   tmpPtr:=PSTFileHeader(FBuf);
   System.Move(Value,tmpPtr^,sizeOf(TSTFileHeader));
 end;
Procedure ClearStyle(style:PStyleRecord);
begin
          style^.ID:=0;
          style^.StyleName:='';

          { Font Setting }
          style^.FontEnabled:=false;
          style^.FontSizeEnabled:=false;
          style^.FontWeightEnabled:=false;
          style^.FontStyleEnabled:=false;
          style^.TextDecorationEnabled:=false;
          style^.TextTransformEnabled:=false;
          style^.FontColorEnabled:=false;
          style^.BackColorEnabled:=false;
          style^.TextIndentEnabled:=false;
          style^.LeadingSpaceEnabled:=false;
          style^.WordSpacingEnabled:=false;
          style^.LetterSpacingEnabled:=false;
          style^.VerticalAlignEnabled:=false;
          style^.TextAlignEnabled:=false;
          style^.LeftMarginEnabled:=false;
          style^.RightMarginEnabled:=false;
          style^.BottomMarginEnabled:=false;
          style^.TopMarginEnabled:=false;
          style^.LeftBorderEnabled:=false;
          style^.RightBorderEnabled:=false;
          style^.TopBorderEnabled:=false;
          style^.BottomBorderEnabled:=false;
          style^.MarksEnabled:=false;
          style^.OrientationEnabled:=false;
          style^.PBBEnabled:=false;
          style^.PBAEnabled:=false;
          style^.ListStyleEnabled:=false;
          style^.WhiteSpaceEnabled:=false;
          style^.ShowSystemChars:=false;
         end;
Procedure AddStyle(style,ss:PStyleRecord);
begin
          style^.ID:=ss^.ID;
          style^.StyleName:=ss^.StyleName;
          if ss^.FontEnabled then
          style^.Font:=ss^.Font;
          style^.FontEnabled:=style^.FontEnabled or ss^.FontEnabled;

          if ss^.FontSizeEnabled then
          begin
          style^.FontSizeUnits:=ss^.FontSizeUnits;
          style^.FontSize:=ss^.FontSize;                { font-size : 14pt; }
          end;
          style^.FontSizeEnabled:=style^.FontSizeEnabled or ss^.FontSizeEnabled;
          if ss^.FontWeightEnabled then
          style^.FontWeight:=ss^.FontWeight;     { font-weight : extra-light; }
          style^.FontWeightEnabled:=style^.FontWeightEnabled or ss^.FontWeightEnabled;
          if ss^.FontStyleEnabled then
          style^.FontStyle:=ss^.FontStyle;       { font-style : italic; }
          style^.FontStyleEnabled:=style^.FontStyleEnabled or ss^.FontStyleEnabled;


          style^.TextDecorationEnabled:=style^.TextDecorationEnabled or ss^.TextDecorationEnabled;
          if ss^.TextDecorationEnabled then
          style^.TextDecoration:=ss^.TextDecoration;

          style^.TextTransformEnabled:=style^.TextTransformEnabled or ss^.TextTransformEnabled;
          if ss^.TextTransformEnabled then
          style^.TextTransform:=ss^.TextTransForm;

          style^.FontColorEnabled:=style^.FontColorEnabled or ss^.FontColorEnabled;
          if ss^.FontColorEnabled then
          style^.FontColor:=ss^.FontColor;               { color : #0099FF; }

          style^.BackColorEnabled:=style^.BackColorEnabled or ss^.BackColorEnabled;
          if ss^.BackColorEnabled then
          style^.BackColor:=ss^.BackColor;               { background : #00FF00; }

          { Align Settings }
          style^.TextIndentEnabled:=style^.TextIndentEnabled or ss^.TextIndentEnabled;
          if ss^.TextIndentEnabled then
          style^.TextIndent:=ss^.TextIndent;              { text-indent : 8pt; }

          {style^.LeadingSpaceEnabled:=style^.LeadingSpaceEnabled or ss^.LeadingSpaceEnabled;}
          {if ss^.LeadingSpaceEnabled then
          style^.LeadingSpace:=ss^.LeadingSpace;}

          style^.WordSpacingEnabled:=style^.WordSpacingEnabled or ss^.WordSpacingEnabled;
          if ss^.WordSpacingEnabled then
          style^.WordSpacing:=ss^.WordSpacing;

          style^.LetterSpacingEnabled:=style^.LetterSpacingEnabled or ss^.LetterSpacingEnabled;
          if ss^.LetterSpacingEnabled then
          style^.LetterSpacing:=ss^.LetterSpacing;       { letter-spacing : 10pt; }

          style^.VerticalAlignEnabled:=style^.VerticalAlignEnabled or ss^.VerticalAlignEnabled;
          if ss^.VerticalAlignEnabled then
          style^.VerticalAlign:=ss^.VerticalAlign;

          style^.TextAlignEnabled:=style^.TextAlignEnabled or ss^.TextAlignEnabled;
          if ss^.TextAlignEnabled then
          style^.TextAlign:=ss^.TextAlign;           { text-align : center; }
          { Borders setting }
          style^.LeftMarginEnabled:=style^.LeftMarginEnabled or ss^.LeftMarginEnabled;
          if ss^.LeftMarginEnabled then
          begin
          style^.LeftMargin:=ss^.LeftMargin;             { margin-left : 1pt; }
          style^.LeftMarginUnits:=ss^.LeftMarginUnits;
          end;
          style^.RightMarginEnabled:=style^.RightMarginEnabled or ss^.RightMarginEnabled;
          if ss^.RightMarginEnabled then
          begin
          style^.RightMargin:=ss^.RightMargin;             { margin-Right : 1pt; }
          style^.RightMarginUnits:=ss^.RightMarginUnits;
          end;

          style^.BottomMarginEnabled:=style^.BottomMarginEnabled or ss^.BottomMarginEnabled;
          if ss^.BottomMarginEnabled then
          begin
          style^.BottomMargin:=ss^.BottomMargin;             { margin-Bottom : 1pt; }
          style^.BottomMarginUnits:=ss^.BottomMarginUnits;
          end;

          style^.TopMarginEnabled:=style^.TopMarginEnabled or ss^.TopMarginEnabled;
          if ss^.TopMarginEnabled then
          begin
          style^.TopMargin:=ss^.TopMargin;             { margin-Top : 1pt; }
          style^.TopMarginUnits:=ss^.TopMarginUnits;
          end;

          style^.LeftBorderEnabled:=style^.LeftBorderEnabled or ss^.LeftBorderEnabled;
          if ss^.LeftBorderEnabled then
          style^.LeftBorder:=ss^.LeftBorder;            { border-left : dotted; }

          style^.RightBorderEnabled:=style^.RightBorderEnabled or ss^.RightBorderEnabled;
          if ss^.RightBorderEnabled then
          style^.RightBorder:=ss^.RightBorder;            { border-Right : dotted; }

          style^.TopBorderEnabled:=style^.TopBorderEnabled or ss^.TopBorderEnabled;
          if ss^.TopBorderEnabled then
          style^.TopBorder:=ss^.TopBorder;            { border-Top : dotted; }

          style^.BottomBorderEnabled:=style^.BottomBorderEnabled or ss^.BottomBorderEnabled;
          if ss^.BottomBorderEnabled then
          style^.BottomBorder:=ss^.BottomBorder;            { border-Bottom : dotted; }

          { Printing settings - only with @page StyleName }

          style^.MarksEnabled:=style^.MarksEnabled or ss^.MarksEnabled;
          if ss^.MarksEnabled then
          style^.MarksType:=ss^.MarksType;

          style^.OrientationEnabled:=style^.OrientationEnabled or ss^.OrientationEnabled;
          if ss^.OrientationEnabled then
          style^.Orientation:=ss^.Orientation;

          style^.PBBEnabled:=style^.PBBEnabled or ss^.PBBEnabled;
          if ss^.PBBEnabled then
          style^.PageBreakBefore:=ss^.PageBreakBefore;

          style^.PBAEnabled:=style^.PBAEnabled or ss^.PBAEnabled;
          if ss^.PBAEnabled then
          style^.PageBreakAfter:=ss^.PageBreakAfter;


          style^.ListStyleEnabled:=style^.ListStyleEnabled or ss^.ListStyleEnabled;
          if ss^.ListStyleEnabled then
          style^.ListStyle:=ss^.ListStyle;


          style^.WhiteSpaceEnabled:=style^.WhiteSpaceEnabled or ss^.WhiteSpaceEnabled;
          if ss^.WhiteSpaceEnabled then
          style^.WhiteSpace:=ss^.WhiteSpace;
          style^.ShowSystemChars:=ss^.ShowSystemChars;

end;
procedure CombineStyles(Styles:array of PStyleRecord;Combo:PStyleRecord);
var i:Integer;
begin
ClearStyle(combo);
for i:=0 to high(Styles) do
AddStyle(Combo,Styles[i]);
end;

end.