Unit BpMsd;

{ Model Structure Diagram - MSD }
{ Start Work 08-07-02 }
{ Complited  06-08-02 }

Interface

Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     Printers,QRPrntr,StdCtrls,BPDef,BPNode,BPLabel,TFlatProgressBarUnit,MyUtils,BPRename;

Type

  PMSDGraphNode=^TMSDGraphNode;
  TMSDGraphNode=record
    BPNode:TBPLSAGraphNode;
    CorrectNode:Boolean;
    llNode:PBPNode;
    NodeX:Array[0..100] of Integer;
    NodeY:Array[0..100] of Integer;
    NodeXYCount:Integer;
    FinalX:Integer;
    FinalY:Integer;
    TopRegion:Integer;
    BottomRegion:Integer;
    RightRegion:Integer;
    LeftRegion:Integer;
    NodePassed:Boolean;
    SecondColumn:Boolean;
    FirstRow:Boolean;
    LevelID:Integer;
    next:PMSDGraphNode;
  end;

  TMSDLinkConnection=(msdlc_onedown_notsecond,msdlc_onedown_second,msdlc_down,msdlc_up);

  PMSDGraphLink=^TMSDGraphLink;
  TMSDGraphLink=record
     BPFromLabel:TBPLabel; {TBPLabel}
     BPToLabel:TBPLabel; {TBPLabel}
     FromNodeNumber:DWORD;
     ToNodeNumber:DWORD;
     dwFlags:DWORD;
     FromLinkNumber:DWORD; { CurrentWork ! }
     ToLinkNumber:DWORD;   { CurrentWork ! }
     LineArrayX:Array[0..20] of Integer;
     LineArrayY:Array[0..20] of Integer;
     LinePointCount:DWORD;
     StartPoint:TPoint;
     EndPoint:TPoint;
     LinkFromCount:DWORD;
     LinkToCount:DWORD;
     LinkFromLeftCount:DWORD;
     LinkToLeftCount:DWORD;
     LinkFromRightCount:DWORD;
     LinkToRightCount:DWORD;
     LinkFromBottomCount:DWORD;
     MinimalXFrom:Integer;
     MinimalXTo:Integer;
     MinimalYFrom:Integer;
     MinimalYTo:Integer;
     Color:TColor;                          { T's LinkType }
     PenStyle:TPenStyle;                    { T's LinkType }
     llLink:PBPLink;                       { For comparing }
     Visible:Boolean;
     LinkConnection:TMSDLinkConnection;
     LinkLeftRight:Boolean; { True Left False Right}
{    LinkDirection:TLinkDirection;    }     { New !!! }
     next:PMSDGraphLink;
  end;

  TBPMSDCheckGraphArray=record
    Nodes:Array[0..100] of PBPNode;
    NodesGraph:Array[0..100] of Integer;
    NodeLevel:Array[0..100] of Integer;
    Links:Array[0..600] of PBPLink;
    LinksGraph:Array[0..600] of Integer;
    LinkRenamedFrom:Array[0..600] of Boolean;
    LinkRenamedTo:Array[0..600] of Boolean;
    NodesCount:Integer;
    LinksCount:Integer;
  end;

  TBPMSDNodeArrayEx=record
    Nodes:Array[0..100] of PBPNode;
    NodesCount:Integer;
    Length:Array[0..100] of Integer;
  end;

  TBPMSDLinkArrayEx=record
    Links:Array[0..100] of PBPLink;
    LinksCount:Integer;
  end;

  TBPMSDNodeArray=record
    Nodes:Array[0..100] of PMSDGraphNode;
    NodesXLeft:Array[0..100] of Integer;
    NodesXRight:Array[0..100] of Integer;
    NodeNumber:Array[0..100] of DWORD;
    NodesCount:Integer;
  end;

  TBPMSDLinkArray=record
    Links:Array[0..600] of PMSDGraphLink;
    LinksCount:Integer;
  end;

  TBPMSDLeftRight=record
    LeftRegion:Integer;
    RightRegion:Integer;
  end;

  TBPMSDCoordinate=record
    Region:Array[0..100] of Integer;
    Count:Array[0..100] of Integer;
    RegionCount:Integer;
  end;

  TBPMSDMultipleCountEx=record
    Count:Integer;
    Left:Integer;
    Right:Integer;
    Bottom:Integer;
  end;

   TBPMSDFrame=class;

   TBPMSDGraph = class(TControl)
      private
       { Private declarations }
        FOwner:TBPMSDFrame;
        FNodes:PBPNode;
        FLinks:PBPLink;
        FTree:PBPTree;     { Tree for model   }
        FNTTree:PBPNodeTypes; { NodeTypes Tree }
        FLTTree:PBPLinkTypes; { LinkTypes Tree }
        FOPTree:PBPOpTree;    { Operation Tree } { CurrentWork ! }
        FEntryArray:PBPEntryArray;
        FCheckGraphArray:PBPCheckGraphArray;
        FHeader:TBPHeader; { Header for model }
        FLevel:Integer;      { Level for model, model must have level -1 }
        FSSLevel:ShortString; { New level for model in x.x.x.x format }
                              { CurrentWork ! }
        FParentLevel:Integer;     { Parent level for model }
        FCurGraph:Integer;
        FRootEntries:Integer;
        FNodesCount:DWORD;
        FLinksCount:DWORD;
        FGNodesCount:Integer;
        FGLinksCount:Integer;
        FGraphNodes:PMSDGraphNode;
        FGraphLinks:PMSDGraphLink;
        FHaspFound:Boolean;
        FMaxWidth:Integer;
        FMaxHeight:Integer;
        { Global nodes links counters }
        FGlobalLeftSize:Integer;
        FGlobalRightSize:Integer;
        FGlobalTopSize:Integer;
        FGlobalBottomSize:Integer;
        { For printing and other }
        FDefWidth:Integer;
        FDefHeight:Integer;
        FPrinting:Boolean;
        FScreenFontName:TFontName;
        FPrinterFontName:TFontName;
        { Vars for mashtabing }
        FFontDPI:Integer;   { FontDPI }
        FFontSize:Integer;  { FontSize }
        FLabelFontSize:Integer;
        FMaxCh:Double;
         {lines mashtabing interval }
        FMinLineStep:Integer; { Line Step }
        FMinArcRadius:Integer;
        FMinLabelX:Integer;
        FMinLabelY:Integer;
        FMinLabelY1:Integer;
        FMinGlobalLabel:Integer;
        FMinLineEndPoint:Integer;
        { nodes mashtabing vars }
        FNodeLineWidth:Integer;
        FNodeDefWidth:Integer;
        FNodeDefHeight:Integer;
        FNodeHSpacing:Integer;
        FNodeVSpacing:Integer;
        FNodeShadowDepth:Integer;
        FNodeWidth:Integer;
        FNodeHeight:Integer;
          {}
        FCalcWidthHeight:Boolean;
          { Debug routines }
        FDebug:Boolean;
        { AF Options }
        FFirstNodeNumber:DWORD;
        FLastNodeNumber:DWORD;
        FScaled:Boolean;             { Clip Windows to fit into ClipRect }
        FScaled2:Boolean;
        FScaled2Ratio:Extended;
        FDiscardDrags:Boolean;
        FRatioWC:Double;             { Ratio for recalc widthcoof }
        FRatioHC:Double;             { Ratio for recalc heightcoof }
        FModified:Boolean;
        FAcceptDragRect:TRect;       { Rect for Accept Drags & Drop }
        FLinksPosRelative:Boolean;
        { Analize graph}
        FADefWidth:Integer;
        FADefHeight:Integer;
        FinalNodeX:Array[0..100] of Integer;
        FinalNodeY:Array[0..100] of Integer;
        FinalWidth:Integer;
        FinalHeight:Integer;
        FRatioX:Double;
        FRatioY:Double;
        FNWidth:Integer;
        FNHeight:Integer;
        FFinalRatio:Double;
        FNodeXArray:TBPMSDNodeArray;  { -+new }
        FChangeTabVisible:Boolean;
        FCheckGraph:TBPMSDCheckGraphArray;
        FEntryGraph:TBPMSDNodeArrayEx;
        FTranslateTopology:Boolean; { Translate topology if True }
        FTranslateNodesPathOptimize:Boolean; { Optimize nodes path }
        FTranslateLinksPathOptimize:Boolean; { Optimize links path }
        FOpenNewGraph:Boolean;
        FItteration:Integer;
        { New Properties }
{        FNodesCaptionVisible:Boolean;
        FJunctionCaptionVisible:Boolean; }
        { Advanced Trace properties}
        FLeftArray:TBPMSDCoordinate;
        FRightArray:TBPMSDCoordinate;
        FBottomArray:TBPMSDCoordinate;
         { Advanced trace functions }
        FEnableMarkBlendingNodes:Boolean;
        { Nodes and Labels }
        FReplaceNodes:Boolean;
        FReplaceLabels:Boolean;
        FMaxWordLength:Integer;
        FMaxWordCount:Integer;
        FMaxLabelLength:Integer;
        { Barahlo}
        FDoOverrideFS:Boolean;
        FNodesFontSize:Integer;
        FDNodesFontSize:Integer;
        FDProjectionFontSize:Integer;
        FInProcessFontSize:Integer;
        FLabelsFontSize:Integer;
        FOverrideNodesFS:Boolean;
        FOverrideDNodesFS:Boolean;
        FOverrideInProcessFS:Boolean;
        FOverrideLabelsFS:Boolean;
        {      }
        FMaxFontSize:Integer;
        FRealMaxFontSize:Integer;
        procedure SetMaxFontSize(Value:Integer);
        procedure UpdateMaxFontSize(Coof:Extended);
        procedure AnalizeStringsFonts;
        procedure MarkBlendingNodes;
        procedure SetEnableMaskBlendingNodes(Value:Boolean);
        procedure FillLeftArray;
        procedure FillRightArray;
        procedure FillBottomArray;
        function  IsLeftArray(value:Integer):Integer;
        function  IsRightArray(value:Integer):Integer;
        function  IsBottomArray(value:Integer):Integer;
         { Graph routines }
        function   GetNTFromIndex(index:DWORD):TBPNodeTypes;
        function   GetLTFromIndex(index:DWORD):TBPLinkTypes;
        procedure  ClearGraphNodes;
        procedure  ClearGraphLinks;
        procedure  CreateGraphNodes(wc,hc:Double);
        procedure  CreateGraphLinks(wc,hc:Double);
        { Internal subroutines }
        procedure  CalcMaxWidthHeight;
{        function   GetLinkLabel(LinkLabel:String;Var caseOp:Boolean):String;}
        function   GetNodeLeftRight(NodeNumber:DWORD):TBPMSDLeftRight;
        function   GetGraphNumberedNode(NodeNumber:DWORD):PMSDGraphNode;
        function   GetNumberedNodeEx(NodeNumber:DWORD):PBPNode;
        function   GetGraphLink(index:DWORD):PMSDGraphLink;
        function   GetGraphNode(index:DWORD):TBPLSAGraphNode;
        function   GetGraphNodeRec(index:DWORD):PMSDGraphNode;
        function   GetLinkFrom(const value:PMSDGraphLink):TLinkType;
        function   GetLinkTo(const value:PMSDGraphLink):TLinkType;
        function   GetMultipleMask(index:Integer):TBPMultipleMask;
        function   GetNonGraphMultipleMask(link:PBPLink):TBPMultipleMask; { Checked }
        function   GetMaxLinkNumber(link:PBPLink;FromNumber:Boolean):Integer;
        function   IsMultipleFirst(index:Integer;MultipleFrom:Boolean):Boolean;
        function   GetMultipleCountFrom(index:Integer):Integer;
        function   GetMultipleCountTo(index:Integer):Integer;

        procedure  TranslateEntryArrayToEntryGraph;
        procedure  TranslateEntryGraphToEntryArray;

        function   GetMultipleMaskEx(index:Integer;const ar:TBPMSDLinkArray):TBPMultipleMask;
        function   IsMultipleFirstEx(index:Integer;MultipleFrom:Boolean;const ar:TBPMSDLinkArray):Boolean;
        function   GetMultipleCountFromEx(index:Integer;const ar:TBPMSDLinkArray):TBPMSDMultipleCountEx;
        function   GetMultipleCountToEx(index:Integer;const ar:TBPMSDLinkArray):TBPMSDMultipleCountEx;
        procedure  CorrectMultipleCountFromEx(index:Integer;var ar:TBPMSDLinkArray);
        procedure  CorrectMultipleCountToEx(index:Integer;var ar:TBPMSDLinkArray);


        function   GetMultipleFirst(index:Integer;MultipleFrom:Boolean):PMSDGraphLink;
        procedure  DrawSS(sx,sy,dx,dy:Integer;color:TColor);
{        procedure  DrawStartEnd(x,y,dx,dy:Integer;color:TColor;Start:Boolean);}
        { trace routines }
        procedure  CalcLabelSizes;
        procedure  TraceNodes;
        procedure  TraceLinksToNodeCounters;
        procedure  TraceNodesToLinksCounters;
        procedure  TraceLocalStartEndPoints;
        procedure  TraceLinks;
        procedure  DrawLinks;
        procedure  SetFontSize(Value:Integer);
        { Set scale of window to fit to Clip Rect }
{        procedure SetNodesCaptionVisible(Value:Boolean);
        procedure SetJunctionCaptionVisible(Value:Boolean);}
        procedure  SetScaled(Value:Boolean);
        procedure  SetScaled2(Value:Boolean);
        procedure  SetScaled2Ratio(Value:Extended);
        procedure SetDefWidth(Value:Integer);
        procedure SetDefHeight(Value:Integer);
        procedure SetDiscardDrags(Value:Boolean);
        { Analyze Graph }
        function  GetFirstInPoint:PMSDGraphNode;
        function  GetFirstInPointEx(var Value:PBPNode):Boolean;
        function  GetNextInPointEx(var Value:PBPNode):Boolean;
        function  AnalizeNode(level:Integer;p:TPoint;node,oldnode:PMSDGraphNode):TPoint;
        procedure AnalizeGraph(node:PBPNode;graph:Integer;nlevel:Integer);
        function  FixGraph(graph:Integer;nlevel:Integer):Boolean;
        procedure ClearLastResult(graph:Integer);
{        function  NodePassedEx(node:PBPNode):Boolean;}
        function  NodeExsistsEx(node:PBPNode;nlevel:Integer):Boolean;
        function  LinkExsistsEx(link:PBPLink;graph:Integer):Boolean;
        function  GetOutputNodesArrayEx(node:PBPNode;graph:Integer;FromNode:Boolean):TBPMSDNodeArrayEx;
        function  GetOutputLinksArrayEx(node:PBPNode;graph:Integer;FromNode:Boolean):TBPMSDLinkArrayEx;
        function  IsNodeVisibleEx(node:PBPNode):Boolean;
        function  IsLinkVisibleEx(link:PBPLink):Boolean;
        procedure RenumberNodesAndLinks;
        procedure DoTranslateTopology(Value:Boolean);

        procedure CreateCheckGraph;
        procedure CreateCheckGraphLinksOptimum;
        procedure CreateCheckGraphNodesOptimum;
        procedure InitGNodes;
        procedure InitGLinks;
        function  GetOutputNodesArray(node:PMSDGraphNode):TBPMSDNodeArray;
        function  GetOutputLinksArray(node:PMSDGraphNode):TBPMSDLinkArray;
        procedure SortOutputNodesArray(var GNodes:TBPMSDNodeArray);
        function  CheckGraphForForwardDirectionLink(node:PMSDGraphNode;const ar:TBPMSDNodeArray):Boolean;
        { For tracing local start end points }
        function  FillGraphLinksArray:TBPMSDLinkArray;
        procedure ReorderFromGLA(var ar:TBPMSDLinkArray);
        procedure ReorderToGLA(var ar:TBPMSDLinkArray);
{        function  CalcOutputCount(node:PLSAGraphNode):Integer;
        function  CalcPagesCount:Integer;                     }
        { Drag and Drop }
        procedure  MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
        procedure  MyLabelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
        procedure  UpdateNodesModel(X,Y:Integer;node:TBPLSAGraphNode);
        procedure  UpdateLinksModel(X,Y:Integer;llabel:TBPLabel);
        procedure  CorrectLinksModel(delta:TPoint;NodeNum:DWORD;AcceptRect:TRect);

        procedure  WriteCurGraphInfo(FileName:String);
      public
       { Public declarations }
        FLang:TFontCharset;
        procedure   Optimize;
        procedure   OptimizeModel(pb:TFlatProgressBar;Lbl:TLabel);
        function    OptimizeNodeFonts:Integer;
        procedure   SetMaxAll(BReplaceNodes,BReplaceLabels:Boolean;IMaxWordLength,IMaxWordCount,IMaxLabelLength:Integer);
        procedure   SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
        procedure   SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                        CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
        constructor Create(AOwner: TComponent); override;
        destructor  Destroy; override;
        procedure   TraceRoute; { Main Tracing Procedure }
        procedure   AssignModel(Tree:PBPTree;NTTree:PBPNodeTypes;LTTree:PBPLinkTypes;
                                OPTree:PBPOpTree;Header:TBPHeader;
                                EntryArray:PBPEntryArray;CheckGraphArray:PBPCheckGraphArray);
        procedure   ClearModel;
        procedure   OpenLevel(wLevel:Integer;Graph:Integer);
        procedure   PresetupFrame(widthcoof,heightcoof:Double);
        { Scale }
        procedure  SetDefaultConstants;
        procedure  SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double;LabelFontSizeRatio:Double);
        function   GetMaxPagesCount:Integer;

      published
       { Published declarations }
       property RootEntries:Integer read FRootEntries;
       property Parent:TBPMSDFrame read FOwner write FOwner;
       property FontDPI:Integer read FFontDPI write FFontDPI;
       property DefWidth:Integer read FDefWidth write SetDefWidth;
       property DefHeight:Integer read FDefHeight write SetDefHeight;
       property MaxWidth:Integer read FMaxWidth;
       property MaxHeight:Integer read FMaxHeight;
       property NodeWidth:Integer read FNodeWidth;
       property NodeHeight:Integer read FNodeHeight;
       property Printing:Boolean read FPrinting write FPrinting;
       property MinLineStep:Integer read FMinLineStep write FMinLineStep default 6;
       property GlobalLeftSize:Integer read FGlobalLeftSize write FGlobalLeftSize default 80;
       property GlobalRightSize:Integer read FGlobalRightSize write FGlobalRightSize default 80;
       property GlobalTopSize:Integer read FGlobalTopSize write FGlobalTopSize default 80;
       property GlobalBottomSize:Integer read FGlobalBottomSize write FGlobalBottomSize default 80;
       property FontSize:Integer read FFontSize write SetFontSize;
       property GNodesCount:DWORD read FGNodesCount;
       property MinArcRadius:Integer read FMinArcRadius write FMinArcRadius;
       property MinLabelX:Integer read FMinLabelX write FMinLabelX;
       property MinLabelY:Integer read FMinLabelY write FMinLabelY;
       property MinLabelY1:Integer read FMinLabelY1 write FMinLabelY1;
       property MinGlobalLabel:Integer read FMinGlobalLabel write FMinGlobalLabel;
       property MinLineEndPoint:Integer read  FMinLineEndPoint write FMinLineEndPoint;
       property Level:Integer read FLevel;
       property SSLevel:ShortString read FSSLevel; { CurrentWork !}
       property ParentLevel:Integer read FParentLevel;
       property HaspFound:Boolean read FHaspFound write FHaspFound default False;
       property ScreenFontName:TFontName read FScreenFontName write FScreenFontName;
       property PrinterFontName:TFontName read FPrinterFontName write FPrinterFontName;
       property Debug:Boolean read FDebug write FDebug;
       property Scaled:Boolean read FScaled write SetScaled;
       property Scaled2:Boolean read FScaled2 write SetScaled2;
       property Scaled2Ratio:Extended read FScaled2Ratio write SetScaled2Ratio;
       property DiscardDrags:Boolean read FDiscardDrags write SetDiscardDrags;
       property Modified:Boolean read FModified write FModified;
       property AcceptDragRect:TRect read FAcceptDragRect;
       property LinksPosRelative:Boolean read FLinksPosRelative write FLinksPosRelative default True;
       property CurGraph:Integer read FCurGraph;
       property TranslateNodesPathOptimize:Boolean read FTranslateNodesPathOptimize write FTranslateNodesPathOptimize default False;
       property TranslateLinksPathOptimize:Boolean read FTranslateLinksPathOptimize write FTranslateLinksPathOptimize default False;
       property TranslateTopology:Boolean read FTranslateTopology write DoTranslateTopology;
       property EnableMarkBlendingNodes:Boolean read FEnableMarkBlendingNodes write SetEnableMaskBlendingNodes;
       {New}
       property NodesFontSize:Integer read FNodesFontSize;
       property DNodesFontSize:Integer read FDNodesFontSize;
       property DProjectionFontSize:Integer read FDProjectionFontSize;
       property InProcessFontSize:Integer read FInProcessFontSize;
       property LabelsFontSize:Integer read FLabelsFontSize;
       property OverrideNodesFS:Boolean read FOverrideNodesFS;
       property OverrideDNodesFS:Boolean read FOverrideDNodesFS;
       property OverrideInProcessFS:Boolean read FOverrideInProcessFS;
       property OverrideLabelsFS:Boolean read FOverrideLabelsFS;
       property MaxFontSize:Integer read FMaxFontSize write SetMaxFontSize;
     end;



{ TBPMSDFrame definition }

  TBPMSDFrame = class(TScrollingWinControl)
  private
    { Private declarations }
    FBPMSDGraph:TBPMSDGraph;                        { _++-+ +- }
    FCanvas: TCanvas;
    { Page Param Options }
    FPageTop:Integer;
    FPageBottom:Integer;
    FPageLeft:Integer;
    FPageRight:Integer;
    FPrinter:TQRPrinter;
    FPrinting:Boolean;
    FPainting:Boolean; { So disable double insert in painting module }
    FAborting:Boolean;
    { Vars for scaling diagrams }
    FHorzPageCount:Integer;
    FVertPageCount:Integer;
    { Vars for scaling ramka font }
    FRamkaFontRatio:Extended;
    FPSizeH:Extended;
    FPSizeW:Extended;
    FRamkaH:Integer;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  protected
    { Protected declarations }
    procedure Paint; virtual;
    procedure PaintWindow(DC: HDC); override;
    procedure PaintTo(DC: HDC; X, Y: Integer);
    procedure PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect);
    { printing routines }
    procedure  PreviewPrintRect(left,right,top,bottom:Integer);
    procedure  PrintRect(left,right,top,bottom:Integer);
    procedure  DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor);
    procedure  DrawLink(pl:PMSDGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
    procedure  MyDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure  MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
  public
    { Public declarations }
    FUpdatingNavigator:Boolean;
    FPreviewOrPrint:Boolean;
    FFontCoof:Double;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean);
    procedure SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer);
    procedure Print;
    procedure CreateBitmap(var value:TBitmap;pf:TPixelFormat);
    procedure GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap }
    procedure CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer);
    procedure CreatePreview;
    procedure PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer);
    procedure CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel);
  published
    { Published declarations }
    property BPMSDGraph:TBPMSDGraph read FBPMSDGraph;
    property HorzPages:Integer read FHorzPageCount write FHorzPageCount default 1;
    property VertPages:Integer read FVertPageCount write FVertPageCount default 1;
    property Align default alNone;
    property Width default 100;
    property Height default 100;
    property Enabled default True;
    property ShowHint;
    property Visible;
    property Ctl3D;
    property TabStop default True;
    property TabOrder;
    property Canvas:TCanvas read FCanvas;
    property QPrinter:TQRPrinter read FPrinter;
    property Printing:Boolean read FPrinting;
    property Aborting:Boolean read FAborting write FAborting;
    property OnKeyUp;
    property OnEnter;
    property OnExit;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnStartDrag;
    property PopupMenu;
  end;


procedure Register;

function SignedVector(Sign,Value:Integer):Integer;


Const StartMinLineStep=6;
      StartMinLabelX=8;
      StartMinLabelY=4;
      StartMinLabelY1=12; { Try to change }
      StartMinArcRadius=8;
      NodeRatio=4/3;
      StartMinGlobalLabel=10;
      StartMinLineEndPoint=4;
      StartMaxLines=4;

      MaxItteration=1000; { Why not ? }
      MIEText='        ';
      MIECaption='  ';
      MSDLogFileName='msd.log';

      A3Width=11.6929;  { Inch }
      A3Height=16.5354; { Inch }
      DefMaxLabelFontSize=14;


Implementation

Uses MainUnit,AnalizeGraphUnit;


function SignedVector(Sign,Value:Integer):Integer;
 begin
   if Sign>0 then Result:=1 else
   if Sign<0 then Result:=-1 else Result:=0;
   Result:=Result*Value;
 end;


function  TBPMSDGraph.OptimizeNodeFonts:Integer;
Var       i:Integer;
  OptFSize,FS:Integer;
     gNode:PMSDGraphNode;
         h:Integer;
         w:Integer;
         dc:HDC;
         ppi:Integer;
 begin
   if FNodesCount=0 then Exit;
   if (FFontSize>=FRealMaxFontSize) then Exit;
   dc:=GetDC(0);
   ppi:=GetDeviceCaps(dc,LOGPIXELSX);
   ReleaseDC(0,dc);
   gNode:=FGraphNodes;
   OptFSize:=100000;
   for i:=0 to (FGNodesCount-1) do
     begin
       h:=gnode^.BPNode.Height;
       w:=gnode^.BPNode.Width;
       fs:=Round(FFontSize/FScaled2Ratio*100);
       gnode^.BPNode.AutoHeight:=True;
       gnode^.BPNode.DefWidth:=Round(w/1.1);
       gnode^.BPNode.Font.PixelsPerInch:=ppi;
       while (gnode^.BPNode.Height<=h) do
         begin
           inc(fs);
           gnode^.BPNode.Font.Size:=fs;
           gnode^.BPNode.PaintImmediate;
           while gnode^.BPNode.Updating do;
         end;
       dec(fs);
       if (OptFSize>fs) then OptFSize:=fs;
       gnode^.BPNode.AutoHeight:=False;
       gnode:=gnode^.next;
     end;
   Result:=OptFSize;
 end;


procedure TBPMSDGraph.OptimizeModel(pb:TFlatProgressBar;Lbl:TLabel);
Var tmptree:PBPTree;
    fs:Integer;
   lfs:Integer;
 oldLevel:Integer;
   pos:Integer;
   cnt:Integer;
   adv:Double;
 begin
   if (FTree=nil) then Exit;
   oldLevel:=FLevel;
   tmpTree:=FTree;
   cnt:=FRootEntries;
   pos:=0;
   pb.Position:=0;
   Lbl.Caption:=IntToStr(pos);
   Application.ProcessMessages;
   while (tmpTree<>nil) do
    begin
          FNodesCount:=tmpTree^.dwNodesCount;
          FLinksCount:=tmpTree^.dwLinksCount;
          FNodes:=tmpTree^.lpNodes;
          FLinks:=tmpTree^.lpLinks;
          FLevel:=tmpTree^.dwLevel;
          FSSLevel:=tmpTree^.ssLevel;
          FParentLevel:=tmpTree^.dwParent;
          FNodesFontSize:=tmpTree^.dwNodesFontSize;
          FDNodesFontSize:=tmpTree^.dwDNodesFontSize;
          FDProjectionFontSize:=tmpTree^.dwDProjectionFontSize;
          FInProcessFontSize:=tmpTree^.dwInProcessFontSize;
          FLabelsFontSize:=tmpTree^.dwLabelsFontSize;
          FOverrideNodesFS:=tmpTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=tmpTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=tmpTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=tmpTree^.dbOverrideLabelsFS;
          FTranslateTopology:=False;
          FOpenNewGraph:=False;
          SetDefaultConstants;
          CreateGraphNodes(1,1);
          CreateGraphLinks(1,1);
          Scaled:=Scaled;
          if (not(FScaled)) then PresetupFrame(1,1);
          TraceRoute;
           FOwner.Invalidate;
     fs:=OptimizeNodeFOnts;
     lfs:=Round(fs*FMaxCH);
     if fs>FRealMaxFontSize then fs:=FRealMaxFontSize;
     if lfs>FRealMaxFontSize then lfs:=FRealMaxFontSize;
     FNodesFontSize:=fs;
     FLabelsFontSize:=lfs;
    {FDNodesFontSize:=lfs;
     FDProjectionFontSize:=lfs;}
{     FInProcessFontSize:=fs;}
     FOverrideNodesFS:=True;
     FOverrideLabelsFS:=True;
{     FOverrideInProcessFS:=True;}
    {FOverrideDNodesFS:=True;}
     tmpTree^.dwNodesFontSize:=fs;
     tmpTree^.dbOverrideNodesFS:=True;
{     tmpTree^.dwInProcessFontSize:=fs;
     tmpTree^.dbOverrideInProcessFS:=True;}
     tmpTree^.dwLabelsFontSize:=LFS;
     tmpTree^.dbOverrideLabelsFS:=True;
{     tmpTree^.dwDNodesFontSize:=lfs;
     tmpTree^.dbOverrideDNodesFS:=True;
     tmpTree^.dwDProjectionFontSize:=lfs;}
     FModified:=True;
     tmpTree:=tmpTree^.next;
     inc(pos);
     pb.Position:=Round(pos/cnt*100);
     Lbl.Caption:=IntToStr(pb.Position);
     Application.ProcessMessages;
    end;
    OpenLevel(OldLevel,FCurGraph);
    FOwner.Visible:=False;
    pb.Position:=100;
    Lbl.Caption:='100';
    Application.ProcessMessages;
 end;

procedure TBPMSDGraph.Optimize;
Var tmptree:PBPTree;
    fs:Integer;
   lfs:Integer;
 begin
   if (FTree=nil) then Exit;
   fs:=OptimizeNodeFOnts;
   lfs:=Round(fs*FMaxCH);
   if fs>FRealMaxFontSize then fs:=FRealMaxFontSize;
   if lfs>FRealMaxFontSize then lfs:=FRealMaxFontSize;
   FNodesFontSize:=fs;
   FLabelsFontSize:=lfs;
{   FDNodesFontSize:=lfs;
   FDProjectionFontSize:=lfs;}
{   FInProcessFontSize:=fs;}
   FOverrideNodesFS:=True;
   FOverrideLabelsFS:=True;
{   FOverrideInProcessFS:=True;}
{   FOverrideDNodesFS:=True;}
   tmpTree:=FTree;
   while (tmpTree<>nil) and (tmpTree^.dwLevel<>FLevel) do tmpTree:=tmpTree^.next;
   if (tmpTree<>nil) then
   begin
     tmpTree^.dwNodesFontSize:=fs;
     tmpTree^.dbOverrideNodesFS:=True;
{     tmpTree^.dwInProcessFontSize:=fs;
     tmpTree^.dbOverrideInProcessFS:=True;}
     tmpTree^.dwLabelsFontSize:=LFS;
     tmpTree^.dbOverrideLabelsFS:=True;
{     tmpTree^.dwDNodesFontSize:=lfs;
     tmpTree^.dbOverrideDNodesFS:=True;
     tmpTree^.dwDProjectionFontSize:=lfs;}
     FModified:=True;
   end;
 end;


procedure TBPMSDGraph.SetOverrideFontsAll(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean;
                                          CNFS,CDNFS,CDPFS,CIPFS,CLFS,CONFS,CODFS,COIFS,COLFS:Boolean);
Var tmptree:PBPTree;
 begin
  if CNFS then  FNodesFontSize:=NFS;
  if CDNFS then FDNodesFontSize:=DNFS;
  if CDPFS then FDProjectionFontSize:=DPFS;
  if CIPFS then FInProcessFontSize:=IPFS;
  if CLFS then FLabelsFontSize:=LFS;
  if CONFS then FOverrideNodesFS:=ONFS;
  if CODFS then FOverrideDNodesFS:=ODFS;
  if COIFS then FOverrideInProcessFS:=OIFS;
  if COLFS then FOverrideLabelsFS:=OLFS;
  if (FTree=nil) then Exit;
  tmpTree:=FTree;
  while (tmpTree<>nil) do
   begin
     if CNFS then tmpTree^.dwNodesFontSize:=NFS;
     if CONFS then tmpTree^.dbOverrideNodesFS:=ONFS;
     if CDNFS then  tmpTree^.dwDNodesFontSize:=DNFS;
     if CODFS then tmpTree^.dbOverrideDNodesFS:=ODFS;
     if CDPFS then tmpTree^.dwDProjectionFontSize:=DPFS;
     if CIPFS then tmpTree^.dwInProcessFontSize:=IPFS;
     if COIFS then tmpTree^.dbOverrideInProcessFS:=OIFS;
     if CLFS then  tmpTree^.dwLabelsFontSize:=LFS;
     if COLFS then tmpTree^.dbOverrideLabelsFS:=OLFS;
     FModified:=True;
     tmpTree:=tmpTree^.next;
   end;
 end;


procedure TBPMSDGraph.SetOverrideFonts(NFS,DNFS,DPFS,IPFS,LFS:Integer;ONFS,ODFS,OIFS,OLFS:Boolean);
 begin
  FNodesFontSize:=NFS;
  FDNodesFontSize:=DNFS;
  FDProjectionFontSize:=DPFS;
  FInProcessFontSize:=IPFS;
  FLabelsFontSize:=LFS;
  FOverrideNodesFS:=ONFS;
  FOverrideDNodesFS:=ODFS;
  FOverrideInProcessFS:=OIFS;
  FOverrideLabelsFS:=OLFS;
 end;


procedure TBPMSDGraph.AnalizeStringsFonts;
Var s:String;
  len,i:Integer;
  node:TBPLSAGraphNode;
  nodeP:PMSDGraphNode;
  flag:Boolean;
  fs:Integer;
 begin
   if not(BPViewMainForm.EnableAnalizForm.Checked) then Exit;
   if (AnalizeGraphForm=nil) then Exit;
   if (FGNodesCount=0) then Exit;
   if (FGraphNodes=nil) then Exit;
   if FOverrideNodesFS then Exit;
   fs:=Round(FFontSize/FScaled2Ratio*100);
   with AnalizeGraphForm do
    begin
      if (not(FReplaceNodes) and (fs<BP_MINFONT_SIZE)) then
       begin
        flag:=False;
        ResultEditor.Clear;
        len:=(FMaxWordLength+1)*FMaxWordCount;
        for i:=0 to (FGNodesCount-1) do
         begin
          node:=GetGraphNode(i);
          if (length(node.Caption)>len) then
           begin
            ResultEditor.Lines.Append(': '+node.SNodeNumber+' "'+node.Caption+'"');
            flag:=True;
           end;
         end;
        if flag then
           begin
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append('    '+IntToStr(len)+' ');
            ResultEditor.Lines.Append('      IDEF0       ');
            ResultEditor.Lines.Append('   "  "  ""');
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append(':    ( )');
            ResultEditor.Lines.Append(' ');
          ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
            ShowModal;
           end;
       end
      else
       if (FReplaceNodes and (fs<BP_MINFONT_SIZE)) then
        begin
          flag:=False;
          ResultEditor.Clear;
          nodeP:=FGraphNodes;
          for i:=0 to (FGNodesCount-1) do
           begin
             if length(nodeP^.BPNode.Caption)<length(nodeP^.llNode^.ssCaption) then
              begin
               ResultEditor.Lines.Append(': '+nodeP^.BPNode.SNodeNumber+' "'+nodeP^.llNode^.ssCaption+'"');
               ResultEditor.Lines.Append(': "'+nodeP^.BPNode.Caption+'"');
               ResultEditor.Lines.Append(' ');
               flag:=True;
              end;
             nodeP:=nodeP^.Next;
           end;
          if flag then
           begin
            ResultEditor.Lines.Append(':  ,        "  "  ""');
            ResultEditor.Lines.Append('      IDEF0       ');
            ResultEditor.Lines.Append(' ');
            ResultEditor.Lines.Append('  ='+IntToStr(fs)+' pt.');
            ShowModal;
           end;
        end;
    end;
 end;


{ TBPMSDGraph }

procedure TBPMSDGraph.TranslateEntryArrayToEntryGraph;
Var i,j:Integer;
      n:PBPNode;
      l:PBPLink;
 begin
   if (FNodesCOunt=0) then Exit;
   if (FEntryArray^.NodesIndexCount=0) then Exit;
   FEntryGraph.NodesCount:=FEntryArray^.NodesIndexCount;
   FRootEntries:=FEntryGraph.NodesCount;
   for j:=0 to (FEntryArray^.NodesIndexCount-1) do
   begin
   n:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       if i=FEntryArray^.NodeIndex[j] then
          FEntryGraph.Nodes[j]:=n;
       inc(n);
     end;
   end;
  if (FCheckGraphArray^.NodesCount=0) then Exit;
  FCheckGraph.NodesCount:=FCheckGraphArray^.NodesCount;
  for j:=0 to (FCheckGraphArray^.NodesCount-1) do
   begin
   n:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       if i=FCheckGraphArray^.NodeIndex[j] then
         begin
          FCheckGraph.Nodes[j]:=n;
          FCheckGraph.NodesGraph[j]:=FCheckGraphArray^.NodesGraph[j];
          FCheckGraph.NodeLevel[j]:=FCheckGraphArray^.NodeLevel[j];
         end;
       inc(n);
     end;
   end;
  if (FLinksCount=0) then Exit;
  if (FCheckGraphArray^.LinksCount=0) then Exit;
  FCheckGraph.LinksCount:=FCheckGraphArray^.LinksCount;
  for j:=0 to (FCheckGraphArray^.LinksCount-1) do
   begin
     l:=FLinks;
     for i:=0 to (FLinksCOunt-1) do
      begin
        if (FCheckGraphArray^.LinkIndex[j]=i) then
          begin
            FCheckGraph.Links[j]:=l;
            FCheckGraph.LinksGraph[j]:=FCheckGraphArray^.LinksGraph[j];
            FCheckGraph.LinkRenamedFrom[j]:=False;
            FCheckGraph.LinkRenamedTo[j]:=False;
          end;
        inc(l);
      end;
   end;
 end;

procedure TBPMSDGraph.TranslateEntryGraphToEntryArray;
Var i,j:Integer;
      n:PBPNode;
      l:PBPLink;
 begin
   if (FNodesCOunt=0) then Exit;
   FEntryArray^.NodesIndexCount:=FEntryGraph.NodesCount;
   for j:=0 to (FEntryGraph.NodesCount-1) do
   begin
   n:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       if (FEntryGraph.Nodes[j]=n) then
           FEntryArray^.NodeIndex[j]:=i;
       inc(n);
     end;
   end;
  FCheckGraphArray^.NodesCount:=FCheckGraph.NodesCount;
  for j:=0 to (FCheckGraph.NodesCount-1) do
   begin
   n:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       if (n=FCheckGraph.Nodes[j]) then
         begin
          FCheckGraphArray^.NodeIndex[j]:=i;
          FCheckGRaphArray^.NodesGraph[j]:=FCheckGraph.NodesGraph[j];
          FCheckGRaphArray^.NodeLevel[j]:=FCheckGraph.NodeLevel[j];
         end;
       inc(n);
     end;
   end;
  if (FLinksCount=0) then Exit;
  FCheckGraphArray^.LinksCount:=FCheckGraph.LinksCount;
  for j:=0 to (FCheckGraph.LinksCount-1) do
   begin
     l:=FLinks;
     for i:=0 to (FLinksCount-1) do
      begin
        if (FCheckGraph.Links[j]=l) then
          begin
            FCheckGraphArray^.LinkIndex[j]:=i;
            FCheckGraphArray^.LinksGraph[j]:=FCheckGraph.LinksGraph[j];
          end;
        inc(l);
      end;
   end;

 end;

procedure TBPMSDGraph.MarkBlendingNodes;
Var i,j,k:Integer;
    n,n1,n2:PMSDGraphNode;
    w,h:Integer;
    ls,le:Integer;
    ts,te:Integer;
    tmp:TBPNodeTypes;
 begin
   if (FGNodesCount=0) then Exit;
   n2:=FGraphNodes;
   for k:=0 to (FGNodesCount-1) do
    begin
     tmp:=GetNTFromIndex(n2^.llNode^.dwNodeIndex);
     n2^.BPNode.PaintColor:=tmp.dwPaintColor;
     n2:=n2^.next;
    end;
   n:=FGraphNodes;
   w:=n^.BPNode.Width;
   h:=n^.BPNode.Height;
   for i:=0 to (FGnodesCount-1) do
    begin
     n1:=FGraphNodes;
     ls:=n^.BPNode.Left;
     ts:=n^.BPNode.Top;
     for j:=0 to (FGNodesCount-1) do
      begin
        le:=n1^.BPNode.Left;
        te:=n1^.BPNode.Top;
        if (i<>j) then
          begin
            if (ABS(le-ls)<w) and (ABS(te-ts)<h) then
              begin
                n^.BPNode.PaintColor:=clGray;
                n1^.BPNode.PaintColor:=clGray;
                n^.BPNode.Repaint;
                N1^.BPNode.Repaint;
              end;
          end;
        n1:=n1^.next;
      end;
      n:=n^.next;
    end;
 end;

 procedure TBPMSDGraph.SetMaxFontSize(Value:Integer);
 Var oldPosX,oldPosY:Integer;
 begin
   FMaxFontSize:=Value;
   FOwner.Visible:=False;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       oldPosX:=FOwner.HorzScrollBar.Position
   else
       oldPosX:=0;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       oldPosY:=FOwner.VertScrollBar.Position
   else
       oldPosY:=0;
   OpenLevel(FLevel,FCurGraph);
   FOwner.Invalidate;
   if FOwner.HorzScrollBar.Visible and
     (FOwner.HorzScrollBar.Range>0) then
       FOwner.HorzScrollBar.Position:=oldPosX;
   if FOwner.VertScrollBar.Visible and
     (FOwner.VertScrollBar.Range>0) then
       FOwner.VertScrollBar.Position:=oldPosY;
   FOwner.Visible:=True;
 end;


procedure TBPMSDGraph.SetMaxAll(BReplaceNodes,BReplaceLabels:Boolean;IMaxWordLength,IMaxWordCount,IMaxLabelLength:Integer);
  begin
   FReplaceNodes:=BReplaceNodes;
   FReplaceLabels:=BReplaceLabels;
   FMaxWordLength:=IMaxWordLength;
   FMaxWordCount:=IMaxWordCount;
   FMaxLabelLength:=IMaxLabelLength;
   FOwner.Visible:=False;
   OpenLevel(FLevel,FCurGraph);
   TraceRoute;
   FOwner.Invalidate;
   FOwner.Visible:=True;
  end;


procedure TBPMSDGraph.SetEnableMaskBlendingNodes(Value:Boolean);
 begin
   FEnableMarkBlendingNodes:=Value;
   FOwner.Visible:=False;
   OpenLevel(FLevel,FCurGraph);
   TraceRoute;
   Invalidate;
   FOwner.Visible:=True;
 end;

function  TBPMSDGraph.GetMaxLinkNumber(link:PBPLink;FromNumber:Boolean):Integer;
Var i:Integer;
    l:PBPLink;
 begin
   Result:=0;
   if (FLinksCount=0) then Exit;
   if (link=nil) then Exit;
   l:=FLinks;
   for i:=0 to (FLinksCount-1) do
    begin
      if FromNumber then
       begin
         if (l^.dwFromNodeNumber=link^.dwFromNodeNumber) and
            ((l^.dwFlags and BP_FROMTOMASK)=(link^.dwFlags and BP_FROMTOMASK)) then
            if Result<l^.dwFromLinkNumber then Result:=l^.dwFromLinkNumber;
       end
      else
       begin
         if (l^.dwToNodeNumber=link^.dwToNodeNumber) and
            ((l^.dwFlags and BP_FROMTOMASK)=(link^.dwFlags and BP_FROMTOMASK)) then
            if Result<l^.dwToLinkNumber then Result:=l^.dwToLinkNumber;
       end;
      inc(l);
    end;
 end;

procedure TBPMSDGraph.WriteCurGraphInfo(FileName:String);
Var i,j,k:Integer;
    s:String;
    f:TextFile;
    n:PMSDGraphNode;
    l:PMSDGraphLink;
 begin
   AssignFile(f,FileName);
   Rewrite(f);
   { Write FCurGraph }
   s:=IntToStr(FCurGraph+1);
   if length(s)=1 then s:='0'+s;
   s:=' '+s;
   Writeln(f,s);
   Writeln(f,'');
   { Write EntryNode For FCurGraph }
   s:='  ';
   Writeln(f,s);
   Writeln(f,'');
   s:='Caption: '+FEntryGraph.Nodes[FCurGraph]^.ssCaption;
   Writeln(f,s);
   s:='dwNodeNumber: '+IntToStr(FEntryGraph.Nodes[FCurGraph]^.dwNodeNumber);
   Writeln(f,s);
   S:='ssNodeNumber: '+FEntryGraph.Nodes[FCurGraph]^.ssNodeNumber;
   Writeln(f,s);
   Writeln(f,'');
   { Write FCheckGraph for FCurGraph }
   s:=' FCheckGraph';
   Writeln(f,s);
   Writeln(f,'');
   j:=1;
   for i:=0 to (FCheckGraph.NodesCount-1) do
    begin
      if (FCheckGraph.NodesGraph[i]=FCurGraph) then
        begin
          s:='Node N '+IntToStr(j);
          Writeln(f,s);
          s:='Caption: '+FCheckGraph.Nodes[i]^.ssCaption;
          Writeln(f,s);
          s:='dwNodeNumber: '+IntToStr(FCheckGraph.Nodes[i]^.dwNodeNumber);
          Writeln(f,s);
          s:='ssNodeNumber: '+FCheckGraph.Nodes[i]^.ssNodeNumber;
          Writeln(f,s);
          Writeln(f,'');
          inc(j);
        end;
    end;
    s:=' FCheckGraph';
    Writeln(f,s);
    Writeln(f,'');
    j:=1;
    for i:=0 to (FCheckGraph.LinksCount-1) do
     begin
       if (FCheckGraph.LinksGraph[i]=FCurGraph) then
         begin
           s:='Link N '+IntToStr(j);
           Writeln(f,s);
           s:='From Caption: '+FCheckGraph.Links[i]^.ssFromCaption;
           Writeln(f,s);
           s:='To Caption: '+FCheckGraph.Links[i]^.ssToCaption;
           Writeln(f,s);
           s:='From Number: '+IntToStr(FCheckGraph.Links[i]^.dwFromNodeNumber);
           Writeln(f,s);
           s:='From LinkNumber:'+IntToStr(FCheckGraph.Links[i]^.dwFromLinkNumber);
           Writeln(f,s);
           s:='To Number: '+IntToStr(FCheckGraph.Links[i]^.dwToNodeNumber);
           Writeln(f,s);
           s:='To LinkNumber: '+IntToStr(FCheckGraph.Links[i]^.dwToLinkNumber);
           Writeln(f,s);
           Writeln(f,'');
           inc(j);
         end;
     end;
   { Write GraphNodes }
   s:=' FGraphNodes';
   Writeln(f,s);
   Writeln(f,'');
   n:=FGraphNodes;
   for i:=0 to (FGNodesCount-1) do
    begin
      s:='GNode N '+IntToStr(i+1);
      Writeln(f,s);
      s:='Caption: '+n^.BPNode.Caption;
      Writeln(f,s);
      s:='NodeNumber: '+IntToStr(n^.BPNode.NodeNumber);
      Writeln(f,s);
      s:='SNodeNumber: '+n^.BPNode.SNodeNumber;
      Writeln(f,s);
      s:='LeftLinksCount: '+IntToStr(n^.BPNode.LeftLinksCount);
      Writeln(f,s);
      s:='RightLinksCount: '+IntToStr(n^.BPNode.RightLinksCount);
      Writeln(f,s);
      s:='TopLinksCount: '+IntToStr(n^.BPNode.TopLinksCount);
      Writeln(f,s);
      s:='BottomLinksCount: '+IntToStr(n^.BPNode.BottomLinksCount);
      Writeln(f,s);
      s:='InputLinksCount: '+IntToStr(n^.BPNode.InputLinksCount);
      Writeln(f,s);
      s:='OutputLinksCount: '+IntToStr(n^.BPNode.OutputLinksCount);
      Writeln(f,s);
      s:='CenterX: '+IntToStr(n^.BPNode.Left+(n^.BPNode.Width div 2));
      Writeln(f,s);
      s:='CenterY: '+IntToStr(n^.BPNode.Top+(n^.BPNode.Height div 2));
      Writeln(f,s);
      s:='SecondColumn: ';
      if n^.SecondColumn then s:=s+'True' else s:=s+'False';
      Writeln(f,s);
      s:='FirstRow: ';
      if n^.FirstRow  then s:=s+'True' else s:=s+'False';
      Writeln(f,s);
      s:='Level: '+IntToStr(n^.LevelID);
      Writeln(f,s);
      Writeln(f,'');
      n:=n^.next;
    end;
   { Write GraphLinks }
   s:=' FGraphLinks';
   Writeln(f,s);
   Writeln(f,'');
   l:=FGraphLinks;
   for i:=0 to FGLinksCount-1 do
    begin
      s:='GLink N '+IntToStr(i+1);
      Writeln(f,s);
      s:='FromNode: '+IntToStr(l^.FromNodeNumber);
      Writeln(f,s);
      s:='FromLinkNumber: '+IntToStr(l^.FromLinkNumber);
      Writeln(f,s);
      s:='ToNode: '+IntToStr(l^.ToNodeNumber);
      Writeln(f,s);
      s:='ToLinkNumber: '+IntToStr(l^.ToLinkNumber);
      Writeln(f,s);
      s:='SX: '+IntToStr(l^.StartPoint.x);
      Writeln(f,s);
      s:='SY: '+IntToStr(l^.StartPoint.y);
      Writeln(f,s);
      s:='EX: '+IntToStr(l^.EndPoint.x);
      Writeln(f,s);
      s:='EY: '+IntToStr(l^.EndPoint.y);
      Writeln(f,s);
      s:='FromCount: '+IntToStr(l^.LinkFromCount);
      Writeln(f,s);
      s:='FromLeftCount: '+IntToStr(l^.LinkFromLeftCount);
      Writeln(f,s);
      s:='FromRightCount: '+IntToStr(l^.LinkFromRightCount);
      Writeln(f,s);
      s:='FromBottomCount: '+IntToStr(l^.LinkFromBottomCount);
      Writeln(f,s);
      s:='ToCount: '+IntToStr(l^.LinkToCount);
      Writeln(f,s);
      s:='ToLeftCount: '+IntToStr(l^.LinkToLeftCount);
      Writeln(f,s);
      s:='ToRightCount: '+IntToStr(l^.LinkToRightCount);
      Writeln(f,s);
      Writeln(f,'');
      l:=l^.next;
    end;
   CloseFile(f);
 end;

procedure TBPMSDGraph.FillLeftArray;
Var tmpNode:PMSDGraphNode;
          i:Integer;
          p:TBPMSDLeftRight;
          lr:Integer;
        posx:Integer;
         ind:Integer;
 begin
  {}
   if (FGNodesCount=0) then Exit;
   FLeftArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
      p:=GetNodeLeftRight(tmpNode^.BPNode.NodeNumber);
      if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
      lr:=Round(p.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
      ind:=IsLeftArray(lr);
      if ind=-1 then
        begin
         FLeftArray.Region[FLeftArray.RegionCount]:=lr;
         FLeftArray.Count[FLeftArray.RegionCount]:=0;
         inc(FLeftArray.RegionCount);
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

procedure TBPMSDGraph.FillRightArray;
Var tmpNode:PMSDGraphNode;
          i:Integer;
          p:TBPMSDLeftRight;
          lr:Integer;
        posx:Integer;
         ind:Integer;
 begin
  {}
   if (FGNodesCount=0) then Exit;
   FRightArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
      p:=GetNodeLeftRight(tmpNode^.BPNode.NodeNumber);
      if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
      lr:=Round(p.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
      ind:=IsRightArray(lr);
      if ind=-1 then
        begin
         FRightArray.Region[FRightArray.RegionCount]:=lr;
         FRightArray.Count[FRightArray.RegionCount]:=0;
         inc(FRightArray.RegionCount);
        end;
      tmpNode:=tmpNode^.next;
    end;
 end;

procedure TBPMSDGraph.FillBottomArray;
Var tmpNode:PMSDGraphNode;
          i:Integer;
         ind:Integer;
           b:Integer;
 begin
  {}
  if (FGNodesCount=0) then Exit;
   FBottomArray.RegionCount:=0;
   tmpNode:=FGraphNodes;
   while (tmpNode<>nil) do
    begin
     b:=tmpNode^.BPNode.Top+tmpNode^.BPNode.Height;
     ind:=IsBottomArray(b);
     if ind=-1 then
      begin
        FBottomArray.Region[FBottomArray.RegionCount]:=b;
        FBottomArray.Count[FBottomArray.RegionCount]:=0;
        inc(FBottomArray.RegionCount);
      end;
     tmpNode:=tmpNode^.next;
    end;
 end;

function  TBPMSDGraph.IsLeftArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FLeftArray.RegionCount-1) do
    begin
      if FLeftArray.Region[i]=value then Result:=i;
    end;
 end;

function  TBPMSDGraph.IsRightArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FRightArray.RegionCount-1) do
    begin
      if FRightArray.Region[i]=value then Result:=i;
    end;
 end;

function  TBPMSDGraph.IsBottomArray(value:Integer):Integer;
Var i:Integer;
 begin
   Result:=-1;
   for i:=0 to (FBottomArray.RegionCount-1) do
    begin
      if FBottomArray.Region[i]=value then Result:=i;
    end;
 end;

procedure TBPMSDGraph.DoTranslateTopology(Value:Boolean);
 begin
   FOwner.Visible:=False;
   FTranslateTopology:=Value;
   OpenLevel(FLevel,FCurGraph);
   TraceRoute;
   FOwner.Invalidate;
   FOwner.Visible:=True;
 end;

procedure TBPMSDGraph.RenumberNodesAndLinks;
Type la=record
      Links:array[0..600] of PBPLink;
      LinksCount:Integer;
      LinkRenamedFrom:array[0..600] of Boolean;
      LinkRenamedTo:array[0..600] of Boolean;
     end;
var i,j,k:Integer;
    nnn:Integer;
    onn:Integer;
    tmpNode:PBPNode;
    LinkArr:la;
    l:PBPLink;
 begin
    if FLinksCount=0 then Exit;
    l:=FLinks;
    for i:=0 to 600 do
     begin
      FCheckGraph.LinkRenamedFrom[i]:=False;
      FCheckGraph.LinkRenamedTo[i]:=False;
     end;
    for i:=0 to (FLinksCount-1) do
     begin
       LinkArr.Links[i]:=l;
       LinkArr.LinkRenamedFrom[i]:=False;
       LinkArr.LinkRenamedTo[i]:=False;
       inc(l);
     end;
    LinkArr.LinksCount:=FLinksCount;
    nnn:=0;
    for i:=0 to (FRootEntries-1) do
      begin
        for j:=0 to (FCheckGraph.NodesCount-1) do
          begin
            if (FCheckGraph.NodesGraph[j]=i) then
              begin
               onn:=FCheckGraph.Nodes[j]^.dwNodeNumber;
               FCheckGraph.Nodes[j]^.dwNodeNumber:=nnn;
               for k:=0 to (LinkArr.LinksCount-1) do
                 begin
{                   if (FCheckGraph.LinksGraph[k]=i) then
                     begin}
                       if (not(LinkArr.LinkRenamedFrom[k])) then
                         begin
                           if (LinkArr.Links[k]^.dwFromNodeNumber=onn) then
                             begin
                              LinkArr.Links[k]^.dwFromNodeNumber:=nnn;
                              LinkArr.LinkRenamedFrom[k]:=True;
                             end;
                         end;
                       if (not(LinkArr.LinkRenamedTo[k])) then
                         begin
                           if (LinkArr.Links[k]^.dwToNodeNumber=onn) then
                             begin
                              LinkArr.Links[k]^.dwToNodeNumber:=nnn;
                              LinkArr.LinkRenamedTo[k]:=True;
                             end;
                         end;
                    { end;}
                 end;
               inc(nnn);
              end;
          end;
      end;
 end;

procedure  TBPMSDGraph.UpdateLinksModel(X,Y:Integer;llabel:TBPLabel);
Var xc,yc:Integer;
    i,j:Integer;
    link:PMSDGraphLink;
 begin
   if FGLinksCount=0 then Exit;
   if llabel=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
    link:=FGraphLinks;
  { Update links model}
    for i:=0 to (FGLinksCount-1) do
      begin
        if (link^.BPFromLabel<>nil) then
          if (link^.BPFromLabel=llabel) then
            begin
              link^.llLink^.FromLeft[3]:=xc;
              link^.llLink^.FromTop[3]:=yc;
              link^.llLink^.FromAcceptPosition[3]:=True;
              FModified:=True;
            end;
        if (link^.BPToLabel<>nil) then
          if (link^.BPToLabel=llabel) then
            begin
              link^.llLink^.ToLeft[3]:=xc;
              link^.llLink^.ToTop[3]:=yc;
              link^.llLink^.ToAcceptPosition[3]:=True;
              FModified:=True;
            end;
        link:=link^.next;
      end;
 end;

procedure  TBPMSDGraph.CorrectLinksModel(delta:TPoint;NodeNum:DWORD;AcceptRect:TRect);
Var p:PMSDGraphLink;
    i:Integer;
    cnt:Integer;
    x,y:Integer;
    x1,y1:Integer;
    dx,dy:Integer;
    flag:Boolean;
    f1:Boolean;
    ff,ft:Boolean;
 begin
   { Correct links coordinates }
   if (FGLinksCount=0) then Exit;
   cnt:=FGLinksCount-1;
   if FOwner.VertScrollBar.Visible then dy:=FOwner.VertScrollBar.Position else dy:=0;
   if FOwner.HorzScrollBar.Visible then dx:=FOwner.HorzScrollBar.Position else dx:=0;
   p:=FGraphLinks;
   for i:=0 to cnt do
     begin
       f1:=((p^.FromNodeNumber=NodeNum) or (p^.ToNodeNumber=NodeNum));
       ff:=(p^.FromNodeNumber=NodeNum);
       ft:=(p^.ToNodeNumber=NodeNum);
       if (f1) then
          begin { Any link to this node }
            flag:=False; { !!! }
            if (p^.BPFromLabel<>nil) then
              if (p^.BPFromLabel.AcceptPosition) then
                 begin
                   if (ff) then Flag:=True;

                   x:=p^.BPFromLabel.LeftDragPos+delta.x;
                   if ((x+p^.BPFromLabel.Width)>AcceptRect.Right) then
                      x:=AcceptRect.Right-p^.BPFromLabel.Width;
                   if (x<AcceptRect.Left) then x:=AcceptRect.Left;

                   x1:=p^.BPFromLabel.Left+delta.x;
                   if ((x1+dx+p^.BPFromLabel.Width)>AcceptRect.Right) then
                      x1:=AcceptRect.Right-dx-p^.BPFromLabel.Width;
                   if ((x1+dx)<AcceptRect.Left) then
                      x1:=AcceptRect.Left-dx;

                   y:=p^.BPFromLabel.TopDragPos+delta.y;
                   if ((y+p^.BPFromLabel.Height)>AcceptRect.Bottom) then
                      y:=AcceptRect.Bottom-p^.BPFromLabel.Height;
                   if (y<AcceptRect.Top) then y:=AcceptRect.Top;

                   y1:=p^.BPFromLabel.Top+delta.y;
                   if ((y1+dy+p^.BPFromLabel.Height)>AcceptRect.Bottom) then
                      y1:=AcceptRect.Bottom-dy-p^.BPFromLabel.Height;
                   if ((y1+dy)<AcceptRect.Top) then
                      y1:=AcceptRect.Top-dy;
                   if Flag then
                   begin
                   p^.BPFromLabel.LeftDragPos:=x;
                   p^.BPFromLabel.TopDragPos:=y;
                   p^.BPFromLabel.Left:=x1;
                   p^.BPFromLabel.Top:=y1;
                   p^.BPFromLabel.AcceptPosition:=True;
                   UpdateLinksModel(x1+dx,y1+dy,p^.BPFromLabel);
                   Flag:=False;
                   end;
                 end;
            Flag:=False;
            if (p^.BPToLabel<>nil) then
              if (p^.BPToLabel.AcceptPosition) then
                 begin
                   if (ft) then Flag:=True;
                   x:=p^.BPToLabel.LeftDragPos+delta.x;
                   if ((x+p^.BPToLabel.Width)>AcceptRect.Right) then
                      x:=AcceptRect.Right-p^.BPToLabel.Width;
                   if (x<AcceptRect.Left) then x:=AcceptRect.Left;

                   x1:=p^.BPToLabel.Left+delta.x;
                   if ((x1+dx+p^.BPToLabel.Width)>AcceptRect.Right) then
                      x1:=AcceptRect.Right-dx-p^.BPToLabel.Width;
                   if ((x1+dx)<AcceptRect.Left) then
                      x1:=AcceptRect.Left-dx;
                   y:=p^.BPToLabel.TopDragPos+delta.y;
                   if ((y+p^.BPToLabel.Height)>AcceptRect.Bottom) then
                      y:=AcceptRect.Bottom-p^.BPToLabel.Height;
                   if (y<AcceptRect.Top) then y:=AcceptRect.Top;

                   y1:=p^.BPToLabel.Top+delta.y;
                   if ((y1+dy+p^.BPToLabel.Height)>AcceptRect.Bottom) then
                      y1:=AcceptRect.Bottom-dy-p^.BPToLabel.Height;
                   if ((y1+dy)<AcceptRect.Top) then
                      y1:=AcceptRect.Top-dy;
                   if Flag then
                   begin
                   p^.BPToLabel.LeftDragPos:=x;
                   p^.BPToLabel.TopDragPos:=y;
                   p^.BPToLabel.Left:=x1;
                   p^.BPToLabel.Top:=y1;
                   p^.BPToLabel.AcceptPosition:=True;
                   UpdateLinksModel(x1+dx,y1+dy,p^.BPToLabel);
                   Flag:=False;
                   end;
                 end;
          end;
        p:=p^.next;
     end;
 end;


procedure TBPMSDGraph.UpdateNodesModel(X,Y:Integer;node:TBPLSAGraphNode);
Var xc,yc:Integer;
    nodePtr:PMSDGraphNode;
    i:Integer;
 begin
   if FGNodesCount=0 then Exit;
   if node=nil then Exit;
   if FRatioWC=0 then Exit;
   if FRatioHC=0 then Exit;
  { Recalc X and Y coord to not scaled model }
   if FScaled or FPrinting then
    begin
     xc:=Round(X/FRatioWC);
     yc:=Round(Y/FRatioHC);
    end
   else
    begin
     xc:=x;
     yc:=y;
    end;
  { Update nodes model }
   nodePtr:=FGraphNodes;
   for i:=0 to (FGNodesCount-1) do
     begin
       if  (node<>nil) and
           (nodePtr^.BPNode=node) then
         begin
           nodePtr^.llNode^.Left[3]:=xc;
           nodePtr^.llNode^.Top[3]:=yc;
           nodePtr^.llNode^.AcceptPosition[3]:=True;
           FModified:=True;
         end;
       nodePtr:=nodePtr^.next;
     end;
 end;


procedure TBPMSDGraph.MyNodeMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
  if (Sender is TBPLSAGraphNode) and (Button=mbLeft) then
   (Sender as TBPLSAGraphNode).BeginDrag(False);
 end;

procedure TBPMSDGraph.MyLabelMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer); { Checked }
 begin
   if (Sender is TBPLabel) and (Button=mbLeft) then
        (Sender as TBPLabel).BeginDrag(True);
 end;

function  TBPMSDGraph.FillGraphLinksArray:TBPMSDLinkArray;
Var i:Integer;
   tmpL:PMSDGraphLink;
 begin
  { Fill Array with PMSDGraphLinks }
  Result.LinksCount:=0;
  if FGLinksCount=0 then Exit;
  tmpL:=FGraphLinks;
  for i:=0 to (FGLinksCount-1) do
    begin
      Result.Links[i]:=tmpL;
      tmpL:=tmpL^.next;
    end;
  Result.LinksCount:=FGLinksCount;
 end;

procedure TBPMSDGraph.ReorderFromGLA(var ar:TBPMSDLinkArray);
Var linkF,linkL:PMSDGraphLink;
    i,j:Integer;
    flag:Boolean;
 begin
  { Reorder Array by FromNode,FromLinkNumber }
   if ar.LinksCount=0 then Exit;
   flag:=False;
   while (not(Flag)) do
     begin
       Flag:=True;
       for i:=0 to (ar.LinksCount-2) do
        begin
        for j:=(i+1) to (ar.LinksCount-1) do
         begin
           linkF:=ar.Links[i];
           linkL:=ar.Links[j];
           if (linkF^.FromNodeNumber>linkL^.FromNodeNumber) or
              ((linkF^.FromNodeNumber=linkL^.FromNodeNumber) and
               (linkF^.FromLinkNumber>linkL^.FromLinkNumber)) then
              begin
                ar.Links[j]:=linkF;
                ar.Links[i]:=linkL;
                Flag:=False;
              end;
         end; { for j }
        end; {for i}
     end; { while not(flag) }
 end;

procedure TBPMSDGraph.ReorderToGLA(var ar:TBPMSDLinkArray);
Var linkF,linkL:PMSDGraphLink;
    i,j:Integer;
    flag:Boolean;
 begin
  { Reorder Array by ToNode,ToLinkNumber }
   if ar.LinksCount=0 then Exit;
   flag:=False;
   while (not(Flag)) do
     begin
       Flag:=True;
       for i:=0 to (ar.LinksCount-2) do
        begin
        for j:=(i+1) to (ar.LinksCount-1) do
         begin
           linkF:=ar.Links[i];
           linkL:=ar.Links[j];
           if (linkF^.ToNodeNumber>linkL^.ToNodeNumber) or
              ((linkF^.ToNodeNumber=linkL^.ToNodeNumber) and
               (linkF^.ToLinkNumber>linkL^.ToLinkNumber)) then
              begin
                ar.Links[j]:=linkF;
                ar.Links[i]:=linkL;
                Flag:=False;
              end;
         end; { for j }
        end; {for i}
     end; { while not(flag) }
 end;

function  TBPMSDGraph.GetNodeLeftRight(NodeNumber:DWORD):TBPMSDLeftRight;
Var i:Integer;
 begin
   Result.LeftRegion:=0;
   Result.RightRegion:=0;
   for i:=0 to (FNodeXArray.NodesCount-1) do
     begin
       if NodeNumber=FNodeXArray.NodeNumber[i] then
         begin
           Result.LeftRegion:=FNodeXArray.NodesXLeft[i];
           Result.RightRegion:=FNodeXArray.NodesXRight[i];
           Exit;
         end;
     end;
 end;


procedure   TBPMSDGraph.TraceLinks;  { Checked }
 Var    linkP:PMSDGraphLink;
        i:Integer;
        sx,sy:Integer;
        ex,ey:Integer;
        hw,hh:Integer;
        fc,tc:DWORD;
        fdc,tdc:DWORD;
        gnode:TBPLSAGraphNode;
        nodePS,nodePE:PMSDGraphNode;
        tx,ty:Integer;
        nfcd,ntcd:DWORD;
        lineWidth:Integer;
        hhh:Integer;
        mm:TBPMultipleMask;
        mft,mff:Boolean;
        coffy,coffx:Integer;
        lrx,rrx:Integer;
        lre,rre:Integer;
        posx:Integer;
        centerx:Integer;
        lr,lr1:TBPMSDLeftRight;
        fip:PMSDGraphNode;
        tmptmp:Integer;
        levdiff:Integer;
        lflc,ltlc:Integer;
        lfrc,ltrc:Integer;
        lfbc:Integer;
  begin
    if (FGNodesCount=0) then Exit;
    if (FGLinksCount=0) then Exit;
    gnode:=GetGraphNode(0);
    hw:=gnode.Width div 2;
    hh:=gnode.Height div 2;
    coffy:=hh div 12; { hm ? }
    coffx:=hw div 12; { hm ? }
    if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
    if FPrinting and (not(FScaled2)) then
      posx:=0;
    fip:=GetFirstInPoint;
    if (fip<>nil) then
      centerx:=fip^.BPNode.Left+(fip^.BPNode.Width div 2)
    else
      centerx:=(FDefWidth div 2)-posx;
{    posx:=FOwner.ClientRect.Left+FGlobalLeftSize+posx;}
    for i:=0 to (FGLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
       mm:=GetMultipleMask(i);
       mff:=IsMultipleFirst(i,True);
       mft:=IsMultipleFirst(i,False);
       sx:=linkP^.StartPoint.X;
       sy:=linkP^.StartPoint.Y;
       ex:=linkP^.EndPoint.X;
       ey:=linkP^.EndPoint.Y;
       fc:=linkP^.LinkFromCount;
       tc:=linkP^.LinkToCount;
       { Set First dot }
       linkP^.LineArrayX[0]:=sx;
       linkP^.LineArrayY[0]:=sy;
       linkP^.LinePointCount:=1;
       nodePS:=GetGraphNumberedNode(linkP^.FromNodeNumber);
       nodePE:=GetGraphNumberedNode(linkP^.ToNodeNumber);
       fdc:=nodePS^.BPNode.OutputLinksCount-fc;
       tdc:=nodePE^.BPNode.InputLinksCount-tc;
       levdiff:=NodePE^.LevelID-NodePS^.LevelID;
       lr:=GetNodeLeftRight(linkP^.FromNodeNumber);
       lrx:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
       rrx:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
       lr1:=GetNodeLeftRight(linkP^.ToNodeNumber);
       lre:=Round(lr1.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
       rre:=Round(lr1.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
       lflc:=LinkP^.LinkFromLeftCount;
       ltlc:=LinkP^.LinkToLeftCount;
       lfrc:=LinkP^.LinkFromRightCount;
       ltrc:=LinkP^.LinkToRightCount;
       lfbc:=LinkP^.LinkFromBottomCount;
       case (linkP^.dwFlags and BP_FROMTOMASK) of
        BP_RIGHT_LEFT: begin
                           case (LinkP^.LinkConnection) of
                             msdlc_onedown_notsecond: begin
                                                        linkP^.LineArrayX[1]:=ex;
                                                        linkP^.LineArrayY[1]:=ey;
                                                        linkP^.LinePointCount:=2;
                                                      end;
                             msdlc_onedown_second:    begin
                                                        if (linkP^.LinkLeftRight) then
                                                          begin { Left Link }
                                                            linkP^.LineArrayX[1]:=lrx+lflc*coffx;
                                                            linkP^.LineArrayY[1]:=sy;
                                                            linkP^.LineArrayX[2]:=lrx+lflc*coffx;
                                                            linkP^.LineArrayY[2]:=ey;
                                                            linkP^.LineArrayX[3]:=ex;
                                                            linkP^.LineArrayY[3]:=ey;
                                                            linkP^.LinePointCount:=4;
                                                          end   { Left Link }
                                                         else
                                                          begin { Right Link }
                                                            linkP^.LineArrayX[1]:=rrx-lfrc*coffx;
                                                            linkP^.LineArrayY[1]:=sy;
                                                            linkP^.LineArrayX[2]:=rrx-lfrc*coffx;
                                                            linkP^.LineArrayY[2]:=ey;
                                                            linkP^.LineArrayX[3]:=ex;
                                                            linkP^.LineArrayY[3]:=ey;
                                                            linkP^.LinePointCount:=4;
                                                          end;  { Right Link }
                                                      end;
                             msdlc_down:              begin
                                                        linkP^.LineArrayX[1]:=ex;
                                                        linkP^.LineArrayY[1]:=ey;
                                                        linkP^.LinePointCount:=2;
                                                      end;
                             msdlc_up:                begin
                                                        if (linkP^.LinkLeftRight) then
                                                          begin { Left Link }
                                                            linkP^.LineArrayX[1]:=sx;
                                                            linkP^.LineArrayY[1]:=sy+2*lfbc*coffy+FMinLineStep;
                                                            linkP^.LineArrayX[2]:=lre+FMinLineStep+ltlc*coffx;
                                                            linkP^.LineArrayY[2]:=sy+2*lfbc*coffy+FMinLineStep;
                                                            linkP^.LineArrayX[3]:=lre+FMinLineStep+ltlc*coffx;
                                                            linkP^.LineArrayY[3]:=ey;
                                                            linkP^.LineArrayX[4]:=ex;
                                                            linkP^.LineArrayY[4]:=ey;
                                                            linkP^.LinePointCount:=5;
                                                          end   { Left Link }
                                                         else
                                                          begin { Right Link }
                                                            linkP^.LineArrayX[1]:=sx;
                                                            linkP^.LineArrayY[1]:=sy+2*lfbc*coffy+FMinLineStep;
                                                            linkP^.LineArrayX[2]:=rre-FMinLineStep-ltrc*coffx;
                                                            linkP^.LineArrayY[2]:=sy+2*lfbc*coffy+FMinLineStep;
                                                            linkP^.LineArrayX[3]:=rre-FMinLineStep-ltrc*coffx;
                                                            linkP^.LineArrayY[3]:=ey;
                                                            linkP^.LineArrayX[4]:=ex;
                                                            linkP^.LineArrayY[4]:=ey;
                                                            linkP^.LinePointCount:=5;
                                                          end;  { Right Link }
                                                      end;
                           end; { case linkConnection }
                       end { RightLeft}
        else  begin
               { Main error link - not traced }
               linkP^.LineArrayX[1]:=ex;
               linkP^.LineArrayY[1]:=ey;
               linkP^.LinePointCount:=2;
              end;
       end; { case }
      end { Visible link }
     else
      begin
        linkP^.LineArrayX[0]:=linkP^.StartPoint.x;
        linkP^.LineArrayY[0]:=linkP^.StartPoint.y;
        linkP^.LineArrayX[1]:=linkP^.EndPoint.x;
        linkP^.LineArrayY[1]:=linkP^.EndPoint.y;
        linkP^.LinePointCount:=2;
      end;
     end; { for links }
  end;

 procedure  TBPMSDGraph.DrawLinks; { Checked }
  Var linkP:PMSDGraphLink;
      xxxlinkP:PMSDGraphLink;
         i,j:Integer;
         fx,fy,lx,ly:Integer;
         dx,dy,dx1,dy1,tx,ty:Integer;
         oldColor,cl:TColor;
         k:Integer;
         mls:Integer;
         linkFromType,linkToType:TLinkType;
         lineWidth:Integer;
         s:Integer;
         ops,ps:TPenStyle;
         gnode:PMSDGraphNode;
         xxx:Integer;
         NewMinArcRadius:Integer;
         NDelta,nd1,nd2:Integer;
         ox,oy,nx,ny:Integer;

function GetStartLabelX(sx,sy,ex,ey,y:Integer):Integer;
Var a:Double;
    x:Integer;
 begin
   if sx=ex then begin Result:=sx; Exit; end;
   if ey=sy then begin Result:=(sx+ex) div 2; Exit; end;
   a:=(sy-ey)/(sx-ex); { True }
   Result:=Round((y-ey)/a+ex);
 end;

  begin
   if (FGLinksCount=0) then Exit;
   oldColor:=FOwner.Canvas.Pen.Color;
   ops:=FOwner.Canvas.Pen.Style;
   mls:=MinLineStep div 2;
    for i:=0 to (FGLinksCount-1) do
     begin
       linkP:=GetGraphLink(i);
       if linkP^.Visible then
       begin
       cl:=LinkP^.Color;
       FOwner.Canvas.Pen.Color:=cl;
       ps:=LinkP^.PenStyle;
       FOwner.Canvas.Pen.Style:=ps;
       linkFromType:=GetLinkFrom(linkP);
       linkToType:=GetLinkTo(linkP);
  {    !!!Connectors!!!
       with FOwner.Canvas do
       begin
        case (LinkToType) of
        lt_Left: begin
               for k:=1 to MinLineEndPoint do
                begin
                 MoveTo(linkP^.EndPoint.x-k,linkP^.EndPoint.y-k);
                 LineTo(linkP^.EndPoint.x+k,linkP^.EndPoint.y-k);
                end;
                 MoveTo(linkP^.EndPoint.x,linkP^.EndPoint.y);
                 LineTo(linkP^.EndPoint.x,linkP^.EndPoint.y-1);
               end;
        end;
      end;}
       FOwner.Canvas.Pen.Color:=cl;
       FOwner.Canvas.Pen.Style:=ps;
       case (LinkFromType) of
        lt_Right: case (LinkP^.LinkConnection) of
                    msdlc_onedown_notsecond,msdlc_down:
                                begin
                                 xxxLinkP:=GetMultipleFirst(i,False);
                                 if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                                   (linkP^.BPFromLabel<>nil) and
                                   ((xxxlinkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                                   (xxxlinkP^.BPFromLabel<>nil)  then
                                begin
                                 xxx:=GetStartLabelX(xxxlinkP^.StartPoint.x,xxxlinkP^.StartPoint.y,
                                                     xxxlinkP^.EndPoint.x,xxxlinkP^.EndPoint.y,
                                                     xxxlinkP^.StartPoint.y+MinLabelY1*(xxxlinkP^.LinkFromCount-1)+MinLabelY+(xxxlinkP^.BPFromLabel.Height div 2));
                                 if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                                   begin
                                    linkP^.BPFromLabel.Top:=xxxlinkP^.StartPoint.y+MinLabelY1*(xxxlinkP^.LinkFromCount-1)+MinLabelY;
                                    linkP^.BPFromLabel.Left:=xxx+MinLabelX;
                                    linkP^.BPFromLabel.AcceptPosition:=False;
                                    DrawSS(xxx+1,xxxlinkP^.StartPoint.y+MinLabelY+MinLabelY1*(xxxlinkP^.LinkFromCount-1)+(xxxlinkP^.BPFromLabel.Height div 2),
                                    xxx+MinLabelX-1,xxxlinkP^.StartPoint.y+MinLabelY+MinLabelY1*(xxxlinkP^.LinkFromCount-1)+(xxxlinkP^.BPFromLabel.Height div 2),cl);
                                   end
                                 else
                                    DrawSS(xxx+1,
                                           xxxlinkP^.StartPoint.y+MinLabelY+MinLabelY1*(xxxlinkP^.LinkFromCount-1)+(xxxlinkP^.BPFromLabel.Height div 2),
                                           xxxlinkP^.BPFromLabel.Left-1,
                                           xxxlinkP^.BPFromLabel.Top+(xxxlinkP^.BPFromLabel.Height div 2),
                                           cl);
                                end;
                              end; {}
                    msdlc_onedown_second: begin
                                            if (linkP^.LinkLeftRight) then
                                              begin { Left Link }
                                               if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                                                   (linkP^.BPFromLabel<>nil) then
                                                begin
                                                 if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                                                  begin
                                                   linkP^.BPFromLabel.Left:=linkP^.StartPoint.x-4-MinLabelX-linkP^.BPFromLabel.Width;
                                                   linkP^.BPFromLabel.Top:=linkP^.StartPoint.y-MinLabelY-linkP^.BPFromLabel.Height;
                                                   linkP^.BPFromLabel.AcceptPosition:=False;
                                                   DrawSS(linkP^.StartPoint.x-5,linkP^.StartPoint.y-2,
                                                          linkP^.StartPoint.x-4-MinLabelX+1,linkP^.StartPoint.y-MinLabelY-((linkP^.BPFromLabel.Height) div 2),cl);
                                                  end
                                                 else
                                                   DrawSS(linkP^.StartPoint.x-5,
                                                          linkP^.StartPoint.y-2,
                                                          linkP^.BPFromLabel.Left+linkP^.BPFromLabel.Width+3,
                                                          linkP^.BPFromLabel.Top+((linkP^.BPFromLabel.Height) div 2),
                                                          cl);
                                                end;
                                              end   { Left Link }
                                             else
                                              begin { Right Link }
                                                if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                                                    (linkP^.BPFromLabel<>nil) then
                                                 begin
                                                  if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                                                   begin
                                                    linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                                                    linkP^.BPFromLabel.Top:=linkP^.StartPoint.y-MinLabelY-linkP^.BPFromLabel.Height;
                                                    linkP^.BPFromLabel.AcceptPosition:=False;
                                                    DrawSS(linkP^.StartPoint.x+2,linkP^.StartPoint.y-1,linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y-(linkP^.BPFromLabel.Height div 2)-MinLabelY,cl);
                                                   end
                                                  else
                                                    DrawSS(linkP^.StartPoint.x+2,
                                                           linkP^.StartPoint.y-1,
                                                           linkP^.BPFromLabel.Left-1,
                                                           linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                                                           cl);
                                                 end;
                                              end;  { Right Link }
                                          end;
                    msdlc_up: begin { msdlc_up }
                               if ((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                                   (linkP^.BPFromLabel<>nil) then
                                begin
                                 if FDiscardDrags or (not(linkP^.BPFromLabel.AcceptPosition)) then
                                   begin
                                    linkP^.BPFromLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                                    linkP^.BPFromLabel.Top:=linkP^.StartPoint.y+MinLabelY1*(linkP^.LinkFromCount-1)+MinLabelY;
                                    linkP^.BPFromLabel.AcceptPosition:=False;
                                    DrawSS(linkP^.StartPoint.x+1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-1)+(linkP^.BPFromLabel.Height div 2),
                                    linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-1)+(linkP^.BPFromLabel.Height div 2),cl);
                                   end
                                 else
                                    DrawSS(linkP^.StartPoint.x+1,
                                           linkP^.StartPoint.y+MinLabelY+MinLabelY1*(linkP^.LinkFromCount-1)+(linkP^.BPFromLabel.Height div 2),
                                           linkP^.BPFromLabel.Left-1,
                                           linkP^.BPFromLabel.Top+(linkP^.BPFromLabel.Height div 2),
                                           cl);
                                end;
                              end; { msdlc_up}

                  end; { case linkConnection }
        end; { end Case LinkFromType }
       case (LinkToType) of
        lt_Left:  case (linkP^.LinkConnection) of
                    msdlc_onedown_notsecond,msdlc_down:
                              begin
                                xxxLinkP:=GetMultipleFirst(i,False);
                                if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                                   (linkP^.BPToLabel<>nil) and
                                   ((xxxlinkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                                   (xxxlinkP^.BPToLabel<>nil) then
                                begin
                                 xxx:=GetStartLabelX(xxxlinkP^.StartPoint.x,xxxlinkP^.StartPoint.y,
                                                     xxxlinkP^.EndPoint.x,xxxlinkP^.EndPoint.y,
                                                     xxxlinkP^.StartPoint.y+MinLabelY1*(xxxlinkP^.LinkFromCount-1)+MinLabelY+(xxxlinkP^.BPToLabel.Height div 2));
                                 if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                                   begin
                                    linkP^.BPToLabel.Left:=xxx+MinLabelX;
                                    linkP^.BPToLabel.Top:=linkP^.EndPoint.y-MinLabelY-MinLabelY1*(linkP^.LinkToCount-1)-linkP^.BPToLabel.Height;
                                    linkP^.BPToLabel.AcceptPosition:=False;
                                    DrawSS(xxx+1,xxxlinkP^.EndPoint.y-MinLabelY-MinLabelY1*(xxxlinkP^.LinkToCount-1)-(xxxlinkP^.BPToLabel.Height div 2),
                                           xxx+MinLabelX-1,xxxlinkP^.EndPoint.y-MinLabelY-MinLabelY1*(xxxlinkP^.LinkToCount-1)-(xxxlinkP^.BPToLabel.Height div 2),cl);
                                   end
                                  else
                                    DrawSS(xxx+1,
                                           xxxlinkP^.EndPoint.y-MinLabelY-MinLabelY1*(xxxlinkP^.LinkToCount-1)-(xxxlinkP^.BPToLabel.Height div 2),
                                           xxxlinkP^.BPToLabel.Left-1,
                                           xxxlinkP^.BPToLabel.Top+(xxxlinkP^.BPToLabel.Height div 2),cl);
                                end;
                              end;
                    msdlc_onedown_second,msdlc_up:
                              begin
                                if (linkP^.LinkLeftRight) then
                                  begin { Left Link}
                                                if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                                                   (linkP^.BPToLabel<>nil) then
                                                begin
                                                 if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                                                  begin
                                                   linkP^.BPToLabel.Left:=linkP^.StartPoint.x-4-MinLabelX-linkP^.BPToLabel.Width;
                                                   linkP^.BPToLabel.Top:=linkP^.StartPoint.y-MinLabelY-linkP^.BPToLabel.Height;
                                                   linkP^.BPToLabel.AcceptPosition:=False;
                                                   DrawSS(linkP^.StartPoint.x-5,linkP^.StartPoint.y-2,
                                                          linkP^.StartPoint.x-4-MinLabelX+1,linkP^.StartPoint.y-MinLabelY-((linkP^.BPToLabel.Height) div 2),cl);
                                                  end
                                                 else
                                                   DrawSS(linkP^.StartPoint.x-5,
                                                          linkP^.StartPoint.y-2,
                                                          linkP^.BPToLabel.Left+linkP^.BPToLabel.Width+3,
                                                          linkP^.BPToLabel.Top+((linkP^.BPToLabel.Height) div 2),
                                                          cl);
                                                end;
                                  end   { Left Link}
                                 else
                                  begin { Right Link}
                                                 if ((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                                                    (linkP^.BPToLabel<>nil) then
                                                 begin
                                                  if FDiscardDrags or (not(linkP^.BPToLabel.AcceptPosition)) then
                                                   begin
                                                    linkP^.BPToLabel.Left:=linkP^.StartPoint.x+MinLabelX;
                                                    linkP^.BPToLabel.Top:=linkP^.StartPoint.y-MinLabelY-linkP^.BPToLabel.Height;
                                                    linkP^.BPToLabel.AcceptPosition:=False;
                                                    DrawSS(linkP^.StartPoint.x+2,linkP^.StartPoint.y-1,linkP^.StartPoint.x+MinLabelX-1,linkP^.StartPoint.y-(linkP^.BPToLabel.Height div 2)-MinLabelY,cl);
                                                   end
                                                  else
                                                    DrawSS(linkP^.StartPoint.x+2,
                                                           linkP^.StartPoint.y-1,
                                                           linkP^.BPToLabel.Left-1,
                                                           linkP^.BPToLabel.Top+(linkP^.BPToLabel.Height div 2),
                                                           cl);
                                                 end;
                                  end;  { Right Link}
                              end;
                  end;
        end;
        FOwner.Canvas.Pen.Color:=cl;
        FOwner.Canvas.Pen.Style:=ps;
        for j:=0 to (linkP^.LinePointCount-1) do
         begin
          tx:=linkP^.LineArrayX[j];
          ty:=linkP^.LineArrayY[j];
          NewMinArcRadius:=MinArcRadius;
          if j=0 then FOwner.Canvas.MoveTo(tx,ty);
          if (j=(linkP^.LinePointCount-1)) then FOwner.Canvas.LineTo(tx,ty);
          if (j<>0) and (j<>(linkP^.LinePointCount-1)) then
           begin
            ox:=linkP^.LineArrayX[j-1];
            oy:=linkP^.LineArrayY[j-1];
            nx:=linkP^.LineArrayX[j+1];
            ny:=linkP^.LineArrayY[j+1];
            if nx=tx then
              nd1:=ABS(ny-ty)
            else
              nd1:=ABS(nx-tx);
            if ox=tx then
              nd2:=ABS(ty-oy)
            else
              nd2:=ABS(tx-ox);
            if nd1<nd2 then nDelta:=nd1 else nDelta:=nd2;
            if (NewMinArcRadius>(nDelta div 2)) then NewMinArcRadius:=nDelta div 2;
            dx:=SignedVector(linkP^.LineArrayX[j+1]-tx,NewMinArcRadius);
            dy:=SignedVector(linkP^.LineArrayY[j+1]-ty,NewMinArcRadius);
            dx1:=SignedVector(linkP^.LineArrayX[j-1]-tx,NewMinArcRadius);
            dy1:=SignedVector(linkP^.LineArrayY[j-1]-ty,NewMinArcRadius);
            if (dx*dy1-dx1*dy)>0 then
             begin
            fx:=tx+dx;
            fy:=ty+dy;
            lx:=tx+dx1;
            ly:=ty+dy1;
             end
            else
             begin
            fx:=tx+dx1;
            fy:=ty+dy1;
            lx:=tx+dx;
            ly:=ty+dy;
             end;
            FOwner.Canvas.Arc(tx+2*dx,ty+2*dy,tx+2*dx1,ty+2*dy1,fx,fy,lx,ly);
             if (dx*dy1-dx1*dy)<0 then
              begin
                 FOwner.Canvas.LineTo(fx,fy);
                 FOwner.Canvas.MoveTo(lx,ly);
              end
              else
              begin
                 FOwner.Canvas.LineTo(lx,ly);
                 FOwner.Canvas.MoveTo(fx,fy);
              end;
           end;
         end;
     end; { Visible link }
    end; { For }

    FOwner.Canvas.Pen.Color:=oldColor;
    FOwner.Canvas.Pen.Style:=ops;
  end;


procedure  TBPMSDGraph.TraceLocalStartEndPoints; { Checked }
 Var linkP:PMSDGraphLink;
     gnode:PMSDGraphNode;
         i:Integer;
       w,h:Integer;
       w1,h1:Integer;
       posx,posy:Integer;
       linkFromType,linkToType:TLinkType;
       lc:Integer;
       mm:TBPMultipleMask;
       mff,mft:Boolean;
  begin
   { SetUp Start & End points of Links }
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   if FOwner.HorzScrollBar.Visible then
     posx:=FOwner.HorzScrollBar.ScrollPos
   else
     posx:=0;
   if FOwner.VertScrollBar.Visible then
     posy:=FOwner.VertScrollBar.ScrollPos
   else
     posx:=0;
   if FPrinting then
    begin
      if not(FScaled2) then
       begin
        posx:=0;
        posy:=0;
       end;
    end;
   for i:=0 to (FGLinksCount-1) do
    begin
      linkP:=GetGraphLink(i);
      if linkP^.Visible then
      begin
      mm:=GetMultipleMask(i);
      mft:=IsMultipleFirst(i,False);
      mff:=IsMultipleFirst(i,True);
      linkFromType:=GetLinkFrom(linkP);
      linkToType:=GetLinkTo(linkP);
      gnode:= GetGraphNumberedNode(linkP^.FromNodeNumber);
      { begin StartPoint }
      if (gnode<>nil) then
       begin
         { local node }
         if (mft) or
         ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) then
         lc:=linkP^.LinkFromCount else
         lc:=GetMultipleCountFrom(i);
         case (LinkFromType) of
          lt_Right: begin
                      case (linkp^.LinkConnection) of
                        msdlc_onedown_notsecond,msdlc_down,msdlc_up: begin { Bottom Link }
                                                                      w1:=gnode^.BPNode.width div (gnode^.BPNode.BottomLinksCount+1);
                                                                      w:=gnode^.BPNode.left+w1*lc;
                                                                      h:=gnode^.BPNode.top+gnode^.BPNode.Height;
                                                                     end;  { Bottom Link }
                        msdlc_onedown_second: begin
                                                 if (linkP^.LinkLeftRight) then
                                                   begin { Left Link }
                                                     w:=gnode^.BPNode.left;
                                                     h1:=gnode^.BPNode.Height div (gnode^.BPNode.LeftLinksCount+1);
                                                     h:=gnode^.BPNode.top+h1*lc;
                                                   end   { Left Link }
                                                  else
                                                   begin { Right Link }
                                                     w:=gnode^.BPNode.left+gnode^.BPNode.width;
                                                     h1:=gnode^.BPNode.Height div (gnode^.BPNode.RightLinksCount+1);
                                                     h:=gnode^.BPNode.top+h1*lc;
                                                   end;  { Right Link }
                                              end;
                      end; { case linkconnection }
                   end; { case linkfromtype }
         end;
         linkP^.StartPoint.x:=w;
         linkP^.StartPoint.y:=h;
       end;
      { End StartPoint }
      gnode:=GetGraphNumberedNode(linkP^.ToNodeNumber);
      { begin EndPoint }
      if (gnode<>nil) then
       begin
         { local node }
        if (mff) or
           ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) then
        lc:=linkP^.LinkToCount else
        lc:=GetMultipleCountTo(i);
         case (LinkToType) of
          lt_Left:  begin
                      case (linkP^.LinkConnection) of
                        msdlc_onedown_notsecond,msdlc_down:  begin { Top Link }
                                                               w1:=gnode^.BPNode.width div (gnode^.BPNode.TopLinksCount+1);
                                                               w:=gnode^.BPNode.left+w1*lc;
                                                               h:=gnode^.BPNode.top;
                                                             end; { Top Link }
                        msdlc_onedown_second,msdlc_up: begin
                                                         if (linkP^.LinkLeftRight) then
                                                            begin { Left Link }
                                                              w:=gnode^.BPNode.left;
                                                              h1:=gnode^.BPNode.Height div (gnode^.BPNode.LeftLinksCount+1);
                                                              h:=gnode^.BPNode.top+h1*lc;
                                                            end   { Left Link }
                                                           else
                                                            begin { Right Link }
                                                              w:=gnode^.BPNode.left+gnode^.BPNode.width;
                                                              h1:=gnode^.BPNode.Height div (gnode^.BPNode.RightLinksCount+1);
                                                              h:=gnode^.BPNode.top+h1*lc;
                                                            end;  { Right Link }
                                                         end;
                      end; { case linkconnection }
                   end;
         end;
         linkP^.EndPoint.x:=w;
         linkP^.EndPoint.y:=h;
       end;
       { End EndPoint }
      end; { LinkP^.Visible }
    end; { for i }
  end;



procedure  TBPMSDGraph.TraceLinksToNodeCounters; { Checked }
 Var linkP:PMSDGraphLink;
     gnode:TBPLSAGraphNode;
     nodePS:PMSDGraphNode;
     nodePE:PMSDGraphNode;
       i,j:Integer;
     linkFromType,linkToType:TLinkType;
        mm:TBPMultipleMask;
       fip:PMSDGraphNode;
   centerx:Integer;
    mff,mft:Boolean;
   laf,lat:TBPMSDLinkArray;
     sx,sy:Integer;
     ex,ey:Integer;
   levDiff:Integer;
      posx:Integer;
 llis,llie:Integer;
 rlis,rlie:Integer;
      blis:Integer;
    lr,lr1:TBPMSDLeftRight;
    lrx,rrx,lre,rre:Integer;
     hm:TBPMSDMultipleCountEx;
  begin
   { Calc links count for every node }
   {TMSDLinkConnection=(msdlc_onedown_notsecond,msdlc_onedown_second,msdlc_down,msdlc_up);}
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   fip:=GetFirstInPoint;
   if FOwner.HorzScrollBar.Visible then posx:=FOwner.HorzScrollBar.ScrollPos else posx:=0;
   if (fip<>nil) then
      centerx:=fip^.BPNode.Left+(fip^.BPNode.Width div 2)
    else
      centerx:=(FDefWidth div 2)-posx;
   { New code - filling Left,Right,Bottom regions arrays }
   FillLeftArray;
   FillRightArray;
   FillBottomArray;
   { End new code }
   laf:=FillGraphLinksArray;
   lat:=FillGraphLinksArray;
   ReorderFromGLA(laf);
   ReorderToGLA(lat);
   for i:=0 to (FGNodesCount-1) do
    begin { for nodes }
     gnode:=GetGraphNode(i);
{     gnode.OutputCount:=0;}
     if (gnode<>nil) then
      begin { gnode<>nil}
         for j:=0 to (laf.LinksCount-1) do
          begin { for from links }
            linkP:=laf.Links[j];
            if LinkP^.Visible then
             begin { link visible }
              linkFromType:=GetLinkFrom(linkP);
              mm:=GetMultipleMaskEx(j,laf);
              mff:=IsMultipleFirstEx(j,True,laf);
              mft:=IsMultipleFirstEx(j,False,laf);
              nodePS:=GetGraphNumberedNode(linkP^.FromNodeNumber);
              nodePE:=GetGraphNumberedNode(linkP^.ToNodeNumber);
              sx:=nodePS^.BPNode.Left+(nodePS^.BPNode.Width div 2);
              sy:=nodePS^.BPNode.Top+(nodePS^.BPNode.Height div 2);
              ex:=nodePE^.BPNode.Left+(nodePE^.BPNode.Width div 2);
              ey:=nodePE^.BPNode.Top+(nodePS^.BPNode.Height div 2);
              levDiff:=nodePE^.LevelID-nodePS^.LevelID;
              lr:=GetNodeLeftRight(linkP^.FromNodeNumber);
              lrx:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
              rrx:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
              lr1:=GetNodeLeftRight(linkP^.ToNodeNumber);
              lre:=Round(lr1.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
              rre:=Round(lr1.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
              llis:=IsLeftArray(lrx);
              llie:=IsLeftArray(lre);
              rlis:=IsRightArray(rrx);
              rlie:=IsRightArray(rre);
              blis:=IsBottomArray(nodePS^.BPNode.Top+nodePS^.BPNode.Height);
              if (linkP^.FromNodeNumber=gnode.NodeNumber) then
                begin { gnode }
                  { if not multiple link from or first multiple link }
                 if ((mm<>bpmm_To) and (mm<>bpmm_FromTo)) or
                    (mft and ((mm=bpmm_To) or (mm=bpmm_FromTo))) then
                  begin
                  case (LinkFromType) of
                   lt_Right:  begin

                               if (sy<ey) then
                                 begin { DownLink }
                                   if (levDiff=1) and (not(nodePE^.SecondColumn)) then
                                     begin { OneLevel directional downlink }
                                       linkP^.LinkConnection:=msdlc_onedown_notsecond;
                                       gnode.BottomLinksCount:=gnode.BottomLinksCount+1;
                                       linkP^.LinkFromCount:=gnode.BottomLinksCount;
                                     end   { OneLevel directional downlink }
                                   else
                                     begin
                                       if (levDiff=1) and (nodePE^.SecondColumn) then
                                         begin { OneLevel Second Column link !!! }
                                           linkP^.LinkConnection:=msdlc_onedown_second;
                                           if (nodePE^.FirstRow) then
                                            begin { Left Link }
                                             FLeftArray.Count[llis]:=FLeftArray.Count[llis]+1;
                                             gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                             linkP^.LinkFromCount:=gnode.LeftLinksCount;
                                             linkP^.LinkFromLeftCount:=FLeftArray.Count[llis];
                                             LinkP^.LinkLeftRight:=True;
                                            end   { Left Link }
                                           else
                                            begin { Right Link }
                                             FRightArray.Count[rlis]:=FRightArray.Count[rlis]+1;
                                             gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                             linkP^.LinkFromCount:=gnode.RightLinksCount;
                                             linkP^.LinkFromRightCount:=FRightArray.Count[rlis];
                                             LinkP^.LinkLeftRight:=False;
                                            end;  { Right Link }
                                         end   { OneLevel Second Column link !!! }
                                        else
                                         begin { Down Link }
                                           linkP^.LinkConnection:=msdlc_down;
                                           gnode.BottomLinksCount:=gnode.BottomLinksCount+1;
                                           linkP^.LinkFromCount:=gnode.BottomLinksCount;
                                         end;  { Down Link }
                                     end;
                                 end   { DownLink }
                               else
                                 begin { UpLink }
                                   FBottomArray.Count[blis]:=FBottomArray.Count[blis]+1;
                                   linkP^.LinkConnection:=msdlc_up;
                                   gnode.BottomLinksCount:=gnode.BottomLinksCount+1;
                                   linkP^.LinkFromCount:=gnode.BottomLinksCount;
                                   linkP^.LinkFromBottomCount:=FBottomArray.Count[blis];
                                 end;  { UpLink }

                               gnode.OutputLinksCount:=gnode.OutputLinksCount+1;
                               {CorrectMultipleCountFromEx(j,laf);}
                             {  linkP^.LinkFromCount:=gnode.OutputLinksCount;  !!! OLD CODE TO RESTORE !!! }
                              end;
                  end;
                  end else
                    begin
                    hm:=GetMultipleCountFromEx(j,laf);
                    linkP^.LinkFromCount:=hm.Count;
                    linkP^.LinkFromLeftCount:=hm.Left;
                    linkP^.LinkFromRightCount:=hm.Right;
                    linkP^.LinkFromBottomCount:=hm.Bottom;
                    end;
                  { end if multiple from }
                end;
             end; { link visible }
          end; { for from links}

         for j:=0 to (lat.LinksCount-1) do
          begin { for to links }
            linkP:=lat.Links[j];
            if LinkP^.Visible then
             begin { link visible }
              linkToType:=GetLinkTo(linkP);
              mm:=GetMultipleMaskEx(j,lat);
              mff:=IsMultipleFirstEx(j,True,lat);
              mft:=IsMultipleFirstEx(j,False,lat);
              nodePS:=GetGraphNumberedNode(linkP^.FromNodeNumber);
              nodePE:=GetGraphNumberedNode(linkP^.ToNodeNumber);
              sx:=nodePS^.BPNode.Left+(nodePS^.BPNode.Width div 2);
              sy:=nodePS^.BPNode.Top+(nodePS^.BPNode.Height div 2);
              ex:=nodePE^.BPNode.Left+(nodePE^.BPNode.Width div 2);
              ey:=nodePE^.BPNode.Top+(nodePE^.BPNode.Height div 2);
              levDiff:=nodePE^.LevelID-nodePS^.LevelID;
              lr:=GetNodeLeftRight(linkP^.FromNodeNumber);
              lrx:=Round(lr.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
              rrx:=Round(lr.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
              lr1:=GetNodeLeftRight(linkP^.ToNodeNumber);
              lre:=Round(lr1.LeftRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
              rre:=Round(lr1.RightRegion*FRatioX)+FOwner.ClientRect.Left+FGlobalLeftSize-posx;
              llis:=IsLeftArray(lrx);
              llie:=IsLeftArray(lre);
              rlis:=IsRightArray(rrx);
              rlie:=IsRightArray(rre);
              blis:=IsBottomArray(nodePS^.BPNode.Top+nodePS^.BPNode.Height);
              if (linkP^.ToNodeNumber=gnode.NodeNumber) then
                begin
                 if ((mm<>bpmm_From) and (mm<>bpmm_FromTo)) or
                    (mff and ((mm=bpmm_From) or (mm=bpmm_FromTo))) then
                  begin
                  case (LinkToType) of
                   lt_Left:   begin
                               if (sy<ey) then
                                 begin { DownLink }
                                   if (levDiff=1) and (not(nodePE^.SecondColumn)) then
                                     begin { OneLevel directional downlink }
                                       linkP^.LinkConnection:=msdlc_onedown_notsecond;
                                       gnode.TopLinksCount:=gnode.TopLinksCount+1;
                                       linkP^.LinkToCount:=gnode.TopLinksCount;
                                     end   { OneLevel directional downlink }
                                   else
                                     begin
                                       if (levDiff=1) and (nodePE^.SecondColumn) then
                                         begin { OneLevel Second Column link !!! }
                                           linkP^.LinkConnection:=msdlc_onedown_second;
                                           if (nodePE^.FirstRow) then
                                            begin { Left Link }
                                             gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                             linkP^.LinkToCount:=gnode.LeftLinksCount;
                                             LinkP^.LinkLeftRight:=True;
                                            end   { Left Link }
                                           else
                                            begin { Right Link }
                                             gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                             linkP^.LinkToCount:=gnode.RightLinksCount;
                                             LinkP^.LinkLeftRight:=False;
                                            end;  { Right Link }
                                         end   { OneLevel Second Column link !!! }
                                        else
                                         begin { Down Link }
                                           linkP^.LinkConnection:=msdlc_down;
                                           gnode.TopLinksCount:=gnode.TopLinksCount+1;
                                           linkP^.LinkToCount:=gnode.TopLinksCount;
                                         end;  { Down Link }
                                     end;
                                 end   { DownLink }
                               else
                                 begin { UpLink }
                                   linkP^.LinkConnection:=msdlc_up;
                                   if (sx<centerx) then
                                     begin
                                       FLeftArray.Count[llie]:=FLeftArray.Count[llie]+1;
                                       gnode.LeftLinksCount:=gnode.LeftLinksCount+1;
                                       linkP^.LinkToCount:=gnode.LeftLinksCount;
                                       linkP^.LinkToLeftCount:=FLeftArray.Count[llie];
                                       LinkP^.LinkLeftRight:=True;
                                     end
                                    else
                                     begin
                                       FRightArray.Count[rlie]:=FRightArray.Count[rlie]+1;
                                       gnode.RightLinksCount:=gnode.RightLinksCount+1;
                                       linkP^.LinkToCount:=gnode.RightLinksCount;
                                       linkP^.LinkToRightCount:=FRightArray.Count[rlie];
                                       LinkP^.LinkLeftRight:=False;
                                     end;
                                 end;  { UpLink }
                              gnode.InputLinksCount:=gnode.InputLinksCount+1;
                             { CorrectMultipleCountToEx(j,lat);}
                            {  linkP^.LinkToCount:=gnode.InputLinksCount; !!! OLD CODE TO RESTORE !!! }
                              end;
                  end;
                  end else
                    begin
                     hm:=GetMultipleCountToEx(j,lat);
                     linkP^.LinkToCount:=hm.Count;
                     linkP^.LinkToLeftCount:=hm.Left;
                     linkP^.LinkToRightCount:=hm.Right;
                    end;
                end;
             end; { link visible }
          end; { for to links}

      end; { node<>nil}
    end; { for nodes }
  end;



procedure  TBPMSDGraph.TraceNodesToLinksCounters; { Checked }
  Var linkP:PMSDGraphLink;
         i:Integer;
 begin
   if (FGLinksCount=0) then Exit;
   for i:=0 to (FGLinksCount-1) do
    begin
     linkP:=GetGraphLink(i);
     linkP^.LinkFromCount:=0;
     linkP^.LinkToCount:=0;
     linkP^.LinkFromLeftCount:=0;
     linkP^.LinkToLeftCount:=0;
     linkP^.LinkFromRightCount:=0;
     linkP^.LinkToRightCount:=0;
     linkP^.LinkFromBottomCount:=0;
     linkP^.MinimalXFrom:=0;
     linkP^.MinimalXTo:=0;
     linkP^.MinimalYFrom:=0;
     linkP^.MinimalYTo:=0;
  end;
 end;


function  TBPMSDGraph.GetOutputLinksArray(node:PMSDGraphNode):TBPMSDLinkArray;
Var tmpL:PMSDGraphLink;
       i:Integer;
 begin
   Result.LinksCount:=0;
   if (FGLinksCount=0) then Exit;
   tmpL:=FGraphLinks;
    for i:=0 to (FGLinksCount-1) do
     begin
       if (tmpL^.FromNodeNumber=node^.BPNode.NodeNumber) then
        begin
          Result.Links[Result.LinksCount]:=tmpL;
          Result.LinksCount:=Result.LinksCount+1;
        end;
       tmpL:=tmpL^.next;
     end;
 end;


function  TBPMSDGraph.GetOutputNodesArray(node:PMSDGraphNode):TBPMSDNodeArray;
Var tmpLinks:TBPMSDLinkArray;
            i:Integer;
            j:Integer;
         tmpN:PMSDGraphNode;
         Addflag:Boolean;
 begin
   Result.NodesCount:=0;
   tmpLinks:=GetOutputLinksArray(node);
   for i:=0 to (tmpLinks.LinksCount-1) do
     begin
       tmpN:=GetGraphNumberedNode(tmpLinks.Links[i]^.ToNodeNumber);
       if (tmpN<>nil) then
        begin
         AddFlag:=True;
         for j:=0 to (Result.NodesCount-1) do
          begin
            if (Result.Nodes[j]=tmpN) then AddFlag:=False;
          end;
         if AddFlag then
          begin
           Result.Nodes[Result.NodesCount]:=tmpN;
           Result.NodeNumber[Result.NodesCount]:=tmpLinks.Links[i]^.ToNodeNumber;
           inc(Result.NodesCount);
          end;
        end;
     end;
 end;

procedure TBPMSDGraph.SortOutputNodesArray(var GNodes:TBPMSDNodeArray);
Var nodeF,nodeL:PMSDGraphNode;
    numF,numL:DWORD;
    i,j:Integer;
    flag:Boolean;
 begin
  { Hm LeftRight order }
    if (GNodes.NodesCount<2) then Exit;
    flag:=False;
    while (not(Flag)) do
     begin
       Flag:=True;
       for i:=0 to (GNodes.NodesCount-2) do
        begin
        for j:=(i+1) to (GNodes.NodesCount-1) do
         begin
           nodeF:=Gnodes.Nodes[i];
           nodeL:=GNodes.Nodes[j];
           numF:=GNodes.NodeNumber[i];
           numL:=GNodes.NodeNumber[j];
            { Changed znak for comparing model }
           if (numF>numL) then
              begin
                GNodes.Nodes[j]:=nodeF;
                GNodes.Nodes[i]:=nodeL;
                GNodes.NodeNumber[j]:=numF;
                GNodes.NodeNumber[i]:=numL;
                Flag:=False;
              end;
         end; { for j }
        end; { for i}
     end;
 end;


function TBPMSDGraph.CheckGraphForForwardDirectionLink(node:PMSDGraphNode;const ar:TBPMSDNodeArray):Boolean;
Var i:Integer;
 begin
   Result:=False;
   if node=nil then Exit;
   if (ar.NodesCount<3) then Exit;
   Result:=True;
   for i:=0 to (ar.NodesCount-1) do
     begin
       if (node^.BPNode.NodeNumber>ar.Nodes[i]^.BPNode.NodeNumber) then
        begin
         Result:=False;
         Exit;
        end;
     end;
 end;



function  TBPMSDGraph.AnalizeNode(level:Integer;p:TPoint;node,oldnode:PMSDGraphNode):TPoint;
Var p1,a,p2,p3:TPoint;
    w,h:Integer;
    tmpNodes:TBPMSDNodeArray;
    nx,ny,mx,my:Integer;
    i,j:Integer;
    tmpN:PMSDGraphNode;
    rr,rl:Integer;
    ind,tmpnc:Integer;
    tmpx:Integer;

function MaxInt(a,b:Integer):Integer;
 begin
  if a<b then Result:=b else Result:=a;
 end;

 begin
     Result:=p;
{1}  if node=nil then Exit;
{2}  w:=Round(FMaxWidth*1.1);
     h:=Round(FMaxHeight*1.1);
{     if w>h then h:=Round(w/NodeRatio) else
     w:=Round(h*NodeRatio);}
{3}  p1.x:=p.x+2*w;
     p1.y:=p.y+2*h;
{4}  if node^.NodePassed then
       begin
         if (oldnode<>nil) and
           (oldnode^.BPNode.NodeNumber>=node^.BPNode.NodeNumber) then Exit; {  Reward Link }
{4.1}    nx:=0;
         ny:=0;
         mx:=p.x+(w div 2);
         my:=p.y+(h div 2);
         for i:=0 to (node^.NodeXYCount-1) do
          begin
            nx:=nx+node^.NodeX[i];
            if ny<node^.NodeY[i] then ny:=node^.NodeY[i];
          end;
         if ny<my then ny:=my;
         nx:=nx+mx;
         node^.NodeXYCount:=node^.NodeXYCount+1;
         node^.NodeX[node^.NodeXYCount-1]:=mx;
         node^.NodeY[node^.NodeXYCount-1]:=my;
         nx:=nx div node^.NodeXYCount;
         {Set FinalX & FinalY }
         node^.FinalX:=nx;
         node^.FinalY:=ny;
         if (node^.LevelID<level) then node^.LevelID:=level;
         rr:=MaxInt(p1.x{p.x - for true},nx+(w div 2)+w);
         Result.x:=rr;
         Result.y:=MaxInt(p1.y,ny+(h div 2)+h);
         if (rr>node^.BPNode.RightRegion) then node^.BPNode.RightRegion:=rr;
         if (p.x<node^.BPNode.LeftRegion) then node^.BPNode.LeftRegion:=p.x;
         Exit;
       end;
{5}  node^.NodePassed:=True;
{6}  tmpNodes:=GetOutputNodesArray(node);
{7}  SortOutputNodesArray(tmpNodes);
     node^.BPNode.OutputCount:=1;
     p3.x:=0;
     p3.y:=0;
   if (tmpNodes.NodesCount>2) and CheckGraphForForwardDirectionLink(node,tmpNodes) then
     begin { 2 stolbeza }
       ny:=0;
       nx:=0;
       tmpnc:=tmpNodes.NodesCount;
       for j:=0 to ((tmpnc-1) div 2) do { column }
        begin
          a.x:=0;
          a.y:=j*2*h;
          for i:=0 to 1 do  { row }
           begin
             ind:=j*2+i; { ind=column*2+row }
             if (ind<tmpnc) then
              begin {   }
               tmpN:=tmpNodes.Nodes[ind];
                if (j>0) then
                 begin
                  tmpN^.SecondColumn:=True; { Set second column factor }
                 end;
               tmpN^.FirstRow:=((i mod 2)=0);
               p2.x:=a.x+p.x;
               p2.y:=a.y+p1.y;
               p3:=AnalizeNode(level+1,p2,tmpN,node);
               a.x:=p3.x-p.x;
               if (ny<p3.y) then ny:=p3.y;
               if (nx<p3.x) then nx:=p3.x;
             end; {   }
           end;
        end;
       if (p3.x<nx) then p3.x:=nx; {   }
     end { 2 stolbeza }
    else
     begin { 1 stolbez }
     a.x:=0;
     a.y:=0;
     ny:=0;
     for i:=0 to (tmpNodes.NodesCount-1) do
       begin
         tmpN:=tmpNodes.Nodes[i];
         p2.x:=a.x+p.x;
         p2.y:=a.y+p1.y;
         p3:=AnalizeNode(level+1,p2,tmpN,node);
         a.x:=p3.x-p.x;
         if (ny<p3.y) then ny:=p3.y;
       end;
      end;  { 1 stolbez }
      node^.NodeXYCount:=node^.NodeXYCount+1;
      node^.NodeX[node^.NodeXYCount-1]:=p.x+((MaxInt(p1.x,p3.x)-p.x-w) div 2);
      node^.NodeY[node^.NodeXYCount-1]:=p.y+(h div 2);
      node^.FinalX:=p.x+((MaxInt(p1.x,p3.x)-p.x-w) div 2);
      node^.FinalY:=p.y+(h div 2);
      node^.LevelID:=level;
      Result.x:=MaxInt(p1.x,p3.x);
      Result.y:=MaxInt(p1.y,ny);
      node^.BPNode.RightRegion:=MaxInt(p1.x,p3.x);
      node^.BPNode.LeftRegion:=p.x;
 end;

function  TBPMSDGraph.GetFirstInPoint:PMSDGraphNode;
 begin
   Result:=nil;
   if FGNodesCount=0 then Exit;
   Result:=FGraphNodes;
   { New code }
{   if BPViewMainForm.TranslateMSDTopology.Checked then}
   while (Result<>nil) and (Result^.llNode<>FEntryGraph.Nodes[FCurGraph]) do
     Result:=Result^.next;
   { End new code }
 end;

procedure  TBPMSDGraph.TraceNodes; { Checked }
 Var i:Integer;
     gnode:PMSDGraphNode;
     w1,h1:Integer;
  begin
    if (FGNodesCount=0) then Exit;
    { We get max node width & height for drawing text, but }
    w1:=Round(FMaxWidth*1.1);
    h1:=Round(FMaxHeight*1.1);
   { if w1>h1 then h1:=Round(w1/NodeRatio) else
     w1:=Round(h1*NodeRatio);}
    { Printing ! }
     if FPrinting then
     begin
      FRatioX:=(FDefWidth-FGlobalLeftSize-FGlobalRightSize-(w1 div 2))/FinalWidth;
      FRatioY:=(FDefHeight-FGlobalTopSize-FGlobalBottomSize-(h1 div 2))/FinalHeight;
      if FRatioX<FRatioY then FFinalRatio:=FRatioX else FFinalRatio:=FRatioY;
      w1:=Round(FNWidth*FRatioX);
      h1:=Round(FNHeight*FRatioY);
     end
      else
     begin
      FinalWidth:=FADefWidth;
      FinalHeight:=FADefHeight;
      FNWidth:=w1;
      FNHeight:=h1;
      FRatioX:=1.0;
      FRatioY:=1.0;
      FFinalRatio:=1.0;
      gnode:=FGraphNodes;
      FNodeXArray.NodesCount:=0;
      for i:=0 to (FGNodesCount-1) do
       begin
         FinalNodeX[i]:=gnode^.FinalX;
         FinalNodeY[i]:=gnode^.FinalY;
         gnode^.RightRegion:={FOwner.ClientRect.Left+FGlobalLeftSize+}gnode^.BPNode.RightRegion{-Parent.HorzScrollBar.Position};
         gnode^.LeftRegion:={FOwner.ClientRect.Left+FGlobalLeftSize+}gnode^.BPNode.LeftRegion{-Parent.HorzScrollBar.Position};
         FNodeXArray.NodeNumber[i]:=gnode^.BPNode.NodeNumber;
         FNodeXArray.NodesXLeft[i]:=gnode^.BPNode.LeftRegion;
         FNodeXArray.NodesXRight[i]:=gnode^.BPNode.RightRegion;
         gnode:=gnode^.next;
         FNodeXArray.NodesCount:=FNodeXArray.NodesCount+1;
       end;
      FDefWidth:=FGlobalLeftSize+FGlobalRightSize+FinalWidth+(w1 div 2);
      FDefHeight:=FGlobalTopSize+FGlobalBottomSize+FinalHeight+(h1 div 2);
     end;
      FAcceptDragRect.Left:=FGlobalLeftSize;
      FAcceptDragRect.Top:=FGlobalTopSize;
      FAcceptDragRect.Bottom:=FDefHeight-FGlobalBottomSize;
      FAcceptDragRect.Right:=FDefWidth-FGlobalRightSize;
      if Parent.HorzScrollBar.Range<>FDefWidth then
       Parent.HorzScrollBar.Range:=FDefWidth;
      if Parent.VertScrollBar.Range<>FDefHeight then
       Parent.VertScrollBar.Range:=FDefHeight;
    FNodeWidth:=Round(w1*0.9);
    FNodeHeight:=Round(h1*0.9);
    for i:=0 to (FGNodesCount-1) do
     begin
       gnode:=GetGraphNodeRec(i);
       if gnode=nil then Exit;
       gnode^.BPNode.AutoHeight:=False;
       gnode^.BPNode.AutoWidth:=False;
       gnode^.BPNode.DefWidth:=w1;
       gnode^.BPNode.DefHeight:=h1;
       if ((FDiscardDrags) or (not(gnode^.BPNode.AcceptPosition))) then
        begin
         gnode^.BPNode.Top:=FOwner.ClientRect.Top+FGlobalTopSize+Round(FinalNodeY[i]*FRatioY)-Parent.VertScrollBar.Position;
         gnode^.BPNode.Left:=FOwner.ClientRect.Left+FGlobalLeftSize+Round(FinalNodeX[i]*FRatioX)-Parent.HorzScrollBar.Position;
         gnode^.BPNode.AcceptPosition:=False;
        end;
       gnode^.BPNode.InputLinksCount:=0;
       gnode^.BPNode.OutputLinksCount:=0;
       gnode^.BPNode.LeftLinksCount:=0;
       gnode^.BPNode.RightLinksCount:=0;
       gnode^.BPNode.TopLinksCount:=0;
       gnode^.BPNode.BottomLinksCount:=0;
     end;
  end;

procedure TBPMSDGraph.InitGNodes;
Var tmpN:PMSDGraphNode;
 begin
   if (FGNodesCount=0) then Exit;
   tmpN:=FGraphNodes;
   while (tmpN<>nil) do
    begin
      tmpN^.NodeXYCount:=0;
      tmpN^.BPNode.RightRegion:=0;
      tmpN^.BPNode.LeftRegion:=0;
      tmpN^.LeftRegion:=0;
      tmpN^.RightRegion:=0;
      tmpN^.BPNode.OutputCount:=0;
      tmpN^.FinalX:=0;
      tmpN^.FinalY:=0;
      tmpN^.SecondColumn:=False;
      tmpN^.FirstRow:=True;
      tmpN^.NodePassed:=False;
      tmpN^.LevelID:=-1;
      tmpN:=tmpN^.next;
    end;
 end;

procedure TBPMSDGraph.InitGLinks;
Var tmpL:PMSDGraphLink;
 begin
   if (FGLinksCount=0) then Exit;
   tmpL:=FGraphLinks;
   while (tmpL<>nil) do
    begin
      tmpL:=tmpL^.next;
    end;
 end;

function  TBPMSDGraph.IsNodeVisibleEx(node:PBPNode):Boolean;
Var i:Integer;
 begin
   Result:=False;
   for i:=0 to (FCheckGraph.NodesCount-1) do
     begin
       if (FCheckGraph.Nodes[i]=node) and
          (FCheckGraph.NodesGraph[i]=FCurGraph) then
         begin
           Result:=True;
           Exit;
         end;
     end;
 end;

function  TBPMSDGraph.IsLinkVisibleEx(link:PBPLink):Boolean;
Var i:Integer;
 begin
   Result:=False;
    for i:=0 to (FCheckGraph.LinksCount-1) do
      begin
        if (FCheckGraph.Links[i]=link) and
           (FCheckGraph.LinksGraph[i]=FCurGraph) then
          begin
            Result:=True;
            Exit;
          end;
      end;
 end;


function  TBPMSDGraph.GetOutputLinksArrayEx(node:PBPNode;graph:Integer;FromNode:Boolean):TBPMSDLinkArrayEx;
Var tmpL,tmpW:PBPLink;
       i,j:Integer;
      flag:Boolean;
       ind:Integer;

procedure ExchangeLink(var link:PBPLink);
Var a,b:DWORD;
    c,d:TBPOrdinate;
      e:TBPAcceptPos;
     mm:TBPMultipleMask;
 begin
   mm:=GetNonGraphMultipleMask(link);
   { Works propertly only for non-multiple links }
   case (mm) of
    bpmm_None:   begin
                   b:=link^.dwFromLinkNumber;
                   link^.dwFromLinkNumber:=link^.dwToLinkNumber;
                   link^.dwToLinkNumber:=b;
                 end;
    bpmm_To:     begin
                   { FromLinkNumber is busy }
                   b:=link^.dwToLinkNumber;
                   link^.dwToLinkNumber:=GetMaxLinkNumber(link,True)+1;
                   link^.dwFromLinkNumber:=b;
                 end;
    bpmm_From:   begin
                   { ToLinkNumber is busy  }
                   b:=link^.dwFromLinkNumber;
                   link^.dwFromLinkNumber:=GetMaxLinkNumber(link,False)+1;
                   link^.dwToLinkNumber:=b;
                 end;
    bpmm_FromTo: begin
                   { FromAndToLinkNumber is busy }
                   link^.dwFromLinkNumber:=GetMaxLinkNumber(link,False)+1;
                   link^.dwToLinkNumber:=GetMaxLinkNumber(link,True)+1;
                 end;

   end;
   a:=link^.dwFromNodeNumber;
   link^.dwFromNodeNumber:=link^.dwToNodeNumber;
   link^.dwToNodeNumber:=a;
{   a:=(link^.dwFlags and BP_FROMMASK) shl 4;
   b:=(link^.dwFlags and BP_TOMASK) shr 4;
   link^.dwFlags:=(link^.dwFlags and BP_FROMTOMASK_INVERT) or a or b;}
   c:=link^.FromLeft;
   d:=link^.FromTop;
   e:=link^.FromAcceptPosition;
   link^.FromLeft:=link^.ToLeft;
   link^.FromTop:=link^.ToTop;
   link^.FromAcceptPosition:=link^.ToAcceptPosition;
   link^.ToLeft:=c;
   link^.ToTop:=d;
   link^.ToAcceptPosition:=e;
 end;

 begin
   Result.LinksCount:=0;
   if (FLinksCount=0) then Exit;
   tmpL:=FLinks;
    for i:=0 to (FLinksCount-1) do
     begin
       if FromNode then
       begin
        if (tmpL^.dwFromNodeNumber=node^.dwNodeNumber) and
          ((tmpL^.dwFlags and BP_RIGHT_LEFT)=BP_RIGHT_LEFT) and
          ((tmpL^.dwToNodeNumber and BPGlobalMask)=0) then
         begin
           Result.Links[Result.LinksCount]:=tmpL;
           Result.LinksCount:=Result.LinksCount+1;
         end;
       end
       else
       begin
        if (tmpL^.dwToNodeNumber=node^.dwNodeNumber) and
          ((tmpL^.dwFlags and BP_RIGHT_LEFT)=BP_RIGHT_LEFT) and
          ((tmpL^.dwFromNodeNumber and BPGlobalMask)=0) then
          begin

           if (not(LinkExsistsEx(tmpL,graph))) and FTranslateTopology then
            begin
             ind:=TmpL^.dwLinkIndex;
             tmpW:=FLinks;
             for j:=0 to (FLinksCount-1) do
              begin
               if tmpW^.dwLinkIndex=ind then
                begin
                 ExchangeLink(tmpW);
                 if not(LinkExsistsEx(tmpW,graph)) then
                  begin
                   Result.Links[Result.LinksCount]:=tmpW;
                   Result.LinksCount:=Result.LinksCount+1;
                  end;
                 FModified:=True;
                end;
                inc(tmpW);
              end;
            end;
          end;
       end;
       inc(tmpL);
     end;
 end;

function  TBPMSDGraph.GetNumberedNodeEx(NodeNumber:DWORD):PBPNode;
Var tmpN:PBPNode;
    i:Integer;
 begin
   Result:=nil;
   if FNodesCount=0 then Exit;
   tmpN:=FNodes;
   for i:=0 to (FNodesCount-1) do
    begin
      if (tmpN^.dwNodeNumber=NodeNumber) then
          begin
           Result:=tmpN;
           Exit;
          end;
      inc(tmpN);
    end;
 end;


function  TBPMSDGraph.GetOutputNodesArrayEx(node:PBPNode;graph:Integer;FromNode:Boolean):TBPMSDNodeArrayEx;
Var i,j:Integer;
    la:TBPMSDLinkArrayEx;
    tmp:PBPNode;
    flag:Boolean;
 begin
  {}
  Result.NodesCount:=0;
  if node=nil then Exit;
  if FNodesCount=0 then Exit;
  if FLinksCount=0 then Exit;
  la:=GetOutputLinksArrayEx(node,graph,FromNode);
   for i:=0 to (la.LinksCount-1) do
     begin
       flag:=True;
       for j:=0 to (FCheckGraph.LinksCount-1) do
         begin
           if (FCheckGraph.Links[j]=la.Links[i]) and
              (FCheckGraph.LinksGraph[j]=graph) then Flag:=False;
         end;
       if (Flag) then
       begin
        FCheckGraph.Links[FCheckGraph.LinksCount]:=la.Links[i];
        FCheckGraph.LinksGraph[FCheckGraph.LinksCount]:=graph;
        inc(FCheckGraph.LinksCount);
        tmp:=GetNumberedNodeEx(la.links[i]^.dwToNodeNumber);
        if (tmp<>nil) then
          begin
           Result.Nodes[Result.NodesCount]:=tmp;
           inc(Result.NodesCount);
          end;
       end;
     end;
 end;

function  TBPMSDGraph.LinkExsistsEx(link:PBPLink;graph:Integer):Boolean;
var i:Integer;
 begin
    Result:=False;
    for i:=0 to (FCheckGraph.LinksCount-1) do
      begin
        if (FCheckGraph.Links[i]=link) and
           (FCheckGraph.LinksGraph[i]=graph) then
           begin
            Result:=True;
            Exit;
           end;
      end;
 end;

function  TBPMSDGraph.NodeExsistsEx(node:PBPNode;nlevel:Integer):Boolean;
var i:Integer;
 begin
    Result:=False;
    for i:=0 to (FCheckGraph.NodesCount-1) do
      begin
        if (FCheckGraph.Nodes[i]=node) then
           begin
            if (FCheckGraph.NodeLevel[i]<nlevel) then FCheckGraph.NodeLevel[i]:=nlevel;
            Result:=True;
            Exit;
           end;
      end;
 end;

function TBPMSDGraph.FixGraph(graph:Integer;nlevel:Integer):Boolean;
Var na:TBPMSDNodeArrayEx;
    i,j,k:Integer;
 begin
   {}
   Result:=False;
   if FTranslateTopology then
    begin { Translate }
     for i:=0 to (FCheckGraph.NodesCount-1) do
      begin { for }
       if (FCheckGraph.NodesGraph[i]=graph) then
        begin { graph check }
         na:=GetOutputNodesArrayEx(FCheckGraph.Nodes[i],graph,False);
         if (na.NodesCount<>0) then Result:=True;
         for j:=0 to (na.NodesCount-1) do
           begin
            if not(NodeExsistsEx(na.Nodes[j],nlevel)) then
             begin
               FCheckGraph.Nodes[FCheckGraph.NodesCount]:=na.Nodes[j];
               FCheckGraph.NodesGraph[FCheckGraph.NodesCount]:=graph;
               FCheckGraph.NodeLevel[FCheckGraph.NodesCount]:=nlevel;
               inc(FCheckGraph.NodesCount);
               Result:=True;
             end;
           end;
         end; { graph check }
       end; { for }
     end; { Translate}
 end;



procedure TBPMSDGraph.AnalizeGraph(node:PBPNode;graph:Integer;nlevel:Integer);
Var na:TBPMSDNodeArrayEx;
    i:Integer;
 begin
   {}
   if node=nil then Exit;
   if NodeExsistsEx(node,nlevel) then Exit;
   FCheckGraph.Nodes[FCheckGraph.NodesCount]:=node;
   FCheckGraph.NodesGraph[FCheckGraph.NodesCount]:=graph;
   FCheckGraph.NodeLevel[FCheckGraph.NodesCount]:=nlevel;
   inc(FCheckGraph.NodesCount);
   na:=GetOutputNodesArrayEx(node,graph,True);
   for i:=0 to (na.NodesCount-1) do
     begin
       AnalizeGraph(na.Nodes[i],graph,nlevel+1);
     end;
 end;

function  TBPMSDGraph.GetFirstInPointEx(var Value:PBPNode):Boolean;
 begin
  {}
  Result:=False;
  if FNodesCount=0 then Exit;
  Value:=FNodes;
  Result:=True;
 end;

function  TBPMSDGraph.GetNextInPointEx(var Value:PBPNode):Boolean;
Var tmp:PBPNode;
      i,j:Integer;
   foundFlag:Boolean;
 begin
  {}
  Result:=False;
  if FNodesCount=0 then Exit;
  tmp:=FNodes;
  for i:=0 to (FNodesCount-1) do
    begin
      foundFlag:=False;
      for j:=0 to (FCheckGraph.NodesCount-1) do
        begin
          if (FCheckGraph.Nodes[j]=tmp) and
             (FCheckGraph.NodesGraph[j]<>-1) then
               begin FoundFlag:=True end;
        end;
        if (not(foundFlag)) then
          begin
            Result:=True;
            Value:=tmp;
            Exit;
          end;
      inc(tmp);
    end;
 end;

procedure TBPMSDGraph.CreateCheckGraphLinksOptimum;
Var i,j,k,l:Integer;
    tmp:PBPNode;
    res:Boolean;
     { Debug }
    flag,flag1,flag2:Boolean;
      na:TBPMSDNodeArrayEx;
     ind:Integer;
     sum:Integer;
     renObj:TBPRename;

function CalcLinksLength(graph:Integer):Integer;
Var i,j,k:Integer;
    l:Integer;
 begin
   Result:=0;
   for i:=0 to (FCheckGraph.LinksCount-1) do
    begin
      if (FCheckGraph.LinksGraph[i]=graph) then
        begin
          j:=0;
          while (j<FCheckGraph.NodesCount) and
                (FCheckGraph.Nodes[j]^.dwNodeNumber<>
                 FCheckGraph.Links[i]^.dwFromNodeNumber)  do inc(j);
          k:=0;
          while (k<FCheckGraph.NodesCount) and
                (FCheckGraph.Nodes[k]^.dwNodeNumber<>
                 FCheckGraph.Links[k]^.dwToNodeNumber)  do inc(k);
          l:=Abs(FCheckGraph.NodeLevel[k]-FCheckGraph.NodeLevel[j]);
          Result:=Result+l;
        end;
    end;
 end;

procedure CheckAndAppendNode(node:PBPNode);
Var i:Integer;
 begin
   flag:=False;
   for i:=0 to (na.NodesCount-1) do
    begin
      if na.nodes[i]=node then flag:=True;
    end;
   if not(flag) then
     begin
       na.nodes[na.NodesCount]:=node;
       na.Length[na.NodesCount]:=$FFFFFF;
       inc(na.NodesCount);
     end;
 end;

procedure CheckAndAppend(graph:Integer);
Var i:Integer;
 begin
   for i:=0 to (FCheckGraph.NodesCount-1) do
    begin
      if FCheckGraph.NodesGraph[i]=graph then
       CheckAndAppendNode(FCheckGraph.Nodes[i]);
    end;
 end;


 begin
  {}
   FCheckGraph.NodesCount:=0;
   FCheckGraph.LinksCount:=0;
   for i:=0 to 100 do FCheckGraph.NodesGraph[i]:=-1;
   for i:=0 to 100 do FCheckGraph.NodeLevel[i]:=0;
   for i:=0 to 600 do FCheckGraph.LinksGraph[i]:=-1;
   if FNodesCount=0 then Exit;
   if FLinksCount=0 then Exit;
   j:=0;
   res:=GetFirstInPointEx(tmp);
   flag:=False;
   while res do
    begin { while }
     { New code }
     if FTranslateTopology then
     begin
     na.NodesCount:=0;
     CheckAndAppendNode(tmp);
     flag2:=True;
     l:=0;
     while (l<na.NodesCount) and flag2 do
     begin
     tmp:=na.Nodes[l];
     flag1:=True;
     FItteration:=0;
     while flag1 do
      begin
       ClearLastResult(j);
       AnalizeGraph(tmp,j,0);
       if not(FixGraph(j,0)) then Flag1:=False;
       CheckAndAppend(j);
       inc(FItteration);
       if (FItteration>=MaxItteration) then Flag1:=False;
      end;
       if FItteration<MaxItteration then flag2:=False;
      inc(l);
     end;
     if (flag2) then
       Application.MessageBox(MIEText,MIECaption,MB_OK or MB_ICONERROR);
     sum:=$0FFFFFFF;
      for k:=0 to (na.NodesCount-1) do { Analize length }
       begin
         FItteration:=0;
         Flag1:=True;
         while Flag1 do
          begin
           ClearLastResult(j);
           AnalizeGraph(na.Nodes[k],j,0);
           if not(FixGraph(j,0)) then Flag1:=False;
           inc(FItteration);
           if (FItteration>=MaxItteration) then Flag1:=False;
          end;
         if FItteration<>MaxItteration then
          na.Length[k]:=CalcLinksLength(j)
         else
          na.Length[k]:=$0FFFFFFF;
         if na.Length[k]<sum then
           begin
            sum:=na.Length[k];
            ind:=k;
           end;
       end;
       tmp:=na.Nodes[ind];
       FEntryGraph.Nodes[j]:=tmp;
       FEntryGraph.NodesCount:=j+1;
      end
     else
      begin
       FEntryGraph.Nodes[j]:=tmp;
       FEntryGraph.NodesCount:=j+1;
      end;
     { New code }
     FItteration:=0;
     Flag1:=True;
     while Flag1 do
      begin
       ClearLastResult(j);
       AnalizeGraph(tmp,j,0);
       if FixGraph(j,0) then Flag:=True else Flag1:=False;
       inc(FItteration);
       if (FItteration>=MaxItteration) then Flag1:=False;
      end;
     if (FItteration=MaxItteration) then
      Application.MessageBox(MIEText,MIECaption,MB_OK or MB_ICONERROR);
     res:=GetNextInPointEx(tmp);
     inc(j);
     Application.ProcessMessages;
    end;
    FRootEntries:=j;
    if flag and FTranslateTopology then
      begin
       RenumberNodesAndLinks;
      end;
    if FTranslateTopology then
     begin
      renObj:=TBPRename.Create(FTree);
      renObj.RenameLinks;
      RenObj.Destroy;
      TranslateEntryGraphToEntryArray;
     end;
{}
 end;


procedure TBPMSDGraph.ClearLastResult(graph:Integer);
Var i,j:Integer;
 begin
   j:=0;
   for i:=0 to (FCheckGraph.LinksCount-1) do
    begin
     if (FCheckGraph.LinksGraph[i]=graph) then
      begin
        FCheckGraph.Links[i]:=nil;
        FCheckGraph.LinksGraph[i]:=-1;
        FCHeckGraph.LinkRenamedFrom[i]:=False;
        FCheckGraph.LinkRenamedTo[i]:=False;
        inc(j);
      end;
    end;
    FCheckGraph.LinksCount:=FCheckGraph.LinksCount-j;
    j:=0;
    for i:=0 to (FCheckGraph.NodesCount-1) do
    begin
     if (FCheckGraph.NodesGraph[i]=graph) then
      begin
        FCheckGraph.Nodes[i]:=nil;
        FCheckGraph.NodesGraph[i]:=-1;
        FCheckGraph.NodeLevel[i]:=0;
        inc(j);
      end;
    end;
    FCheckGraph.NodesCount:=FCheckGraph.NodesCount-j;
 end;


procedure TBPMSDGraph.CreateCheckGraphNodesOptimum;
Var i,j,k,l:Integer;
    tmp:PBPNode;
    res:Boolean;
     { Debug }
   flag,flag1,flag2:Boolean;
      na:TBPMSDNodeArrayEx;
     ind:Integer;
     sum:Integer;
     renObj:TBPRename;

function CalcNodesLength(graph:Integer):Integer;
Var i,j,k:Integer;
    l:Integer;
 begin
   Result:=0;
   for i:=0 to (FCheckGraph.NodesCount-1) do
    begin
      if (FCheckGraph.NodesGraph[i]=graph) then
        begin
          l:=FCheckGraph.NodeLevel[i];
          Result:=Result+l;
        end;
    end;
 end;

procedure CheckAndAppendNode(node:PBPNode);
Var i:Integer;
 begin
   flag:=False;
   for i:=0 to (na.NodesCount-1) do
    begin
      if na.nodes[i]=node then flag:=True;
    end;
   if not(flag) then
     begin
       na.nodes[na.NodesCount]:=node;
       na.Length[na.NodesCount]:=$FFFFFF;
       inc(na.NodesCount);
     end;
 end;

procedure CheckAndAppend(graph:Integer);
Var i:Integer;
 begin
   for i:=0 to (FCheckGraph.NodesCount-1) do
    begin
      if FCheckGraph.NodesGraph[i]=graph then
       CheckAndAppendNode(FCheckGraph.Nodes[i]);
    end;
 end;


 begin
  {}
   FCheckGraph.NodesCount:=0;
   FCheckGraph.LinksCount:=0;
   for i:=0 to 100 do FCheckGraph.NodesGraph[i]:=-1;
   for i:=0 to 100 do FCheckGraph.NodeLevel[i]:=0;
   for i:=0 to 600 do FCheckGraph.LinksGraph[i]:=-1;
   if FNodesCount=0 then Exit;
   if FLinksCount=0 then Exit;
   j:=0;
   res:=GetFirstInPointEx(tmp);
   flag:=False;
   while res do
    begin { while }
     { New code }
     if FTranslateTopology then
     begin
     na.NodesCount:=0;
     CheckAndAppendNode(tmp);
     flag2:=True;
     l:=0;
     while (l<na.NodesCount) and flag2 do
     begin
     tmp:=na.Nodes[l];
     flag1:=True;
     FItteration:=0;
     while flag1 do
      begin
       ClearLastResult(j);
       AnalizeGraph(tmp,j,0);
       if not(FixGraph(j,0)) then flag1:=False;
       CheckAndAppend(j);
       inc(FItteration);
       if (FItteration>=MaxItteration) then flag1:=False;
      end;
      if FItteration<MaxItteration then flag2:=False;
      inc(l);
     end;
     if (flag2) then
       Application.MessageBox(MIEText,MIECaption,MB_OK or MB_ICONERROR);
     sum:=$0FFFFFFF;
      for k:=0 to (na.NodesCount-1) do { Analize length }
       begin
         flag1:=True;
         FItteration:=0;
         while flag1 do
          begin
           ClearLastResult(j);
           AnalizeGraph(na.Nodes[k],j,0);
           if not(FixGraph(j,0)) then flag1:=False;
           inc(FItteration);
           if (FItteration>=MaxItteration) then flag1:=False;
          end;
         if FItteration<MaxItteration then
           na.Length[k]:=CalcNodesLength(j)
         else
           na.Length[k]:=$0FFFFFFF;
         if na.Length[k]<sum then
           begin
            sum:=na.Length[k];
            ind:=k;
           end;
       end;
       tmp:=na.Nodes[ind];
       FEntryGraph.Nodes[j]:=tmp;
       FEntryGraph.NodesCount:=j+1;
      end
     else
      begin
       FEntryGraph.Nodes[j]:=tmp;
       FEntryGraph.NodesCount:=j+1;
      end;
     { New code }
     flag1:=True;
     FItteration:=0;
     while flag1 do
      begin
       ClearLastResult(j);
       AnalizeGraph(tmp,j,0);
       if FixGraph(j,0) then  Flag:=True else Flag1:=False;
       inc(FItteration);
       if (FItteration>=MaxItteration) then flag1:=False;
      end;
     if FItteration=MaxItteration then
       Application.MessageBox(MIEText,MIECaption,MB_OK or MB_ICONERROR);
     res:=GetNextInPointEx(tmp);
     inc(j);
     Application.ProcessMessages;
    end;
    FRootEntries:=j;
    if flag and FTranslateTopology then
      begin
       RenumberNodesAndLinks;
      end;
    if FTranslateTopology then
     begin
      renObj:=TBPRename.Create(FTree);
      renObj.RenameLinks;
      RenObj.Destroy;
      TranslateEntryGraphToEntryArray;
     end;
{ }
 end;


procedure TBPMSDGraph.CreateCheckGraph;
Type TICheckArray=record
       Nodes:array[0..100] of PBPNode;
       NodesCount:Integer;
     end;

Var i,j,k,l:Integer;
    tmp:PBPNode;
    res:Boolean;
     { Debug }
    flag,flag1,flag2:Boolean;
    na:TICheckArray;
    renObj:TBPRename;

procedure CheckAndAppendNode(node:PBPNode);
Var i:Integer;
 begin
   flag:=False;
   for i:=0 to (na.NodesCount-1) do
    begin
      if na.nodes[i]=node then flag:=True;
    end;
   if not(flag) then
     begin
       na.nodes[na.NodesCount]:=node;
       inc(na.NodesCount);
     end;
 end;

procedure CheckAndAppend(graph:Integer);
Var i:Integer;
 begin
   for i:=0 to (FCheckGraph.NodesCount-1) do
    begin
      if FCheckGraph.NodesGraph[i]=graph then
       CheckAndAppendNode(FCheckGraph.Nodes[i]);
    end;
 end;


 begin
  {}
   FCheckGraph.NodesCount:=0;
   FCheckGraph.LinksCount:=0;
   for i:=0 to 100 do FCheckGraph.NodesGraph[i]:=-1;
   for i:=0 to 100 do FCheckGraph.NodeLevel[i]:=0;
   for i:=0 to 600 do FCheckGraph.LinksGraph[i]:=-1;
   if FNodesCount=0 then Exit;
   if FLinksCount=0 then Exit;
   j:=0;
   res:=GetFirstInPointEx(tmp);
   flag:=False;
   while res do
    begin
     na.NodesCount:=0;
     CheckAndAppendNode(tmp);
     flag2:=True;
     l:=0;
     while (l<na.NodesCount) and flag2 do
     begin
     tmp:=na.Nodes[l];
     Flag1:=True;
     FItteration:=0;
     while Flag1 do
      begin
        ClearLastResult(j);
        AnalizeGraph(tmp,j,0);
        if FixGraph(j,0) then Flag:=True else Flag1:=False;
        CheckAndAppend(j);
        inc(FItteration);
        if (FItteration>=MaxItteration) then flag1:=False;
      end;
      if FItteration<MaxItteration then flag2:=False;
      inc(l);
     end;
     if (flag2) then
       Application.MessageBox(MIEText,MIECaption,MB_OK or MB_ICONERROR);
     FEntryGraph.Nodes[j]:=tmp;
     FEntryGraph.NodesCount:=j+1;
     res:=GetNextInPointEx(tmp);
     inc(j);
     Application.ProcessMessages;
    end;
    FRootEntries:=j;
    if flag and FTranslateTopology then
      begin
       RenumberNodesAndLinks;
      end;
    if FTranslateTopology then
     begin
      renObj:=TBPRename.Create(FTree);
      renObj.RenameLinks;
      RenObj.Destroy;
      TranslateEntryGraphToEntryArray;
     end;
    if (FOpenNewGraph) then TranslateEntryGraphToEntryArray;
 end;


procedure   TBPMSDGraph.PresetupFrame(widthcoof,heightcoof:Double); { Checked }
Var p:TPoint;
    node:PBPNode;
    link:PBPLink;
    gnode:PMSDGraphNode;
    glink:PMSDGraphLink;
    s:String;
    f:TextFile;
    i:Integer;
  begin
   FCalcWidthHeight:=True;
   CalcMaxWidthHeight;
   FCalcWidthHeight:=False;
  { FDiscardDrags:=True;}
   FRatioWC:=widthcoof;
   FRatioHC:=heightcoof;
   p.x:=0;
   p.y:=0;
   InitGNodes;
   InitGLinks;
   p:=AnalizeNode(0,p,GetFirstInPoint,nil);
   FADefWidth:=p.x;
   FADefHeight:=p.y;
   FOwner.Hint:=': '+IntToStr(FGNodesCount)+' ';
   FOwner.ShowHint:=True;
  end;

procedure   TBPMSDGraph.OpenLevel(wLevel:Integer;Graph:Integer); { Checked }
 Var tmpTree:PBPTree;
     Flag:Boolean;
     fip:PMSDGraphLink;
  begin
     if (FTree=nil) then Exit;
     tmpTree:=FTree;
     Flag:=True;
     while (tmpTree<>nil) and (flag) do
      begin
       if (tmpTree^.dwLevel=wLevel) then
         begin
          FNodesCount:=tmpTree^.dwNodesCount;
          FLinksCount:=tmpTree^.dwLinksCount;
          FNodes:=tmpTree^.lpNodes;
          FLinks:=tmpTree^.lpLinks;
          FLevel:=tmpTree^.dwLevel;
          FSSLevel:=tmpTree^.ssLevel;
          FParentLevel:=tmpTree^.dwParent;
          FNodesFontSize:=tmpTree^.dwNodesFontSize;
          FDNodesFontSize:=tmpTree^.dwDNodesFontSize;
          FDProjectionFontSize:=tmpTree^.dwDProjectionFontSize;
          FInProcessFontSize:=tmpTree^.dwInProcessFontSize;
          FLabelsFontSize:=tmpTree^.dwLabelsFontSize;
          FOverrideNodesFS:=tmpTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=tmpTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=tmpTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=tmpTree^.dbOverrideLabelsFS;
          Flag:=False;
         end;
       tmpTree:=tmpTree^.next;
      end;
    if (Flag) then
     begin
          FNodesCount:=FTree^.dwNodesCount;
          FLinksCount:=FTree^.dwLinksCount;
          FNodes:=FTree^.lpNodes;
          FLinks:=FTree^.lpLinks;
          FLevel:=FTree^.dwLevel;
          FSSLevel:=FTree^.ssLevel;
          FParentLevel:=FTree^.dwParent;
          FNodesFontSize:=FTree^.dwNodesFontSize;
          FDNodesFontSize:=FTree^.dwDNodesFontSize;
          FDProjectionFontSize:=FTree^.dwDProjectionFontSize;
          FInProcessFontSize:=FTree^.dwInProcessFontSize;
          FLabelsFontSize:=FTree^.dwLabelsFontSize;
          FOverrideNodesFS:=FTree^.dbOverrideNodesFS;
          FOverrideDNodesFS:=FTree^.dbOverrideDNodesFS;
          FOverrideInProcessFS:=FTree^.dbOverrideInProcessFS;
          FOverrideLabelsFS:=FTree^.dbOverrideLabelsFS;
          Flag:=False;
     end;
    if not(FOpenNewGraph) then TranslateEntryArrayToEntryGraph;
    if (FTranslateTopology or FOpenNewGraph) then CreateCheckGraph;
    if (FTranslateNodesPathOptimize and FTranslateTopology) then CreateCheckGraphNodesOptimum;
    if (FTranslateLinksPathOptimize and FTranslateTopology) then CreateCheckGraphLinksOptimum;
    FTranslateTopology:=False;
    FOpenNewGraph:=False;
{    BPViewMainForm.TranslateMSDTopology.Checked:=False;
    CreateCheckGraph1;}
    FCurGraph:=Graph;
    if FCurGraph<0 then FCurGraph:=0;
    if FCurGraph>=FRootEntries then FCurGraph:=FRootEntries-1;
    SetDefaultConstants;
    CreateGraphNodes(1,1);
    CreateGraphLinks(1,1);
    Scaled:=Scaled;
    if (not(FScaled)) then PresetupFrame(1,1);
{    if (BPViewMainForm.BPNavigator.Height>1) and
       (BPViewMainForm.PageControl1.ActivePage=BPViewMainForm.TabSheet4) then
      begin
       AnalizeStringsFonts;
       BPViewMainFOrm.BPGetBitmapTimer.Enabled:=True;
      end;}
  end;


 procedure TBPMSDGraph.ClearModel;
 begin
   FTree:=nil;
   FNTTree:=nil;
   FLTTree:=nil;
   FOPTree:=nil;
   FHeader.dwNodesTypesCount:=0;
   FHeader.dwLinksTypesCount:=0;
   FHeader.dwOpEntries:=0;
 end;

 procedure TBPMSDGraph.AssignModel(Tree:PBPTree;NTTree:PBPNodeTypes;LTTree:PBPLinkTypes;
                                OPTree:PBPOpTree;Header:TBPHeader;
                                EntryArray:PBPEntryArray;CheckGraphArray:PBPCheckGraphArray);
 begin
   FTree:=Tree;
   FNTTree:=NTTree;
   FLTTree:=LTTree;
   FOPTree:=OPTree;
   FHeader:=Header;
   FEntryArray:=EntryArray;
   FCheckGraphArray:=CheckGraphArray;
{   FRootEntries:=CalcPagesCount;}
   FChangeTabVisible:=True;
   if (FEntryArray^.NodesIndexCount=0) then
    FOpenNewGraph:=True
   else
    FOpenNewGraph:=False;
{   FOpenNewGraph:=True;}
   OpenLevel(-1,0);
   TraceRoute;
   FOwner.Invalidate;
 end;

  procedure  TBPMSDGraph.TraceRoute; { Main Tracing Procedure } { Checked }
  begin
    { Lets Trace graph }
     TraceNodes;                           { Trace Nodes }
     if FEnableMarkBlendingNodes then MarkBlendingNodes;
     TraceNodesToLinksCounters;             { Hm }
     TraceLinksToNodeCounters;              { Hm }
     TraceLocalStartEndPoints;              { OK }
     CalcLabelSizes;                        { Yes }
     TraceLinks;                           { Yes }
     DrawLinks;                            { Yes }
     FDiscardDrags:=False;
     if FDebug then WriteCurGraphInfo(MSDLogFileName);
  end;

 constructor TBPMSDGraph.Create(AOwner: TComponent); { Checked }
  begin
    inherited Create(AOwner);
    FOwner:=AOwner as TBPMSDFrame;
    FNodes:=nil;
    FLinks:=nil;
    FNodesCount:=0;
    FLinksCount:=0;
    FGNodesCount:=0;
    FGLinksCount:=0;
    FGraphNodes:=nil;
    FGraphLinks:=nil;
    FLang:=RUSSIAN_CHARSET;
    FTree:=nil;
    FOpTree:=nil;     { CurrentWork ! }
    FLTTree:=nil;
    FNTTree:=nil;
    FEntryArray:=nil;
    FCheckGraphArray:=nil;
    FLevel:=-1;
    FSSLevel:='-1';   { CurrentWork ! }
    FParentLevel:=-2; { Disabled }
    FHaspFound:=False;
    FillChar(FHeader,sizeof(FHeader),0);
    FMaxWidth:=0;
    FMaxHeight:=0;
    FRootEntries:=0;
    FGlobalLeftSize:=80;
    FGlobalRightSize:=80;
    FGlobalTopSize:=80;
    FGlobalBottomSize:=80;
    FFontDPI:=96;
    FFontSize:=8;
    FLabelFontSize:=8;
    FMinLineStep:=StartMinLineStep;
    FNodeLineWidth:=1;
    FNodeDefWidth:=100;
    FNodeDefHeight:=100;
    FNodeHSpacing:=8;
    FNodeVSpacing:=8;
    FNodeShadowDepth:=4;
    FMinArcRadius:=StartMinArcRadius;
    FMinLabelX:=StartMinLabelX;
    FMinLabelY:=StartMinLabelY;
    FMinLabelY1:=StartMinLabelY1;
    FMinGlobalLabel:=StartMinGlobalLabel;
    FMinLineEndPoint:=StartMinLineEndPoint;
    FNodeWidth:=0;
    FNodeHeight:=0;
    FCalcWidthHeight:=False;
    FDebug:=False;
    FScaled:=False;
    FScreenFontName:='Times New Roman';
    FPrinterFontName:='Times New Roman';
    FFirstNodeNumber:=0;
    FLastNodeNumber:=0;
    FDiscardDrags:=False;
    FRatioWC:=1;
    FRatioHC:=1;
    FModified:=False;
    FLinksPosRelative:=True;
    FTranslateTopology:=False;
    FTranslateNodesPathOptimize:=False;
    FTranslateLinksPathOptimize:=False;
    FCurGraph:=0;
    FEnableMarkBlendingNodes:=True;
    FScaled2Ratio:=100;
    FScaled2:=True;
    FReplaceNodes:=False;
    FReplaceLabels:=False;
    FMaxWordLength:=8;
    FMaxWordCount:=5;
    FMaxLabelLength:=32;
    FMaxFontSize:=DefMaxLabelFontSize;
    FRealMaxFontSize:=DefMaxLabelFontSize;
    Scaled:=True;
  end;

 destructor  TBPMSDGraph.Destroy;  { Checked }
  begin
    if (FGraphNodes<>nil) then ClearGraphNodes;
    if (FGraphLinks<>nil) then ClearGraphLinks;
    if (FTree<>nil) then FTree:=nil;
    if (FNTTree<>nil) then FNTTree:=nil;
    if (FLTTree<>nil) then FLTTree:=nil;
    if (FOPTree<>nil) then FOPTree:=nil; { CurrentWork ! }
    if (FEntryArray<>nil) then FEntryArray:=nil;
    if (FCheckGraphArray<>nil) then FCheckGraphArray:=nil;
    inherited Destroy;
  end;

procedure TBPMSDGraph.SetDiscardDrags(Value:Boolean); { Checked }
var i:Integer;
    nodePtr:PBPNode;
    linkPtr:PBPLink;
 begin
  { Disable all drags in context diagram }
   FDiscardDrags:=True;
   FOwner.Repaint;
   if FNodesCount=0 then Exit;
   nodePtr:=FNodes;
   for i:=0 to (FNodesCount-1) do
     begin
       nodePtr^.AcceptPosition[3]:=False;
       FModified:=True;
       inc(nodePtr);
     end;
   if FLinksCount=0 then Exit;
   linkPtr:=FLinks;
   for i:=0 to (FLinksCount-1) do
     begin
       LinkPtr^.FromAcceptPosition[3]:=False;
       linkPtr^.ToAcceptPosition[3]:=False;
       FModified:=True;
       inc(linkPtr);
     end;
 end;

procedure TBPMSDGraph.SetDefWidth(Value:Integer);  { Checked }
 begin
  FDefWidth:=Value;
 end;

procedure TBPMSDGraph.SetDefHeight(Value:Integer);  { Checked }
 begin
  FDefHeight:=Value;
 end;

 procedure TBPMSDGraph.SetScaled2(Value:Boolean);
  begin
   {}
    FScaled2:=Value;
  end;

 procedure TBPMSDGraph.SetScaled2Ratio(Value:Extended);
 Var posx,posy:Double; 
  begin
   {}
{!} posx:=FScaled2Ratio;
{!} posy:=FScaled2Ratio;
{!} if (FOwner.HorzScrollBar.Range>0) and
       (FOwner.HorzScrollBar.Visible) then
     posx:=Value/(posx+0.01)*FOwner.HorzScrollBar.Position
    else
     posx:=0;
{!} if (FOwner.VertScrollBar.Range>0) and
       (FOwner.VertScrollBar.Visible) then
     posy:=Value/(posy+0.01)*FOwner.VertScrollBar.Position
    else
     posy:=0;
    FScaled2Ratio:=Value;
    FOwner.Visible:=False;
    Scaled:=Scaled;
    FOwner.Invalidate;
{!} if (FOwner.HorzScrollBar.Range>0) then
        FOwner.HorzScrollBar.Position:=Round(posx);
{!} if (FOwner.VertScrollBar.Range>0) then
        FOwner.VertScrollBar.Position:=Round(posy);
    FOwner.Visible:=True;
  end;

procedure TBPMSDGraph.UpdateMaxFontSize(Coof:Extended);
Var hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
  { Update & calc real max font size }
  hca3:=1.0;
  if MainUnit.HasPrnDevice then
   begin
    aSize:=Printer.PaperSize;
    for tmpi:= Default to Custom do
      begin
       if aSize=cQRPaperTranslate[tmpI] then
        begin
         hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
        end;
      end;
   end;
  if FScaled then
    begin
      if FScaled2 then
       begin { if FScaled2 }
        FRealMaxFontSize:=Round(FMaxFontSize*hca3*FScaled2Ratio/100.0);
       end
      else
       begin
        FRealMaxFontSize:=Round(FMaxFontSize/coof*hca3);
       end;
    end
   else
    begin
      FRealMaxFontSize:=Round(FMaxFontSize*FOwner.FFontCoof*hca3);
    end;
 end;


procedure TBPMSDGraph.SetScaled(Value:Boolean);  { Checked }
Var r1,r2,ratio,fontRatio,labelFontRatio:Double;
    nw,nh,mw,mh:Integer;
    rw,rh:Double;
    dc:HDC;
    ws2,hs2:Extended;
    {New}
    wca3,hca3:Extended;
    aSize:Integer;
    tmpi:TQRPaperSize;
 begin
   FScaled:=Value;
   if FTree=nil then Exit;
   if FScaled then
    begin
    if FOwner.VertScrollBar.Visible then FOwner.VertScrollBar.Position:=0;
    if FOwner.HorzScrollBar.Visible then FOwner.HorzScrollBar.Position:=0;
    Repaint;
    SetDefaultConstants;
    Printing:=False;
    SetDefaultConstants;
    CreateGraphNodes(1,1); { read x,y,acceptposition }
    CreateGraphLinks(1,1); { read x,y,acceptposition }
    PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
    TraceRoute;
    FOwner.Invalidate;
   end;
   if FScaled2 then
    begin { if FScaled2 }
      wca3:=1.0;
     hca3:=1.0;
     if MainUnit.HasPrnDevice then
      begin
       aSize:=Printer.PaperSize;
       for tmpi:= Default to Custom do
        begin
         if aSize=cQRPaperTranslate[tmpI] then
           begin
            hca3:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A3,0];
            wca3:=cQRPaperSizeMetrics[tmpI,1]/cQRPaperSizeMetrics[A3,1];
           end;
        end;
       end;
      dc:=GetDC(0);
      ws2:=GetDeviceCaps(dc,LOGPIXELSX)*A3Width*hca3*FScaled2Ratio/100.0;
      hs2:=GetDeviceCaps(dc,LOGPIXELSY)*A3Height*wca3*FScaled2Ratio/100.0;
      UpdateMaxFontSize(1);
      ReleaseDC(0,dc);
      if (FOwner.HorzScrollBar.Range>0)and
         (FOwner.HorzScrollBar.Visible) then
       begin
        FOwner.HorzScrollBar.Position:=0;
        r1:=ws2/(FOwner.HorzScrollBar.Range);
       end
      else r1:=ws2/FOwner.ClientWidth;
      if (FOwner.VertScrollBar.Visible) and
         (FOwner.VertScrollBar.Range>0) then
       begin
         FOwner.VertScrollBar.Position:=0;
         r2:=hs2/(FOwner.VertScrollBar.Range);
       end
      else r2:=hs2/FOwner.ClientHeight;
    end { if FScaled2 }
   else
   begin { if not FScaled2 }
   if FOwner.HorzScrollBar.Visible then
    begin
     FOwner.HorzScrollBar.Position:=0;
     r1:=FOwner.ClientWidth/(FOwner.HorzScrollBar.Range+1);
    end
   else r1:=1;
   if FOwner.VertScrollBar.Visible then
    begin
     FOwner.VertScrollBar.Position:=0;
     r2:=FOwner.ClientHeight/(FOwner.VertScrollBar.Range+1);
    end
   else r2:=1;
   UpdateMaxFontSize(r2);
   end; { if not FScaled2 }
   if r1<r2 then ratio:=r1 else ratio:=r2;
   if FScaled then
    begin
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,ratio,ratio);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     Printing:=True;
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     PresetupFrame(r1,r2); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
     while FOwner.FPainting do;
     nw:=NodeWidth;
     nh:=NodeHeight;
     mw:=MaxWidth;
     mh:=MaxHeight;
     rw:=ratio*nw/(mw+1);
     rh:=ratio*nh/(mh+1);
     if rw<=rh then fontRatio:=rw else fontRatio:=rh;
{     if fontRatio>ratio then fontRatio:=ratio;}
     LabelFontRatio:=fontRatio*FMaxCH;
     FOwner.Canvas.FillRect(FOwner.Canvas.ClipRect);
     if FScaled2 then
      begin
       DefWidth:=Round(ws2);
       DefHeight:=Round(hs2);
      end
     else
      begin
       DefWidth:=FOwner.ClientWidth;
       DefHeight:=FOwner.ClientHeight;
      end;
     SetDefaultConstants;
     SetScaledConstants(r1,r2,ratio,fontRatio,labelFontRatio);
     CreateGraphNodes(r1,r2); { read x,y,acceptposition }
     CreateGraphLinks(r1,r2); { read x,y,acceptposition }
     PresetupFrame(r1,r2);   { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end
   else
    begin
     UpdateMaxFontSize(1);
     SetDefaultConstants;
     Printing:=False;
     SetDefaultConstants;
     CreateGraphNodes(1,1); { read x,y,acceptposition }
     CreateGraphLinks(1,1); { read x,y,acceptposition }
     PresetupFrame(1,1); { Scale x,y to widthcoof,heightcoof }
     TraceRoute;
     FOwner.Invalidate;
    end;
 end;

function   TBPMSDGraph.GetMultipleMaskEx(index:Integer;const ar:TBPMSDLinkArray):TBPMultipleMask;
 Var linkP:PMSDGraphLink;
     linkC:PMSDGraphLink;
     i:Integer;
  begin
   Result:=bpmm_None;
   if (index>=ar.LinksCount) or (index<0) then Exit;
   linkP:=ar.Links[index];
   for i:=0 to (ar.LinksCount-1) do
     begin
       linkC:=ar.Links[i];
       if (i<>index) then
         begin
           if (linkC^.FromNodeNumber=linkP^.FromNodeNumber) and
              (linkC^.FromLinkNumber=linkP^.FromLinkNumber) and
              ((linkC^.dwFlags and BP_FROMMASK)=(LinkP^.dwFlags and BP_FROMMASK)) then
               begin
                 if Result=bpmm_From then Result:=bpmm_FromTo
                      else Result:=bpmm_To;
               end;
           if (linkC^.ToNodeNumber=linkP^.ToNodeNumber) and
              (linkC^.ToLinkNumber=linkP^.ToLinkNumber) and
              ((linkC^.dwFlags and BP_TOMASK)=(LinkP^.dwFlags and BP_TOMASK)) then
               begin
                 if Result=bpmm_To then Result:=bpmm_FromTo
                      else Result:=bpmm_From;
               end;
         end;
     end;
  end;

function   TBPMSDGraph.IsMultipleFirstEx(index:Integer;MultipleFrom:Boolean;const ar:TBPMSDLinkArray):Boolean;
Var tmpLink:PMSDGraphLink;
    tmpLink1:PMSDGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=False;
   if (ar.LinksCount=0) then Exit;
   tmpLink:=ar.Links[index];
   flag:=True;
   i:=0;
   while ((i<ar.LinksCount) and (flag)) do
    begin
      tmpLink1:=ar.Links[i];
      if MultipleFrom then
         begin
           if (tmpLink^.ToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.ToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) then
             begin
               if (tmpLink=tmpLink1) then Result:=True;
               flag:=False;
             end;
         end
      else
         begin
           if (tmpLink^.FromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.FromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) then
             begin
               if (tmpLink=tmpLink1) then Result:=True;
               flag:=False;
             end;
         end;
      inc(i);
    end;
 end;

function   TBPMSDGraph.GetMultipleCountFromEx(index:Integer;const ar:TBPMSDLinkArray):TBPMSDMultipleCountEx;
Var tmpLink:PMSDGraphLink;
    tmpLink1:PMSDGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result.Count:=0;
   Result.Left:=0;
   Result.Right:=0;
   Result.Bottom:=0;
   if (ar.LinksCount=0) then Exit;
   tmpLink:=ar.Links[index];
   flag:=True;
   i:=0;
   while ((i<ar.LinksCount) and (flag)) do
    begin
           tmpLink1:=ar.Links[i];
           if (tmpLink^.FromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.FromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) then
             begin
               Result.Count:=tmpLink1^.LinkFromCount;
               Result.Left:=tmpLink1^.LinkFromLeftCount;
               Result.Right:=tmpLink1^.LinkFromRightCount;
               Result.Bottom:=tmpLink1^.LinkFromBottomCount;
               flag:=False;
             end;
      inc(i);
    end;
 end;

procedure  TBPMSDGraph.CorrectMultipleCountFromEx(index:Integer;var ar:TBPMSDLinkArray);
Var tmpLink:PMSDGraphLink;
    tmpLink1:PMSDGraphLink;
    i:Integer;
 begin
   if (ar.LinksCount=0) then Exit;
   tmpLink:=ar.Links[index];
   i:=0;
   while (i<ar.LinksCount) do
    begin
           tmpLink1:=ar.Links[i];
           if (tmpLink^.FromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.FromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) then
             begin
               tmpLink1^.LinkFromCount:=tmpLink^.LinkFromCount;
               tmpLink1^.LinkFromLeftCount:=tmpLink^.LinkFromLeftCount;
               tmpLink1^.LinkFromRightCount:=tmpLink^.LinkFromRightCount;
               tmpLink1^.LinkFromBottomCount:=tmpLink^.LinkFromBottomCount;
             end;
      inc(i);
    end;
 end;


function   TBPMSDGraph.GetMultipleCountToEx(index:Integer;const ar:TBPMSDLinkArray):TBPMSDMultipleCountEx;
Var tmpLink:PMSDGraphLink;
    tmpLink1:PMSDGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result.Count:=0;
   Result.Left:=0;
   Result.Right:=0;
   Result.Bottom:=0;
   if (ar.LinksCount=0) then Exit;
   tmpLink:=ar.Links[index];
   flag:=True;
   i:=0;
   while ((i<ar.LinksCount) and (flag)) do
    begin
           tmpLink1:=ar.Links[i];
           if (tmpLink^.ToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.ToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) then
             begin
               Result.Count:=tmpLink1^.LinkToCount;
               Result.Left:=tmpLink1^.LinkToLeftCount;
               Result.Right:=tmpLink1^.LinkToRightCount;
               Result.Bottom:=0;
               flag:=False;
             end;
      inc(i);
    end;
 end;

procedure  TBPMSDGraph.CorrectMultipleCountToEx(index:Integer;var ar:TBPMSDLinkArray);
Var tmpLink:PMSDGraphLink;
    tmpLink1:PMSDGraphLink;
    i:Integer;
 begin
   if (ar.LinksCount=0) then Exit;
   tmpLink:=ar.Links[index];
   i:=0;
   while (i<ar.LinksCount) do
    begin
           tmpLink1:=ar.Links[i];
           if (tmpLink^.ToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.ToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) then
             begin
               tmpLink1^.LinkToCount:=tmpLink^.LinkToCount;
               tmpLink1^.LinkToLeftCount:=tmpLink^.LinkToLeftCount;
               tmpLink1^.LinkToRightCount:=tmpLink^.LinkToRightCount;
             end;
      inc(i);
    end;
 end;

function TBPMSDGraph.GetMultipleCountFrom(index:Integer):Integer; { Checked }
Var tmpLink:PMSDGraphLink;
    tmpLink1:PMSDGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=0;
   if (FGLinksCount=0) then Exit;
   tmpLink:=FGraphLinks;
   i:=0;
   while (i<index) do
    begin
     tmpLink:=tmpLink^.next;
     inc(i);
    end;
   flag:=True;
   i:=0;
   while ((i<FGLinksCount) and (flag)) do
    begin
           tmpLink1:=GetGraphLink(i);
           if (tmpLink^.FromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.FromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) then
             begin
               Result:=tmpLink1^.LinkFromCount;
               flag:=False;
             end;
      inc(i);
    end;
 end;


function  TBPMSDGraph.GetMultipleFirst(index:Integer;MultipleFrom:Boolean):PMSDGraphLink; { Checked }
 Var linkP:PMSDGraphLink;
     f:Boolean;
     linkT:PMSDGraphLink;
     i:Integer;
  begin
   Result:=nil;
   if FGLinksCount=0 then Exit;
   linkT:=FGraphLinks;
   i:=0;
   while (i<index) do
    begin
     linkT:=linkT^.next;
     inc(i);
    end;
   linkP:=FGraphLinks;
   f:=True;
   while (linkP<>nil) and (f) do
    begin
      if MultipleFrom then
         begin
           if (linkP^.ToNodeNumber=linkT^.ToNodeNumber) and
              ((linkP^.dwFlags and BP_TOMASK)=(linkT^.dwFlags and BP_TOMASK)) and
              (linkP^.ToLinkNumber=linkT^.ToLinkNumber) then
              begin
                Result:=linkP;
                f:=False;
              end;
         end
        else
         begin
           if (linkP^.FromNodeNumber=linkT^.FromNodeNumber) and
              ((linkP^.dwFlags and BP_FROMMASK)=(linkT^.dwFlags and BP_FROMMASK)) and
              (linkP^.FromLinkNumber=linkT^.FromLinkNumber) then
              begin
                Result:=linkP;
                f:=False;
              end;
         end;
      if f then linkP:=linkP^.next;
    end;
  end;


function TBPMSDGraph.GetMultipleCountTo(index:Integer):Integer; { Checked }
Var tmpLink:PMSDGraphLink;
    tmpLink1:PMSDGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=0;
   if (FGLinksCount=0) then Exit;
   tmpLink:=FGraphLinks;
   i:=0;
   while (i<index) do
    begin
      tmpLink:=tmpLink^.next;
      inc(i);
    end;
   flag:=True;
   i:=0;
   while ((i<FGLinksCount) and (flag)) do
    begin
           tmpLink1:=GetGraphLink(i);
           if (tmpLink^.ToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.ToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) then
             begin
               Result:=tmpLink1^.LinkToCount;
               flag:=False;
             end;
      inc(i);
    end;
 end;

function TBPMSDGraph.IsMultipleFirst(index:Integer;MultipleFrom:Boolean):Boolean; { Checked }
Var tmpLink:PMSDGraphLink;
    tmpLink1:PMSDGraphLink;
    flag:Boolean;
    i:Integer;
 begin
   Result:=False;
   if (FGLinksCount=0) then Exit;
   tmpLink:=FGraphLinks;
   tmpLink1:=FGraphLinks;
   i:=0;
   while (i<index) do
    begin
      tmpLink:=tmpLink^.next;
      inc(i);
    end;
   flag:=True;
   i:=0;
   while ((i<FGLinksCount) and (flag)) do
    begin
      if MultipleFrom then
         begin
           if (tmpLink^.ToLinkNumber=tmpLink1^.ToLinkNumber) and
              (tmpLink^.ToNodeNumber=tmpLink1^.ToNodeNumber) and
              ((tmpLink^.dwFlags and BP_TOMASK)=(tmpLink1^.dwFlags and BP_TOMASK)) then
             begin
               if (tmpLink=tmpLink1) then Result:=True;
               flag:=False;
             end;
         end
      else
         begin
           if (tmpLink^.FromLinkNumber=tmpLink1^.FromLinkNumber) and
              (tmpLink^.FromNodeNumber=tmpLink1^.FromNodeNumber) and
              ((tmpLink^.dwFlags and BP_FROMMASK)=(tmpLink1^.dwFlags and BP_FROMMASK)) then
             begin
               if (tmpLink=tmpLink1) then Result:=True;
               flag:=False;
             end;
         end;
      tmpLink1:=tmpLink1^.next;
      inc(i);
    end;
 end;

 function  TBPMSDGraph.GetNonGraphMultipleMask(link:PBPLink):TBPMultipleMask; { Checked }
 Var linkC:PBPLink;
     i:Integer;
  begin
   Result:=bpmm_None;
   if link=nil then Exit;
   linkC:=FLinks;
   for i:=0 to (FlinksCount-1) do
     begin
       if (linkC<>link) then
         begin
           if (linkC^.dwFromNodeNumber=link^.dwFromNodeNumber) and
              (linkC^.dwFromLinkNumber=link^.dwFromLinkNumber) and
              ((linkC^.dwFlags and BP_FROMMASK)=(Link^.dwFlags and BP_FROMMASK)) then
               begin
                 if Result=bpmm_From then Result:=bpmm_FromTo
                      else Result:=bpmm_To;
               end;
           if (linkC^.dwToNodeNumber=link^.dwToNodeNumber) and
              (linkC^.dwToLinkNumber=link^.dwToLinkNumber) and
              ((linkC^.dwFlags and BP_TOMASK)=(Link^.dwFlags and BP_TOMASK)) then
               begin
                 if Result=bpmm_To then Result:=bpmm_FromTo
                      else Result:=bpmm_From;
               end;
         end;
       inc(linkC);
     end;
  end;


 function  TBPMSDGraph.GetMultipleMask(index:Integer):TBPMultipleMask; { Checked }
 Var linkP:PMSDGraphLink;
     linkC:PMSDGraphLink;
     i:Integer;
  begin
   Result:=bpmm_None;
   if (index>=FGLinksCount) or (index<0) then Exit;
   linkP:=FGraphLinks;
   linkC:=FGraphLinks;
   i:=0;
   while (i<index) do
     begin
       LinkP:=linkP^.next;
       inc(i);
     end;
   for i:=0 to (FGlinksCount-1) do
     begin
       if (i<>index) then
         begin
           if (linkC^.FromNodeNumber=linkP^.FromNodeNumber) and
              (linkC^.FromLinkNumber=linkP^.FromLinkNumber) and
              ((linkC^.dwFlags and BP_FROMMASK)=(LinkP^.dwFlags and BP_FROMMASK)) then
               begin
                 if Result=bpmm_From then Result:=bpmm_FromTo
                      else Result:=bpmm_To;
               end;
           if (linkC^.ToNodeNumber=linkP^.ToNodeNumber) and
              (linkC^.ToLinkNumber=linkP^.ToLinkNumber) and
              ((linkC^.dwFlags and BP_TOMASK)=(LinkP^.dwFlags and BP_TOMASK)) then
               begin
                 if Result=bpmm_To then Result:=bpmm_FromTo
                      else Result:=bpmm_From;
               end;
         end;
       linkC:=linkC^.next;
     end;
  end;

 function   TBPMSDGraph.GetLinkFrom(const value:PMSDGraphLink):TLinkType; { Checked }
  begin
    Result:=lt_Right;
    if value=nil then Exit;
    case (value^.dwFlags and BP_FROMMASK) of
     BP_FROMNODE_LEFT:   Result:=lt_Left;
     BP_FROMNODE_RIGHT:  Result:=lt_Right;
     BP_FROMNODE_TOP:    Result:=lt_Top;
     BP_FROMNODE_BOTTOM: Result:=lt_Bottom;
    end;
  end;

 function   TBPMSDGraph.GetLinkTo(const value:PMSDGraphLink):TLinkType; { Checked }
  begin
   Result:=lt_Left;
    case (value^.dwFlags and BP_TOMASK) of
     BP_TONODE_LEFT:   Result:=lt_Left;
     BP_TONODE_RIGHT:  Result:=lt_Right;
     BP_TONODE_TOP:    Result:=lt_Top;
     BP_TONODE_BOTTOM: Result:=lt_Bottom;
    end;
  end;

 procedure  TBPMSDGraph.SetDefaultConstants; { Checked }
 Var dc:HDC;
  begin
   FDoOverrideFS:=False;
   dc:=GetDC(FOwner.Handle);
   FFontDPI:=96;{GetDeviceCaps(dc,LOGPIXELSX);}
   ReleaseDC(FOwner.Handle,dc);
   FFontSize:=8;
   FLabelFontSize:=8;
   FMinLineStep:=StartMinLineStep;
   FNodeLineWidth:=1;
   FNodeDefWidth:=100;
   FNodeDefHeight:=100;
   FNodeHSpacing:=1;
   FNodeVSpacing:=1;
   FGlobalLeftSize:=80;
   FGlobalRightSize:=80;
   FGlobalTopSize:=80;
   FGlobalBottomSize:=80;
   FMinArcRadius:=StartMinArcRadius;
   FMinLabelX:=StartMinLabelX;
   FMinLabelY:=StartMinLabelY;
   FMinLabelY1:=StartMinLabelY1;
   FMinGlobalLabel:=StartMinGlobalLabel;
   FNodeShadowDepth:=4;
   FMinLineEndPoint:=StartMinLineEndPoint;
  end;

 procedure  TBPMSDGraph.SetScaledConstants(ratiox,ratioy,ratio:Double;fontSizeRatio:Double;LabelFontSizeRatio:Double); { Checked }

  function GetMinLabelY1(Value:Integer):Integer;
 Var  dc:HDC;
     ppi:Integer;
  begin
    Result:=Value;
    if not(FDoOverrideFS and FOverrideLabelsFS) then Exit;
    dc:=GetDC(0);
    ppi:=GetDeviceCaps(dc,LOGPIXELSY);
    ReleaseDC(0,dc);
    if FOwner.FPreviewOrPrint then
      Result:=Round(1.2*FLabelsFontSize*ppi*FOwner.FFOntCoof/72)
    else
      Result:=Round(1.2*FLabelsFontSize*ppi*FScaled2Ratio/100/72);
  end;

  begin
   FDoOverrideFS:=True;
   FFontDPI:=Round(FFontDPI*ratio);
   FFontSize:=Round(FFontSize*fontSizeRatio);
   if FFontSize=0 then FFontSize:=1;
   FLabelFontSize:=Round(FLabelFontSize*LabelfontSizeRatio);
   if FLabelFontSize=0 then FLabelFontSize:=1;
   if FLabelFontSize>FRealMaxFontSize then FLabelFontSize:=FRealMaxFontSize;
   if FFontSize>FRealMaxFontSize then FFontSize:=FRealMaxFontSize;
{   FMinLineStep:=(FNodeWidth div 4) div StartMaxLines;}
   FMinLineStep:=FNodeWidth div 8;
   FNodeLineWidth:=Round(FNodeLineWidth*ratio);
   if FNodeLineWidth=0 then FNodeLineWidth:=1;
   FNodeDefWidth:=Round(FNodeDefWidth*ratiox);
   FNodeDefHeight:=Round(FNodeDefHeight*ratioy);
   FNodeHSpacing:=Round(FNodeHSpacing*ratiox);
   FNodeVSpacing:=Round(FNodeVSpacing*ratioy);
   FGlobalLeftSize:=Round(FGlobalLeftSize*ratiox);
   FGlobalRightSize:=Round(FGlobalRightSize*ratiox);
   FGlobalTopSize:=Round(FGlobalTopSize*ratioy);
   FGlobalBottomSize:=Round(FGlobalBottomSize*ratioy);
   FMinArcRadius:=Round(FMinArcRadius*ratio);
   FMinLabelX:=Round(FMinLabelX*ratiox);
   FMinLabelY:=Round(FMinLabelY*ratioy);
   FMinLabelY1:=Round(FMinLabelY1*fontSizeRatio);
   FMinLabelY1:=GetMinLabelY1(FMinLabelY1);
   FMinGlobalLabel:=Round(FMinGlobalLabel*ratio);
   FNodeShadowDepth:=Round(FNodeShadowDepth*ratio);
   if FNodeShadowDepth=0 then FNodeShadowDepth:=1;
   FMinLineEndPoint:=Round(FMinLineEndPoint*ratio);
  end;

 procedure  TBPMSDGraph.SetFontSize(Value:Integer);  { Checked }
  begin
   if Value=FFontSize then Exit;
   FFontSize:=Value;
   CreateGraphNodes(FRatioWC,FRatioHC);
   CreateGraphLinks(FRatioWC,FRatioHC);
  end;

 procedure  TBPMSDGraph.CalcLabelSizes; { Checked }
  Var gnode:TBPLSAGraphNode;
      i,j:Integer;
      maxlch:Integer;
      FSize:Integer;
      linkP:PMSDGraphLink;
  begin
   if (FTree=nil) then Exit;
   if (FGLinksCount=0) then Exit;
   if (FGNodesCount=0) then Exit;
   maxlch:=0;
   for i:=0 to (FGNodesCount-1) do
    begin
     gnode:=GetGraphNode(i);
     if (gnode<>nil) then
      begin
        if (maxlch<gnode.InputLinksCount) then maxlch:=gnode.InputLinksCount;
        if (maxlch<gnode.OutputLinksCount) then maxlch:=gnode.OutputLinksCount;
      end;
    end;
    if (maxlch<8) then
     begin
      FMaxCH:=1.0;
      FSize:=FLabelFontSize;
     end
    else
     begin
      FMaxCH:=8/maxlch;
      FSize:=Round(FLabelFontSize*8/maxlch)+1;
     end;
    if FPrinting then Exit;
    if FScaled then Exit;
    for j:=0 to (FGLinksCount-1) do
        begin
         linkP:=GetGraphLink(j);
          if linkP<>nil then
            begin
              if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and
                  linkP^.Visible) then
               begin
                 linkP^.BPFromLabel.Font.Size:=FSize;
               end;
              if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and
                  linkP^.Visible) then
               begin
                 linkP^.BPToLabel.Font.Size:=FSize;
               end;
            end;
        end;
  end;


 procedure  TBPMSDGraph.DrawSS(sx,sy,dx,dy:Integer;color:TColor); { Checked }
  Var oldColor:TColor;
      hw:Integer;
      x1,y1,x2,y2:Integer;
      zx,zy:Integer;
      f1,f2:Double;
      normaz:Integer;
      sizex,sizey:Integer;
  begin
   { Draws SS link from point to caption }
    with FOwner.Canvas do
     begin
       oldColor:=Pen.Color;
       Pen.Color:=color;
       zx:=(dx-sx) div 2;
       zy:=(dy-sy) div 2;
       normaz:=Round(Sqrt(zx*zx+zy*zy));
       f1:=3.14/2;
       f2:=-3.14/2;
       sizex:=MinLabelX div 4;
       sizey:=sizex;
       if (normaz=0) then normaz:=1;
       if (sizex=0) then sizex:=1;
       if (sizey=0) then sizey:=1;
       x1:=Round((cos(f1)*zx+sin(f1)*zy)/normaz*sizex)+sx+zx;
       y1:=Round((cos(f1)*zy-sin(f1)*zx)/normaz*sizey)+sy+zy;
       x2:=Round((cos(f2)*zx+sin(f2)*zy)/normaz*sizex)+sx+zx;
       y2:=Round((cos(f2)*zy-sin(f2)*zx)/normaz*sizey)+sy+zy;
       MoveTo(sx,sy);
       LineTo(x1,y1);
       LineTo(x2,y2);
       LineTo(dx,dy);
       Pen.Color:=oldColor;
     end;
  end;


 function   TBPMSDGraph.GetGraphNodeRec(index:DWORD):PMSDGraphNode;
 Var tmpN:PMSDGraphNode;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   if (index>=FGNodesCount) then Exit;
   tmpN:=FGraphNodes;
   for i:=0 to index do
    begin
      Result:=tmpN;
      tmpN:=tmpN^.Next;
    end;
  end;

 function   TBPMSDGraph.GetGraphNode(index:DWORD):TBPLSAGraphNode; { Checked }
 Var tmpN:PMSDGraphNode;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   if (index>=FGNodesCount) then Exit;
   tmpN:=FGraphNodes;
   for i:=0 to index do
    begin
      Result:=tmpN^.BPNode;
      tmpN:=tmpN^.Next;
    end;
  end;


function   TBPMSDGraph.GetGraphNumberedNode(NodeNumber:DWORD):PMSDGraphNode; { Checked }
 Var tmpN:PMSDGraphNode;
  begin
   Result:=nil;
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   while ((tmpN<>nil) and (tmpN^.BPNode.NodeNumber<>NodeNumber)) do
    begin
      tmpN:=tmpN^.Next;
    end;
   if (tmpN<>nil) then Result:=tmpN;
  end;

function   TBPMSDGraph.GetGraphLink(index:DWORD):PMSDGraphLink; { Checked }
 Var tmpN:PMSDGraphLink;
     i:DWORD;
  begin
   Result:=nil;
   if FGraphLinks=nil then Exit;
   if (index>=FGLinksCount) then Exit;
   tmpN:=FGraphLinks;
   for i:=0 to index do
    begin
      Result:=tmpN;
      tmpN:=tmpN^.Next;
    end;
  end;


 procedure  TBPMSDGraph.CalcMaxWidthHeight;  { Checked }
 Var nodeP:PMSDGraphNode;
     i:Integer;
  begin
   if FGNodesCount=0 then Exit;
   FMaxWidth:=0;
   FMaxHeight:=0;
   nodeP:=FGraphNodes;
    for i:=0 to (FGNodesCount-1) do
     begin
       nodeP^.BPNode.AutoHeight:=True;
       nodeP^.BPNode.AutoWidth:=True;
       nodeP^.BPNode.Repaint;
       if nodeP^.BPNode.MaxWidth>FMaxWidth then
               FMaxWidth:=nodeP^.BPNode.MaxWidth;
       if nodeP^.BPNode.MaxHeight>FMaxHeight then
               FMaxHeight:=nodeP^.BPNode.MaxHeight;
       nodeP^.BPNode.AutoHeight:=False;
       nodeP^.BPNode.AutoWidth:=False;
       nodeP^.BPNode.Repaint;
       nodeP:=nodeP^.next;
     end;
  end;


 procedure  TBPMSDGraph.CreateGraphLinks(wc,hc:Double); { Checked }
 Var linkP:PBPLink;
     linkG:PMSDGraphLink;
     curLinkG:PMSDGraphLink;
     i:Integer;
     tmp:TBPLinkTypes;
     tnnd,fnnd:Boolean;
     linkVisible:Boolean;
     lfl:String;
     ltl:String;

  begin
   if (FGraphLinks<>nil) then ClearGraphLinks;
   if (FLinks=nil) then Exit;
   linkP:=FLinks;
   FGLinksCount:=0;
   curLinkG:=nil;
   for i:=0 to (FLinksCount-1) do
    begin
      tmp:=GetLTFromIndex(linkP^.dwLinkIndex);
      fnnd:=((linkp^.dwFromNodeNumber and BPGlobalNodeOperation)<>0);
      tnnd:=((linkp^.dwToNodeNumber and BPGlobalNodeOperation)<>0);
      linkVisible:=((not(fnnd or tnnd)));
      linkVisible:=linkVisible and IsLinkVisibleEx(linkP);
      linkVisible:=linkVisible and tmp.dbShowLinkType;
      if linkVisible then
      begin
      if (curLinkG=nil) then
          begin
            curLinkG:=PMSDGraphLink(AllocMem(sizeof(TMSDGraphLink)));
            curLinkG^.llLink:=linkP;
            lfl:=MyUtils.MyReplaceLabelCaption(linkP^.ssFromCaption,FMaxLabellength,FReplaceLabels);
            ltl:=MyUtils.MyReplaceLabelCaption(linkP^.ssToCaption,FMaxLabellength,FReplaceLabels);
            if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and linkVisible)  then
            begin
            curLinkG^.BPFromLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPFromLabel.Parent:=Parent as TWinControl;
            curLinkG^.BPFromLabel.Caption:=lfl{linkP^.ssFromCaption};
            curLinkG^.BPFromLabel.ParentFont:=False;
            curLinkG^.BPFromLabel.Hint:=lfl{linkP^.ssFromCaption};
            curLinkG^.BPFromLabel.ShowHint:=True;
            curLinkG^.BPFromLabel.Path:=linkP^.ssFromPath;
            curLinkG^.BPFromLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            curLinkG^.BPFromLabel.Font.Size:=FLabelFontSize;
            curLinkG^.BPFromLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPFromLabel.Font.Charset:=FLang;
            curLinkG^.BPFromLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPFromLabel.Transparent:=True;
            curLinkG^.BPFromLabel.AutoSize:=True;
            curLinkG^.BPFromLabel.Color:=clWhite;
            curLinkG^.BPFromLabel.WordWrap:=False;
            curLinkG^.BPFromLabel.AcceptPosition:=False;
            curLinkG^.BPFromLabel.Top:=Round(linkP^.FromTop[3]*hc);
            curLinkG^.BPFromLabel.Left:=Round(linkP^.FromLeft[3]*wc);
            curLinkG^.BPFromLabel.AcceptPosition:=linkP^.FromAcceptPosition[3];
            curLinkG^.BPFromLabel.DragMode:=dmManual;
            curLinkG^.BPFromLabel.OnMouseDown:=MyLabelMouseDown;
            curLinkG^.BPFromLabel.PopupMenu:=BPViewMainForm.MSDLinksPopupMenu;
            curLinkG^.BPFromLabel.Cursor:=crHandPoint;
            curLinkG^.BPFromLabel.SendToBack;
            end
             else
            curLinkG^.BPFromLabel:=nil;
            if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and linkVisible) then
            begin
            curLinkG^.BPToLabel:=TBPLabel.Create(Parent);
            curLinkG^.BPToLabel.Parent:=Parent as TWinControl;
            curLinkG^.BPToLabel.Caption:=ltl{linkP^.ssToCaption};
            curLinkG^.BPToLabel.ParentFont:=False;
            curLinkG^.BPToLabel.Hint:=ltl{linkP^.ssToCaption};
            curLinkG^.BPToLabel.ShowHint:=True;
            curLinkG^.BPToLabel.Path:=linkP^.ssToPath;
            curLinkG^.BPToLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              curLinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              curLinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            curLinkG^.BPToLabel.Font.Size:=FLabelFontSize;
            curLinkG^.BPToLabel.Font.Color:=tmp.dwColor;
            curLinkG^.BPToLabel.Font.Charset:=FLang;
            curLinkG^.BPToLabel.SetFontDPI(FFontDPI);
            curLinkG^.BPToLabel.Transparent:=True;
            curLinkG^.BPToLabel.AutoSize:=True;
            curLinkG^.BPToLabel.Color:=clWhite;
            curLinkG^.BPToLabel.WordWrap:=False;
            curLinkG^.BPToLabel.AcceptPosition:=False;
            curLinkG^.BPToLabel.Top:=Round(linkP^.ToTop[3]*hc);
            curLinkG^.BPToLabel.Left:=Round(linkP^.ToLeft[3]*wc);
            curLinkG^.BPToLabel.AcceptPosition:=linkP^.ToAcceptPosition[3];
            curLinkG^.BPToLabel.DragMode:=dmManual;
            curLinkG^.BPToLabel.Cursor:=crHandPoint;
            curLinkG^.BPToLabel.OnMouseDown:=MyLabelMouseDown;
            curLinkG^.BPToLabel.PopupMenu:=BPViewMainForm.MSDLinksPopupMenu;
            curLinkG^.BPToLabel.SendToBack;
            end
             else
            curLinkG^.BPToLabel:=nil;
            curLinkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            curLinkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            curLinkG^.dwFlags:=linkP^.dwFlags;
            curLinkG^.FromLinkNumber:=linkP^.dwFromLinkNumber;
            curLinkG^.ToLinkNumber:=linkP^.dwToLinkNumber;
{            curLinkG^.LinkDirection:=linkP^.dwLinkDirectional;}
            curLinkG^.StartPoint.x:=0;
            curLinkG^.StartPoint.y:=0;
            curLinkG^.EndPoint.x:=0;
            curLinkG^.EndPoint.y:=0;
            curLinkG^.LinkFromCount:=0;
            curLinkG^.LinkToCount:=0;
            curLinkG^.MinimalXFrom:=0;
            curLinkG^.MinimalXTo:=0;
            curLinkG^.MinimalYFrom:=0;
            curLinkG^.MinimalYTo:=0;
            FillChar(curLinkG^.LineArrayX,sizeof(curLinkG^.LineArrayX),0);
            FillChar(curLinkG^.LineArrayY,sizeof(curLinkG^.LineArrayY),0);
            curLinkG^.LinePointCount:=0;
            curLinkG^.Color:=tmp.dwColor;
            curLinkG^.PenStyle:=tmp.dwPenStyle;
            curLinkG^.Visible:=linkVisible;
            curLinkG^.next:=nil;
            FGraphLinks:=curLinkG;
            Inc(FGLinksCount);
          end
       else
          begin
            linkG:=PMSDGraphLink(AllocMem(sizeof(TMSDGraphLink)));
            linkG^.llLink:=linkP;
            lfl:=MyUtils.MyReplaceLabelCaption(linkP^.ssFromCaption,FMaxLabellength,FReplaceLabels);
            ltl:=MyUtils.MyReplaceLabelCaption(linkP^.ssToCaption,FMaxLabellength,FReplaceLabels);
            if (((linkP^.dwFlags and BP_SHOW_FROMCAPTION)<>0) and linkVisible) then
            begin
            LinkG^.BPFromLabel:=TBPLabel.Create(Parent);
            LinkG^.BPFromLabel.Parent:=Parent as TWinControl;
            LinkG^.BPFromLabel.Caption:=lfl{linkP^.ssFromCaption};
            LinkG^.BPFromLabel.ParentFont:=False;
            LinkG^.BPFromLabel.Hint:=lfl{linkP^.ssFromCaption};
            LinkG^.BPFromLabel.ShowHint:=True;
            LinkG^.BPFromLabel.Path:=linkP^.ssFromPath;
            LinkG^.BPFromLabel.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPFromLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            LinkG^.BPFromLabel.Font.Size:=FLabelFontSize;
            LinkG^.BPFromLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPFromLabel.Font.Charset:=FLang;
            LinkG^.BPFromLabel.SetFontDPI(FFontDPI);
            LinkG^.BPFromLabel.Transparent:=True;
            LinkG^.BPFromLabel.AutoSize:=True;
            LinkG^.BPFromLabel.Color:=clWhite;
            LinkG^.BPFromLabel.WordWrap:=False;
            LinkG^.BPFromLabel.AcceptPosition:=False;
            LinkG^.BPFromLabel.Top:=Round(linkP^.FromTop[3]*hc);
            LinkG^.BPFromLabel.Left:=Round(linkP^.FromLeft[3]*wc);
            LinkG^.BPFromLabel.AcceptPosition:=linkP^.FromAcceptPosition[3];
            LinkG^.BPFromLabel.DragMode:=dmManual;
            LinkG^.BPFromLabel.OnMouseDown:=MyLabelMouseDown;
            LinkG^.BPFromLabel.PopupMenu:=BPViewMainForm.MSDLinksPopupMenu;
            LinkG^.BPFromLabel.Cursor:=crHandPoint;
            LinkG^.BPFromLabel.SendToBack;
            end
             else
            LinkG^.BPFromLabel:=nil;
            if (((linkP^.dwFlags and BP_SHOW_TOCAPTION)<>0) and LinkVisible) then
            begin
            LinkG^.BPToLabel:=TBPLabel.Create(Parent);
            LinkG^.BPToLabel.Parent:=Parent as TWinControl;
            LinkG^.BPToLabel.Caption:=ltl{linkP^.ssToCaption};
            LinkG^.BPToLabel.ParentFont:=False;
            LinkG^.BPToLabel.Hint:=ltl{linkP^.ssToCaption};
            LinkG^.BPToLabel.ShowHint:=True;
            LinkG^.BPToLabel.Path:=linkP^.ssToPath;
            LinkG^.BPToLabel.Font.Name:=FPrinterFontName;
            LinkG^.BPToLabel.Font.Charset:=FLang;
            if FDoOverrideFS and FOverrideLabelsFS then
             if FOwner.FPreviewOrPrint then
              LinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FOwner.FFOntCoof)
             else
              LinkG^.BPToLabel.Font.Size:=Round(FLabelsFontSize*FScaled2Ratio/100)
            else
            LinkG^.BPToLabel.Font.Size:=FLabelFontSize;
            LinkG^.BPToLabel.Font.Color:=tmp.dwColor;
            LinkG^.BPToLabel.SetFontDPI(FFontDPI);
            LinkG^.BPToLabel.Transparent:=True;
            LinkG^.BPToLabel.AutoSize:=True;
            LinkG^.BPToLabel.Color:=clWhite;
            LinkG^.BPToLabel.WordWrap:=False;
            LinkG^.BPToLabel.AcceptPosition:=False;
            LinkG^.BPToLabel.Top:=Round(linkP^.ToTop[3]*hc);
            LinkG^.BPToLabel.Left:=Round(linkP^.ToLeft[3]*wc);
            LinkG^.BPToLabel.AcceptPosition:=linkP^.ToAcceptPosition[3];
            LinkG^.BPToLabel.DragMode:=dmManual;
            LinkG^.BPToLabel.Cursor:=crHandPoint;
            LinkG^.BPToLabel.OnMouseDown:=MyLabelMouseDown;
            LinkG^.BPToLabel.PopupMenu:=BPViewMainForm.MSDLinksPopupMenu;
            LinkG^.BPToLabel.SendToBack;
            end
             else
            LinkG^.BPToLabel:=nil;
            linkG^.FromNodeNumber:=linkP^.dwFromNodeNumber;
            linkG^.ToNodeNumber:=linkP^.dwToNodeNumber;
            LinkG^.dwFlags:=linkP^.dwFlags;
            LinkG^.FromLinkNumber:=linkP^.dwFromLinkNumber;
            LinkG^.ToLinkNumber:=linkP^.dwToLinkNumber;
{            LinkG^.LinkDirection:=linkP^.dwLinkDirectional;}
            linkG^.StartPoint.x:=0;
            linkG^.StartPoint.y:=0;
            linkG^.EndPoint.x:=0;
            linkG^.EndPoint.y:=0;
            linkG^.LinkFromCount:=0;
            linkG^.LinkToCount:=0;
            linkG^.MinimalXFrom:=0;
            linkG^.MinimalXTo:=0;
            linkG^.MinimalYFrom:=0;
            linkG^.MinimalYTo:=0;
            FillChar(linkG^.LineArrayX,sizeof(linkG^.LineArrayX),0);
            FillChar(linkG^.LineArrayY,sizeof(linkG^.LineArrayY),0);
            linkG^.LinePointCount:=0;
            LinkG^.Color:=tmp.dwColor;
            LinkG^.PenStyle:=tmp.dwPenStyle;
            LinkG^.Visible:=linkVisible;
            linkG^.next:=nil;
            curLinkG^.next:=linkG;
            curLinkG:=linkG;
            Inc(FGLinksCount);
          end;
      end; { linkVisible }
      Inc(linkP);
    end; { for }
  end;


procedure  TBPMSDGraph.CreateGraphNodes(wc,hc:Double); { Checked }
 Var nodeP:PBPNode;
     nodeG:PMSDGraphNode;
     curNodeG:PMSDGraphNode;
     i,j:Integer;
     tmp:TBPNodeTypes;
     s:String;
     nc:String;
  begin
   if (FGraphNodes<>nil) then ClearGraphNodes;
   if (FNodes=nil) then Exit;
   FGNodesCount:=0;
   nodeP:=FNodes;
   j:=-1;
   for i:=0 to (FNodesCount-1) do
    begin
      tmp:=GetNTFromIndex(nodeP^.dwNodeIndex);
      if  IsNodeVisibleEx(nodeP) then
      begin { Node Visible }
      nc:=MyUtils.MyReplaceNodeCaption(nodeP^.ssCaption,FMaxWordLength,FMaxWordCount,FReplaceNodes);
      if (j=-1) then
          begin
            j:=1;
            curNodeG:=PMSDGraphNode(AllocMem(sizeof(TMSDGraphNode)));
            curNodeG^.BPNode:=TBPLSAGraphNode.Create(Parent);
            curNodeG^.BPNode.Parent:=Parent as TWinControl;
            curNodeG^.BPNode.Caption:=nc;
            curNodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            curNodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            curNodeG^.BPNode.AutoHeight:=False;
            curNodeG^.BPNode.AutoWidth:=False;
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
            if (Length(nodeP^.ssComment)>0) then
               curNodeG^.BPNode.Hint:=nodeP^.ssComment
            else
              begin
               s:=Format('%f',[nodeP^.fABCValue]);
               curNodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
              end;
            end;
            { New }
            curNodeG^.BPNode.ShowHint:=True;
            curNodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            curNodeG^.BPNode.Font.Charset:=FLang;
            curNodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            curNodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            curNodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            curNodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            curNodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            curNodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
             if FOwner.FPreviewOrPrint then
                curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
             else
                curNodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            curNodeG^.BPNode.Font.Size:=FFontSize;
            curNodeG^.BPNode.Font.Style:=[fsBold];
            curNodeG^.BPNode.InputLinksCount:=0;
            curNodeG^.BPNode.OutputLinksCount:=0;
            curNodeG^.BPNode.LeftLinksCount:=0;
            curNodeG^.BPNode.RightLinksCount:=0;
            curNodeG^.BPNode.TopLinksCount:=0;
            curNodeG^.BPNode.BottomLinksCount:=0;
            curNodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            curNodeG^.BPNode.SetFontDPI(FFontDPI);
            curNodeG^.BPNode.LineWidth:=FNodeLineWidth;
            curNodeG^.BPNode.DefWidth:=FNodeDefWidth;
            curNodeG^.BPNode.DefHeight:=FNodeDefHeight;
            curNodeG^.BPNode.HSpacing:=FNodeHSpacing;
            curNodeG^.BPNode.VSpacing:=FNodeVSpacing;
            curNodeG^.CorrectNode:=True;
            if nodeP^.AcceptPosition[3] then
            begin
            curNodeG^.BPNode.Top:=Round(nodeP^.Top[3]*hc);
            curNodeG^.BPNode.Left:=Round(nodeP^.Left[3]*wc);
            end;
            curNodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[3];
            curNodeG^.BPNode.DragMode:=dmManual;
            curNodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
            curNodeG^.BPNode.PopupMenu:=BPViewMainForm.MSDNodesPopupMenu;
            curNodeG^.BPNode.Tag:=i;
            curNodeG^.next:=nil;
            curNodeG^.llNode:=nodeP;
            FGraphNodes:=curNodeG;
            inc(FGNodesCount);
          end
       else
          begin
            nodeG:=PMSDGraphNode(AllocMem(sizeof(TMSDGraphNode)));
            nodeG^.BPNode:=TBPLSAGraphNode.Create(Parent);
            nodeG^.BPNode.Parent:=Parent as TWinControl;
            nodeG^.BPNode.Caption:=nc;
            nodeG^.BPNode.SNodeNumber:=nodeP^.ssNodeNumber;
            nodeG^.BPNode.NodeNumber:=nodeP^.dwNodeNumber;
            nodeG^.BPNode.AutoHeight:=False;
            nodeG^.BPNode.AutoWidth:=False;
            if not(FScaled2) then
            begin
            s:=Format('%f',[nodeP^.fABCValue]);
            nodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
            end
            else
            begin
            if (Length(nodeP^.ssComment)>0) then
             nodeG^.BPNode.Hint:=nodeP^.ssComment
            else
             begin
              s:=Format('%f',[nodeP^.fABCValue]);
              nodeG^.BPNode.Hint:=nodeP^.ssNodeNumber+': '+nodeP^.ssCaption+' ['+s+']';
             end;
            end;
            { New }
            nodeG^.BPNode.ShowHint:=True;
            nodeG^.BPNode.Font.Color:=tmp.dwFontColor;
            NodeG^.BPNode.Font.Charset:=FLang;
            nodeG^.BPNode.PaintColor:=tmp.dwPaintColor;
            nodeG^.BPNode.ShadowType:=TDSShadowType(tmp.dwShadowStyle);
            nodeG^.BPNode.RectStyle:=TDSRectStyle(tmp.dwRectStyle);
            nodeG^.BPNode.ShadowColor:=tmp.dwShadowColor;
            nodeG^.BPNode.RectColor:=tmp.dwDrawColor;
            { End New }
            nodeG^.BPNode.Font.Name:=FPrinterFontName;
            if FDoOverrideFS and FOverrideNodesFS then
             if FOwner.FPreviewOrPrint then
               NodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FOwner.FFOntCoof)
             else
               NodeG^.BPNode.Font.Size:=Round(FNodesFontSize*FScaled2Ratio/100)
            else
            nodeG^.BPNode.Font.Size:=FFontSize;
            nodeG^.BPNode.Font.Style:=[fsBold];
            nodeG^.BPNode.InputLinksCount:=0;
            nodeG^.BPNode.OutputLinksCount:=0;
            nodeG^.BPNode.LeftLinksCount:=0;
            nodeG^.BPNode.RightLinksCount:=0;
            nodeG^.BPNode.TopLinksCount:=0;
            nodeG^.BPNode.BottomLinksCount:=0;
            nodeG^.BPNode.ShadowDepth:=FNodeShadowDepth;
            nodeG^.BPNode.SetFontDPI(FFontDPI);
            nodeG^.BPNode.LineWidth:=FNodeLineWidth;
            nodeG^.BPNode.DefWidth:=FNodeDefWidth;
            nodeG^.BPNode.DefHeight:=FNodeDefHeight;
            nodeG^.BPNode.HSpacing:=FNodeHSpacing;
            nodeG^.BPNode.VSpacing:=FNodeVSpacing;
            nodeG^.CorrectNode:=True;
            if nodeP^.AcceptPosition[3] then
            begin
            nodeG^.BPNode.Top:=Round(nodeP^.Top[3]*hc);
            nodeG^.BPNode.Left:=Round(nodeP^.Left[3]*wc);
            end;
            nodeG^.BPNode.AcceptPosition:=nodeP^.AcceptPosition[3];
            nodeG^.BPNode.DragMode:=dmManual;
            nodeG^.BPNode.OnMouseDown:=MyNodeMouseDown;
            nodeG^.BPNode.PopupMenu:=BPViewMainForm.MSDNodesPopupMenu;
            nodeG^.BPNode.Tag:=i;
            nodeG^.llNode:=nodeP;
            nodeG^.next:=nil;
            curNodeG^.next:=nodeG;
            curNodeG:=nodeG;
            inc(FGNodesCount);
            FLastNodeNumber:=nodeP^.dwNodeNumber;
          end;
     end; { NodeVisible }
     if (FGNodesCount=1) then FFirstNodeNumber:=nodeP^.dwNodeNumber;
     Inc(nodeP);
    end; { for }
  end;


 procedure  TBPMSDGraph.ClearGraphNodes; { Checked }
 Var tmpN,tmpN1:PMSDGraphNode;
  begin
   if FGraphNodes=nil then Exit;
   tmpN:=FGraphNodes;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
{         tmpN1^.BPNode.OnDblClick:=nil;}
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
{         tmpN1^.BPNode.OnDblClick:=nil;}
         tmpN1^.BPNode.OnMouseDown:=nil;
         tmpN1^.BPNode.PopupMenu:=nil;
         tmpN1^.BPNode.Destroy;
         FreeMem(tmpN1);
       end;
   FGraphNodes:=nil;
   FGNodesCount:=0;
   FMaxWidth:=0;
   FMaxHeight:=0;
  end;

 procedure  TBPMSDGraph.ClearGraphLinks; { Checked }
  Var tmpN,tmpN1:PMSDGraphLink;
  begin
   { Clears graphics links list }
   if FGraphLinks=nil then Exit;
   tmpN:=FGraphLinks;
   tmpN1:=nil;
   while tmpN<>nil do
    begin
      if tmpN1<>nil then
        begin
         if ((tmpN1^.dwFlags and BP_SHOW_FROMCAPTION)<>0)  and (tmpN1^.BPFromLabel<>nil) and (tmpN1^.BPFromLabel<>nil) then
           begin
            tmpN1^.BPFromLabel.OnMouseDown:=nil;
            tmpN1^.BPFromLabel.PopupMenu:=nil;
            tmpN1^.BPFromLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_TOCAPTION)<>0) and (tmpN1^.BPToLabel<>nil) and (tmpN1^.BPToLabel<>nil) then
           begin
            tmpN1^.BPToLabel.OnMouseDown:=nil;
            tmpN1^.BPToLabel.PopupMenu:=nil;
            tmpN1^.BPToLabel.Destroy;
           end;
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
        end;
      tmpN1:=tmpN;
      tmpN:=tmpN.Next;
    end;
    if tmpN1<>nil then
       begin
         if ((tmpN1^.dwFlags and BP_SHOW_FROMCAPTION)<>0)  and (tmpN1^.BPFromLabel<>nil) then
           begin
            tmpN1^.BPFromLabel.OnMouseDown:=nil;
            tmpN1^.BPFromLabel.PopupMenu:=nil;
            tmpN1^.BPFromLabel.Destroy;
           end;
         if ((tmpN1^.dwFlags and BP_SHOW_TOCAPTION)<>0)  and (tmpN1^.BPToLabel<>nil) then
           begin
            tmpN1^.BPToLabel.OnMouseDown:=nil;
            tmpN1^.BPToLabel.PopupMenu:=nil;
            tmpN1^.BPToLabel.Destroy;
           end;
         tmpN1^.llLink:=nil;
         FreeMem(tmpN1);
       end;
   FGraphLinks:=nil;
   FGLinksCount:=0;
  end;

 function  TBPMSDGraph.GetNTFromIndex(index:DWORD):TBPNodeTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPNodeTypes;
  begin
     flag:=True;
     tmpPtr:=FNTTree;
     ic:=FHeader.dwNodesTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwNodeIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwNodeIndex:=index;
      Result.ssCaption:='Default';
      Result.dwFontColor:=clBlack;
      Result.dwPaintColor:=clWhite;
      Result.dwDrawColor:=clBlack;
      Result.dwShadowColor:=clBlack;
      Result.dwShadowStyle:=6;
      Result.dwRectStyle:=2;
  end;

function  TBPMSDGraph.GetLTFromIndex(index:DWORD):TBPLinkTypes; { Checked }
 Var flag:Boolean;
     i,ic:Integer;
     tmpPtr:PBPLinkTypes;
  begin
     flag:=True;
     tmpPtr:=FLTTree;
     ic:=FHeader.dwLinksTypesCount;
     if (ic>0) then
       begin
         i:=0;
         while ((i<ic) and (flag)) do
           begin
              if tmpPtr^.dwLinkIndex=index then
                 begin
                   flag:=False;
                   Result:=tmpPtr^;
                   Exit;
                 end
               else
                begin
                 inc(tmpPtr);
                 inc(i);
                end;
           end;
       end;
      Result.dwLinkIndex:=index;
      Result.ssCaption:='Default';
      Result.dwPenStyle:=psSolid;
      Result.dwColor:=clBlack;
  end;

{ TBPMSDFrame }

procedure TBPMSDFrame.MyDragDrop(Sender, Source: TObject; X, Y: Integer); { Checked }
var p:TPoint;
    vpos,hpos:Integer;
begin
 if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
 if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
 if (Sender is TBPMSDFrame) and (Source is TBPLSAGraphCustomNode) then
  begin
    with Source as TBPLSAGraphNode do
    begin
      p.x:=X-Left;
      p.y:=Y-Top;
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
      FBPMSDGraph.UpdateNodesModel(LeftDragPos,TopDragPos,Source as TBPLSAGraphNode);
      if FBPMSDGraph.FLinksPosRelative then FBPMSDGraph.CorrectLinksModel(p,(Source as TBPLSAGraphNode).NodeNumber,FBPMSDGraph.AcceptDragRect);
      BringToFront;
    end;
    with (Sender as TBPMSDFrame) do
      begin
       Visible:=False;
       FBPMSDGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
  end;
 if (Sender is TBPMSDFrame) and (Source is TBPLabel) then
  begin
    with Source as TBPLabel do
    begin
      Left:=X;
      Top:=Y;
      if VertScrollBar.Visible then
       TopDragPos:=Y+VertScrollBar.Position
      else
       TopDragPos:=Y;
      if HorzScrollBar.Visible then
       LeftDragPos:=X+HorzScrollBar.Position
      else
       LeftDragPos:=X;
      AcceptPosition:=True;
    end;
     with (Sender as TBPMSDFrame) do
      begin
       FBPMSDGraph.UpdateLinksModel((Source as TBPLabel).LeftDragPos,
               (Source as TBPLabel).TopDragPos,Source as TBPLabel);
       Visible:=False;
       FBPMSDGraph.TraceRoute;
       Repaint;
       Visible:=True;
       if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
       if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
       BPViewMainForm.BPGetBitmapTimer.Enabled:=True;
      end;
   end;
end;



procedure TBPMSDFrame.MyDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean); { Checked }
Var tmpn:TBPLSAGraphNode;
    tmpl:TBPLabel;
    xnew,ynew:Integer;
begin
 if VertScrollBar.Visible then
   ynew:=y+VertScrollBar.Position
 else
   ynew:=y;
 if HorzScrollBar.Visible then
   xnew:=x+HorzScrollBar.Position
 else
   xnew:=x;
 { Check for Source }
 Accept:=(Source is TBPLSAGraphCustomNode);
 { Check coordinates }
 if Accept then
    begin
      tmpn:=Source as TBPLSAGraphNode;
      if   (Xnew<FBPMSDGraph.AcceptDragRect.Left)
       or  (Ynew<FBPMSDGraph.AcceptDragRect.Top)
       or  ((Xnew+tmpn.Width)>FBPMSDGraph.AcceptDragRect.Right)
       or  ((Ynew+tmpn.Height)>FBPMSDGraph.AcceptDragRect.Bottom)
        then
         Accept:=False;
    end;
 if not(Accept) then
  begin
   Accept:=Source is TBPLabel;
   if Accept then
     begin
       tmpl:=Source as TBPLabel;
       if   (Xnew<FBPMSDGraph.AcceptDragRect.Left)
       or  (Ynew<FBPMSDGraph.AcceptDragRect.Top)
       or  ((Xnew+tmpl.Width)>FBPMSDGraph.AcceptDragRect.Right)
       or  ((Ynew+tmpl.Height)>FBPMSDGraph.AcceptDragRect.Bottom)
        then
         Accept:=False;
     end;
  end;
end;


constructor TBPMSDFrame.Create(AOwner: TComponent); { Checked }
begin
 inherited Create(AOwner);
 FPainting:=False;
 FPrinting:=False;
 FAborting:=False;
 FPreviewOrPrint:=False;
 FFontCoof:=1;
 FBPMSDGraph:=TBPMSDGraph.Create(self);
 FBPMSDGraph.Parent:=self;
 FCanvas := TControlCanvas.Create;
 TControlCanvas(FCanvas).Control := Self;
 Canvas.Brush.Color:=clWhite;
 DragCursor:=crMyCursor;
 OnDragDrop:=MyDragDrop;
 OnDragOver:=MyDragOver;
 FPageTop:=15;
 FPageBottom:=15;
 FPageLeft:=25;
 FPageRight:=15;
 FHorzPageCount:=1;
 FVertPageCount:=1;
 FRamkaFontRatio:=1.0;
 FPSizeH:=21;
 FPSizeW:=29.7;
 FRamkaH:=0;
 TabStop:=True;
 Enabled:=True;
 FUpdatingNavigator:=False;
 if MainUnit.HasPrnDevice then SetPageParam(FPageTop,FPageBottom,FPageLeft,FPageRight,False);
end;

destructor TBPMSDFrame.Destroy; { Checked }
begin
 OnDragDrop:=nil;
 OnDragOver:=nil;
 if (FPrinter<>nil) then FPrinter.Free;
 if (FCanvas<>nil) then FCanvas.Free;
 if (FBPMSDGraph<>nil) then FBPMSDGraph.Destroy; { +-+ +- }
 inherited Destroy;
end;

procedure TBPMSDFrame.WMPaint(var Message: TWMPaint); { Checked }
begin
   PaintHandler(Message);
end;

procedure TBPMSDFrame.PaintWindow(DC: HDC); { Checked }
begin
  if FPainting then Exit;
  FPainting:=True;
  inherited PaintWindow(DC);
  FCanvas.Lock;
  try
    FCanvas.Handle := DC;
    try
      Paint;
    finally
      FCanvas.Handle := 0;
    end;
  finally
    FCanvas.Unlock;
    FPainting:=False;
  end;
end;

procedure TBPMSDFrame.Paint; { Checked }
Var oldcr:TCursor;
begin
  oldcr:=Cursor;
  Cursor:=crHourGlass;
  Canvas.FillRect(ClientRect);
  FBPMSDGraph.TraceRoute;
  if (not(FUpdatingNavigator)) and
  (BPViewMainFOrm.PageControl1.ActivePage=BPViewMainFOrm.TabSheet4) then
    if (BPViewMainFOrm.BPNavigator.Height>1) then
      BPViewMainFOrm.BPNavigator.ScrollBarChanged(self);
{    BPViewMainForm.BPNavTimer.Enabled:=True;}
  Cursor:=oldcr;
end;

procedure TBPMSDFrame.PaintTo(DC: HDC; X, Y: Integer); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X, Y);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TBPMSDFrame.PaintPageTo(DC: HDC; X, Y: Integer; PageClipRect:TRect); { Checked }
var
  SaveIndex: Integer;
begin
  SaveIndex := SaveDC(DC);
  MoveWindowOrg(DC, X-PageClipRect.Left, Y-PageClipRect.Top);
  IntersectClipRect(DC, PageClipRect.Left, PageClipRect.Top, PageClipRect.Right, PageClipRect.Bottom);
  Perform(WM_ERASEBKGND, DC, 0);
  Perform(WM_PAINT, DC, 0);
  RestoreDC(DC, SaveIndex);
end;

procedure TBPMSDFrame.PrintRect(left,right,top,bottom:Integer); { Checked }
Var oldStyle:TPenStyle;
    oldSize:Integer;
    w,h:Integer;
    s:String;
begin
 with Printer.Canvas do
 begin
  oldStyle:=Pen.Style;
  Pen.Style:=psSolid;
  oldSize:=Font.Size;
  Font.Size:=16;
  s:='   :   '+IntToStr(FBPMSDGraph.CurGraph+1);
  w:=TextWidth(s);
  h:=TextHeight(s);
  TextOut(Left+((Right-Left-w) div 2),Top+2*h,s);
  Font.Size:=oldSize;
  Pen.Style:=psDot;
  MoveTo(Left,Top);
  LineTo(Right,Top);
  LineTo(Right,Bottom);
  LineTo(Left,Bottom);
  LineTo(Left,Top);
  Pen.Style:=oldStyle;
 end;
end;

procedure TBPMSDFrame.PreviewPrintRect(left,right,top,bottom:Integer);  { Checked }
Var oldStyle:TPenStyle;
    oldSize:Integer;
    w,h:Integer;
    s:String;
begin
 if FPrinter = nil then Exit;
 with FPrinter.Canvas do
  begin
   oldStyle:=Pen.Style;
   Pen.Style:=psSolid;
   oldSize:=Font.Size;
   Font.Size:=16;
   s:='   :   '+IntToStr(FBPMSDGraph.CurGraph+1);
   w:=TextWidth(s);
   h:=TextHeight(s);
   TextOut(Left+((Right-Left-w) div 2),Top+2*h,s);
   Font.Size:=oldSize;
   Pen.Style:=psDot;
   MoveTo(Left,Top);
   LineTo(Right,Top);
   LineTo(Right,Bottom);
   LineTo(Left,Bottom);
   LineTo(Left,Top);
   Pen.Style:=oldStyle;
  end;
end;

procedure TBPMSDFrame.SetPageParam(Var PageTop,PageBottom,PageLeft,PageRight:Integer;ShowWarning:Boolean); { Checked }
Var px,py,plofs,ptofs,pbofs,profs:Integer;
    s:String;
    pw,ph,hw,hh:Integer;
    po:TPrinterOrientation;
Const   es='      .    ';
        se=' ';
begin
 po:=Printer.Orientation;
 case po of
 poPortrait:
   begin
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hw:=GetDeviceCaps(Printer.Handle,HORZRES);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hh:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
  poLandscape:
   begin
    py:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
    px:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);
    ptofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETX);
    plofs:=GetDeviceCaps(Printer.Handle,PHYSICALOFFSETY);
    ph:=GetDeviceCaps(Printer.Handle,PHYSICALWIDTH);
    hh:=GetDeviceCaps(Printer.Handle,HORZRES);
    pw:=GetDeviceCaps(Printer.Handle,PHYSICALHEIGHT);
    hw:=GetDeviceCaps(Printer.Handle,VERTRES);
   end;
 end;
 pbofs:=ph-hh-ptofs;
 profs:=pw-hw-plofs;
 FPageTop:=Round(PageTop*py/25.4)-ptofs;
 FPageBottom:=Round(PageBottom*py/25.4)-pbofs;
 FPageLeft:=Round(PageLeft*px/25.4)-plofs;
 FPageRight:=Round(PageRight*px/25.4)-profs;
 if ShowWarning then
 begin
 if FPageTop<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageTop:=0;
   PageTop:=Round(ptofs*25.4/py)+1;
   end;
  if FPageBottom<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageBottom:=0;
   PageBottom:=Round(pbofs*25.4/py)+1;
   end;
  if FPageLeft<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageLeft:=0;
   PageLeft:=Round(plofs*25.4/px)+1;
   end;
  if FPageRight<0 then
   begin
   s:=se+''+es;
   Application.MessageBox(PChar(s),' !',MB_OK);
   FPageRight:=0;
   PageRight:=Round(profs*25.4/px)+1;
   end;
  end;
end;

procedure TBPMSDFrame.SetPreviewPageParam(PageTop,PageBottom,PageLeft,PageRight:Integer); { Checked }
Var px,py:Integer;
begin
 FPageTop:=PageTop;
 FPageBottom:=PageBottom;
 FPageLeft:=PageLeft;
 FPageRight:=PageRight;
end;

procedure TBPMSDFrame.DrawNode(l,t,w,h:Integer;Canvas:TCanvas;PaintColor,DrawColor:TColor);
Var r1:TRect;
  oldPenColor:TColor;
  oldBrushColor:TColor;
 begin
    oldBrushColor:=Canvas.Brush.Color;
    oldPenColor:=Canvas.Pen.Color;
    Canvas.Brush.Color:=PaintColor;
    Canvas.Pen.Color:=DrawColor;
    r1.Left:=l;
    r1.Top:=t;
    r1.Right:=l+w;
    r1.Bottom:=t+h;
    Canvas.FillRect(r1);
    Canvas.MoveTo(l,t);
    Canvas.LineTo(l+w,t);
    Canvas.LineTo(l+w,t+h);
    Canvas.LineTo(l,t+h);
    Canvas.LineTo(l,t);
    Canvas.Brush.Color:=oldBrushColor;
    Canvas.Pen.Color:=oldPenColor;
end;

procedure TBPMSDFrame.DrawLink(pl:PMSDGraphLink;Canvas:TCanvas;RatioX,RatioY:Double;Wpos,Hpos:Integer);
Var i,cnt:Integer;
    oldPenColor:TColor;
    oldPenStyle:TPenStyle;
begin
{}
  if pl=nil then Exit;
  oldPenColor:=Canvas.Pen.Color;
  oldPenStyle:=Canvas.Pen.Style;
  Canvas.Pen.Color:=pl^.Color;
  Canvas.Pen.Style:=pl^.PenStyle;
  cnt:=pl^.LinePointCount-1;
  Canvas.MoveTo(Round((pl^.LineArrayX[0]+wpos)*RatioX),Round((pl^.LineArrayY[0]+hpos)*RatioY));
  for i:=1 to cnt do
   begin
      Canvas.LineTo(Round((pl.LineArrayX[i]+wpos)*RatioX),Round((pl^.LineArrayY[i]+hpos)*RatioY));
    end;
  Canvas.Pen.Color:=oldPenColor;
  Canvas.Pen.Style:=oldPenStyle;
end;

function   TBPMSDGraph.GetMaxPagesCount:Integer;
 begin
   Result:=FRootEntries;
 end;

procedure TBPMSDFrame.PrintAll(pb:TFlatProgressBar;Lbl:TLabel;StartP,EndP:Integer); { Checked }
Var  i:Integer;
     prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio,LabelFontRatio:Double;
     rw,rh:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     pw,ph:Double;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
     pc,oldGraph:Integer;
begin
  { Print All Pages }
  oldScaled:=BPMSDGraph.Scaled;
  oldScaled2:=BPMSDGraph.Scaled2;
  if (FBPMSDGraph.FRootEntries=0) then Exit;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  OldGraph:=FBPMSDGraph.FCurGraph;
  FBPMSDGraph.Scaled2:=False;
  if FBPMSDGraph.FScaled then FBPMSDGraph.Scaled:=False;
  try
   FPrinting:=True;
  { Store old viewing level }
   i:=0;
   prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
   ramkaH:=Round(prnppi/2.54);
   FRamkaH:=ramkaH;
   dc:=GetDC(self.Handle);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSX)/GetDeviceCaps(dc,LOGPIXELSX);
   FBPMSDGraph.UpdateMaxFontSize(1);
   ReleaseDC(self.Handle,dc);
   aSize:=Printer.PaperSize;
   FRamkaFontRatio:=1.0;
   FPSizeH:=21;
   FPSizeW:=29.7;
   for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
   { New Code }
   pw:= GetDeviceCaps(Printer.Handle,VERTRES);
   ph:= GetDeviceCaps(Printer.Handle,HORZRES);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph - ramkaH;
   { End New Code }
  { ratio:=(prnppi*FHorzPageCount) / scrppi;}
   pc:=0;
   Printer.BeginDoc;
   while (pc<FBPMSDGraph.FRootEntries) and (not(FAborting)) do
    begin
     if (pc>=StartP) and (pc<=EndP) then
     begin
     FBPMSDGraph.OpenLevel(FBPMSDGraph.FLevel,pc);
     FBPMSDGraph.TraceRoute;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     Repaint;
     inc(i);
     pb.Position:=Round((i-1)*100/(EndP-StartP+1));
     Lbl.Caption:=IntToStr(pb.Position);
     pb.Update;
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     { New Code }
     rw:=(pw*FHorzPageCount)/FBPMSDGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPMSDGraph.DefHeight;
     wc:=FBPMSDGraph.DefWidth;
     hc:=FBPMSDGraph.DefHeight;
     if rw<=rh then ratio:=rw else ratio:=rh;
    { End New Code }
     FBPMSDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
     FBPMSDGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPMSDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPMSDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     wc:=FBPMSDGraph.DefWidth/wc;
     hc:=FBPMSDGraph.DefHeight/hc;
     FBPMSDGraph.Printing:=True;
     FBPMSDGraph.CreateGraphNodes(wc,hc);
     FBPMSDGraph.CreateGraphLinks(wc,hc);
     FBPMSDGraph.PresetupFrame(wc,hc);
     FBPMSDGraph.TraceRoute;
     Repaint;
     while FPainting do;
     nw:=FBPMSDGraph.NodeWidth;
     nh:=FBPMSDGraph.NodeHeight;
     mw:=FBPMSDGraph.MaxWidth;
     mh:=FBPMSDGraph.MaxHeight;
     rw:=ratio*nw/mw;
     rh:=ratio*nh/mh;
     if rw<=rh then fontRatio:=rw else fontRatio:=rh;
{     if fontRatio>ratio then fontRatio:=ratio;}
     LabelFontRatio:=fontRatio*FBPMSDGraph.FMaxCH;
     FBPMSDGraph.DefWidth:=FHorzPageCount*(Printer.PageWidth-FPageLeft-FPageRight);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPMSDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom-ramkaH)
     else
      FBPMSDGraph.DefHeight:=FVertPageCount*(Printer.PageHeight-FPageTop-FPageBottom);
     FBPMSDGraph.SetDefaultConstants;
     FBPMSDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
     FBPMSDGraph.CreateGraphNodes(wc,hc);
     FBPMSDGraph.CreateGraphLinks(wc,hc);
     FBPMSDGraph.PresetupFrame(wc,hc);
     FBPMSDGraph.TraceRoute;
     Repaint;
     while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+ramkaH);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
     FBPMSDGraph.SetDefaultConstants;
     FBPMSDGraph.Printing:=False;
     FBPMSDGraph.CreateGraphNodes(1,1);
     FBPMSDGraph.CreateGraphLinks(1,1);
     FBPMSDGraph.PresetupFrame(1,1);
     FBPMSDGraph.TraceRoute;
     Invalidate;
     if ((pc+1)<FBPMSDGraph.FRootEntries) and (pc<EndP) then Printer.NewPage;
     end; { StartP,EndP loop }
     inc(pc);
    end;  { while }
   if FAborting then Printer.Abort
   else Printer.EndDoc;
  finally
   { Restore old viewing level}
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.Printing:=False;
   FBPMSDGraph.CreateGraphNodes(1,1);
   FBPMSDGraph.CreateGraphLinks(1,1);
   FBPMSDGraph.SetScaled2(oldScaled2);
   FBPMSDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPMSDGraph.PresetupFrame(1,1);
   FBPMSDGraph.TraceRoute;
   Invalidate;
   pb.Position:=100;
   lbl.Caption:=IntToStr(pb.Position);
   pb.Update;
   lbl.Update;
   FBPMSDGraph.OpenLevel(FBPMSDGraph.FLevel,OldGraph);
   FBPMSDGraph.TraceRoute;
   Invalidate;
  end;
 end;


procedure TBPMSDFrame.Print; { Checked }
Var  prnppi,scrppi:Integer;
     w,h:Integer;
     prnx,prny:Integer;
     dc:HDC;
     ratio,fontRatio,labelFontRatio:Double;
     rw,rh:Double;
     pw,ph:Double;
     ramkaH:Integer;
     nw,nh,mw,mh:Integer;
     oldScaled:Boolean;
     oldScaled2:Boolean;
     clRect:TRect;
     px,py:Integer;
     tmpI:TQRPaperSize;
     asize:Integer;
     wc,hc:Double;
begin
 try
  oldScaled:=BPMSDGraph.Scaled;
  oldScaled2:=BPMSDGraph.Scaled2;
  FUpdatingNavigator:=True;
  FPreviewOrPrint:=True;
  FBPMSDGraph.Scaled2:=False;
  if FBPMSDGraph.FScaled then FBPMSDGraph.Scaled:=False;
  FPrinting:=True;
  if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
  if VertScrollBar.Visible then VertScrollBar.Position:=0;
  prnppi:=GetDeviceCaps(Printer.Handle,LOGPIXELSX);
  dc:=GetDC(self.Handle);
  scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
  FFontCoof:=GetDeviceCaps(Printer.Handle,LOGPIXELSX)/GetDeviceCaps(dc,LOGPIXELSX);
  FBPMSDGraph.UpdateMaxFontSize(1);
  ReleaseDC(self.Handle,dc);
  aSize:=Printer.PaperSize;
  FRamkaFontRatio:=1.0;
  FPSizeH:=21;
  FPSizeW:=29.7;
  for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
  ramkaH:=Round(prnppi/2.54);
  FRamkaH:=ramkaH;
  { New Code }
  pw:= GetDeviceCaps(Printer.Handle,VERTRES);
  ph:= GetDeviceCaps(Printer.Handle,HORZRES);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   ph:= ph-ramkaH;
  { End New Code }
{  ratio:=(prnppi*FHorzPageCount) / scrppi;}
  { New Code }
  rw:=(pw*FHorzPageCount)/FBPMSDGraph.DefWidth;
  rh:=(ph*FVertPageCount)/FBPMSDGraph.DefHeight;
  wc:=FBPMSDGraph.DefWidth;
  hc:=FBPMSDGraph.DefHeight;
  if rw<=rh then ratio:=rw else ratio:=rh;
  { End New Code }
  Printer.BeginDoc;
  FBPMSDGraph.SetDefaultConstants;
  FBPMSDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
  FBPMSDGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPMSDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPMSDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
   wc:=FBPMSDGraph.DefWidth/wc;
   hc:=FBPMSDGraph.DefHeight/hc;
  FBPMSDGraph.Printing:=True;
  FBPMSDGraph.CreateGraphNodes(wc,hc);
  FBPMSDGraph.CreateGraphLinks(wc,hc);
  FBPMSDGraph.PresetupFrame(wc,hc);
  FBPMSDGraph.TraceRoute;
  Repaint;
  while FPainting do;
  nw:=FBPMSDGraph.NodeWidth;
  nh:=FBPMSDGraph.NodeHeight;
  mw:=FBPMSDGraph.MaxWidth;
  mh:=FBPMSDGraph.MaxHeight;
  rw:=ratio*nw/mw;
  rh:=ratio*nh/mh;
  if rw<=rh then fontRatio:=rw else fontRatio:=rh;
{  if fontRatio>ratio then fontRatio:=ratio;}
  LabelFontRatio:=fontRatio*FBPMSDGraph.FMaxCH;
  FBPMSDGraph.DefWidth:=(Printer.PageWidth*FHorzPageCount-FPageLeft*FHorzPageCount-FPageRight*FHorzPageCount);
  if ((FHorzPageCount=1) and (FVertPageCount=1)) then
   FBPMSDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount-ramkaH*FVertPageCount)
  else
   FBPMSDGraph.DefHeight:=(Printer.PageHeight*FVertPageCount-FPageTop*FVertPageCount-FPageBottom*FVertPageCount);
  FBPMSDGraph.SetDefaultConstants;
  FBPMSDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
  FBPMSDGraph.CreateGraphNodes(wc,hc);
  FBPMSDGraph.CreateGraphLinks(wc,hc);
  FBPMSDGraph.PresetupFrame(wc,hc);
  FBPMSDGraph.TraceRoute;
  Repaint;
  while FPainting do;
   for px:=1 to FHorzPageCount do
    begin
     clRect.Left:=(px-1)*(Printer.PageWidth-FPageRight-FPageLeft);
     clRect.Right:=px*(Printer.PageWidth-FPageRight-FPageLeft);
    for py:=1 to FVertPageCount do
     begin
     clRect.Top:=(py-1)*(Printer.PageHeight-FPageTop-FPageBottom);
     clRect.Bottom:=py*(Printer.PageHeight-FPageTop-FPageBottom);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
        PaintTo(Printer.Handle,FPageLeft,FPageTop+ramkaH);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end
      else
       begin
        PaintPageTo(Printer.Handle,FPageLeft,FPageTop,clRect);
        PrintRect(FPageLeft,Printer.PageWidth-FPageRight,
                           FPageTop,Printer.PageHeight-FPageBottom);
       end;
       if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
        Printer.NewPage;
     end;
    end;
  finally
   Printer.EndDoc;
   FPrinting:=False;
   FUpdatingNavigator:=False;
   FPreviewOrPrint:=False;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.Printing:=False;
   FBPMSDGraph.CreateGraphNodes(1,1);
   FBPMSDGraph.CreateGraphLinks(1,1);
{   FBPMSDGraph.CheckLinksAndNodes;}
   FBPMSDGraph.SetScaled2(oldScaled2);
   FBPMSDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPMSDGraph.PresetupFrame(1,1);
   FBPMSDGraph.TraceRoute;
   Invalidate;
  end;
end;


procedure TBPMSDFrame.CreatePreviewAll(pb:TFlatProgressBar;Lbl:TLabel); { Checked }
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio,LabelFontRatio:Double;
    rw,rh:Double;
    dc:HDC;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    i:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clrect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    wc,hc:Double;
    pc,oldGraph:Integer;
begin
 { Create QRPreview Model }
   oldScaled:=BPMSDGraph.Scaled;
   oldScaled2:=BPMSDGraph.Scaled2;
   if (FBPMSDGraph.FRootEntries=0) then Exit;
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FBPMSDGraph.Scaled2:=False;
   if FBPMSDGraph.FScaled then FBPMSDGraph.Scaled:=False;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   oldGraph:=FBPMSDGraph.FCurGraph;
   FPrinter:=TQRPrinter.Create;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=poPortrait;
    Printer.Orientation:=poPortrait;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
    FPrinter.PaperLength:=Printer.PaperLength;
    FPrinter.PaperWidth:=Printer.PaperWidth;
    dc:=GetDC(0);
    scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
    FFontCoof:=1;
    FBPMSDGraph.UpdateMaxFontSize(1);
    ReleaseDC(0,dc);
    ramkaH:=Round(scrppi/2.54);
    FRamkaH:=ramkaH;
    FPrinter.NewPage;
{   if SavedOrd=poPortrait then
   begin}
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
{   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;}
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     ph:=ph - ramkaH;
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   i:=0;
   pc:=0;
   while (pc<FBPMSDGraph.FRootEntries) and (not(FAborting)) do
    begin  { while }
     FBPMSDGraph.OpenLevel(FBPMSDGraph.FLevel,pc);
     FBPMSDGraph.TraceRoute;
     Repaint;
     inc(i);
     pb.Position:=Round((i-1)*100/FBPMSDGraph.FRootEntries);
     lbl.Caption:=IntToStr(pb.Position);
     pb.Update;
     lbl.Update;
     Application.ProcessMessages;
     if FAborting then break;
     while (FPainting) do;
     if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
     if VertScrollBar.Visible then VertScrollBar.Position:=0;
     rw:=(pw*FHorzPageCount)/FBPMSDGraph.DefWidth;
     rh:=(ph*FVertPageCount)/FBPMSDGraph.DefHeight;
     wc:=FBPMSDGraph.DefWidth;
     hc:=FBPMSDGraph.DefHeight;
     if rw<=rh then ratio:=rw else ratio:=rh;
     FBPMSDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
     FBPMSDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
     if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPMSDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
     else
      FBPMSDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
     wc:=FBPMSDGraph.DefWidth/wc;
     hc:=FBPMSDGraph.DefHeight/hc;
     FBPMSDGraph.Printing:=True;
     FBPMSDGraph.CreateGraphNodes(wc,hc);
     FBPMSDGraph.CreateGraphLinks(wc,hc);
     FBPMSDGraph.PresetupFrame(wc,hc);
     FBPMSDGraph.TraceRoute;
     Repaint;
    while FPainting do;
    nw:=FBPMSDGraph.NodeWidth;
    nh:=FBPMSDGraph.NodeHeight;
    mw:=FBPMSDGraph.MaxWidth;
    mh:=FBPMSDGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    if rw<=rh then fontRatio:=rw else fontRatio:=rh;
{    if fontRatio>ratio then fontRatio:=ratio;}
    LabelFontRatio:=fontRatio*FBPMSDGraph.FMaxCH;
    FBPMSDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPMSDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
    FBPMSDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPMSDGraph.SetDefaultConstants;
    FBPMSDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
    FBPMSDGraph.CreateGraphNodes(wc,hc);
    FBPMSDGraph.CreateGraphLinks(wc,hc);
    FBPMSDGraph.PresetupFrame(wc,hc);
    FBPMSDGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
     begin
      clRect.Left:=(px-1)*(pw-fpl-fpr);
      clRect.Right:=px*(pw-fpl-fpr);
      for py:=1 to FVertPageCount do
       begin
        clRect.Top:=(py-1)*(ph-fpt-fpb);
        clRect.Bottom:=py*(ph-fpt-fpb);
        if ((FHorzPageCount=1) and (FVertPageCount=1)) then
         begin
          PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
          PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
         end
        else
         begin
          PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt,clRect);
          PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
         end;
         if ((FHorzPageCount<>px) or (FVertPageCount<>py)) then
          FPrinter.NewPage;
       end;
     end;
    inc(pc);
    if (pc<FBPMSDGraph.FRootEntries) then FPrinter.NewPage;
    FBPMSDGraph.SetDefaultConstants;
    FBPMSDGraph.Printing:=False;
    FBPMSDGraph.CreateGraphNodes(1,1);
    FBPMSDGraph.CreateGraphLinks(1,1);
    FBPMSDGraph.PresetupFrame(1,1);
    FBPMSDGraph.TraceRoute;
    Invalidate;
   end; { while }
   finally
    if FAborting then FPrinter.AbortDoc else
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FBPMSDGraph.SetDefaultConstants;
    FBPMSDGraph.Printing:=False;
    FBPMSDGraph.CreateGraphNodes(1,1);
    FBPMSDGraph.CreateGraphLinks(1,1);
    FBPMSDGraph.SetScaled2(oldScaled2);
    FBPMSDGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPMSDGraph.PresetupFrame(1,1);
    FBPMSDGraph.TraceRoute;
    Invalidate;
    pb.Position:=100;
    lbl.Caption:=IntToStr(pb.Position);
    pb.Update;
    lbl.Update;
    FBPMSDGraph.OpenLevel(FBPMSDGraph.FLevel,oldGraph);
    FBPMSDGraph.TraceRoute;
    Invalidate;
   end;
end;

procedure TBPMSDFrame.CreatePreview; { Checked }
Var savedOrd:TPrinterOrientation;
    pw,ph:Integer;
    fpl,fpr,fpt,fpb:Integer;
    ratio,fontRatio,LabelFontRatio:Double;
    dc:HDC;
    rw,rh:Double;
    scrppi:LongInt;
    ramkaH:Integer;
    nw,nh,mw,mh:Integer;
    oldScaled:Boolean;
    oldScaled2:Boolean;
    px,py:Integer;
    clRect:TRect;
    aSize:Integer;
    tmpi:TQRPaperSize;
    FTmp:Double;
    wc,hc:Double;
begin
 { Create QRPreview }
   oldScaled:=BPMSDGraph.Scaled;
   oldScaled2:=BPMSDGraph.Scaled2;
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FBPMSDGraph.Scaled2:=False;
   if FBPMSDGraph.FScaled then FBPMSDGraph.Scaled:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   if (fPrinter<>nil) then fPrinter.Free;
   savedOrd:=Printer.Orientation;
   FPrinter:=TQRPrinter.Create;
   try
    FPrinting:=True;
    FPrinter.Cleanup;
    FPrinter.BeginDoc;
    FPrinter.Orientation:=poPortrait;
    Printer.Orientation:=poPortrait;
    FPrinter.PrinterIndex:=Printer.PrinterIndex;
    aSize:=Printer.PaperSize;
    FPrinter.PaperSize:=Default;
    FRamkaFontRatio:=1.0;
    FPSizeH:=21;
    FPSizeW:=29.7;
    for tmpi:= Default to Custom do
     begin
      if aSize=cQRPaperTranslate[tmpI] then
         begin
           FPrinter.PaperSize := tmpI;
           FRamkaFontRatio:=cQRPaperSizeMetrics[tmpI,0]/cQRPaperSizeMetrics[A4,0];
           FPSizeH:=cQRPaperSizeMetrics[tmpI,0]/10;
           FPSizeW:=cQRPaperSizeMetrics[tmpI,1]/10;
         end;
     end;
     FPrinter.PaperLength:=Printer.PaperLength;
     FPrinter.PaperWidth:=Printer.PaperWidth;
   dc:=GetDC(0);
   scrppi:=GetDeviceCaps(dc,LOGPIXELSX);
   FFontCoof:=1;
   FBPMSDGraph.UpdateMaxFontSize(1);
   ReleaseDC(0,dc);
   ramkaH:=Round(scrppi/2.54);
   FRamkaH:=ramkaH;
    FPrinter.NewPage;
{   if SavedOrd=poPortrait then
   begin}
    pw:= FPrinter.XSize(FPrinter.PaperWidth);
    ph:= FPrinter.YSize(FPrinter.PaperLength);
{   end
   else
   begin
    pw:= FPrinter.XSize(FPrinter.PaperLength);
    ph:= FPrinter.YSize(FPrinter.PaperWidth);
   end;}
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
    ph:=ph-ramkaH;
   rw:=(pw*FHorzPageCount)/FBPMSDGraph.DefWidth;
   rh:=(ph*FVertPageCount)/FBPMSDGraph.DefHeight;
{   wc:=rw;
    hc:=rh; }
   if rw<=rh then ratio:=rw else ratio:=rh;
   fpl:=FPrinter.XSize(FPageLeft*10);
   fpr:=FPrinter.XSize(FPageRight*10);
   fpt:=FPrinter.YSize(FPageTop*10);
   fpb:=FPrinter.YSize(FPageBottom*10);
   wc:=FBPMSDGraph.DefWidth;
   hc:=FBPMSDGraph.DefHeight;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPMSDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
   if ((FHorzPageCount=1) and (FVertPageCount=1)) then
     FBPMSDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
   else
     FBPMSDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
   wc:=FBPMSDGraph.DefWidth/wc;
   hc:=FBPMSDGraph.DefHeight/hc;
   FBPMSDGraph.Printing:=True;
   FBPMSDGraph.CreateGraphNodes(wc,hc);
   FBPMSDGraph.CreateGraphLinks(wc,hc);
   FBPMSDGraph.PresetupFrame(wc,hc);
   FBPMSDGraph.TraceRoute;
   Repaint;
   while FPainting do;
    nw:=FBPMSDGraph.NodeWidth;
    nh:=FBPMSDGraph.NodeHeight;
    mw:=FBPMSDGraph.MaxWidth;
    mh:=FBPMSDGraph.MaxHeight;
    rw:=ratio*nw/mw;
    rh:=ratio*nh/mh;
    if rw<=rh then fontRatio:=rw else fontRatio:=rh;
{    if fontRatio>ratio then fontRatio:=ratio;}
    LabelFontRatio:=fontRatio*FBPMSDGraph.FMaxCH;
    FBPMSDGraph.DefWidth:=(PW*FHorzPageCount-FPL*FHorzPageCount-FPR*FHorzPageCount);
    if ((FHorzPageCount=1) and (FVertPageCount=1)) then
      FBPMSDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount-ramkaH*FVertPageCount)
    else
     FBPMSDGraph.DefHeight:=(PH*FVertPageCount-FPT*FVertPageCount-FPB*FVertPageCount);
    FBPMSDGraph.SetDefaultConstants;
    FBPMSDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
    FBPMSDGraph.CreateGraphNodes(wc,hc);
    FBPMSDGraph.CreateGraphLinks(wc,hc);
    FBPMSDGraph.PresetupFrame(wc,hc);
    FBPMSDGraph.TraceRoute;
    Repaint;
    while FPainting do;
    for px:=1 to FHorzPageCount do
    begin
     clrect.Left:=(px-1)*(pw-fpl-fpr);
     clRect.Right:=px*(pw-fpl-fpr);
     for py:=1 to FVertPageCount do
     begin
      clrect.Top:=(py-1)*(ph-fpt-fpb);
      clrect.Bottom:=py*(ph-fpt-fpb);
      if ((FHorzPageCount=1) and (FVertPageCount=1)) then
       begin
         PaintTo(FPrinter.Canvas.Handle,fpl,fpt+ramkaH);
         PreviewPrintRect(FPageLeft,pw-FPageRight,FPageTop,ph+ramkaH-FPageBottom);
       end
       else
        begin
         PaintPageTo(FPrinter.Canvas.Handle,fpl,fpt{+ramkaH},clrect);
         PreviewPrintRect(fpl,pw-fpr,fpt,ph-fpb);
        end;
      if ((px<>FHorzPageCount) or (py<>FVertPageCount)) then FPrinter.NewPage;
     end;
    end;
   finally
    FPrinter.EndDoc;
    FPrinting:=False;
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    FHorzPageCount:=1;
    FVertPageCount:=1;
    FBPMSDGraph.SetDefaultConstants;
    FBPMSDGraph.Printing:=False;
    FBPMSDGraph.CreateGraphNodes(1,1);
    FBPMSDGraph.CreateGraphLinks(1,1);
{    FBPMSDGraph.CheckLinksAndNodes;}
    FBPMSDGraph.SetScaled2(oldScaled2);
    FBPMSDGraph.SetScaled(oldScaled);
    if (not(oldScaled)) then FBPMSDGraph.PresetupFrame(1,1);
    FBPMSDGraph.TraceRoute;
    Invalidate;
   end;
end;

procedure TBPMSDFrame.CreateBitmap(var value:TBitmap;pf:TPixelFormat); { Checked }
 begin
  try
   FUpdatingNavigator:=True;
   FPreviewOrPrint:=True;
   FFontCoof:=1;
   FBPMSDGraph.UpdateMaxFontSize(1);
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=FBPMSDGraph.FDefWidth;
   value.Height:=FBPMSDGraph.FDefHeight;
   Repaint;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   Value.Canvas.Unlock;
  finally
    FUpdatingNavigator:=False;
    FPreviewOrPrint:=False;
    Visible:=True;
  end;
 end;

procedure TBPMSDFrame.CreateBitmapWithSize(var value:TBitmap;pf:TPixelFormat;iw,ih:Integer); { scaled bitmap } { Checked }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
 begin
  try
   FUpdatingNavigator:=True;
   oldScaled:=FBPMSDGraph.Scaled;
   oldScaled2:=FBPMSDGraph.Scaled2;
   oldPrinting:=FBPMSDGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   if FBPMSDGraph.Scaled2 then FBPMSDGraph.Scaled2:=False;
   if FBPMSDGraph.Scaled then FBPMSDGraph.Scaled:=False;
   FPrinting:=True;
   rw:=iw/FBPMSDGraph.DefWidth;
   rh:=ih/FBPMSDGraph.DefHeight;
   wc:=rw;
   hc:=rh;
   if rw<=rh then ratio:=rw else ratio:=rh;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPMSDGraph.DefHeight:=ih;
   FBPMSDGraph.DefWidth:=iw;
   FBPMSDGraph.Printing:=True;
   FBPMSDGraph.CreateGraphNodes(wc,hc);
   FBPMSDGraph.CreateGraphLinks(wc,hc);
   FBPMSDGraph.PresetupFrame(wc,hc);
   FBPMSDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   nw:=FBPMSDGraph.NodeWidth;
   nh:=FBPMSDGraph.NodeHeight;
   mw:=FBPMSDGraph.MaxWidth;
   mh:=FBPMSDGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   if rw<=rh then fontRatio:=rw else fontRatio:=rh;
{   if fontRatio>ratio then fontRatio:=ratio;}
   LabelFontRatio:=fontRatio*FBPMSDGraph.FMaxCH;
   FBPMSDGraph.DefHeight:=ih;
   FBPMSDGraph.DefWidth:=iw;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
   FBPMSDGraph.CreateGraphNodes(wc,hc);
   FBPMSDGraph.CreateGraphLinks(wc,hc);
   FBPMSDGraph.PresetupFrame(wc,hc);
   FBPMSDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   value.Canvas.Lock;
   PaintTo(value.Canvas.Handle,0,0);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.Printing:=oldPrinting;
   FBPMSDGraph.CreateGraphNodes(1,1);
   FBPMSDGraph.CreateGraphLinks(1,1);
{   FBPMSDGraph.CheckLinksAndNodes;}
   FBPMSDGraph.SetScaled2(oldScaled2);
   FBPMSDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPMSDGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPMSDGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;

procedure TBPMSDFrame.GetBitmapWithSize(value:TBitmap;iw,ih:Integer); { scaled bitmap } { Checked }
Var rw,rh:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    wc,hc:Double;
    i:Integer;
    wl,wt,ww,wh:Integer;
    node:PMSDGraphNode;
    link:PMSDGraphLink;
    hpos,vpos:Integer;
 begin
  try
   FUpdatingNavigator:=True;
   if HorzScrollBar.Visible then hpos:=HorzScrollBar.Position;
   if VertScrollBar.Visible then vpos:=VertScrollBar.Position;
   Visible:=False;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   while FPainting do;
   rw:=iw/(FBPMSDGraph.DefWidth+1);
   rh:=ih/(FBPMSDGraph.DefHeight+1);
   value.Canvas.Lock;
   Value.Canvas.FillRect(Value.Canvas.ClipRect);
   { Draw Node}
     node:=FBPMSDGraph.FGraphNodes;
    for i:=0 to (FBPMSDGraph.FGNodesCount-1) do
    begin
     wl:=Round(node^.BPNode.Left*rw);
     wt:=Round(node^.BPNode.Top*rh);
     ww:=Round(node^.BPNode.Width*rw);
     wh:=Round(node^.BPNode.Height*rh);
     DrawNode(wl,wt,ww,wh,Value.Canvas,node^.BPNode.PaintColor,node^.BPNode.RectColor);
     node:=node^.next;
    end;
     { Draw Links}
    link:=BPMSDGraph.FGraphLinks;
    for i:=0 to(BPMSDGraph.FGLinksCount-1) do
    begin
     if link^.Visible then  DrawLink(link,value.Canvas,rw,rh,hpos,vpos);
     link:=link^.next;
    end;
   value.Canvas.Unlock;
  finally
   if HorzScrollBar.Visible then HorzScrollBar.Position:=hpos;
   if VertScrollBar.Visible then VertScrollBar.Position:=vpos;
   Visible:=True;
   FUpdatingNavigator:=False;
  end;
 end;


procedure TBPMSDFrame.CreateBitmapForOneShit(var value:TBitmap;pf:TPixelFormat;iw,ih,shitw,shith,maxshitw,maxshith:Integer); { Checked }
Var oldScaled:Boolean;
    oldScaled2:Boolean;
    oldPrinting:Boolean;
    rw,rh:Double;
    ratio,fontRatio,LabelFontRatio:Double;
    nw,nh:Integer;
    mw,mh:Integer;
    clRect:TRect;
    wc,hc:Double;
 begin
    try
   FUpdatingNavigator:=True;
   oldScaled:=FBPMSDGraph.Scaled;
   oldScaled2:=FBPMSDGraph.Scaled2;
   oldPrinting:=FBPMSDGraph.Printing;
   if HorzScrollBar.Visible then HorzScrollBar.Position:=0;
   if VertScrollBar.Visible then VertScrollBar.Position:=0;
   Visible:=False;
   if FBPMSDGraph.Scaled2 then FBPMSDGraph.Scaled2:=False;
   if FBPMSDGraph.Scaled then FBPMSDGraph.Scaled:=False;
   FPrinting:=True;
   rw:=(iw*maxshitw)/FBPMSDGraph.DefWidth;
   rh:=(ih*maxshith)/FBPMSDGraph.DefHeight;
   wc:=rw;
   hc:=rh;
   if rw<=rh then ratio:=rw else ratio:=rh;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.SetScaledConstants(rw,rh,ratio,ratio,ratio);
   FBPMSDGraph.DefHeight:=ih*maxshith;
   FBPMSDGraph.DefWidth:=iw*maxshitw;
   FBPMSDGraph.Printing:=True;
   FBPMSDGraph.CreateGraphNodes(wc,hc);
   FBPMSDGraph.CreateGraphLinks(wc,hc);
   FBPMSDGraph.PresetupFrame(wc,hc);
   FBPMSDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   nw:=FBPMSDGraph.NodeWidth;
   nh:=FBPMSDGraph.NodeHeight;
   mw:=FBPMSDGraph.MaxWidth;
   mh:=FBPMSDGraph.MaxHeight;
   rw:=ratio*nw/mw;
   rh:=ratio*nh/mh;
   if rw<=rh then fontRatio:=rw else fontRatio:=rh;
{   if fontRatio>ratio then fontRatio:=ratio;}
   LabelFontRatio:=fontRatio*FBPMSDGraph.FMaxCH;
   FBPMSDGraph.DefHeight:=ih*maxshith;
   FBPMSDGraph.DefWidth:=iw*maxshitw;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.SetScaledConstants(wc,hc,ratio,fontRatio,LabelFontRatio);
   FBPMSDGraph.CreateGraphNodes(wc,hc);
   FBPMSDGraph.CreateGraphLinks(wc,hc);
   FBPMSDGraph.PresetupFrame(wc,hc);
   FBPMSDGraph.TraceRoute;
   Repaint;
   while FPainting do;
   value:=TBitmap.Create;
   value.PixelFormat:=pf;
   value.Width:=iw;
   value.Height:=ih;
   while FPainting do;
   clrect.Left:=shitw*iw;
   clRect.Right:=(shitw+1)*iw;
   clrect.Top:=shith*ih;
   clrect.Bottom:=(shith+1)*ih;
   value.Canvas.Lock;
   PaintPageTo(Value.Canvas.Handle,0,0,clrect);
   value.Canvas.Unlock;
  finally
   FPrinting:=False;
   FBPMSDGraph.SetDefaultConstants;
   FBPMSDGraph.Printing:=oldPrinting;
   FBPMSDGraph.CreateGraphNodes(1,1);
   FBPMSDGraph.CreateGraphLinks(1,1);
   FBPMSDGraph.SetScaled2(oldScaled2);
   FBPMSDGraph.SetScaled(oldScaled);
   if (not(oldScaled)) then FBPMSDGraph.PresetupFrame(1,1);
   FUpdatingNavigator:=False;
   FBPMSDGraph.TraceRoute;
   Invalidate;
   Visible:=True;
  end;
 end;


procedure Register; { Checked }
begin
  RegisterComponents('DeadSouls', [TBPMSDFrame]);
end;

end.